GNU bug report logs - #57963
[PATCH 0/1] Support user's fontconfig.

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: guix-patches; Reported by: Taiju HIGASHI <higashi@HIDDEN>; Keywords: patch; dated Wed, 21 Sep 2022 00:28:02 UTC; Maintainer for guix-patches is guix-patches@HIDDEN.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 23 Oct 2022 11:40:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 23 07:40:59 2022
Received: from localhost ([127.0.0.1]:43781 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1omZLf-0002Tk-JC
	for submit <at> debbugs.gnu.org; Sun, 23 Oct 2022 07:40:59 -0400
Received: from mail-pl1-f177.google.com ([209.85.214.177]:45783)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1omZLd-0002TY-Fi
 for 57963 <at> debbugs.gnu.org; Sun, 23 Oct 2022 07:40:58 -0400
Received: by mail-pl1-f177.google.com with SMTP id u6so6224634plq.12
 for <57963 <at> debbugs.gnu.org>; Sun, 23 Oct 2022 04:40:57 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:from:to:cc:subject:date:message-id:reply-to;
 bh=9vuPbFxjRIrmjYkaLr0Yt4T2DjKuK1m/amXa+tuyBL4=;
 b=P7F8Ai7P/opuXYrltpgxU24aEEHboqxdYji4CHhOcBsnebHouQmYD0eg5x7ng87mwI
 9oQk5aj0YGwNgnbs1PHDmSHIPozC7VbYUmuY3V4MDMvu1P+evKQObJJW/GJYhPvzNYVz
 EfEAu8sWNaLiCAen2Fu0fesVLSGTd0+5jFSfpvMR4w3TjcVW26c6lWopTembr61rkF8s
 /egyx9VCsF1bIDrVdCZtvDF+EbSxLr20TuhJvbh+c5N8jXa8RX8zlnCFRhftxzEuhtbu
 R15IdysTxkACLBoSOIXR3nOe4dQD1X+8DC+B2iar3OODNYkNnbVEORB5MX5iuEDF+Cib
 zRyA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:x-gm-message-state:from:to:cc:subject:date
 :message-id:reply-to;
 bh=9vuPbFxjRIrmjYkaLr0Yt4T2DjKuK1m/amXa+tuyBL4=;
 b=7zt3o8+shmLkcZEhxf3fMtuMQVGQWPAxZ/eeDRw5WuJyGI37+ExbPqeWyZgt+ZEaXi
 vHWI2Xemnm6+6T3kFXRVvhgyMW2K3sJ/s3uYG7eJWMHM0tPqOWNZI5EvReOC2DsAzRhV
 B4UKEjycQwd+npE/3S4iHViufBdxBUsiRV+bpRSRF/bzbNcEAAVRMsHVZF2FnTZLlBLg
 JaxU6W3Wt6iCL0b7AVY/kzRVBnGO0vmcwiFrPkTsnvsCIuNhBJqqeO8OhdcC+QlSdauK
 MzblcsF88yxT2vxRkA0IREG9GkNvkN9qvbrHG2CGlQ+5zn5wzX5T1YUmBqMszC56gSlX
 bCgw==
X-Gm-Message-State: ACrzQf2+oYy77pP0eWLz1HW9olZca0ZYLf2LXG//aNiGfwROmVdbJQ3o
 MS6aWbp32s78+YbWKAiafdOiodHBRCqaXg==
X-Google-Smtp-Source: AMsMyM4E9Kux1GLl8UnSZRHnzW/LmHUQ6E+jMcKkhKBOLNLeH9fzLe7qHmaOfCPyKTaCUx0pYRTGkA==
X-Received: by 2002:a17:902:be03:b0:178:6f5d:e979 with SMTP id
 r3-20020a170902be0300b001786f5de979mr28213494pls.163.1666525251206; 
 Sun, 23 Oct 2022 04:40:51 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 i3-20020a170902cf0300b001785fa792f4sm17935559plg.243.2022.10.23.04.40.49
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sun, 23 Oct 2022 04:40:50 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Declan Tsien <declantsien@HIDDEN>
Subject: Re: [bug#57963] [PATCH v5 2/2] home: services: Support user's
 fontconfig configuration.
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN> <875ygf3ve6.fsf@HIDDEN>
 <87ilkdbz75.fsf@HIDDEN> <87a65psra1.fsf@HIDDEN>
 <87wn8ta9ma.fsf@HIDDEN> <87czalzgei.fsf@HIDDEN>
 <87mt9n9hiq.fsf@HIDDEN> <87r0yzro2v.fsf@HIDDEN>
Date: Sun, 23 Oct 2022 20:40:47 +0900
In-Reply-To: <87r0yzro2v.fsf@HIDDEN> (Declan Tsien's message of "Sun, 23
 Oct 2022 15:33:44 +0800")
Message-ID: <87fsfeahts.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Declan Tsien <declantsien@HIDDEN> writes:

> Taiju HIGASHI <higashi@HIDDEN> writes:
>
>>
>> I see.  We may make the interface even more unsuitable for extensions
>> since we plan to allow the user to choose whether to configure with the
>> fontconfig-configuration or a file-like object.
>>
>> I am taking a very long time to finalize the interface on this issue,
>> should I still think about it more carefully...?
>>
>> Thanks,
>> --
>> Taiju
>
> I think we can stick to the current specification for now. We can go from
> there later.
>

Thank you.  I will proceed with the current specification.

Thanks,
-- 
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 23 Oct 2022 07:34:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 23 03:34:08 2022
Received: from localhost ([127.0.0.1]:42802 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1omVUm-0007ef-7E
	for submit <at> debbugs.gnu.org; Sun, 23 Oct 2022 03:34:08 -0400
Received: from mx0.riseup.net ([198.252.153.6]:53150)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <declantsien@HIDDEN>) id 1omVUh-0007dy-15
 for 57963 <at> debbugs.gnu.org; Sun, 23 Oct 2022 03:34:06 -0400
Received: from fews1.riseup.net (fews1-pn.riseup.net [10.0.1.83])
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256/256 bits)
 key-exchange X25519 server-signature RSA-PSS (2048 bits) server-digest SHA256
 client-signature RSA-PSS (2048 bits) client-digest SHA256)
 (Client CN "mail.riseup.net", Issuer "R3" (not verified))
 by mx0.riseup.net (Postfix) with ESMTPS id 4Mw91d0X0Dz9sm5;
 Sun, 23 Oct 2022 07:33:57 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=riseup.net; s=squak;
 t=1666510437; bh=7fT/uIBdfvMzreS5Ib6RCY0ZQ6odHaXCvYlVsWe0l38=;
 h=From:To:Cc:Subject:In-Reply-To:References:Date:From;
 b=iwD9/nT8alxhJKxe6J6tTzYv+XHQfg1f97/feux10Yd/ggXyjgW+4bbo7Dd2Gz8R1
 Xncg9gLuolkH5WKoZ3JWa2uLycFenjqCbl9VzXjLzhm9ld5X+YQipbolNKR3fCV2U+
 DDMhYRCJz8/DLNPZvryTMckZIOJe22sND5+wzL3Y=
X-Riseup-User-ID: F0315F7812AE76396A973BAD0ABA66102FA63EFE6430D284EF8FD5ED0AD4F2A5
Received: from [127.0.0.1] (localhost [127.0.0.1])
 by fews1.riseup.net (Postfix) with ESMTPSA id 4Mw91c39PGz5vTf;
 Sun, 23 Oct 2022 07:33:56 +0000 (UTC)
From: Declan Tsien <declantsien@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>
Subject: Re: [bug#57963] [PATCH v5 2/2] home: services: Support user's
 fontconfig configuration.
In-Reply-To: <87mt9n9hiq.fsf@HIDDEN>
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN> <875ygf3ve6.fsf@HIDDEN>
 <87ilkdbz75.fsf@HIDDEN> <87a65psra1.fsf@HIDDEN>
 <87wn8ta9ma.fsf@HIDDEN> <87czalzgei.fsf@HIDDEN>
 <87mt9n9hiq.fsf@HIDDEN>
Date: Sun, 23 Oct 2022 15:33:44 +0800
Message-ID: <87r0yzro2v.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

Taiju HIGASHI <higashi@HIDDEN> writes:

>
> I see.  We may make the interface even more unsuitable for extensions
> since we plan to allow the user to choose whether to configure with the
> fontconfig-configuration or a file-like object.
>
> I am taking a very long time to finalize the interface on this issue,
> should I still think about it more carefully...?
>
> Thanks,
> --=20
> Taiju

I think we can stick to the current specification for now. We can go from
there later.


--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHLBAEBCAA1FiEE9pXznsYl4IEztXWfD8aHA3Xv4vUFAmNU7lgXHGRlY2xhbnRz
aWVuQHJpc2V1cC5uZXQACgkQD8aHA3Xv4vUSHwv+Me2ZI33DAdLYPT5S2TYj+wDO
sazmox+5i/qFQjU4Ni+XigUsnmToIXtE7suTvV8Z0tcKKtOHotXACA7PRzhZe1hN
RkfIZ9zcKPNHitqTmmSORUtZJz5JYZkEcAZk7sCy2yaXPwBZ/y9XB4bSQ0OyHxmD
1yJvvMR+Grsg81X8lx7h2AXgNK55SwdMwtnmemCno+AgnE38t5dMv8LQfvxOcWKA
tS4k6/qjiL/uoIKKbcboyysESnn5O6iw2fne6WNSt5b/uXLLvAqZvdWUSboo/i2G
LKRd5OdvzZkNdHibMj1OCiaJSmrGhiSINCdjsQwf0ClC1WtyeAbd5SV9pbkXnNO0
zny7/nvPKinM4yDPeom7PSb4yGo67opEBp6Yg7El7y3rv9vvM9xmZxvjzJ6zXaqo
OtntmBH8Qi2aS52LL9GRFXBSJufSmmAcTj3uErNFg9vgX7niPBL/BpK7b4QXFxCD
+fKkeK282q2HW/We0Jp6CvpWGK6mdw71jk2p2W00
=6AZi
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 23 Oct 2022 06:32:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 23 02:32:58 2022
Received: from localhost ([127.0.0.1]:42786 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1omUXa-00068u-AE
	for submit <at> debbugs.gnu.org; Sun, 23 Oct 2022 02:32:58 -0400
Received: from mail-pg1-f182.google.com ([209.85.215.182]:37570)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1omUXX-00068g-IR
 for 57963 <at> debbugs.gnu.org; Sun, 23 Oct 2022 02:32:56 -0400
Received: by mail-pg1-f182.google.com with SMTP id h2so14496pgp.4
 for <57963 <at> debbugs.gnu.org>; Sat, 22 Oct 2022 23:32:55 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:from:to:cc:subject:date:message-id:reply-to;
 bh=neo7y7RqNMb/53H8cztn3cJXjlXM/sSSd6l5G9L+G2A=;
 b=6SHIx6ZJ+PrDluRdbyj/dcpt8KzkNxFP4fvVoIp7hM9uX2Zd33iHhwhEmsMk6szBa1
 wLB0cFx+JpAwdrqetQ2lqtJr8kDTVMpV8+aIrgIQtj+156dlU6gOpY4oXrjORFikDMTs
 FUbfMxpOaEMSupqzA2tPiWnhJL70Cf13L6mZmkbJdvsixwCDujKdnmFeJ2mP5sUnYxj5
 eZPebEyGr9ghjhtsjZBmmDlhofFMFxIXHATdlLiH2RPAzMqTb0TLMcAvewmHKRT9Nt9m
 KaArdHGt3g4KZ4+On/xhpyP9cMvCZ0xNiPDmt6XZII35bwmTHyIQ1IQHGTue04xvWT6M
 xNVQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:x-gm-message-state:from:to:cc:subject:date
 :message-id:reply-to;
 bh=neo7y7RqNMb/53H8cztn3cJXjlXM/sSSd6l5G9L+G2A=;
 b=FNvs8WhxRAHu3E7Thdd6M046+QyOlxZO9Nez/EncVL21/X6So825reBw2Zn1azMpHJ
 KF4vGCaI4/xVKHI7BgZ0r11RLYbT9IaMhGdSDMTXgYXYU6hCrXRsdFGE/gGnpxXRErah
 Bp8IYZkbbYjuSUjLhlqOu/+nVGWy+h4vwldajq7f2QjZbuIHGO28IAhmg1NFS1K/7QVt
 Vzpx616VoaZgHXpeFjWZoaYrT0hLcKsfTiT2xdDf/IFPw9m+O4XQ2i79e5oMd7dtnUgu
 bbCXJ5nc4d1g2hqAPiciP8jzH5hhXQpUqLOKG6T92p52Z7aJwnr+DEjpClm7+Vj0rxu/
 hCLA==
X-Gm-Message-State: ACrzQf2nUSZkUo7FGYQtNRCRX4rukQTHnWLUmhFJ8Nnf/MiQGDjnBPGl
 VTYWKhMcu5OTb9k3jd3RXSiqnmN65f2+3A==
X-Google-Smtp-Source: AMsMyM6M47Esn8lC97wUEi4YF3QlwJxejM4cN4Jrvmr32JI66dTSxdcJ0kE+jHmfFmmqUhIFeUwF8A==
X-Received: by 2002:a05:6a00:2307:b0:565:9079:b165 with SMTP id
 h7-20020a056a00230700b005659079b165mr27982454pfh.53.1666506768791; 
 Sat, 22 Oct 2022 23:32:48 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 e13-20020aa798cd000000b0056bc0578c7dsm263669pfm.110.2022.10.22.23.32.46
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 22 Oct 2022 23:32:48 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Declan Tsien <declantsien@HIDDEN>
Subject: Re: [bug#57963] [PATCH v5 2/2] home: services: Support user's
 fontconfig configuration.
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN> <875ygf3ve6.fsf@HIDDEN>
 <87ilkdbz75.fsf@HIDDEN> <87a65psra1.fsf@HIDDEN>
 <87wn8ta9ma.fsf@HIDDEN> <87czalzgei.fsf@HIDDEN>
Date: Sun, 23 Oct 2022 15:32:45 +0900
In-Reply-To: <87czalzgei.fsf@HIDDEN> (Declan Tsien's message of "Fri, 21
 Oct 2022 17:15:33 +0800")
Message-ID: <87mt9n9hiq.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Declan Tsien <declantsien@HIDDEN> writes:

> Taiju HIGASHI <higashi@HIDDEN> writes:
>
>> See: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=57963#71
>>
>> We have to come up with a merge strategy if we allow to extend, how
>> would you like to extend it?
>
> OK, got it. Sounds reasonable.
> I should have followed the conversation thoroughly,  Sorry about that.
>
>>
>> Perhaps I am less experienced in Guix customization than you are, and
>
> Nah, I haven't contributed much to Guix community yet. Only poking around with my
> guix-config ha.
>
>> don't understand the use cases that cannot be achieved with
>> modify-services.
>
> I'd prefer =simple-service= over =modify-services= when possible.
> For example, in this case. Let's say I want to add an item to
> =font-directories=, I should not forget to include =guix-home-font-dir=
> too, like this:
>
> #+begin_src scheme
> (home-fontconfig-configuration
>  (font-directories
>   (string-list (list guix-home-font-dir "another-dir")))
> #+end_src
>
>
> But with service extension I can just write:
>
> #+begin_src scheme
> (home-fontconfig-extension
>  (font-directories
>   (string-list (list "another-dir")))
> #+end_src
>
> =guix-home-font-dir= doesn't need to show up in my configuration.

I see.  We may make the interface even more unsuitable for extensions
since we plan to allow the user to choose whether to configure with the
fontconfig-configuration or a file-like object.

I am taking a very long time to finalize the interface on this issue,
should I still think about it more carefully...?

Thanks,
-- 
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 21 Oct 2022 09:15:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 21 05:15:53 2022
Received: from localhost ([127.0.0.1]:37016 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1olo89-0006pX-IT
	for submit <at> debbugs.gnu.org; Fri, 21 Oct 2022 05:15:53 -0400
Received: from mx0.riseup.net ([198.252.153.6]:43498)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <declantsien@HIDDEN>) id 1olo87-0006lP-R7
 for 57963 <at> debbugs.gnu.org; Fri, 21 Oct 2022 05:15:52 -0400
Received: from fews1.riseup.net (fews1-pn.riseup.net [10.0.1.83])
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256/256 bits)
 key-exchange X25519 server-signature RSA-PSS (2048 bits) server-digest SHA256
 client-signature RSA-PSS (2048 bits) client-digest SHA256)
 (Client CN "mail.riseup.net", Issuer "R3" (not verified))
 by mx0.riseup.net (Postfix) with ESMTPS id 4MtzN16Jq0z9sPR;
 Fri, 21 Oct 2022 09:15:45 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=riseup.net; s=squak;
 t=1666343745; bh=CK1jeCSUrsn4GiIz2jcn7h+zT9QRej5kQ6qvNaxqFso=;
 h=From:To:Cc:Subject:In-Reply-To:References:Date:From;
 b=mSGV4f0OE2X9AX7wqcOkZ2h4qGW85qiaYTowPYA8Dph6UcR19gCZ3Aw1TDYgGqQLu
 bDchSYd4M7BDC3ICQpY+jYC/nw1caJJclLF3q+dKTW3zH3dfWyyre2VA1Qx+rFCw61
 rzggMryb0rthkUlSFg0FjnKn6iocq6vLrMj4YECw=
X-Riseup-User-ID: 4BA38C4B9347E12A95F1B0107A4DC6609A6A2B8E53CD8D8E2F552FF46D327FD0
Received: from [127.0.0.1] (localhost [127.0.0.1])
 by fews1.riseup.net (Postfix) with ESMTPSA id 4MtzN11wbrz5vVd;
 Fri, 21 Oct 2022 09:15:45 +0000 (UTC)
From: Declan Tsien <declantsien@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>
Subject: Re: [bug#57963] [PATCH v5 2/2] home: services: Support user's
 fontconfig configuration.
In-Reply-To: <87wn8ta9ma.fsf@HIDDEN>
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN> <875ygf3ve6.fsf@HIDDEN>
 <87ilkdbz75.fsf@HIDDEN> <87a65psra1.fsf@HIDDEN>
 <87wn8ta9ma.fsf@HIDDEN>
Date: Fri, 21 Oct 2022 17:15:33 +0800
Message-ID: <87czalzgei.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

Taiju HIGASHI <higashi@HIDDEN> writes:

> See: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=3D57963#71
>
> We have to come up with a merge strategy if we allow to extend, how
> would you like to extend it?

OK, got it. Sounds reasonable.=20
I should have followed the conversation thoroughly,  Sorry about that.

>
> Perhaps I am less experienced in Guix customization than you are, and

Nah, I haven't contributed much to Guix community yet. Only poking around w=
ith my
guix-config ha.

> don't understand the use cases that cannot be achieved with
> modify-services.

I'd prefer =3Dsimple-service=3D over =3Dmodify-services=3D when possible.
For example, in this case. Let's say I want to add an item to
=3Dfont-directories=3D, I should not forget to include =3Dguix-home-font-di=
r=3D
too, like this:

#+begin_src scheme
(home-fontconfig-configuration
 (font-directories
  (string-list (list guix-home-font-dir "another-dir")))
#+end_src

But with service extension I can just write:

#+begin_src scheme
(home-fontconfig-extension
 (font-directories
  (string-list (list "another-dir")))
#+end_src

=3Dguix-home-font-dir=3D doesn't need to show up in my configuration.

=2D---
Thanks

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHLBAEBCAA1FiEE9pXznsYl4IEztXWfD8aHA3Xv4vUFAmNSYzUXHGRlY2xhbnRz
aWVuQHJpc2V1cC5uZXQACgkQD8aHA3Xv4vXHkwwAtHUOPTBnc/bIM4pmNW9C6ax4
d+r9yifg8bVIYN/x+L0hpgACPK2TKMQs5v/2oLcTWVJ9iuXIHl2Dyo6jF7om1rO2
H4OESDYT0gfPenctTJWdaT6n8GJkn9vpx9HcS4jxuzQx2Zv8r7pwJHw8IL1SloXV
db5vHAVUDyjIkXNHuh6+O+GYVISeeU/psl2VhtQ6qghO5TmZek1IMCaOw728honw
iarDuF58NU/TAeEkplPlAAsaiWNgKKfWJhRuEplCLZ8W8DXPnKv9ZmIWFrF3NeR0
IYHOduH4zjSfJON2DwlxMgBR4KGrYVre08zcOQ1oYutlbY59zpDzR9A6mVj/HqRL
gNZ1oyg3L5buT33JXFgngBN4kk6gvZppm0Pwi5D21nJj0avAMMVvj0YczEmk+JF8
mZoTsQPiqgaa4M7agecksSNbOuTdZLfaWhamac0kdlKKh4vqq0uDt8JmOTIF2GVK
Qxm5YsTKXpJAnGQJcQgfGzcR1jzMiK5PE7dUgHZr
=NMlp
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 21 Oct 2022 08:01:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 21 04:01:29 2022
Received: from localhost ([127.0.0.1]:36888 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1olmy8-0000Ps-Of
	for submit <at> debbugs.gnu.org; Fri, 21 Oct 2022 04:01:29 -0400
Received: from mail-pg1-f181.google.com ([209.85.215.181]:36762)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1olmy6-0000Pf-VT
 for 57963 <at> debbugs.gnu.org; Fri, 21 Oct 2022 04:01:27 -0400
Received: by mail-pg1-f181.google.com with SMTP id s196so1898931pgs.3
 for <57963 <at> debbugs.gnu.org>; Fri, 21 Oct 2022 01:01:26 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:from:to:cc:subject:date:message-id:reply-to;
 bh=msWwSAvLcLsNEcoJBEHZeClX85D31OYD33rHyqywR+0=;
 b=xb+1nf2iQZse3TqxvoEzwpGX3ytEAeQJ7MW+HgfXhloTN+M9hHRzVKML0Mwq0kdi56
 HLj0MO9ml6dOt36qHJeeQIEnwxQxEb7C1F8kGQxLmoFoVdLKjicP+Pdn1bj5MV45nMuY
 dsM9e5Ewp+Imb4cKXV012oGkuHaw1Xu7NSuTIgMxnxqQXWpdoJzEYiWBZb2zZzKDWnGA
 FUA3ozIyWM29F/d8/jqTCgQ0wyQkEN+c2jWUjui9WhSXSnHmwvTYmoN2EMw6tfIz3/9h
 YHiMTBTC77ndAuHKaJuodiWxhhP56AsO/tk7S8bW64lrdQBhoM3Lnp+QGrd3JaGKVjAn
 VO1w==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:x-gm-message-state:from:to:cc:subject:date
 :message-id:reply-to;
 bh=msWwSAvLcLsNEcoJBEHZeClX85D31OYD33rHyqywR+0=;
 b=G+D4mL+Us9MYfnvrQvs1wCHmXXfex3qZ2fXHIGPL6vbdA5zLFm4j4TmoLDmikelc51
 pnf/tO1UbK3yjLCclZP6pFh8Jg6QHMqxmFn7ZtwuVFwIMs5znzn6Fp42H2lT+FtRckyL
 nKfQEMqC0vnh3Iha41jd4L0F3aELgWVtzEb/DKcZUHLe5bNVQeJ3OHYuYh+qJFU7v5K1
 3r7NaPfos1gagLIlrDu66ESHm7p47DCbx1By1CufclzgpfLqTThz4FVL71tSh4K6ZYC6
 o9eQgGPd1Qh/vmhjvZ/MQ3eHeWg40v3vzuWUbzzYH/rlwJ+XlKiUVs9T3UuCPRCtKMP3
 Ji2Q==
X-Gm-Message-State: ACrzQf3ybAZ6F44qa6Hxp+WiYre5tajzkFL12Fb7lPrxlnWW88tEkWmF
 O+WocrO/eNLxjTiAFzJECN9KoA==
X-Google-Smtp-Source: AMsMyM6/2rlhztvaW3iSGO9O5vKt4KAUeGK/AI0BzJL+T2oCm/9/uhSFP+DhlfFlt9/0Rm7vnys5JA==
X-Received: by 2002:a05:6a00:1344:b0:565:e95c:6da4 with SMTP id
 k4-20020a056a00134400b00565e95c6da4mr17874313pfu.45.1666339281113; 
 Fri, 21 Oct 2022 01:01:21 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 o11-20020a17090a4b4b00b0020d45a155d9sm521476pjl.35.2022.10.21.01.01.18
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Fri, 21 Oct 2022 01:01:20 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Declan Tsien <declantsien@HIDDEN>
Subject: Re: [bug#57963] [PATCH v5 2/2] home: services: Support user's
 fontconfig configuration.
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN> <875ygf3ve6.fsf@HIDDEN>
 <87ilkdbz75.fsf@HIDDEN> <87a65psra1.fsf@HIDDEN>
Date: Fri, 21 Oct 2022 17:01:17 +0900
In-Reply-To: <87a65psra1.fsf@HIDDEN> (Declan Tsien's message of "Fri, 21
 Oct 2022 13:02:30 +0800")
Message-ID: <87wn8ta9ma.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN,
 Andrew Tropin <andrew@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Declan Tsien <declantsien@HIDDEN> writes:

> Taiju HIGASHI <higashi@HIDDEN> writes:
>
>>
>> Sorry, I didn't understand your question. Could you give me more
>> specific needs?
>>
>
> My apologies. I should be more clear.
>
> I think I saw we are using =modify-services= (somewhere in this
> thread) to configure =home-fontconfig-service-type=. But wouldn't be nice
> if user can just use =simple-service= to extend it?
>
> Like this in my guix-config:
>
> https://git.sr.ht/~declantsien/guix-config/tree/master/item/home-conf/appearance/font.scm#L30-55
> https://git.sr.ht/~declantsien/guix-config/tree/master/item/guix/gnu/home/services/fontutils.scm#L94-96
>

Thank you for detail information.
Currently, It not support.  The interface is not suitable for extension,
so we decided to forgot it.
See: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=57963#71

We have to come up with a merge strategy if we allow to extend, how
would you like to extend it?

Perhaps I am less experienced in Guix customization than you are, and
don't understand the use cases that cannot be achieved with
modify-services.

Thanks,
-- 
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 21 Oct 2022 05:02:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 21 01:02:50 2022
Received: from localhost ([127.0.0.1]:36634 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1olkBG-0001X1-5r
	for submit <at> debbugs.gnu.org; Fri, 21 Oct 2022 01:02:50 -0400
Received: from mx0.riseup.net ([198.252.153.6]:41782)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <declantsien@HIDDEN>) id 1olkBE-0001Wm-4A
 for 57963 <at> debbugs.gnu.org; Fri, 21 Oct 2022 01:02:48 -0400
Received: from fews1.riseup.net (fews1-pn.riseup.net [10.0.1.83])
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256/256 bits)
 key-exchange X25519 server-signature RSA-PSS (2048 bits) server-digest SHA256
 client-signature RSA-PSS (2048 bits) client-digest SHA256)
 (Client CN "mail.riseup.net", Issuer "R3" (not verified))
 by mx0.riseup.net (Postfix) with ESMTPS id 4Mtsm22CnZz9s4c;
 Fri, 21 Oct 2022 05:02:42 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=riseup.net; s=squak;
 t=1666328562; bh=OeExrDZyFaynVlX+ASOnPV1pvS8YLJTEVsQ0NFxcxc4=;
 h=From:To:Cc:Subject:In-Reply-To:References:Date:From;
 b=K9rd5Z6BE8in8qBntj19qm4BcV0hA3fdMTiTr2Yk5sVLW+8GyRhgkMjGXFpaaAO5X
 qljTfoGF8st9N+0bBw/apfObMTqhmgyiTwsTDJfdRUi9zIKD2RZrxcpSuQrATZZ5FP
 Hj+/RM8jvIH/3c3g0Slk8TbKJqh0qORG5fCwCKXA=
X-Riseup-User-ID: 840155BD7D1C881F3513E92CBC56BDC22E951889E68315F765B4F3159EF1F94D
Received: from [127.0.0.1] (localhost [127.0.0.1])
 by fews1.riseup.net (Postfix) with ESMTPSA id 4Mtsm14sYCz5vP3;
 Fri, 21 Oct 2022 05:02:41 +0000 (UTC)
From: Declan Tsien <declantsien@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>
Subject: Re: [bug#57963] [PATCH v5 2/2] home: services: Support user's
 fontconfig configuration.
In-Reply-To: <87ilkdbz75.fsf@HIDDEN>
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN> <875ygf3ve6.fsf@HIDDEN>
 <87ilkdbz75.fsf@HIDDEN>
Date: Fri, 21 Oct 2022 13:02:30 +0800
Message-ID: <87a65psra1.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN,
 Andrew Tropin <andrew@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain


Taiju HIGASHI <higashi@HIDDEN> writes:

>
> Sorry, I didn't understand your question. Could you give me more
> specific needs?
>

My apologies. I should be more clear.

I think I saw we are using =modify-services= (somewhere in this
thread) to configure =home-fontconfig-service-type=. But wouldn't be nice
if user can just use =simple-service= to extend it?

Like this in my guix-config:

https://git.sr.ht/~declantsien/guix-config/tree/master/item/home-conf/appearance/font.scm#L30-55
https://git.sr.ht/~declantsien/guix-config/tree/master/item/guix/gnu/home/services/fontutils.scm#L94-96

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHLBAEBCAA1FiEE9pXznsYl4IEztXWfD8aHA3Xv4vUFAmNSJ+YXHGRlY2xhbnRz
aWVuQHJpc2V1cC5uZXQACgkQD8aHA3Xv4vVMBAv/b6gpU7YoVDRrbA+bXjZcjgVf
huKi02NQJniP7Erpxziz4l0vxO8jIKRAsgVHPK+DB6LVMunNvNkn5Kkf0MKoNVX4
GU5JIkDcy8Sapm742lOCk6Vx7v+O7QxCu9wbUNfDuAmAFhVMXt3Whb4H5CUC+9Kz
nFFx55mKbmB54em5/qOXuFJbXOn/TkKbOEQcqqSBOurPzmB3Q6CdzQfl0hCRXfZn
OiYk+stvbxUktsK3p40xHQTDdLeu2V9MmDDtQUMzx0L4cRVqdjpUdX2Pqfvbad36
1ILj9X0fU5pup34ozqweRTLA7jGJhrTUtZzlvNTdTnMajLzAUEKqqg5vT4ZmcX+Z
hm8xkDek6flSQKH6Rsd7kaUBteMBVV1muWnwkvk9SzIYVix8WH8VO6hUOZIP68UB
fv9VfSHnMwLJL2trVeXaQOv4cqPTVHuUSb08MwamQ+qeeh5/wS0rsSmfa00IGTwf
LRCbpRWHjzGJEu8i2KPnXX6zkjK2+T+ha1pgPaO9
=YHGF
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 21 Oct 2022 04:03:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 21 00:03:40 2022
Received: from localhost ([127.0.0.1]:36585 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oljFz-0008R6-Pd
	for submit <at> debbugs.gnu.org; Fri, 21 Oct 2022 00:03:40 -0400
Received: from mail-pj1-f52.google.com ([209.85.216.52]:51106)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1oljFx-0008Qs-Jx
 for 57963 <at> debbugs.gnu.org; Fri, 21 Oct 2022 00:03:38 -0400
Received: by mail-pj1-f52.google.com with SMTP id h12so1356238pjk.0
 for <57963 <at> debbugs.gnu.org>; Thu, 20 Oct 2022 21:03:37 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:from:to:cc:subject:date:message-id:reply-to;
 bh=KNs7Fy2SI3HOknOACv2+qS80zKBAwpg6iiRSUUyRTQc=;
 b=t0d/hCxlLHqTv0VOzNkcZq2B5guphO5ZeH2tLazVushgL7Lpz9NnqEZlSRw9AKYY1l
 QViLgLwo/hLKPLh/8esrMdOZwlqkhhuWus1CIvuQY/DK1YccPV+0t9sXktWse21fkip4
 32cH/bvoEaKoRcnzxOJgb6SKil7cilS1kv8mRclM2FqnfHBgpRTAZjfybv6CrJTysyvT
 dbzgBje4iEmK4M4pMTnOyLKv/KqM1ERIIvI7DZPMDicA7Bn6Apzf/wE8pIVyfdv7/txo
 CA/QBiCpdcTLi5wPBuLE0mzdxFXXg1t5vH3eClcY5yvBHQR2lyC9jJO4zAPEfkl5OSky
 50hg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:x-gm-message-state:from:to:cc:subject:date
 :message-id:reply-to;
 bh=KNs7Fy2SI3HOknOACv2+qS80zKBAwpg6iiRSUUyRTQc=;
 b=aTvp0t3dC4GCv/eoSg1FLq/417tQIux5C+hCtRDWgJXxSb1yewKZqQcSbLn4ecPPTp
 sBXGTaMBwDQGEe5pavdR9yT64Nz0/6LoIxAbUfmenNI4h8t8kvex41GwX0tmzzV3RNXS
 jfOVrG8DowBAvhIUpocA+KMqPJbgBIpcs1Dx39rPzQmirrJZ63EmU7wSriM2Tvth7JhA
 KKQ7g7qYI3cvkQuMLhrzBlQJWDTenj48MhqcAcw+af0OcgY5BUpQUbHZNBo6Al2LtiMq
 /i+CX3zAdswRtJINFGJgzW/BDABNJXeyz9hgHI3H99HZMdg5QxqXAIrlCjmtQT6H3VXa
 CD8w==
X-Gm-Message-State: ACrzQf2Skq/7kZaVEvQYdzwn8+UEBj2if7XkAwYZ3m5ta1ai8a6yz002
 +I74nVURzdutFgO9u8CYvWYWwQ==
X-Google-Smtp-Source: AMsMyM5B12V+xazVrC3qS3bNS0Bw7XpUIFG94DfVBjLouexMZcy9rGeUD1ktF5iBehwtMPmjBTeIMg==
X-Received: by 2002:a17:90a:e10:b0:211:9e6a:a099 with SMTP id
 v16-20020a17090a0e1000b002119e6aa099mr8474024pje.27.1666325011409; 
 Thu, 20 Oct 2022 21:03:31 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 ch24-20020a17090af41800b001fe39bda429sm584812pjb.38.2022.10.20.21.03.28
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 20 Oct 2022 21:03:30 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Declan Tsien <declantsien@HIDDEN>
Subject: Re: [bug#57963] [PATCH v5 2/2] home: services: Support user's
 fontconfig configuration.
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN> <875ygf3ve6.fsf@HIDDEN>
Date: Fri, 21 Oct 2022 13:03:26 +0900
In-Reply-To: <875ygf3ve6.fsf@HIDDEN> (Declan Tsien's message of "Thu, 20
 Oct 2022 13:40:33 +0800")
Message-ID: <87ilkdbz75.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN,
 andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Declan Tsien <declantsien@HIDDEN> writes:

> Taiju HIGASHI <higashi@HIDDEN> writes:
>
>> @@ -59,7 +136,7 @@ (define home-fontconfig-service-type
>>                         (service-extension
>>                          home-profile-service-type
>>                          (const (list fontconfig)))))
>> -                (default-value #f)
>> +                (default-value (home-fontconfig-configuration))
>>                  (description
>>                   "Provides configuration file for fontconfig and make
>>  fc-* utilities aware of font packages installed in Guix Home's profile.")))
>> --
>> 2.37.3
>
> Do we also have support service extension here? like this.
>
> #+begin_src scheme
>   (compose identity)
>   (extend home-fontconfig-extensions)
>   (default-value (home-fontconfig-configuration))
> #+end_src
>

Sorry, I didn't understand your question. Could you give me more
specific needs?

Thanks,
-- 
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 21 Oct 2022 01:02:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 20 21:02:22 2022
Received: from localhost ([127.0.0.1]:36442 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1olgQX-0003ZD-R9
	for submit <at> debbugs.gnu.org; Thu, 20 Oct 2022 21:02:22 -0400
Received: from mail-pg1-f181.google.com ([209.85.215.181]:36463)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1olgQW-0003Z1-AQ
 for 57963 <at> debbugs.gnu.org; Thu, 20 Oct 2022 21:02:21 -0400
Received: by mail-pg1-f181.google.com with SMTP id s196so1145883pgs.3
 for <57963 <at> debbugs.gnu.org>; Thu, 20 Oct 2022 18:02:20 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:from:to:cc:subject:date:message-id:reply-to;
 bh=e8wNfGiAQ34OONuZMT/pXmwal77routaJm4E52mw5nk=;
 b=vKMwsVATo6DZ2zOR9cz3vC1rJzUM6Rfkp/HOaiku0pUXZLJDMukQ/LiVBETQmTlxN1
 DJerCXV9GIrqSfYK6j8ZpZ4hsU9tqoS5mfqfUlxydC6DrsqFLNVOjbGYTch2OPXhaPJv
 KK1CcLvDfI2WjxvYPHdSsnXEKriVh5ELBS8vKhWronOA6M4R1Y4oI2EBnYEzZuzjp2dR
 sI9pSjZaw5fE+7PeijJ4OWW4+wxB3020cOEl8bq6cRRp83f+DvrV7ibKSczf3YNAZKre
 t0QcrNNPnFkw+oxb7b5ocxLrvupsWqHkDcdflIWlS/kh2eux3bmBX5yrQXBL+g189izQ
 o73g==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:x-gm-message-state:from:to:cc:subject:date
 :message-id:reply-to;
 bh=e8wNfGiAQ34OONuZMT/pXmwal77routaJm4E52mw5nk=;
 b=8IltyURibvMXpeNURKLvyoGLxDMxi6H0WnNk+XV4Hj9enqEteSYH59biKBgq01Wry/
 fn33eLlCwCtDEbarh+y4I0j3x6ACwXggKffkuW6/hm3h9YcPIOg9/NC+gWfUBNsDDyFk
 LirFfPUVz+fY4sQ01MRNBWbkSeYX1ANZuY8EjjTF1kSBLDkYV5CZ+NWk64yKD7suPgjD
 q5zqZzJOeAAo+01nK4n5woUtEwvYq4TqcB03J7nUfpoKVEBYpCm7gkOziMaKpi7R3H6k
 7WGnH67JNlV/mFaHkMlsaa7B19r1evaTsMqCLWGy16ow/OaMSGIn251TYPeLDeCOgUk/
 tttA==
X-Gm-Message-State: ACrzQf1mwUIPYy/6uHUbhHEi0ohJJyIkY5pgU0CjzSQwo1FTdjjPglgG
 f12fhw7NaruR1y+KU5yDbw6oyg==
X-Google-Smtp-Source: AMsMyM6lnYu9AKpQMTqvQ3K2P1C4R775DLQOkdw+Fyf4k3cxMgAAt3Oo1f4ZsPnJU3f7Q9chFugmxQ==
X-Received: by 2002:a63:4e66:0:b0:456:b3a7:7a80 with SMTP id
 o38-20020a634e66000000b00456b3a77a80mr13687067pgl.467.1666314134343; 
 Thu, 20 Oct 2022 18:02:14 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 f125-20020a625183000000b005627868e27esm13967327pfb.127.2022.10.20.18.02.12
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 20 Oct 2022 18:02:13 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Declan Tsien <declantsien@HIDDEN>
Subject: Re: bug#57963: [PATCH 0/1] Support user's fontconfig.
References: <87k053sxur.fsf@HIDDEN> <87zgdzat99.fsf@HIDDEN>
 <87zgdxgx0l.fsf@HIDDEN> <875ygiqur9.fsf@HIDDEN>
 <87r0z5e23k.fsf@HIDDEN> <87czanebhd.fsf@HIDDEN>
 <87o7u7e1ai.fsf@HIDDEN> <87wn8vcm1y.fsf@HIDDEN>
 <87czan45fs.fsf@HIDDEN> <87zgdrb1lq.fsf@HIDDEN>
 <87fsfj84p0.fsf@HIDDEN>
Date: Fri, 21 Oct 2022 10:02:10 +0900
In-Reply-To: <87fsfj84p0.fsf@HIDDEN> (Declan Tsien's message of "Thu, 20
 Oct 2022 13:06:03 +0800")
Message-ID: <87r0z2at0t.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN,
 Andrew Tropin <andrew@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Declan Tsien <declantsien@HIDDEN> writes:

> Taiju HIGASHI <higashi@HIDDEN> writes:
>
>>
>> You can also configure the settings you want by specifying them in
>> extra-config.
>>
>
> Oh, nice. So my use case is covered. Didn't realize that. Nice work.
>
>>
>> I don't see clearly what the typical configuration of alias should be,
>> but I believe the current specification is sufficient for our needs.
>>
>> Do you still think it is preferable to change the default-font-* field
>> interface, even knowing that you can configure it in the extra-config
>> field?  Please give me your frank opinion :)
>>
>
> Let's stick to the current specification, no changes needed. Cheers.

OK. Thank you for your input!

Thanks,
-- 
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 20 Oct 2022 05:40:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 20 01:40:55 2022
Received: from localhost ([127.0.0.1]:60940 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1olOIZ-0001TK-4j
	for submit <at> debbugs.gnu.org; Thu, 20 Oct 2022 01:40:55 -0400
Received: from mx1.riseup.net ([198.252.153.129]:50924)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <declantsien@HIDDEN>) id 1olOIT-0001Sz-PT
 for 57963 <at> debbugs.gnu.org; Thu, 20 Oct 2022 01:40:53 -0400
Received: from fews1.riseup.net (fews1-pn.riseup.net [10.0.1.83])
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256/256 bits)
 key-exchange X25519 server-signature RSA-PSS (2048 bits) server-digest SHA256
 client-signature RSA-PSS (2048 bits) client-digest SHA256)
 (Client CN "mail.riseup.net", Issuer "R3" (not verified))
 by mx1.riseup.net (Postfix) with ESMTPS id 4MtGfN036bzDqPY;
 Thu, 20 Oct 2022 05:40:43 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=riseup.net; s=squak;
 t=1666244444; bh=BSaqwicJNxQt08mQVDp2JZDYQYlOlhE8aCRKt/3mzqs=;
 h=From:To:Cc:Subject:In-Reply-To:References:Date:From;
 b=Zm9bOe8gEjFov5cksKebLKmNRjsOmymgCpD1t3eBkLTV8UxsToC1DKitC+6hgqyVj
 8aacfg//eQBrv7gvWw1GgLbbg2hUU68kWj6p6/G+xtAZSgBs7FnZzXe228si/Awc/W
 IkSjAFrAyqyPzHbHAeIRaq1O6MiQh02V8Ie1WW3o=
X-Riseup-User-ID: 72D9E6D362E8592F93A764A74B446F59C55DE0787ED2EF67B57F14BDF236A226
Received: from [127.0.0.1] (localhost [127.0.0.1])
 by fews1.riseup.net (Postfix) with ESMTPSA id 4MtGfM2P7Lz5vTb;
 Thu, 20 Oct 2022 05:40:43 +0000 (UTC)
From: Declan Tsien <declantsien@HIDDEN>
To: 57963 <at> debbugs.gnu.org
Subject: Re: [bug#57963] [PATCH v5 2/2] home: services: Support user's
 fontconfig configuration.
In-Reply-To: <20221002131535.9972-2-higashi@HIDDEN>
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN>
Date: Thu, 20 Oct 2022 13:40:33 +0800
Message-ID: <875ygf3ve6.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, Taiju HIGASHI <higashi@HIDDEN>, liliana.prikler@HIDDEN,
 andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

Taiju HIGASHI <higashi@HIDDEN> writes:

> @@ -59,7 +136,7 @@ (define home-fontconfig-service-type
>                         (service-extension
>                          home-profile-service-type
>                          (const (list fontconfig)))))
> -                (default-value #f)
> +                (default-value (home-fontconfig-configuration))
>                  (description
>                   "Provides configuration file for fontconfig and make
>  fc-* utilities aware of font packages installed in Guix Home's profile."=
)))
> --=20
> 2.37.3

Do we also have support service extension here? like this.

#+begin_src scheme
  (compose identity)
  (extend home-fontconfig-extensions)
  (default-value (home-fontconfig-configuration))
#+end_src

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHLBAEBCAA1FiEE9pXznsYl4IEztXWfD8aHA3Xv4vUFAmNQ31EXHGRlY2xhbnRz
aWVuQHJpc2V1cC5uZXQACgkQD8aHA3Xv4vVThQwAmDBuz7kxR/ODEezsmu1hCCmf
dawNEX3fFe9IQDPt7jUrwmSKaqOzYEc/WpnRlH39wKtsI6V8meIDd0vWVFUNjdPk
tBs70y2Ip4/g7/62K8Tj9NraZZwaOq+ZFlsLofF1PlyowS6ushfKXyVc3jfG4z8V
/PSA1eO8nuGLMCal7/ADTU8ngcxbuEcEiKEk5C+txXjbktc4lKz4e6sVNcS8ScZd
xM+ZV6+7ijkyGH/OcG1iyhJ3IvQmYKBA8eIQqEC2w8Ns1q4nuN5NeLqyDvudVe5g
ccPkKulAYBOeLy25LmkYzPod5EQrlDRQOeswy9ujixwsDGsEnczKceirnwXHPHJ4
O2Fiy4ReBtxzBZ6GJFfehZStGjtMs40qVCsMtUp4LhU1b7udgk8KUTaGBJLJqTZe
vagoZxCBfB5Dfy/qcTA4EMfP/I/RFhyZKkT+majRWmB5jyi70UCQ4T9hufoGLCLt
ansqEIzsIXMfnHU98H4gIfatW6pKfMLxNR644MX8
=kR4/
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 20 Oct 2022 05:06:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 20 01:06:25 2022
Received: from localhost ([127.0.0.1]:60905 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1olNlB-0000NR-CT
	for submit <at> debbugs.gnu.org; Thu, 20 Oct 2022 01:06:25 -0400
Received: from mx0.riseup.net ([198.252.153.6]:58162)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <declantsien@HIDDEN>) id 1olNl6-0000NB-S7
 for 57963 <at> debbugs.gnu.org; Thu, 20 Oct 2022 01:06:24 -0400
Received: from fews1.riseup.net (fews1-pn.riseup.net [10.0.1.83])
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256/256 bits)
 key-exchange X25519 server-signature RSA-PSS (2048 bits) server-digest SHA256
 client-signature RSA-PSS (2048 bits) client-digest SHA256)
 (Client CN "mail.riseup.net", Issuer "R3" (not verified))
 by mx0.riseup.net (Postfix) with ESMTPS id 4MtFtZ5ZyHz9s8B;
 Thu, 20 Oct 2022 05:06:14 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=riseup.net; s=squak;
 t=1666242374; bh=pa9GfEgXhSrLV0DZkC4LlI7D7B+T09K4/t/9shk+U80=;
 h=From:To:Cc:Subject:In-Reply-To:References:Date:From;
 b=He3Ma0elnTtZu9nUYYRdVntNtuYRwK5H/TmD/V5/StGsgoCDDAbUyahk5oYOw5qtY
 ASBimWKtdzdYKbjZvJEsHnkt2v1dZwR0B2qauZYsm5LRilkqOACUm34l25Xi3hVZ4v
 Hl7XbuOJJGJppUwwE8d+dglEMLF1vWALqZlQtn3w=
X-Riseup-User-ID: 9D9AC63FD5E4E83AFDDAB6B908F01F059587D130760C26ADA0308D1BB9B94E48
Received: from [127.0.0.1] (localhost [127.0.0.1])
 by fews1.riseup.net (Postfix) with ESMTPSA id 4MtFtY6zHMz5vTb;
 Thu, 20 Oct 2022 05:06:13 +0000 (UTC)
From: Declan Tsien <declantsien@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>
Subject: Re: bug#57963: [PATCH 0/1] Support user's fontconfig.
In-Reply-To: <87zgdrb1lq.fsf@HIDDEN>
References: <87k053sxur.fsf@HIDDEN> <87zgdzat99.fsf@HIDDEN>
 <87zgdxgx0l.fsf@HIDDEN> <875ygiqur9.fsf@HIDDEN>
 <87r0z5e23k.fsf@HIDDEN> <87czanebhd.fsf@HIDDEN>
 <87o7u7e1ai.fsf@HIDDEN> <87wn8vcm1y.fsf@HIDDEN>
 <87czan45fs.fsf@HIDDEN> <87zgdrb1lq.fsf@HIDDEN>
Date: Thu, 20 Oct 2022 13:06:03 +0800
Message-ID: <87fsfj84p0.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN,
 Andrew Tropin <andrew@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain

Taiju HIGASHI <higashi@HIDDEN> writes:

>
> You can also configure the settings you want by specifying them in
> extra-config.
>

Oh, nice. So my use case is covered. Didn't realize that. Nice work.

>
> I don't see clearly what the typical configuration of alias should be,
> but I believe the current specification is sufficient for our needs.
>
> Do you still think it is preferable to change the default-font-* field
> interface, even knowing that you can configure it in the extra-config
> field?  Please give me your frank opinion :)
>

Let's stick to the current specification, no changes needed. Cheers.

Thanks

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHLBAEBCAA1FiEE9pXznsYl4IEztXWfD8aHA3Xv4vUFAmNQ1zwXHGRlY2xhbnRz
aWVuQHJpc2V1cC5uZXQACgkQD8aHA3Xv4vV9RQv9HHPzEG/6yZMeeatNNrvFXnh6
91gD4o62goMe2+QtaGAnagvMbmDumxP/7caeojKl/kZOWxjgNzXyRz6EOkUPHXZy
fctlvWbM1jpAbAugrKpTZHuk329KKvK4fuDvpkdKNgVdJ4N/xgF5O79l2LjEpYdy
oT64ZAusRv58L1S+I24KgLmZ1Gbcud3TwsuBZd4UK8nPcpDcxxb8iiITs39hTqKS
+J602JKw3hmj2Tngi4Hdt3jxz49zyoFxW5sUo2LAVDRZojh1DEk/948+YYQ787hw
OWp0+82lnPT3e6x5WgQpwJkvf5a3DRdcUUV1VLiwvlVvyqk3F5lVHpaqvDOv5E3H
ZsgiquD1AlxONt0xtiscdKtcSs3nbWIKvq9uyIEK5FXWbG+A3gpNAudr0IjtZUkR
r6vAx/fWqJUVHusOMaEaRVGr1JKvMApzUox+RxnS+F5kLaIlRteIdzNIu4MlbB7s
RgTTS5m3ZM6RDMtvom3GmES8chOMGzeIOUa2ydUG
=zNoA
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 20 Oct 2022 03:44:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 19 23:44:48 2022
Received: from localhost ([127.0.0.1]:60828 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1olMUB-0006mz-Gj
	for submit <at> debbugs.gnu.org; Wed, 19 Oct 2022 23:44:47 -0400
Received: from mail-pf1-f181.google.com ([209.85.210.181]:35677)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1olMU6-0006mi-L3
 for 57963 <at> debbugs.gnu.org; Wed, 19 Oct 2022 23:44:46 -0400
Received: by mail-pf1-f181.google.com with SMTP id y191so19133858pfb.2
 for <57963 <at> debbugs.gnu.org>; Wed, 19 Oct 2022 20:44:42 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:from:to:cc:subject:date:message-id:reply-to;
 bh=BUsUsk+f7x0KKIxOnsSbQC7JFstgMA6tF3lFQNDCzhg=;
 b=l+ThfVll8HmwxqrpUDxJIex7fyNlc8RIl+mP26TwDZckQT4BsJ6eoXbnxO7q1+ZmmJ
 2RhuKTv6EBSyRugEI3vJHkow043vOMQJFFW5VUfXh3lb1OAISnHPluv7ZlBcWVytcTSv
 IqLBAybCYfHXPEChllRSnxW/LVugVnpBAv/pLTInNWzRlCjDMnqykwZ9G+4Xd3AvsQGx
 ZjFvMvrOFNR/j3y9A+RNheCOXhKKJJnCyPU7TiFPLAt8EJG3FveZG4+9KWLpehKK0HXj
 uKUFpT3Ab/Z1MiJ4ztUJIEHFtpf+CF9tG+cgrFQlJPVHofDvOjdCNQtR4NU4R02M+MXe
 BglQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:x-gm-message-state:from:to:cc:subject:date
 :message-id:reply-to;
 bh=BUsUsk+f7x0KKIxOnsSbQC7JFstgMA6tF3lFQNDCzhg=;
 b=lPX9rAE/i+sHZ4zNBnmLB+1CCXMgZ63i3afRkplu9/t427cTQYTC+Ki/cFSFqZO6Ju
 d6AhVaErql3sXdJt3+hz/NZhtsYiTQk6DRzN/I3fOjQ+FilP4/LrqjkmYYc3kj0jTPQ8
 dEwL2xWaId4r8rXcyB6u0SMO+yb2Bw2Lf/r0due7R3x2t/cGlB69CKpgM48K0crroimK
 mtMasVMIAlPRKNXAsAwNASApB00TBjKlKTVk/8FSctv4PqdNuMClkCttxKAalIbStDL/
 obIWcSEh6Mnoy5hC7oyykkUSXpus4OVTcUZeLasLamxdZOR0skmFJG/LzoDgO3sWRFwm
 v1Pw==
X-Gm-Message-State: ACrzQf2eIVrymIBoSHtX4tS7dJh+wLONAHevjNI/MNKfJImax/LoxygH
 tH0x6BNPjnyAk0UHxR0HlU6gGw==
X-Google-Smtp-Source: AMsMyM45wanlyC1bowHXPpc1FW2xiKnZzHw4j5OMt0j0df/FKAZa4Xfxa01vZRQa/hsf/dqGSex6Zw==
X-Received: by 2002:a63:6a85:0:b0:43b:dac2:ff0b with SMTP id
 f127-20020a636a85000000b0043bdac2ff0bmr10381313pgc.234.1666237476578; 
 Wed, 19 Oct 2022 20:44:36 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 n14-20020a170902d2ce00b0017f36638010sm11603120plc.276.2022.10.19.20.44.34
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Wed, 19 Oct 2022 20:44:36 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Declan Tsien <declantsien@HIDDEN>
Subject: Re: bug#57963: [PATCH 0/1] Support user's fontconfig.
References: <87k053sxur.fsf@HIDDEN> <87zgdzat99.fsf@HIDDEN>
 <87zgdxgx0l.fsf@HIDDEN> <875ygiqur9.fsf@HIDDEN>
 <87r0z5e23k.fsf@HIDDEN> <87czanebhd.fsf@HIDDEN>
 <87o7u7e1ai.fsf@HIDDEN> <87wn8vcm1y.fsf@HIDDEN>
 <87czan45fs.fsf@HIDDEN>
Date: Thu, 20 Oct 2022 12:44:33 +0900
In-Reply-To: <87czan45fs.fsf@HIDDEN> (Declan Tsien's message of "Thu, 20
 Oct 2022 10:03:35 +0800")
Message-ID: <87zgdrb1lq.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN,
 Andrew Tropin <andrew@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Declan Tsien <declantsien@HIDDEN> writes:

> Taiju HIGASHI <higashi@HIDDEN> writes:
>
>>
>> By the way, should we be able to specify the binding attribute as well?
>>
>
> I checked the fontconfig doc.
> https://www.freedesktop.org/software/fontconfig/fontconfig-user.html
> Here is the relevant portation:
>
>> There is one special case to this rule; family names are split into
>> two bindings; strong and weak. Strong family names are given greater
>> precedence in the match than lang elements while weak family names are
>> given lower precedence than lang elements. This permits the document
>> language to drive font selection when any document specified font is
>> unavailable.
>
> I guess it's ok to ignore or set a default =strong= when serializing?
>

If you put the setting below,

--8<---------------cut here---------------start------------->8---
(home-fontconfig-configuration
  (default-font-serif-family "Noto Serif CJK JP")
  (default-font-sans-serif-family "Noto Sans Serif CJK JP")
  (default-font-monospace-family "PlemolJP Console"))
--8<---------------cut here---------------end--------------->8---

The current implementation serializes below.

--8<---------------cut here---------------start------------->8---
<!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
<fontconfig>
  <dir>~/.guix-home/profile/share/fonts</dir>
  <alias>
    <family>serif</family>
    <prefer>
      <family>Noto Serif CJK JP</family>
    </prefer>
  </alias>
  <alias>
    <family>sans-serif</family>
    <prefer>
      <family>Noto Sans Serif CJK JP</family>
    </prefer>
  </alias>
  <alias>
    <family>monospace</family>
    <prefer>
      <family>PlemolJP Console</family>
    </prefer>
  </alias>
</fontconfig>
--8<---------------cut here---------------end--------------->8---

Since the binding attribute is omitted, it would be interpreted as the
default weak.
ref: https://github.com/behdad/fontconfig/blob/5b41ded2b0ddb98a07ac86264b94403cb7a0fd82/fonts.dtd#L127-L128

I would like the default-font-* fields to cover only typical settings.
Instead, we provide extra-config field to be used for settings that are
not typical.

You can also configure the settings you want by specifying them in
extra-config.

--8<---------------cut here---------------start------------->8---
(home-fontconfig-configuration
 (extra-config
  '((alias (@ (binding "strong"))
	   (family "sans-serif")
	   (prefer
	    (family "WenQuanYi Micro Hei")
	    (family "Noto Sans")))
    (alias (@ (binding "strong"))
	   (family "monospace")
	   (prefer
	    (family "Sarasa Mono CL")
	    (family "Inconsolata")
	    (family "Noto Mono"))))))
--8<---------------cut here---------------end--------------->8---

I don't see clearly what the typical configuration of alias should be,
but I believe the current specification is sufficient for our needs.

Do you still think it is preferable to change the default-font-* field
interface, even knowing that you can configure it in the extra-config
field?  Please give me your frank opinion :)

Thanks,
-- 
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 20 Oct 2022 02:03:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 19 22:03:57 2022
Received: from localhost ([127.0.0.1]:60692 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1olKub-0004HP-HX
	for submit <at> debbugs.gnu.org; Wed, 19 Oct 2022 22:03:57 -0400
Received: from mx0.riseup.net ([198.252.153.6]:41120)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <declantsien@HIDDEN>) id 1olKuY-0004H5-Rz
 for 57963 <at> debbugs.gnu.org; Wed, 19 Oct 2022 22:03:56 -0400
Received: from fews1.riseup.net (fews1-pn.riseup.net [10.0.1.83])
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256/256 bits)
 key-exchange X25519 server-signature RSA-PSS (2048 bits) server-digest SHA256
 client-signature RSA-PSS (2048 bits) client-digest SHA256)
 (Client CN "mail.riseup.net", Issuer "R3" (not verified))
 by mx0.riseup.net (Postfix) with ESMTPS id 4Mt9r50DjSz9sZ3;
 Thu, 20 Oct 2022 02:03:49 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=riseup.net; s=squak;
 t=1666231429; bh=t89sSRde3Ct3feo2JIzdC7SbWZ9qlB5UrRB9zg10n1M=;
 h=From:To:Cc:Subject:In-Reply-To:References:Date:From;
 b=mUdxJLlPJWBhDHSRO5IkJnj0Yhnub2qTd5J0Zu0/Y5GPxD+c3eaOX1VuNFMBV35dt
 AcnkRBcPbWvc+EqLF1GofKSd3rZNUz/5XScCSJoYGt2WlH0iFh1P8zy7PeRTRTyKxb
 mUEXr7HJxVgCNIdl8apSB/Nk4pW7TGfnLf2P05gw=
X-Riseup-User-ID: F25A5E57681E2D216C09120690665ABD398C90B82BB30585598BCE422F39B9F6
Received: from [127.0.0.1] (localhost [127.0.0.1])
 by fews1.riseup.net (Postfix) with ESMTPSA id 4Mt9r22Lckz5vTb;
 Thu, 20 Oct 2022 02:03:46 +0000 (UTC)
From: Declan Tsien <declantsien@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>
Subject: Re: bug#57963: [PATCH 0/1] Support user's fontconfig.
In-Reply-To: <87wn8vcm1y.fsf@HIDDEN>
References: <87k053sxur.fsf@HIDDEN> <87zgdzat99.fsf@HIDDEN>
 <87zgdxgx0l.fsf@HIDDEN> <875ygiqur9.fsf@HIDDEN>
 <87r0z5e23k.fsf@HIDDEN> <87czanebhd.fsf@HIDDEN>
 <87o7u7e1ai.fsf@HIDDEN> <87wn8vcm1y.fsf@HIDDEN>
Date: Thu, 20 Oct 2022 10:03:35 +0800
Message-ID: <87czan45fs.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN,
 Andrew Tropin <andrew@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain


Taiju HIGASHI <higashi@HIDDEN> writes:

>
> By the way, should we be able to specify the binding attribute as well?
>

I checked the fontconfig doc.
https://www.freedesktop.org/software/fontconfig/fontconfig-user.html
Here is the relevant portation:

> There is one special case to this rule; family names are split into
> two bindings; strong and weak. Strong family names are given greater
> precedence in the match than lang elements while weak family names are
> given lower precedence than lang elements. This permits the document
> language to drive font selection when any document specified font is
> unavailable.

I guess it's ok to ignore or set a default =strong= when serializing?

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHLBAEBCAA1FiEE9pXznsYl4IEztXWfD8aHA3Xv4vUFAmNQrHcXHGRlY2xhbnRz
aWVuQHJpc2V1cC5uZXQACgkQD8aHA3Xv4vW9Tgv/YTzV9CfjNztURy7uEDXeTzHv
qEr3aFUxqB8g2fmdGKgPNTOdGjh8BHMvuEoGKJQrnQ7C5m7M81VjNioVMX1F5lFv
RYQ6lx9Vp9c0TljMKWLoPp+j0Fv2NUGd0af0sgmj6chsbY5jGt6ftbfXAMezeupU
o9cu/H3nUE5QbMNBGJwWUkNJ8ycrouajEeCrdLuAtvZ5TwJ0XLq+CSk38SnLhtGW
8J5B7mF05MclsfIwZGitYs2br/QAysOCo9MorbMPRpFG992gRRHsssYKLji6RGGq
k83n0VfFjCfDJ1dyHD1/+UkDlBFRRxCQCyo1dl2MlG5wekRM9F3ANZnyxdJo4cyh
PvoN+k50VvwYHRbuTx0ibmjQVWJWFJ6y5sb+6KzBpaeydHMN8oV1hNCjFi9bxeDL
MfkQSQDmwC1JYBQOLwhMg4gdcDRLVBmKDBwXPZuXIqbCx8qEY5EMZ26NVDRZZjUy
kP2u1roa0rgsWLBBLDIKq+hAdCcwzzsraqfuu1Kg
=5fmb
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 20 Oct 2022 01:37:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 19 21:37:43 2022
Received: from localhost ([127.0.0.1]:60662 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1olKVD-0003aL-0g
	for submit <at> debbugs.gnu.org; Wed, 19 Oct 2022 21:37:43 -0400
Received: from mail-pj1-f46.google.com ([209.85.216.46]:45046)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1olKV8-0003a4-QI
 for 57963 <at> debbugs.gnu.org; Wed, 19 Oct 2022 21:37:41 -0400
Received: by mail-pj1-f46.google.com with SMTP id
 t10-20020a17090a4e4a00b0020af4bcae10so1618090pjl.3
 for <57963 <at> debbugs.gnu.org>; Wed, 19 Oct 2022 18:37:38 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:from:to:cc:subject:date:message-id:reply-to;
 bh=Vo5WP1K/gNUnyvCIll1BqZMjF4TFOBbRYL3IuAcLRI0=;
 b=8KJsND4NkxzjYIbSJK7nQhKMukpiZ56RnJ35d9YDn8MH+B5ncAQlAkJZ7z/35FvDyd
 69O/9z0ll73Lhb8DH/nmso3wAayG8JizU/j9YlTCjb1rWBj1D3e7cygHHuOv6FOtfnWy
 eDeOgkRCZ1uWTLos5eAj/i+DiLqaD1K4EB+fytxZPqKVSwxsWH12ke7TxyZwW6IxF859
 bt5byCxVkuDkRRzYQ4SXoBjKvsTirz9thqnUJiyLTqyO/QX750URkLyJnBp4h3ulCt2h
 ZKLoNhBCPVRDnEwY4mUHwt69yhSRoxjCv3gH9304yq+ZiucMWksh2lTxu/7RIM5Lc10M
 HrWg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:x-gm-message-state:from:to:cc:subject:date
 :message-id:reply-to;
 bh=Vo5WP1K/gNUnyvCIll1BqZMjF4TFOBbRYL3IuAcLRI0=;
 b=KWEyp8hyLMnq/PNRXlvT+ZupZ3YIbilh3/KU/kFLq3TRePeGPuNrCJ3lK6a78IOxAt
 RZ+CdlahWmCCGQMcw4je4XCaMwnBzy1lixIKUqtl2HLgba/7jgxLGuJTXej0/bCaCx4A
 gAHRAPw1rUpJzLl7KIXm0DoP1/Xe4qc4z+r5adMYVthXafN54A0RgnDtkYcJtQYym4+U
 ArgcxS+k77dUIGoimLZScta10V+NEuT8zLO2uOUuWSUbOviv8+z9ddM3aO3bjurOl8W0
 rZwjHTrdJL+M+fbfiwlLD5z+yUGNh+cQ4R3EmnPmYTamepIa91Hf06vhT5Y3tXo3S49y
 gN1w==
X-Gm-Message-State: ACrzQf3gNfOBN5ZjG14Wppzc/4aamhZFoxBkkpZQf52A2xnyPu29MJ9D
 Yqrl83ltRChBhRrEJbgVgTWMuw==
X-Google-Smtp-Source: AMsMyM4qi4cUJ7X/XpM9nS5M1u7qKUISTn0IR5Xwpxumq5VjMHVxA9otgETmpnHw6VjmgdOLTJUd2Q==
X-Received: by 2002:a17:90b:19d0:b0:20b:1d66:8a17 with SMTP id
 nm16-20020a17090b19d000b0020b1d668a17mr13341675pjb.2.1666229852833; 
 Wed, 19 Oct 2022 18:37:32 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 r27-20020aa79edb000000b005403b8f4bacsm11886425pfq.137.2022.10.19.18.37.31
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Wed, 19 Oct 2022 18:37:32 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Declan Tsien <declantsien@HIDDEN>
Subject: Re: bug#57963: [PATCH 0/1] Support user's fontconfig.
References: <87k053sxur.fsf@HIDDEN> <87zgdzat99.fsf@HIDDEN>
 <87zgdxgx0l.fsf@HIDDEN> <875ygiqur9.fsf@HIDDEN>
 <87r0z5e23k.fsf@HIDDEN> <87czanebhd.fsf@HIDDEN>
 <87o7u7e1ai.fsf@HIDDEN>
Date: Thu, 20 Oct 2022 10:37:29 +0900
In-Reply-To: <87o7u7e1ai.fsf@HIDDEN> (Declan Tsien's message of "Thu, 20
 Oct 2022 09:23:01 +0800")
Message-ID: <87wn8vcm1y.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN,
 Andrew Tropin <andrew@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Declan,

Declan Tsien <declantsien@HIDDEN> writes:

> Taiju HIGASHI <higashi@HIDDEN> writes:
>
>>                     (default-font-serif-family "Noto Serif CJK JP")
>>                     (default-font-sans-serif-family "Noto Sans Serif CJK JP")
>>                     (default-font-monospace-family "PlemolJP Console")
>
> Does this take a list as value? Because I have specified some fallback fonts in my configuration.
> I directly use sxml to serialize the config file right now. Below is a portion of it.
>
> It would be great if I could use this home-service without writing extra sxml code once it gets merged.
>
> #+begin_src scheme
>   (alias (@ (binding "strong"))
> 	 (family "sans-serif")
> 	 (prefer
> 	  (family "WenQuanYi Micro Hei")
> 	  (family "Noto Sans")))
>
>   (alias (@ (binding "strong"))
> 	 (family "monospace")
> 	 (prefer
> 	  (family "Sarasa Mono CL")
> 	  (family "Inconsolata")
> 	  (family "Noto Mono")))
> #+end_src
>

That makes sense.
I thought that being able to specify one preferred font would be
sufficient, but since actual fontconfig allows multiple specification, I
thought it would certainly be better to be able to specify more than one
in this setting as well.
By the way, should we be able to specify the binding attribute as well?

Best Regards,
-- 
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 20 Oct 2022 01:23:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 19 21:23:27 2022
Received: from localhost ([127.0.0.1]:60641 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1olKHO-0003EA-Mm
	for submit <at> debbugs.gnu.org; Wed, 19 Oct 2022 21:23:27 -0400
Received: from mx0.riseup.net ([198.252.153.6]:43192)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <declantsien@HIDDEN>) id 1olKHH-0003Dp-8H
 for 57963 <at> debbugs.gnu.org; Wed, 19 Oct 2022 21:23:26 -0400
Received: from fews1.riseup.net (fews1-pn.riseup.net [10.0.1.83])
 (using TLSv1.3 with cipher TLS_AES_256_GCM_SHA384 (256/256 bits)
 key-exchange X25519 server-signature RSA-PSS (2048 bits) server-digest SHA256
 client-signature RSA-PSS (2048 bits) client-digest SHA256)
 (Client CN "mail.riseup.net", Issuer "R3" (not verified))
 by mx0.riseup.net (Postfix) with ESMTPS id 4Mt8xF1BWNz9snQ;
 Thu, 20 Oct 2022 01:23:13 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=riseup.net; s=squak;
 t=1666228993; bh=xVLrg0Rsf7gBMJT74xxNRzEqCHrOBevBXlR7fhk/kWw=;
 h=From:To:Cc:Subject:In-Reply-To:References:Date:From;
 b=V1p3bI/WRSFrRvBLHfollHQyRDVm5XYcWEjfMi2r45ktT/YUlYPXvPoWfdSjgB1/a
 TFyAFzjE6z1zx2QJMqfvwpkKDFDwemkpa0c3vC96oMp0d6sQMXPzXTmOqNIxzJMNwF
 mh9GYOq0r+lnSyv3xCWMMCVJlKlN5plgNCXPsTGE=
X-Riseup-User-ID: 3DF7B43BD2009CBC51260ADDB58B842E598B19446AE874C965E5493835D99A6E
Received: from [127.0.0.1] (localhost [127.0.0.1])
 by fews1.riseup.net (Postfix) with ESMTPSA id 4Mt8xD2sx6z5w5f;
 Thu, 20 Oct 2022 01:23:12 +0000 (UTC)
From: Declan Tsien <declantsien@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>
Subject: Re: bug#57963: [PATCH 0/1] Support user's fontconfig.
In-Reply-To: <87czanebhd.fsf@HIDDEN> (Taiju HIGASHI's message of "Thu, 20
 Oct 2022 06:42:54 +0900")
References: <87k053sxur.fsf@HIDDEN> <87zgdzat99.fsf@HIDDEN>
 <87zgdxgx0l.fsf@HIDDEN> <875ygiqur9.fsf@HIDDEN>
 <87r0z5e23k.fsf@HIDDEN> <87czanebhd.fsf@HIDDEN>
Date: Thu, 20 Oct 2022 09:23:01 +0800
Message-ID: <87o7u7e1ai.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN,
 Andrew Tropin <andrew@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain


Taiju HIGASHI <higashi@HIDDEN> writes:

>                     (default-font-serif-family "Noto Serif CJK JP")
>                     (default-font-sans-serif-family "Noto Sans Serif CJK JP")
>                     (default-font-monospace-family "PlemolJP Console")

Does this take a list as value? Because I have specified some fallback fonts in my configuration.
I directly use sxml to serialize the config file right now. Below is a portion of it.

It would be great if I could use this home-service without writing extra sxml code once it gets merged.

#+begin_src scheme
  (alias (@ (binding "strong"))
	 (family "sans-serif")
	 (prefer
	  (family "WenQuanYi Micro Hei")
	  (family "Noto Sans")))

  (alias (@ (binding "strong"))
	 (family "monospace")
	 (prefer
	  (family "Sarasa Mono CL")
	  (family "Inconsolata")
	  (family "Noto Mono")))
#+end_src

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQHLBAEBCAA1FiEE9pXznsYl4IEztXWfD8aHA3Xv4vUFAmNQovUXHGRlY2xhbnRz
aWVuQHJpc2V1cC5uZXQACgkQD8aHA3Xv4vUbVgv/U1xHJ6dMuyZc0T1O0uV5mSNr
9KndwGd3BiOJndmNyFvriePC6fnKJIkdbzL8Ts1B/gUHDGbeeGp+rUkXdpXqRUUb
ZNLrB+CzSoI+ezLaZz6RClFX8BqjTwXxu2Gr9xuCPv9kw7SSwGBSeS84BwHfdHBU
JR6jQh4ECb+XS3T4FavvQJNSklAp2gPvCNe8Pzi5JsrQCUzNR53cptfZqLQyw553
7i4e+7y/Hr9Y2nOje8aAiIbkn8MvwhVfNdwWbE4J5MElFPcvNqNvAA+1Dsc9e7tY
qX7UHVqhCllPXzpfdY5rWU2LgWd+WmPw9+UrdC2ytl2bLvtCCyeFgh8oSSm+OeZE
9BJ1GBVz3c3zT1txeB6w1dGjQFlBcDTZcgkKZArFTJ0+WoN52W9zGfqu1DgEFKPp
fPmqTqUOeOhGt4lnm4ZcbcOI/7BVZeUMoLr/CRJNZyXE5jk596gofWjxvZSJcJcP
FH/BOO2cSYcU+1jUCO3xm4+lWFeXK6239Ri3RUqM
=siHZ
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 19 Oct 2022 21:43:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 19 17:43:07 2022
Received: from localhost ([127.0.0.1]:60342 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1olGqB-00065m-Aw
	for submit <at> debbugs.gnu.org; Wed, 19 Oct 2022 17:43:07 -0400
Received: from mail-pj1-f51.google.com ([209.85.216.51]:38467)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1olGq8-00065F-0B
 for 57963 <at> debbugs.gnu.org; Wed, 19 Oct 2022 17:43:05 -0400
Received: by mail-pj1-f51.google.com with SMTP id
 x1-20020a17090ab00100b001fda21bbc90so1415414pjq.3
 for <57963 <at> debbugs.gnu.org>; Wed, 19 Oct 2022 14:43:03 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:from:to:cc:subject
 :date:message-id:reply-to;
 bh=PBt6NNu370LE2hoa4egU1qFcz9IOeYi0kVik7iOLTsc=;
 b=MCafOlLHZN7eXailGomE7F4LkyWyhMPUkgXt05vVPbsdHzhu2EnOEaSH+/Q51mdJUu
 ANVfUo0XK2v3w1cVxN/ssyvsNNzHSWHfP3aZ+pgUp65SUQF1eaPT0fTqfHfX12QGrO5P
 Uk2BV2L3qACUKD6XPqVh+D6xHj3wy1BQuMuoaeygsBKMZReCa7Siz0SRUHI1pcrSymWc
 4RdyjrQ6b62x2XQW/xrvr4klDmU1fbCM0UhEJBrPN2ru2d1xrIhb3vR+MOWyP1oCa9Rp
 1vCQ7yPnBoRSBU5U6juKzumwYDBg2sJdK5usvCZ3JVZMfaxw11LbG1qzqdzNL7+LgXtZ
 65fg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:x-gm-message-state
 :from:to:cc:subject:date:message-id:reply-to;
 bh=PBt6NNu370LE2hoa4egU1qFcz9IOeYi0kVik7iOLTsc=;
 b=JKAnTyZwW7L6thUcBN5L+O7OFnUIy+O0nAKvwv++VXs6XlvKkV8fnTHg8qWKSS4fBb
 lR8Hkr5EFnhNh4Hx7Keh6KJ1yYSNU9V48aVLJ157qSPvGh37ULLCzVSZQu+0FImZpi6+
 0ezzo/CEBcyAse1oGj1Go2D6W26sM+t+49BPILNaLS4pxef1Z7pCFH7eFDhC0UQ7mCQ8
 5TgoXqjh0qxQ8dz9sZULT/aoPKllXxcxJ7Pj7ZNLM1qEI11Kcfh03HmxvstW+Nm6MnHS
 MuGwNDCvLOLHSspkYNNqdQQA07tYqBdUCf3YcPnZEwjw7gNalalAyCOMwHIiEaEFNt6s
 b9Eg==
X-Gm-Message-State: ACrzQf0OarqSvTnXKLmzBalDtMlTWBWOdDAUlMxjY9vOFfYJk8IuX8ZM
 r4mTsnDA0/JgqsEQJcN+ylaOCg==
X-Google-Smtp-Source: AMsMyM6faeiMTozER6W2CkxDQ9lOyjfDwk901x8anWoEWHWi54+8mr30gTYU7Mn8e1dh+xJyflo/vg==
X-Received: by 2002:a17:90b:4b8b:b0:20d:ac2f:8bb2 with SMTP id
 lr11-20020a17090b4b8b00b0020dac2f8bb2mr38439524pjb.194.1666215777898; 
 Wed, 19 Oct 2022 14:42:57 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 b5-20020a170902650500b00179f442519csm11240152plk.40.2022.10.19.14.42.55
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Wed, 19 Oct 2022 14:42:57 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Ludovic =?iso-8859-1?Q?Court=E8s?= <ludo@HIDDEN>
Subject: Re: [bug#57963] [PATCH v5 2/2] home: services: Support user's
 fontconfig configuration.
References: <87k053sxur.fsf@HIDDEN> <87zgdzat99.fsf@HIDDEN>
 <87zgdxgx0l.fsf@HIDDEN> <875ygiqur9.fsf@HIDDEN>
 <87r0z5e23k.fsf@HIDDEN>
Date: Thu, 20 Oct 2022 06:42:54 +0900
In-Reply-To: <87r0z5e23k.fsf@HIDDEN> (Taiju HIGASHI's message of "Tue, 18
 Oct 2022 21:41:03 +0900")
Message-ID: <87czanebhd.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN,
 Andrew Tropin <andrew@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Taiju HIGASHI <higashi@HIDDEN> writes:

> Hi,
>
> Ludovic Court=C3=A8s <ludo@HIDDEN> writes:
>
>> Hi,
>>
>> Taiju HIGASHI <higashi@HIDDEN> skribis:
>>
>>> Andrew Tropin <andrew@HIDDEN> writes:
>>
>> [...]
>>
>>>>> Andrew Tropin <andrew@HIDDEN> skribis:
>>>>>
>>>>>> If serialization would support G-exps, we could write
>>>>>>
>>>>>> (list #~"RAW_XML_HERE")
>>>>>
>>>>> There=E2=80=99s a one-to-one lossless mapping between XML and SXML, s=
o I don=E2=80=99t
>>>>> think it makes sense to support XML-in-strings when we have SXML.
>>>>>
>>>>> The only thing it would give us, as I see it, is the ability to gener=
ate
>>>>> syntactically-invalid XML.  Maybe we can live without it?  :-)
>>>>
>>>> Of course we can :), but we won't be able:
>>>>
>>>> 1. To take already existing xml config and use it without rewriting.
>>>
>>> I find it surprisingly important to be able to simply copy and paste
>>> settings without having to rewrite existing settings or those listed on
>>> a web page somewhere.  I know we can easily convert from XML to SXML,
>>> but those unfamiliar with SXML may find it a bothering task.
>>
>> OK, that makes sense.
>>
>> But then, let=E2=80=99s not allow users to intersperse XML-in-strings in=
 the
>> middle of XML.  It should be either a user-provided file/string or the
>> generated config, but not a mixture of both; that=E2=80=99d be a recipe =
for
>> confusion.
>>
>> How about this: the service takes either a <fontconfig-configuration>
>> record or a file-like object?
>>
>> (We can even have a =E2=80=9Cgexp compiler=E2=80=9D for <fontconfig-conf=
iguration> to
>> make that transparent.)
>
> Thank you for your consideration.
>
> That idea sounds good.  I don't know if I can successfully implement
> this, but I will consider it and give it a try.
>
> Thanks,

I'm trying to implement the following, is it consistent with the intent
of what you suggested?

--8<---------------cut here---------------start------------->8---
(define (add-fontconfig-config-file user-config)
  `(("fontconfig/fonts.conf"
     ,(if (home-fontconfig-configuration? user-config)
          (mixed-text-file
           "fonts.conf"
           "<?xml version=3D'1.0'?>
<!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
<fontconfig>"
           (serialize-configuration user-config home-fontconfig-configurati=
on-fields)
           "</fontconfig>\n")
          user-config))))
--8<---------------cut here---------------end--------------->8---

It is assumed that configurations can be specified in one of the
following ways.

* fontconfig-configuration:

--8<---------------cut here---------------start------------->8---
(home-environment
 (packages (list font-google-noto))
 (services
  (append
      (list
       (service home-bash-service-type))
      (modify-services %home-base-services
        (home-fontconfig-service-type
         config =3D> (home-fontconfig-configuration
                    (font-directories
                     (cons* "~/fonts" %home-fontconfig-base-font-directorie=
s))
                    (default-font-serif-family "Noto Serif CJK JP")
                    (default-font-sans-serif-family "Noto Sans Serif CJK JP=
")
                    (default-font-monospace-family "PlemolJP Console")
                    (extra-config
                     '(foo "bar"))))))))
--8<---------------cut here---------------end--------------->8---

Note:
%home-fontconfig-base-font-directories is the new variable I plan to
export as the default value, based on Andrew's and Liliana's point.

* file-like objects:

--8<---------------cut here---------------start------------->8---
(home-environment
 (packages (list font-google-noto))
 (services
  (append
      (list
       (service home-bash-service-type))
      (modify-services %home-base-services
        (home-fontconfig-service-type
         config =3D> (local-file "/path/to/your/fonts.conf"))))))
--8<---------------cut here---------------end--------------->8---

Thanks,
--=20
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 18 Oct 2022 12:41:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 18 08:41:16 2022
Received: from localhost ([127.0.0.1]:51471 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1okluF-0000kk-OP
	for submit <at> debbugs.gnu.org; Tue, 18 Oct 2022 08:41:16 -0400
Received: from mail-pf1-f181.google.com ([209.85.210.181]:36856)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1okluC-0000kW-V9
 for 57963 <at> debbugs.gnu.org; Tue, 18 Oct 2022 08:41:14 -0400
Received: by mail-pf1-f181.google.com with SMTP id y1so13959339pfr.3
 for <57963 <at> debbugs.gnu.org>; Tue, 18 Oct 2022 05:41:12 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:from:to:cc:subject
 :date:message-id:reply-to;
 bh=55XA5CqRqnIECBSi6ne6Wdv40ry76SnE/Yw1LA6yyF4=;
 b=UsxkS0HGeOJ0cNBxMeUT1PP1Q69+NlNYTvJ6xe03kX0E61Axpb4dCC5DrGRnyarYYb
 O2Vb8eUQERUsfqWkUQmx8IsLns+0VQAnQRo2lsPk8hqBQEzIKQxL3DigBHX2mZ0w2H42
 I3qntAJ5uaXAzUiRaWvX+X6h559niSFnSaNKUoCRSumARHgYgRzsoIJz0HuPc0njISpA
 WjZIt2v0VYOjABQu++ho/R7lywgBH0O2+kJE7M82qn+Qey+VEArDkuhCetMVp1JhUU7M
 tFUiidlHOp7Y1FtPDdM8BsFxRLkGcQCL1xVYE2lWukIF6ohczsaWB+Ku629suz6V1Lv2
 zcbg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:x-gm-message-state
 :from:to:cc:subject:date:message-id:reply-to;
 bh=55XA5CqRqnIECBSi6ne6Wdv40ry76SnE/Yw1LA6yyF4=;
 b=np972WrK2A38/SXvukCyso2PKNELMNlDcyWwvYs4xn8s3scOG+TOxnNFw07dyaJcV4
 flAg0oMbRd9J3uBNj+aTFeLJKC19mXqHU7pmuLCHnvSatBsuEwD1IokmXjAFxnR5ybcc
 72cBj05SD7lQlbR20wgVIF1FaS00mdIvGpyETfhjgCMDc5VWI8ktlCvKy2uAWCC4Y5EE
 CGOK/cCeHHl/ioXEHf+VY5umH9Vz31aPd4Cp0m1cLeNvhpUfpMVi3XBSOF4/vL3eMVK3
 +YgFTS7sfXzhCig7pAngkvnL8GoCCEBc5uCt/BPQfPwFStiRlqS40NwGyys8kqtniab8
 28ww==
X-Gm-Message-State: ACrzQf23GZvyEMu+IUvwnUy+BOwhHSny5WtNAVBBQMzM8bZhJmCV/xTA
 6zFGs2dZ2Gf9ZEq2J+eSYuBjaA==
X-Google-Smtp-Source: AMsMyM6A40ncOwQDAvWlg0ph4z4PK4CWZ1tAcVMMBt0supFox6pYWECfFUcS9rNLWGWC/EVTtO+EEg==
X-Received: by 2002:a63:5a0c:0:b0:46a:fcba:862c with SMTP id
 o12-20020a635a0c000000b0046afcba862cmr2469805pgb.187.1666096867040; 
 Tue, 18 Oct 2022 05:41:07 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 h16-20020a170902f55000b001755ac7dd0asm8761810plf.290.2022.10.18.05.41.05
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Tue, 18 Oct 2022 05:41:06 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Ludovic =?iso-8859-1?Q?Court=E8s?= <ludo@HIDDEN>
Subject: Re: [bug#57963] [PATCH v5 2/2] home: services: Support user's
 fontconfig configuration.
References: <87k053sxur.fsf@HIDDEN> <87zgdzat99.fsf@HIDDEN>
 <87zgdxgx0l.fsf@HIDDEN> <875ygiqur9.fsf@HIDDEN>
Date: Tue, 18 Oct 2022 21:41:03 +0900
In-Reply-To: <875ygiqur9.fsf@HIDDEN> ("Ludovic =?iso-8859-1?Q?Court=E8s?=
 =?iso-8859-1?Q?=22's?= message of "Mon, 17
 Oct 2022 18:28:58 +0200")
Message-ID: <87r0z5e23k.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN,
 Andrew Tropin <andrew@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi,

Ludovic Court=C3=A8s <ludo@HIDDEN> writes:

> Hi,
>
> Taiju HIGASHI <higashi@HIDDEN> skribis:
>
>> Andrew Tropin <andrew@HIDDEN> writes:
>
> [...]
>
>>>> Andrew Tropin <andrew@HIDDEN> skribis:
>>>>
>>>>> If serialization would support G-exps, we could write
>>>>>
>>>>> (list #~"RAW_XML_HERE")
>>>>
>>>> There=E2=80=99s a one-to-one lossless mapping between XML and SXML, so=
 I don=E2=80=99t
>>>> think it makes sense to support XML-in-strings when we have SXML.
>>>>
>>>> The only thing it would give us, as I see it, is the ability to genera=
te
>>>> syntactically-invalid XML.  Maybe we can live without it?  :-)
>>>
>>> Of course we can :), but we won't be able:
>>>
>>> 1. To take already existing xml config and use it without rewriting.
>>
>> I find it surprisingly important to be able to simply copy and paste
>> settings without having to rewrite existing settings or those listed on
>> a web page somewhere.  I know we can easily convert from XML to SXML,
>> but those unfamiliar with SXML may find it a bothering task.
>
> OK, that makes sense.
>
> But then, let=E2=80=99s not allow users to intersperse XML-in-strings in =
the
> middle of XML.  It should be either a user-provided file/string or the
> generated config, but not a mixture of both; that=E2=80=99d be a recipe f=
or
> confusion.
>
> How about this: the service takes either a <fontconfig-configuration>
> record or a file-like object?
>
> (We can even have a =E2=80=9Cgexp compiler=E2=80=9D for <fontconfig-confi=
guration> to
> make that transparent.)

Thank you for your consideration.

That idea sounds good.  I don't know if I can successfully implement
this, but I will consider it and give it a try.

Thanks,
--=20
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 17 Oct 2022 16:29:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 17 12:29:12 2022
Received: from localhost ([127.0.0.1]:49720 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1okSzI-0005QY-DK
	for submit <at> debbugs.gnu.org; Mon, 17 Oct 2022 12:29:12 -0400
Received: from eggs.gnu.org ([209.51.188.92]:48982)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1okSzG-0005QJ-47
 for 57963 <at> debbugs.gnu.org; Mon, 17 Oct 2022 12:29:10 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:44444)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ludo@HIDDEN>)
 id 1okSzA-0007ux-8A; Mon, 17 Oct 2022 12:29:04 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-Version:In-Reply-To:Date:References:Subject:To:
 From; bh=AnEdja1o4zzTxK5C6FMciPz0kxPs+/eSBYG+iRpPvVo=; b=RBcG2CDXQcuogJoiSGj4
 f8tjchtRcakGYc9EBiiqIetbnGCmzyORwlxJpOsF2WVY/es2dZ10j5YbqbxPo9j1Wut/AbOPjL8RU
 VPZWbM0rBPO19nNWtfUkNxSQFwrSXmK7pnxdd4mdMappUWbLECPpPLSyYZQkC2Nyv9VL6R29x7bNF
 QLmkkHgm/LxnKscrh8O1lWGcn3DIjoaEQ8FHEudoWOyiAHGXyfa8QAdMuhY7uL6alNRqrRaUf7nF0
 lFejBP1L4CvgXvkNhTXPl/2vIVYjYBw6jKf0mBLmtagAevx4DY1LrWPZakHOqoPg3Acjq+PGYiEaj
 yqr6ZhV7JMvYww==;
Received: from [193.50.110.209] (port=34820 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ludo@HIDDEN>)
 id 1okSz6-0000iK-DF; Mon, 17 Oct 2022 12:29:03 -0400
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>
Subject: Re: [bug#57963] [PATCH v5 2/2] home: services: Support user's
 fontconfig configuration.
References: <87k053sxur.fsf@HIDDEN> <87zgdzat99.fsf@HIDDEN>
 <87zgdxgx0l.fsf@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: Sextidi 26 =?utf-8?Q?Vend=C3=A9miaire?= an 231 de la
 =?utf-8?Q?R=C3=A9volution=2C?= jour de l'Aubergine
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Mon, 17 Oct 2022 18:28:58 +0200
In-Reply-To: <87zgdxgx0l.fsf@HIDDEN> (Taiju HIGASHI's message of "Sat, 15
 Oct 2022 20:13:30 +0900")
Message-ID: <875ygiqur9.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN,
 Andrew Tropin <andrew@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi,

Taiju HIGASHI <higashi@HIDDEN> skribis:

> Andrew Tropin <andrew@HIDDEN> writes:

[...]

>>> Andrew Tropin <andrew@HIDDEN> skribis:
>>>
>>>> If serialization would support G-exps, we could write
>>>>
>>>> (list #~"RAW_XML_HERE")
>>>
>>> There=E2=80=99s a one-to-one lossless mapping between XML and SXML, so =
I don=E2=80=99t
>>> think it makes sense to support XML-in-strings when we have SXML.
>>>
>>> The only thing it would give us, as I see it, is the ability to generate
>>> syntactically-invalid XML.  Maybe we can live without it?  :-)
>>
>> Of course we can :), but we won't be able:
>>
>> 1. To take already existing xml config and use it without rewriting.
>
> I find it surprisingly important to be able to simply copy and paste
> settings without having to rewrite existing settings or those listed on
> a web page somewhere.  I know we can easily convert from XML to SXML,
> but those unfamiliar with SXML may find it a bothering task.

OK, that makes sense.

But then, let=E2=80=99s not allow users to intersperse XML-in-strings in the
middle of XML.  It should be either a user-provided file/string or the
generated config, but not a mixture of both; that=E2=80=99d be a recipe for
confusion.

How about this: the service takes either a <fontconfig-configuration>
record or a file-like object?

(We can even have a =E2=80=9Cgexp compiler=E2=80=9D for <fontconfig-configu=
ration> to
make that transparent.)

Thanks,
Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 15 Oct 2022 11:13:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 15 07:13:41 2022
Received: from localhost ([127.0.0.1]:39608 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ojf6r-0000kB-DK
	for submit <at> debbugs.gnu.org; Sat, 15 Oct 2022 07:13:41 -0400
Received: from mail-pg1-f182.google.com ([209.85.215.182]:44970)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1ojf6o-0000jx-JI
 for 57963 <at> debbugs.gnu.org; Sat, 15 Oct 2022 07:13:40 -0400
Received: by mail-pg1-f182.google.com with SMTP id q1so6458005pgl.11
 for <57963 <at> debbugs.gnu.org>; Sat, 15 Oct 2022 04:13:38 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:from:to:cc:subject
 :date:message-id:reply-to;
 bh=LDwuv9EragTq+nhen6UdZC8gqtqkospy8yYgOJSttDY=;
 b=57WgIbDXGPkmGH5JzkQAx/9C8RlFas/ckBnHAVAt3ZE1V4CTmm9FgbK1JWdl+tmCAY
 5bUqOLMGfBib7zVQ9E//IvlMoscZdksOgOBD5gFEU/dyK8dbByjEdMqARcNlaaEU3jG7
 +UHl6hQF6eCd59PI2QNFQdXSbi00fK8uQJxcM0cke0PnYMvXEh7ygIFQUudXHn37zu1q
 6HL9xd0qJk43VOcTgHgut5AYW5ndouTA7uOuSZ9k8+E/0r1zxopSOkKmMWDMz/k4oFq5
 Ikic0dw9KoKb7UWoRoQN8mOvl1AVANr4yMLWNETSn7XFRsiDRRqMsTxCxNPjUQeql7qe
 BIRA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:x-gm-message-state
 :from:to:cc:subject:date:message-id:reply-to;
 bh=LDwuv9EragTq+nhen6UdZC8gqtqkospy8yYgOJSttDY=;
 b=2Wca1Gjm4W4R3biEMbxsQhiAQZ8/rR3WGzt6fLaO12IKjkbz3YsOinh5WSLKjCcdDr
 rg7y76/81HWe8rkN2z1h+t9496EAdTZO72bmJrS8GKJ7fQiMAG27ryLybZPxYplJAO2p
 KCMcvMybiJNQrvJSvZz9sObq6T4rvWkiKqTcMnbXvSPNUjhq0kZcmelcVYSWG0taQXOV
 LIVlKcoBipQc7/615mIWRpYqIHQFkgedQEKdrqtx+pJ1g2exNbD3rTpuOObu9ifsJy/8
 tMa+OF3CN32CzJt174xS2GkebokWiP5i6rAFae88VJQH4YIxzG/aCL0r5+qUUqECdNlO
 SnHQ==
X-Gm-Message-State: ACrzQf2LOujxXKKO+khe2UwB/xAr7F/55+bLEHlLdFcxfSk6tWUltaHI
 2AqR1IPZfFjvX1aMhI3U+JowLg==
X-Google-Smtp-Source: AMsMyM4NEsZly9MB69dR6zCMhZEAi6cdn7BbgiIq1LD3/rLX3bkOVMIcm/NaOAgsIXA9mpiYE7juQQ==
X-Received: by 2002:a63:f47:0:b0:46a:e00c:24c7 with SMTP id
 7-20020a630f47000000b0046ae00c24c7mr2185264pgp.239.1665832412747; 
 Sat, 15 Oct 2022 04:13:32 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 l10-20020a170903244a00b0017f637b3e87sm3166821pls.279.2022.10.15.04.13.30
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 15 Oct 2022 04:13:32 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Andrew Tropin <andrew@HIDDEN>
Subject: Re: [bug#57963] [PATCH v5 2/2] home: services: Support user's
 fontconfig configuration.
References: <87k053sxur.fsf@HIDDEN> <87zgdzat99.fsf@HIDDEN>
Date: Sat, 15 Oct 2022 20:13:30 +0900
In-Reply-To: <87zgdzat99.fsf@HIDDEN> (Andrew Tropin's message of "Fri, 14 Oct
 2022 09:06:42 +0400")
Message-ID: <87zgdxgx0l.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: Ludovic =?iso-8859-1?Q?Court=E8s?= <ludo@HIDDEN>, 57963 <at> debbugs.gnu.org,
 liliana.prikler@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Andrew Tropin <andrew@HIDDEN> writes:

> On 2022-10-13 14:37, Ludovic Court=C3=A8s wrote:
>
>> Hello,
>>
>> Andrew Tropin <andrew@HIDDEN> skribis:
>>
>>> If serialization would support G-exps, we could write
>>>
>>> (list #~"RAW_XML_HERE")
>>
>> There=E2=80=99s a one-to-one lossless mapping between XML and SXML, so I=
 don=E2=80=99t
>> think it makes sense to support XML-in-strings when we have SXML.
>>
>> The only thing it would give us, as I see it, is the ability to generate
>> syntactically-invalid XML.  Maybe we can live without it?  :-)
>
> Of course we can :), but we won't be able:
>
> 1. To take already existing xml config and use it without rewriting.

I find it surprisingly important to be able to simply copy and paste
settings without having to rewrite existing settings or those listed on
a web page somewhere.  I know we can easily convert from XML to SXML,
but those unfamiliar with SXML may find it a bothering task.

> 2. Use full path to gnu store of file-like objects.

Thanks,
--=20
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 14 Oct 2022 05:07:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 14 01:07:02 2022
Received: from localhost ([127.0.0.1]:35501 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ojCuQ-0002mn-RW
	for submit <at> debbugs.gnu.org; Fri, 14 Oct 2022 01:07:02 -0400
Received: from relay4-d.mail.gandi.net ([217.70.183.196]:59935)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <andrew@HIDDEN>) id 1ojCuL-0002mQ-6f
 for 57963 <at> debbugs.gnu.org; Fri, 14 Oct 2022 01:06:57 -0400
Received: (Authenticated sender: andrew@HIDDEN)
 by mail.gandi.net (Postfix) with ESMTPSA id AC091E0004;
 Fri, 14 Oct 2022 05:06:45 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=trop.in; s=gm1;
 t=1665724007;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:cc:mime-version:mime-version:content-type:content-type:
 in-reply-to:in-reply-to:references:references;
 bh=MweB1kpcnLZa8XEQAd+DFG2JzCMB750Rf/Nt1Kijw68=;
 b=Y+mhEKWp0TzMl5hCTOUyTMjCbAeCrlLrl+7t2/aQsTfidrPlVE42p9jyA9aRbonsiz8xPQ
 fBma9GuWQJ3QphsW+2Qhc+UIqhOF8/y1z4LDAOWkZN1xDJ7sb/UlZ/sr6CQIR9KGSj4Zha
 7zhXP20uxszkBUFsCStTBV3wdH+lQb2CELbyiq9yWYjmPCda3d8QFI9u1xg4UzthIgQcKs
 MwZRRS/PMS9JOjh7ZPH/hYkM2QCVPD6cQhLZ7QBb75f6Wegz4PubbVrLjqseKpJyCSJae9
 KDQPUNSZt95JoE8AxcRFUe2HP0ANg9Pzemmbq7ZGCfKXkLByrMPI1z6wqGjaJw==
From: Andrew Tropin <andrew@HIDDEN>
To: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
Subject: Re: [bug#57963] [PATCH v5 2/2] home: services: Support user's
 fontconfig configuration.
In-Reply-To: <87k053sxur.fsf@HIDDEN>
References: <87k053sxur.fsf@HIDDEN>
Date: Fri, 14 Oct 2022 09:06:42 +0400
Message-ID: <87zgdzat99.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, Taiju HIGASHI <higashi@HIDDEN>,
 liliana.prikler@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

On 2022-10-13 14:37, Ludovic Court=C3=A8s wrote:

> Hello,
>
> Andrew Tropin <andrew@HIDDEN> skribis:
>
>> If serialization would support G-exps, we could write=20
>>
>> (list #~"RAW_XML_HERE")
>
> There=E2=80=99s a one-to-one lossless mapping between XML and SXML, so I =
don=E2=80=99t
> think it makes sense to support XML-in-strings when we have SXML.
>
> The only thing it would give us, as I see it, is the ability to generate
> syntactically-invalid XML.  Maybe we can live without it?  :-)

Of course we can :), but we won't be able:

1. To take already existing xml config and use it without rewriting.

2. Use full path to gnu store of file-like objects.

=2D-=20
Best regards,
Andrew Tropin

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCgAdFiEEKEGaxlA4dEDH6S/6IgjSCVjB3rAFAmNI7mIACgkQIgjSCVjB
3rC1fhAAj3ZZm1jXqI9Iqkn2tRywvyBLBmsJjcZJSQibDCAk5jV1g8e0J22NhXAb
0Vs5CLt0hYS5WztRl2l55RtXPjG59fPwLQqWzENlAF0/RRXJlyRF4iLGkZTKnp6q
0taYR8IzQtwrU0SHNnTtNKjEEcnRyUutivAUMfc4GPMJgrDCF4YHtpLaeR2sj/X2
rPYgN2+nryZlkmKI4TWoZzBwo2beVtTKKtV+s+DMZPEPdrBpeY4fmJaT0LXfJMdT
3oiDGYGmgahmNjrRSMS9eh9SdihLpjVPltB83/nDDaSUPN9XK2kWdxM8RkWmfM6O
wXzuMf0iupn4IQpeWNCGC6ARggCBf/wgWA9Pv771+TN1lrEskbORM1/+ncf+FTUs
5WZGxJF0bSGWYnkRGW9VdHFwN18bKCkANXmeC+9Kj1udGsWkXXrqmskT5a1YP77p
SQfBRlyV5YJ2j1Rovw6vEN9TPCpuY66y+3URewwuLBZOsRWc4GMPYjG7vfiiDMj1
gyl8IlMM4xnJcBfJV9lQYzq3B/xMLAmP2ircbSt2t9Zxun0Xe+nAwDR88TUs5eXz
0JyA9HrXYZ6xpkWlkR+Cqlf3yCtuWgJeXsjnY0ejsx+hrHlgrPKiDhc2Uykx4g/3
yg+JzYkPFr9jtb3tOgX39dMVeiRj6t0GD+NPMWCxozaXXJuxi/s=
=CxsF
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 13 Oct 2022 12:38:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 13 08:38:05 2022
Received: from localhost ([127.0.0.1]:59869 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oixTQ-0003M7-Pb
	for submit <at> debbugs.gnu.org; Thu, 13 Oct 2022 08:38:05 -0400
Received: from eggs.gnu.org ([209.51.188.92]:37720)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1oixTM-0003La-AR
 for 57963 <at> debbugs.gnu.org; Thu, 13 Oct 2022 08:38:03 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:35126)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ludo@HIDDEN>)
 id 1oixTF-00049W-GF; Thu, 13 Oct 2022 08:37:53 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-Version:In-Reply-To:Date:References:Subject:To:
 From; bh=0GpJnnxO6Sc8Y9epMaOVsYvW9KYR6rHiNQSbkIpasv8=; b=nEPKY7rZfy/jJB3O6XkF
 rHWJmj5rgkIPQb363z4XKFtoVX27rZWMkzPix+KRjA7kw/C09hrQo1BvE8GolnZEx3XY1HQ8g4+HE
 sampGxFUa+iCpiUWMwVZdPQVz06byX3Pekw616sWekwNDKZqG+MMGc51JK3ieP6arBKaj9opwI6bx
 /884NIMed4eT4xyC71UQHx0I4uUhMGmPv0+mcRWrgg8AsHoeBMrBqkeOJ95v2LCcRVTPTg1k882ox
 Li9pUlToHn5mkUI167XV/e2vBj3WgqNvo+yQT9BUFB8TRtw0Cj1YiJpv2ZTPFTz+hrS7ObUfMdnsD
 xj9HI7AGYfunGg==;
Received: from 91-160-117-201.subs.proxad.net ([91.160.117.201]:59428
 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ludo@HIDDEN>)
 id 1oixTD-0004JY-27; Thu, 13 Oct 2022 08:37:51 -0400
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Andrew Tropin <andrew@HIDDEN>
Subject: Re: [PATCH v5 2/2] home: services: Support user's fontconfig
 configuration.
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN> <87zge4chb5.fsf@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: Duodi 22 =?utf-8?Q?Vend=C3=A9miaire?= an 231 de la
 =?utf-8?Q?R=C3=A9volution=2C?= jour de
 la =?utf-8?Q?P=C3=AAche?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Thu, 13 Oct 2022 14:37:48 +0200
In-Reply-To: <87zge4chb5.fsf@HIDDEN> (Andrew Tropin's message of "Mon, 10 Oct
 2022 10:40:30 +0400")
Message-ID: <87k053sxur.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, Taiju HIGASHI <higashi@HIDDEN>,
 liliana.prikler@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hello,

Andrew Tropin <andrew@HIDDEN> skribis:

> If serialization would support G-exps, we could write=20
>
> (list #~"RAW_XML_HERE")

There=E2=80=99s a one-to-one lossless mapping between XML and SXML, so I do=
n=E2=80=99t
think it makes sense to support XML-in-strings when we have SXML.

The only thing it would give us, as I see it, is the ability to generate
syntactically-invalid XML.  Maybe we can live without it?  :-)

Thanks,
Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 13 Oct 2022 03:51:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 12 23:51:48 2022
Received: from localhost ([127.0.0.1]:58796 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oipG7-00050Y-Pk
	for submit <at> debbugs.gnu.org; Wed, 12 Oct 2022 23:51:48 -0400
Received: from relay10.mail.gandi.net ([217.70.178.230]:34685)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <andrew@HIDDEN>) id 1oipG5-00050M-VL
 for 57963 <at> debbugs.gnu.org; Wed, 12 Oct 2022 23:51:46 -0400
Received: (Authenticated sender: andrew@HIDDEN)
 by mail.gandi.net (Postfix) with ESMTPSA id E17DD240003;
 Thu, 13 Oct 2022 03:51:38 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=trop.in; s=gm1;
 t=1665633099;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:cc:mime-version:mime-version:content-type:content-type:
 in-reply-to:in-reply-to:references:references;
 bh=PzjHwD2j3Y89APng2Fm+6yXLEpQi6u/JGCEG03pY9bM=;
 b=hhTAJZAaKgzxPD8VrAezny75zBjhH7+QukUTTxE/LbTRsm3c2sghxI8D4iaKA+BUqYKFKh
 xYdujZD0Jnix7ZFScbVqWxqZhs+tcOTZHA5Ce2co8czrlNE+SL+72Ks9ujiNCGnzeuuMko
 dXU3f4Wu+QsQ6/YXQxqTCzCM5t8QJBdyjQC9hWFxOM/Y8aLQZjHhxaONVMQh0xbCkEvCOO
 jaqD5pqam49j5TANVVPrNazUHr2cAiCS7Yn9MJ5CsemO6fBWG8N62trWMKEMl0E+QQhR4N
 C/Lzm3lAbs+pZyHlHXoKlih5/8mU4UagEO+mTpzVXvTp3Uy1EGTsdB+muiSZrQ==
From: Andrew Tropin <andrew@HIDDEN>
To: Liliana Marie Prikler <liliana.prikler@HIDDEN>, Taiju HIGASHI
 <higashi@HIDDEN>
Subject: Re: Almost plain SXML serializer
In-Reply-To: <4e239948c075c47041a4ac1087b25de65a9172b3.camel@HIDDEN>
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN> <87zge4chb5.fsf@HIDDEN>
 <87edvfkob8.fsf@HIDDEN>
 <7a7ba84518d2f6afa387e1e2649bc249acd74750.camel@HIDDEN>
 <87pmexmsei.fsf@HIDDEN> <87a661i7zm.fsf@HIDDEN>
 <874jw9mbxc.fsf@HIDDEN>
 <4e239948c075c47041a4ac1087b25de65a9172b3.camel@HIDDEN>
Date: Thu, 13 Oct 2022 07:51:35 +0400
Message-ID: <875ygoe5yw.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, 57963 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

On 2022-10-12 20:23, Liliana Marie Prikler wrote:

> Am Mittwoch, dem 12.10.2022 um 17:03 +0400 schrieb Andrew Tropin:
>> On 2022-10-12 20:42, Taiju HIGASHI wrote:
>>=20
>> > Andrew Tropin <andrew@HIDDEN> writes:
>> >=20
>> > > On 2022-10-11 06:21, Liliana Marie Prikler wrote:
>> > >=20
>> > > > Am Dienstag, dem 11.10.2022 um 12:54 +0900 schrieb Taiju
>> > > > HIGASHI:
>> > > > > We can specify invalid value such as (list "foo" '(foo bar)
>> > > > > 123).
>> > > > It will be sanitized before that.
>> > > >=20
>> > > > > > Also, making multi-type fields is debatable, but isn't
>> > > > > > great IMO.
>> > > > >=20
>> > > > > I see. If we had to choose one or the other, I would prefer
>> > > > > the
>> > > > > string-type field.
>> > > > Prefer sexp-type.
>> > > >=20
>> > >=20
>> > > Current (v5) extra-config has a list type.=C2=A0 This list can conta=
in
>> > > strings
>> > > and nested lists, string elements are for raw XML, and list
>> > > elements are for SXML.
>> > >=20
>> > > This is done I guess to support following use case:
>> > >=20
>> > > (list "<tag>Already existing XML copied from existing .xml file,
>> > > which
>> > > we don't want to rewrite to SXML.</tag>"
>> > > =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 '((tag (@ (attr1 "value1")
>> > > =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=
=C2=A0=C2=A0=C2=A0=C2=A0 (attr2 "value2"))
>> > > =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=
=C2=A0 (nested "Part of the configuration defined with
>> > > SXML")
>> > > =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=
=C2=A0 (empty)))
>> > > =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 "<another-tag>Maybe some other part o=
f raw XML</another-
>> > > tag>")
>> > >=20
>> > > This way we can combine SXML with already existing raw XML.
>> > >=20
>> > > Am I right?
>> >=20
>> > You're right.=C2=A0 The current implementation allows XML string and
>> > SXML
>> > list in the list.=C2=A0 Also, it can mix those.
>> >=20
>>=20
>> Ok, that means we can cover this use case, but at the same time have
>> more functionality, clarity and consistency.
>>=20
>> We can make extra-config to be SXML only (with G-exps support), this
>> way we will achieve not only the same functionality, but will get
>> more advanced features like referencing files/directiories in the
>> /gnu/store or generating parts of configuration using full-fledged
>> scheme (the simpliest example is just reading the content of the
>> existing file-like object or using format to generate "raw XML" and
>> insert it in arbitrary place of SXML tree).
>>=20
>> --8<---------------cut here---------------start------------->8---
>> (list #~"<tag>Already existing XML copied from existing .xml file,
>> which
>> we don't want to rewrite to SXML.</tag>"
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 `((tag (@ (attr1 "value1")
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=
=C2=A0=C2=A0=C2=A0 (attr2 "value2"))
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=
 (nested "Part of the configuration defined with SXML")
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=
 ,#~(format #f "=C2=A0=C2=A0=C2=A0 <nested-tag>~a</nested-tag>"
>> #$variable)
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=
 (fontdirs
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=
=C2=A0 (dirs ,(file-append font-iosevka "/share/fonts")))
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=
 (empty)))
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 #~(call-with-input-file #$(local-file "ol=
d.xml") get-string-
>> all)
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 #~"<another-tag>Maybe some other part of =
raw XML</another-
>> tag>")
>> --8<---------------cut here---------------end--------------->8---
>>=20
>> Liliana, Ludo what do you think?
> I think the mockup implementation is a little unclear.=20

The file generated from definition above should look like:
=2D-8<---------------cut here---------------start------------->8---
<tag>Already existing XML copied from existing .xml file, which we don't wa=
nt to rewrite to SXML.</tag>
<tag attr1=3D"value1"
     attr2=3D"value2">
  <nested>Text node</nested>
    <nested-tag>variable value here</nested-tag>
  <fontdirs>
    <dirs>
      /gnu/store/w2wvg2229lj3qba0r44pmd786mkllvjl-font-iosevka-15.2.0/share=
/fonts
    </dirs>
  </fontdirs>
  <empty/>
</tag>
<!-- the literal content of old.xml file here -->
<another-tag>Maybe some other part of raw XML</another-tag>
=2D-8<---------------cut here---------------end--------------->8---

Hope it helps, let me know if you want me to rephrase or clarify
something.

> Do you mean that G-Expressions should imply a string that is to be
> parsed?  Because note that gexp->sexp exists and you could likewise
> #~(sxml->xml #$some- file-in-the-store) imho.

Not sure what you mean. Can you elaborate, please?

=2D-=20
Best regards,
Andrew Tropin

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCgAdFiEEKEGaxlA4dEDH6S/6IgjSCVjB3rAFAmNHi0cACgkQIgjSCVjB
3rBGJQ/+ItF65K+KBzlbNOK7obqzx4lPDPAYySYvwWW/lOyDpseiCSpM2dly+bAc
LuxoIB7Fa5/00hkCla+zobJurKekvLPEcvf6aDaYJMAXcvtkoWXFnWta3ikh+zYD
VImbcPUCIIeJ03JvpL8+KMKWq2GNeVvUiUCyzhhJTqB5na5eZ6p9EKUiHFExIcKe
mXA4je1XjZ/1DcEEIemrOfce1p2/h3uoJ7Oft+qgyUgNUXDkHZFhV7T7q0Y9/qkt
J883T9L+XLbkTVYMbtUnddK4rq0jTFUaZBnqMQxgh4vQewU7NswuaNM0Qyjjk3+W
1GIunVqaHqapOMKSp5KA5SeatyxfqpXL32//fh1J5aoXLpUmOOozuN75V+PcirWp
xkJEgmH/q6t3ZiXy5OH6yuR2S2vBJtCF5EzrF2+oJV4cu3yiC8xsef+Q35kRXriv
KSGX8z/M/C/6qBMLjNpwdmgAAs7vycl3ToD0l8yV/vSgNwOCRhsAL1M7NjtIOwIP
L+WSYKSoaeNWyI2NPHdc5wE+73Tyry8Sp8/z9tBcyIkbusWiabEQSFSX4Vn40ndY
xP/2ZY42l/N4Ifge6oSE5FfdQWsd28X2Iqbz88Vci8uZRtui4SBl/rmWB+zoWLxD
QoEgagpk4Ka2QEYuRXxNU3CMYBE0kL8QutY1RRGwguLwKbSB9AA=
=f3Pk
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 12 Oct 2022 18:23:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 12 14:23:19 2022
Received: from localhost ([127.0.0.1]:58421 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oigNy-0007TQ-Mt
	for submit <at> debbugs.gnu.org; Wed, 12 Oct 2022 14:23:19 -0400
Received: from mail-ed1-f67.google.com ([209.85.208.67]:41588)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <liliana.prikler@HIDDEN>) id 1oigNw-0007TA-Tx
 for 57963 <at> debbugs.gnu.org; Wed, 12 Oct 2022 14:23:17 -0400
Received: by mail-ed1-f67.google.com with SMTP id z97so25599665ede.8
 for <57963 <at> debbugs.gnu.org>; Wed, 12 Oct 2022 11:23:16 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:from:to:cc:subject
 :date:message-id:reply-to;
 bh=uu9JyCd3lYWT9h6h8iJAWurn0JFYQCFGhLZvWAFToRY=;
 b=lPftW3L34qjoF7jmZPUAvooHnhIppFZoNmGlhnik7dMOUwm/ZjCSlRa9TcQ2+5P36I
 wa9+iqmhW76sO+ZsaaprDR3010FJwcqolIieQ1Ap95LoHJ73vvt5lH7x5to2zXo8Ab4F
 LjFtm7zR4w1o29oEL0Nn6RMeR7ZNwLHi3FCg+XxbHDo6kSRM985ThTUE5IjfMqO+70+Z
 TfZtqRbyGvKTbWIKoX0QGSvzekWek3d7x1pbsQ/rvwIPn7fcTsDCS04VAVkHzkQfEuAN
 U5U8WXi9VDntCBLknQS7FPSemLgw5a/iQfFXkONJhMasAWqDZwHjUQC0Z1pTtJ4N1DUu
 rjYA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:x-gm-message-state
 :from:to:cc:subject:date:message-id:reply-to;
 bh=uu9JyCd3lYWT9h6h8iJAWurn0JFYQCFGhLZvWAFToRY=;
 b=HK8UsFsi0GR5N2ZdZwF8bg5lFgcX3OPu5ilpJ0vXf/Aa4ALiSsqstUH60nvbjsFCT5
 mS0+RejWlpKo4Jbo/wNKVj1ZZeaXNZEebRGlWLJd0//a7pF8RWBmCn891eheLSvtvex9
 HW7Yh23jVU6aVH5v/hJazW6GI9ULKF8ayeQM+1ysRokRVm23n9KU8yDj7yO3bYVjxTkS
 MxixN2IHSGPDxhvaARPkoF1sA1GSICw2LevLbKTppbxHxnziEtHD6y+6LDiZsA56geiy
 gh8P6kPChlMzFV1nYBNMznjpl7Xoil+Hs56u8RGpW7LzUQ7weRy54b/6TylSrgAkscaR
 dFFA==
X-Gm-Message-State: ACrzQf1g9HmYE5QavPjDKB46GKPtYl9ace8bQOotXefU/H88SMQTIjeb
 3gCXstb7Rojb12GkKGYtlnM=
X-Google-Smtp-Source: AMsMyM41NUqmFV0HVbkjHfgzmXobc3aNp7LFQ1C2YVuwc392gk4+x5vtyqOYfJGK46FqdPwbzkDTJQ==
X-Received: by 2002:aa7:c04f:0:b0:457:1b08:d056 with SMTP id
 k15-20020aa7c04f000000b004571b08d056mr29484829edo.146.1665598989813; 
 Wed, 12 Oct 2022 11:23:09 -0700 (PDT)
Received: from lumine.fritz.box (85-127-52-93.dsl.dynamic.surfer.at.
 [85.127.52.93]) by smtp.gmail.com with ESMTPSA id
 z14-20020a170906074e00b007828150a2f1sm1681523ejb.36.2022.10.12.11.23.08
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Wed, 12 Oct 2022 11:23:09 -0700 (PDT)
Message-ID: <4e239948c075c47041a4ac1087b25de65a9172b3.camel@HIDDEN>
Subject: Re: Almost plain SXML serializer
From: Liliana Marie Prikler <liliana.prikler@HIDDEN>
To: Andrew Tropin <andrew@HIDDEN>, Taiju HIGASHI <higashi@HIDDEN>
Date: Wed, 12 Oct 2022 20:23:08 +0200
In-Reply-To: <874jw9mbxc.fsf@HIDDEN>
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN> <87zge4chb5.fsf@HIDDEN>
 <87edvfkob8.fsf@HIDDEN>
 <7a7ba84518d2f6afa387e1e2649bc249acd74750.camel@HIDDEN>
 <87pmexmsei.fsf@HIDDEN> <87a661i7zm.fsf@HIDDEN>
 <874jw9mbxc.fsf@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
User-Agent: Evolution 3.46.0 
MIME-Version: 1.0
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, 57963 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Am Mittwoch, dem 12.10.2022 um 17:03 +0400 schrieb Andrew Tropin:
> On 2022-10-12 20:42, Taiju HIGASHI wrote:
>=20
> > Andrew Tropin <andrew@HIDDEN> writes:
> >=20
> > > On 2022-10-11 06:21, Liliana Marie Prikler wrote:
> > >=20
> > > > Am Dienstag, dem 11.10.2022 um 12:54 +0900 schrieb Taiju
> > > > HIGASHI:
> > > > > We can specify invalid value such as (list "foo" '(foo bar)
> > > > > 123).
> > > > It will be sanitized before that.
> > > >=20
> > > > > > Also, making multi-type fields is debatable, but isn't
> > > > > > great IMO.
> > > > >=20
> > > > > I see. If we had to choose one or the other, I would prefer
> > > > > the
> > > > > string-type field.
> > > > Prefer sexp-type.
> > > >=20
> > >=20
> > > Current (v5) extra-config has a list type.=C2=A0 This list can contai=
n
> > > strings
> > > and nested lists, string elements are for raw XML, and list
> > > elements are for SXML.
> > >=20
> > > This is done I guess to support following use case:
> > >=20
> > > (list "<tag>Already existing XML copied from existing .xml file,
> > > which
> > > we don't want to rewrite to SXML.</tag>"
> > > =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 '((tag (@ (attr1 "value1")
> > > =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=
=A0=C2=A0=C2=A0=C2=A0 (attr2 "value2"))
> > > =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=
=A0 (nested "Part of the configuration defined with
> > > SXML")
> > > =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=
=A0 (empty)))
> > > =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 "<another-tag>Maybe some other part of=
 raw XML</another-
> > > tag>")
> > >=20
> > > This way we can combine SXML with already existing raw XML.
> > >=20
> > > Am I right?
> >=20
> > You're right.=C2=A0 The current implementation allows XML string and
> > SXML
> > list in the list.=C2=A0 Also, it can mix those.
> >=20
>=20
> Ok, that means we can cover this use case, but at the same time have
> more functionality, clarity and consistency.
>=20
> We can make extra-config to be SXML only (with G-exps support), this
> way we will achieve not only the same functionality, but will get
> more advanced features like referencing files/directiories in the
> /gnu/store or generating parts of configuration using full-fledged
> scheme (the simpliest example is just reading the content of the
> existing file-like object or using format to generate "raw XML" and
> insert it in arbitrary place of SXML tree).
>=20
> --8<---------------cut here---------------start------------->8---
> (list #~"<tag>Already existing XML copied from existing .xml file,
> which
> we don't want to rewrite to SXML.</tag>"
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 `((tag (@ (attr1 "value1")
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=
=C2=A0=C2=A0=C2=A0 (attr2 "value2"))
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 =
(nested "Part of the configuration defined with SXML")
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 =
,#~(format #f "=C2=A0=C2=A0=C2=A0 <nested-tag>~a</nested-tag>"
> #$variable)
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 =
(fontdirs
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=
=C2=A0 (dirs ,(file-append font-iosevka "/share/fonts")))
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 =
(empty)))
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 #~(call-with-input-file #$(local-file "old=
.xml") get-string-
> all)
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 #~"<another-tag>Maybe some other part of r=
aw XML</another-
> tag>")
> --8<---------------cut here---------------end--------------->8---
>=20
> Liliana, Ludo what do you think?
I think the mockup implementation is a little unclear.  Do you mean
that G-Expressions should imply a string that is to be parsed?  Because
note that gexp->sexp exists and you could likewise #~(sxml->xml #$some-
file-in-the-store) imho.

Cheers




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 12 Oct 2022 13:03:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 12 09:03:42 2022
Received: from localhost ([127.0.0.1]:56075 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oibOg-00008V-Fa
	for submit <at> debbugs.gnu.org; Wed, 12 Oct 2022 09:03:42 -0400
Received: from relay3-d.mail.gandi.net ([217.70.183.195]:55879)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <andrew@HIDDEN>) id 1oibOe-00008I-Gi
 for 57963 <at> debbugs.gnu.org; Wed, 12 Oct 2022 09:03:41 -0400
Received: (Authenticated sender: andrew@HIDDEN)
 by mail.gandi.net (Postfix) with ESMTPSA id 0E66260008;
 Wed, 12 Oct 2022 13:03:30 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=trop.in; s=gm1;
 t=1665579814;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:cc:mime-version:mime-version:content-type:content-type:
 in-reply-to:in-reply-to:references:references;
 bh=6tIhvS4qKFpKFOoti0n6gE5y7Z6wRXBcMri5tfXIysk=;
 b=K4tB2J2onVifzEZryn5Bu+8FrbGh5OGi67H7Drryye4FtmtglstE+Opy+sV8Qz2F/LxAvj
 oYEekdUzuTQPBZRRW9bc9tmrrbnitUWoFB8PWqq2D21Okg6O7nNJBFgpRMAt9nJIDbbYED
 G3Yi1u855bxVxqzFYeUMBMm3MRbque1o34XTB15wwKtjrQaga82gq81qeSgiFOrlclCxxj
 USD+OQ69Po8UFTh7Ykygp0halwD0Xqormfhs8PoWbhK18SxAYRqTBhV5EViQQyu2dxYBAF
 5JqAdENCFWgzjaIs9cQSeOJEwqhBul5gYiCJ0wJHFKkrcd+AqWBgd42E2dAfaw==
From: Andrew Tropin <andrew@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>
Subject: Re: Almost plain SXML serializer
In-Reply-To: <87a661i7zm.fsf@HIDDEN>
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN> <87zge4chb5.fsf@HIDDEN>
 <87edvfkob8.fsf@HIDDEN>
 <7a7ba84518d2f6afa387e1e2649bc249acd74750.camel@HIDDEN>
 <87pmexmsei.fsf@HIDDEN> <87a661i7zm.fsf@HIDDEN>
Date: Wed, 12 Oct 2022 17:03:27 +0400
Message-ID: <874jw9mbxc.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, 57963 <at> debbugs.gnu.org,
 Liliana Marie Prikler <liliana.prikler@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

On 2022-10-12 20:42, Taiju HIGASHI wrote:

> Andrew Tropin <andrew@HIDDEN> writes:
>
>> On 2022-10-11 06:21, Liliana Marie Prikler wrote:
>>
>>> Am Dienstag, dem 11.10.2022 um 12:54 +0900 schrieb Taiju HIGASHI:
>>>> We can specify invalid value such as (list "foo" '(foo bar) 123).
>>> It will be sanitized before that.
>>>
>>>> > Also, making multi-type fields is debatable, but isn't great IMO.
>>>>
>>>> I see. If we had to choose one or the other, I would prefer the
>>>> string-type field.
>>> Prefer sexp-type.
>>>
>>
>> Current (v5) extra-config has a list type.  This list can contain strings
>> and nested lists, string elements are for raw XML, and list
>> elements are for SXML.
>>
>> This is done I guess to support following use case:
>>
>> (list "<tag>Already existing XML copied from existing .xml file, which
>> we don't want to rewrite to SXML.</tag>"
>>       '((tag (@ (attr1 "value1")
>>                 (attr2 "value2"))
>>              (nested "Part of the configuration defined with SXML")
>>              (empty)))
>>       "<another-tag>Maybe some other part of raw XML</another-tag>")
>>
>> This way we can combine SXML with already existing raw XML.
>>
>> Am I right?
>
> You're right.  The current implementation allows XML string and SXML
> list in the list.  Also, it can mix those.
>

Ok, that means we can cover this use case, but at the same time have
more functionality, clarity and consistency.

We can make extra-config to be SXML only (with G-exps support), this way
we will achieve not only the same functionality, but will get more
advanced features like referencing files/directiories in the /gnu/store
or generating parts of configuration using full-fledged scheme (the
simpliest example is just reading the content of the existing file-like
object or using format to generate "raw XML" and insert it in arbitrary
place of SXML tree).

=2D-8<---------------cut here---------------start------------->8---
(list #~"<tag>Already existing XML copied from existing .xml file, which
we don't want to rewrite to SXML.</tag>"
      `((tag (@ (attr1 "value1")
                (attr2 "value2"))
             (nested "Part of the configuration defined with SXML")
             ,#~(format #f "    <nested-tag>~a</nested-tag>" #$variable)
             (fontdirs
              (dirs ,(file-append font-iosevka "/share/fonts")))
             (empty)))
      #~(call-with-input-file #$(local-file "old.xml") get-string-all)
      #~"<another-tag>Maybe some other part of raw XML</another-tag>")
=2D-8<---------------cut here---------------end--------------->8---

Liliana, Ludo what do you think?

>>>> > If serialization would support G-exps, we could write
>>>> >
>>>> > (list #~"RAW_XML_HERE")
>>>> >
>>>> > or even something like this:
>>>> >
>>>> > (list #~(READ-THE-WHOLE-FILE #$(local-file "our-old.xml")))
>>>>
>>>> Does it mean that the specification does not allow it now? Or does it
>>>> mean that it is not possible with my implementation?
>>> I think your serialize would have to unpack the G-Expressions.  You can
>>> test that with some example configs of your own.
>>>
>>>> >
>>> Cheers
>
> Thanks,

=2D-=20
Best regards,
Andrew Tropin

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCgAdFiEEKEGaxlA4dEDH6S/6IgjSCVjB3rAFAmNGux8ACgkQIgjSCVjB
3rByiw//ccD4PWgx5vOF9EsKb5sZfeDD4bYEPnV5O0LcAwT1ZcJd+NbfOIwbjAw1
3rsCiYnpfXZy2qcDd1fUO7w4e1lZDVzEBYBykrHAkaqLNE8acr4nSEutIE16fWK4
1AmoiFnLN0cE4XyYZNtuklDewflQ9jraS2emuWNpvKDOb+yAfx5aBQ0ZLadB3N4L
4fTVqQD0j/PCAbRJUW+sYGAaa+oRrJK+xNENEC8xXHIUFcXHny1S6C5I5SD4aBwx
PQLxTLHo7NwGqVQOsCT0Ar3ucRPeSVnrotwmooBJ7L2sWIuyvA3Ml61R+fJSD4FS
7QYfbsiXp2kQwNC9nQ1z2YgIW11DtM0ofUCwLqy5EoHwpVA9MaGP4nQyqGpRGfUq
YubY2YO3pvmdb7OrWZIsrKtRjRaAYZLEQ8TjGczSIpOJHDx5MhHCVxm5sHZXjudR
Cp+Sq98AiJNi8zQzCUb2gp/1ukOvZg/CBHT2Cx2Y+V7qcd/qsFsNYZEbvH/DJOw9
4lKurc1ULCUDEbeaqDDz/yjUHU/qHNlaopSSvCJW5Yb4AFOljLqkTgD4MHwCh8oZ
glA9FuxZFqLqIXeDCCJrz74rX/35GVyh+DYDnwI1MxENeWIvMNekuXsY2j5ad2bu
/5ODLsMLEjKK78dPuGLYJakEIioEbk6XiWo1/6r4jXrcmckLKUI=
=MX+m
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 12 Oct 2022 12:41:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 12 08:41:34 2022
Received: from localhost ([127.0.0.1]:56036 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oib3F-0005RI-Mq
	for submit <at> debbugs.gnu.org; Wed, 12 Oct 2022 08:41:34 -0400
Received: from relay8-d.mail.gandi.net ([217.70.183.201]:55869)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <andrew@HIDDEN>) id 1oib3E-0005R6-Ag
 for 57963 <at> debbugs.gnu.org; Wed, 12 Oct 2022 08:41:33 -0400
Received: (Authenticated sender: andrew@HIDDEN)
 by mail.gandi.net (Postfix) with ESMTPSA id 9C6531BF212;
 Wed, 12 Oct 2022 12:41:25 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=trop.in; s=gm1;
 t=1665578486;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:cc:mime-version:mime-version:content-type:content-type:
 in-reply-to:in-reply-to:references:references;
 bh=Uz+g2UdVDr1SBtKhiv9n4T4IZ44+oKz1cUmbTPheT3s=;
 b=RnZBbBJjXp+DlEbP8o6sDRoZINJwcEQ+UyVkYVBlS7N7KAzxME1ev+MDbsuIUFlPDHaKM4
 h8GbeXQaop/gc/fit60MMIQjoURVTOPeUgtvOxe9Bn2vsJjqZ3X0PoOK9WlwTsAb8Dspdz
 Mlns250y+cd2QzG99ElQxbr/63x/mv42ZbxMDRrrZokc5AcOgeQ2SN7XQyqYuoY/Wujcag
 hrZodXcZSWslTRFGXDa/ILT0yIalo/rkvAya441xjI4VXbRZyAkh0r9oj1+zlwaBy3ZdLX
 cdNe56dH7Ca+tXs3Ctccl8MyGUrkpDmBwFJyiY3pEw7pS6fD4I+/ROiDY4c47Q==
From: Andrew Tropin <andrew@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>
Subject: Re: [PATCH v5 2/2] home: services: Support user's fontconfig
 configuration.
In-Reply-To: <87k055i864.fsf@HIDDEN>
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN> <87zge4chb5.fsf@HIDDEN>
 <87edvfkob8.fsf@HIDDEN> <87wn95mtih.fsf@HIDDEN>
 <87k055i864.fsf@HIDDEN>
Date: Wed, 12 Oct 2022 16:41:16 +0400
Message-ID: <87a661mcyb.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

On 2022-10-12 20:38, Taiju HIGASHI wrote:

> Andrew Tropin <andrew@HIDDEN> writes:
>
>> On 2022-10-11 12:54, Taiju HIGASHI wrote:
>>
>>> Hi Andrew,
>>>
>>> Thank you for your review!
>>>
>>>>> +(define (string-list? value)
>>>>> +  (and (pair? value) (every string? value)))
>>>>
>>>> Better to use list? here and in the other places, at least for the
>>>> consistency, but also for semantic meaning.
>>>
>>> OK. I'll rewrite it to below.
>>>
>>> --8<---------------cut here---------------start------------->8---
>>> (define (string-list? value)
>>>   (and (list? value) (every string? value)))
>>> --8<---------------cut here---------------end--------------->8---
>>>
>>>>> +
>>>>> +(define (serialize-string-list field-name value)
>>>>> +  (sxml->xml-string
>>>>> +   (map
>>>>> +    (lambda (path) `(dir ,path))
>>>>> +    (if (member guix-home-font-dir value)
>>>>> +        value
>>>>> +        (append (list guix-home-font-dir) value)))))
>>>>> +
>>>>> +(define (serialize-string field-name value)
>>>>> +  (define (serialize type value)
>>>>> +    (sxml->xml-string
>>>>> +     `(alias
>>>>> +       (family ,type)
>>>>> +       (prefer
>>>>> +        (family ,value)))))
>>>>> +  (match (list field-name value)
>>>>> +    (('default-font-serif-family family)
>>>>> +     (serialize 'serif family))
>>>>> +    (('default-font-sans-serif-family family)
>>>>> +     (serialize 'sans-serif family))
>>>>> +    (('default-font-monospace-family family)
>>>>> +     (serialize 'monospace family))))
>>>>> +
>>>>> +(define-maybe string)
>>>>> +
>>>>> +(define extra-config-list? list?)
>>>>> +
>>>>> +(define-maybe extra-config-list)
>>>>> +
>>>>> +(define (serialize-extra-config-list field-name value)
>>>>> +  (sxml->xml-string
>>>>> +   (map (match-lambda
>>>>> +          ((? pair? sxml) sxml)
>>>>
>>>> Other branches would never be visited because it will fail earlier by
>>>> define-configuration predicate check for extra-config-list? (which is
>>>> basically list?).
>>
>> Oh, I missed the map over the list elements and slightly missread the
>> code.  I thought (according to my incorrect perception of
>> implementation) extra-config have to be either sxml or string, that's is
>> why I said that it will fail earlier because plan string value won't
>> satisfy list predicate attached to extra-config field, but in a fact
>> extra-config is always a list, but can be a list of sxml's and strings
>> mixed together.
>>
>> Thus, some of my comments are invalid.  Sorry for the confusion.  I'll
>> rephrase and elaborate in the later message.
>
> I was worried that I was the only one who did not understand the code I
> wrote, but I've relieved to hear that it was a misunderstanding :)
>
> Is it OK to have multiple data types (XML string and SXML list) in a
> list?
>

I think it's not a great practice, I'll describe an alternative approach
in the other message.

>>> We can specify invalid value such as (list "foo" '(foo bar) 123).
>>>
>>>> Also, making multi-type fields is debatable, but isn't great IMO.
>>>
>>> I see. If we had to choose one or the other, I would prefer the
>>> string-type field.
>>>
>>>> If serialization would support G-exps, we could write
>>>>
>>>> (list #~"RAW_XML_HERE")
>>>>
>>>> or even something like this:
>>>>
>>>> (list #~(READ-THE-WHOLE-FILE #$(local-file "our-old.xml")))
>>>
>>> Does it mean that the specification does not allow it now? Or does it
>>> mean that it is not possible with my implementation?
>>>
>>
>> It's not possible with the current implementation.
>
> I'll try to modify it so that it can support G-exps.
>
>>>>> + ((? string? xml) (xml->sxml xml)) + (else + (raise
>>>>> (formatted-message + (G_ "'extra-config' type must be xml string or
>>>>> sxml list, was given: ~a") + value)))) + value))) +
>>>>> +(define-configuration home-fontconfig-configuration +
>>>>> (font-directories + (string-list (list guix-home-font-dir))
>>>>
>>>> It's not a generic string-list, but a specific font-directories-list
>>>> with extra logic inside.
>>>>
>>>> Also, because guix-home-font-dir always added to the list, the default
>>>> value should '() and field should be called additional-font-directories
>>>> instead.  Otherwise it will be confusing, why guix-home-font-dir is not
>>>> removed from the final configuration, when this field is set to a
>>>> different value.
>>>>
>>>> I skimmed previous messages, but sorry, if I missed any already
>>>> mentioned points.
>>>
>>> Sure, It is more appropriate that the field type is to
>>> font-directories-list field name is to additional-font-directories.
>>>
>>
>> As Liliana mentioned in the other message, it's better not to set
>> anything implicitly.  It's better to keep the name, but change the
>> implementation and remove implicitly and unconditionally added
>> directory.
>
> OK.  I'll modify the default value to an empty list and include
> ~/.guix-home/profile/share/fonts in the sample code in the
> documentation.
>

The default value is good, but the code, which always adds
~/.guix-home/profile/share/fonts to fontdirs is not.

=2D-8<---------------cut here---------------start------------->8---
+    (if (member guix-home-font-dir value)
+        value
+        (append (list guix-home-font-dir) value))
=2D-8<---------------cut here---------------end--------------->8---


>>>>> +   "The directory list that provides fonts.")
>>>>> +  (default-font-serif-family
>>>>> +    maybe-string
>>>>> +    "The preffered default fonts of serif.")
>>>>> +  (default-font-sans-serif-family
>>>>> +    maybe-string
>>>>> +    "The preffered default fonts of sans-serif.")
>>>>> +  (default-font-monospace-family
>>>>> +    maybe-string
>>>>> +    "The preffered default fonts of monospace.")
>>>>> +  (extra-config
>>>>> +   maybe-extra-config-list
>>>>> +   "Extra configuration values to append to the fonts.conf."))
>>>>> +
>>>>> +(define (add-fontconfig-config-file user-config)
>>>>>    `(("fontconfig/fonts.conf"
>>>>>       ,(mixed-text-file
>>>>>         "fonts.conf"
>>>>>         "<?xml version=3D'1.0'?>
>>>>>  <!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
>>>>> -<fontconfig>
>>>>> -  <dir>~/.guix-home/profile/share/fonts</dir>
>>>>> -</fontconfig>"))))
>>>>> +<fontconfig>"
>>>>> +       (serialize-configuration user-config home-fontconfig-configur=
ation-fields)
>>>>
>>>> Just a thought for the future and a point for configuration module
>>>> improvements: It would be cool if serialize-configuration and all other
>>>> serialize- functions returned a G-exps, this way we could write
>>>> something like that:
>>>>
>>>> (home-fontconfig-configuration
>>>>  (font-directories (list (file-append font-iosevka "/share/fonts"))))
>>>
>>> Nice.
>>>
>>> Thanks,
>>> --
>>> Taiju
>
> Thanks,
> --
> Taiju

=2D-=20
Best regards,
Andrew Tropin

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCgAdFiEEKEGaxlA4dEDH6S/6IgjSCVjB3rAFAmNGtewACgkQIgjSCVjB
3rBjhw/+PHqGEzKvXRkm8osF/xuxxOIclJUU2bi0N85/+9/KquL0QOlCf2QcxIS1
DHBrLEe6LCEgpqeQSVrsAxsMRs8wWDglPinafFtl3fbqqHdzVcOTs/xj5iZiYcew
thDUoUtXneAlfrKj7QONyd6aBaluhcG1fgRYKq9OXLQxwPD188vDjfIlQ6rflthk
A+umhNcrqX3QM34/shK8OzDwb7p+T33z/xy/dlzDlbwXGkpiFRE2/je1i5I8kP8q
oyXD33oBDuql4Z688btUqeWVfGFo17LUILFc237TDSaq70OsD3itjGbsRpykR/cw
F2OQNfjOYPx21T8p4rhlNUy6H7guy4s+vaqC1Fc+3lB0QMMinL5yTncC58BnDIiy
yKzBYDs+MssqK98cNHA2QurKtj+d0afhB8Eiqq7iDZ3iKQP7Ea8wkGGglGbev0hQ
U872q92rLjKsQxQrFHKQPpGLgGPJx183Bw+P4ARXgev3yj30+68R+HejOkOR9bAF
U2jKOO24oIMeALK8ASTzMDXLtxdAjyt2K5hwsc2QnoOarsUqHcVOkxjqyjGgPR9M
MV0VOg/DHQR3rn/Lcb1XOWjTwqm6GZnVLzZrVg/vuB611cGdHq/h+e+eiqiYa9xo
VUX9D9bjsrlWC+f/WQMMiodvdzLlLWmeyGP2t1CP4t4tsAakcw0=
=iXYB
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 12 Oct 2022 11:42:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 12 07:42:26 2022
Received: from localhost ([127.0.0.1]:55946 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oia7s-0002tl-Bd
	for submit <at> debbugs.gnu.org; Wed, 12 Oct 2022 07:42:25 -0400
Received: from mail-pf1-f169.google.com ([209.85.210.169]:38683)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1oia7q-0002ta-Gq
 for 57963 <at> debbugs.gnu.org; Wed, 12 Oct 2022 07:42:14 -0400
Received: by mail-pf1-f169.google.com with SMTP id p14so11911471pfq.5
 for <57963 <at> debbugs.gnu.org>; Wed, 12 Oct 2022 04:42:14 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:from:to:cc:subject:date:message-id:reply-to;
 bh=whODAPZbvc6AFK9k3pueepiq4rTsadMtAnKhbHcgpa4=;
 b=lobX1G0SqosqE/3NtsCz7P5nDvURFMphH7C7VG0gKvRKXkfhzz6nebdjsMIXTmV/2r
 OtOfuP/8JgAAOtKR6aQXb90p2o9PuEqo8UfGdm4JkWM5Gv7XbIpdbPZ5yrPG/LZ4HmqA
 cu0Xt2kEJfxkF/pRBv2DArW3tZlBFiCNX7zGrL97s0KqSVvLdCX/5rSiWe4d29bPyyJa
 vI9iX3o5jkfxegpyFYJaxWABbjJg9Xm66/hSZRINchIorDkQ1W2qQcZ0Rltbfoa+0wdr
 2rn7H0h1Vq8vVXx5sUD5qPh6qzKjaJT9u10fq6H3Mmgau3hIujPkHCZ+dcGIsg/vz0q0
 zCUA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:x-gm-message-state:from:to:cc:subject:date
 :message-id:reply-to;
 bh=whODAPZbvc6AFK9k3pueepiq4rTsadMtAnKhbHcgpa4=;
 b=52HrfS1mdWmjKvQ8ZoZL/NwStc5Fk5XqAj0qzwGqo+1LN7xK0Ew1fllrqQGw/fjLkJ
 VyNlu2TcK01hKVdYiGWbyK758N0g60z+WMTnNMFbltexZWcSgBte/MFrIZFEp/3svrJq
 2FVVXj+3JaJuiTye2dH4iOA6m7Sf4E3Xn05s5o9CZyfpt6SuKIj1kHbVlH6cgp10dw73
 F+oT9+nQLzns8pfVn3u8S+ScvQs+SImeNIFHvLeY+ePLGVpIft0A9XVWLWgRXW5P1Tow
 VjuXIe3GfsjkCFx1GBEX3uT+PVUktWOpU6CeaWz6nmxPz7wD/TO8Lbf6Z8z0aFFlGwdl
 DiQw==
X-Gm-Message-State: ACrzQf3pUnQmH2qIE8cYrhryzt9lqAO9EpGY7JJEJSHzGQXjgOudXMrn
 2RS0LTnmW/n+UPpHYMmOzIwXzxgWd6NYMw==
X-Google-Smtp-Source: AMsMyM7ykQ2k550qp3rtOsv28qB4VkNBkmKd0aPojns5FMHtwcasEoEoEh69RU9rZw11R0rMWwM7Dg==
X-Received: by 2002:a05:6a00:2409:b0:54e:a3ad:d32d with SMTP id
 z9-20020a056a00240900b0054ea3add32dmr30340822pfh.70.1665574928824; 
 Wed, 12 Oct 2022 04:42:08 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 a8-20020a17090a008800b001fd7e56da4csm1266705pja.39.2022.10.12.04.42.07
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Wed, 12 Oct 2022 04:42:08 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Andrew Tropin <andrew@HIDDEN>
Subject: Re: Almost plain SXML serializer
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN> <87zge4chb5.fsf@HIDDEN>
 <87edvfkob8.fsf@HIDDEN>
 <7a7ba84518d2f6afa387e1e2649bc249acd74750.camel@HIDDEN>
 <87pmexmsei.fsf@HIDDEN>
Date: Wed, 12 Oct 2022 20:42:05 +0900
In-Reply-To: <87pmexmsei.fsf@HIDDEN> (Andrew Tropin's message of "Wed, 12 Oct
 2022 11:07:33 +0400")
Message-ID: <87a661i7zm.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, 57963 <at> debbugs.gnu.org,
 Liliana Marie Prikler <liliana.prikler@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Andrew Tropin <andrew@HIDDEN> writes:

> On 2022-10-11 06:21, Liliana Marie Prikler wrote:
>
>> Am Dienstag, dem 11.10.2022 um 12:54 +0900 schrieb Taiju HIGASHI:
>>> We can specify invalid value such as (list "foo" '(foo bar) 123).
>> It will be sanitized before that.
>>
>>> > Also, making multi-type fields is debatable, but isn't great IMO.
>>>
>>> I see. If we had to choose one or the other, I would prefer the
>>> string-type field.
>> Prefer sexp-type.
>>
>
> Current (v5) extra-config has a list type.  This list can contain strings
> and nested lists, string elements are for raw XML, and list
> elements are for SXML.
>
> This is done I guess to support following use case:
>
> (list "<tag>Already existing XML copied from existing .xml file, which
> we don't want to rewrite to SXML.</tag>"
>       '((tag (@ (attr1 "value1")
>                 (attr2 "value2"))
>              (nested "Part of the configuration defined with SXML")
>              (empty)))
>       "<another-tag>Maybe some other part of raw XML</another-tag>")
>
> This way we can combine SXML with already existing raw XML.
>
> Am I right?

You're right.  The current implementation allows XML string and SXML
list in the list.  Also, it can mix those.

>>> > If serialization would support G-exps, we could write
>>> >
>>> > (list #~"RAW_XML_HERE")
>>> >
>>> > or even something like this:
>>> >
>>> > (list #~(READ-THE-WHOLE-FILE #$(local-file "our-old.xml")))
>>>
>>> Does it mean that the specification does not allow it now? Or does it
>>> mean that it is not possible with my implementation?
>> I think your serialize would have to unpack the G-Expressions.  You can
>> test that with some example configs of your own.
>>
>>> >
>> Cheers

Thanks,
-- 
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 12 Oct 2022 11:38:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 12 07:38:24 2022
Received: from localhost ([127.0.0.1]:55942 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oia47-0002no-IB
	for submit <at> debbugs.gnu.org; Wed, 12 Oct 2022 07:38:23 -0400
Received: from mail-pg1-f182.google.com ([209.85.215.182]:39853)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1oia45-0002na-4b
 for 57963 <at> debbugs.gnu.org; Wed, 12 Oct 2022 07:38:21 -0400
Received: by mail-pg1-f182.google.com with SMTP id b5so15312105pgb.6
 for <57963 <at> debbugs.gnu.org>; Wed, 12 Oct 2022 04:38:21 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:from:to:cc:subject:date:message-id:reply-to;
 bh=qCThdVYoiHOdElzmiHBfKyKfVtAT1DHfWAopE7gbyFs=;
 b=tp3WsiMPXP2Tp2EZp2aGDKLTFku02oDcVJnruQ+NHQTzoRroXxY3PxPGX79YwOjsPL
 kV1AObvT/FXLPSzMw+xr2rPzY8L6SrZJ+qfajCbxPmCSaAM91PJfzrtIUqTgmYacOS6Q
 05XtrK/qB8MYlI8Ix40YGb0FfB1AM4knqtW19pH/GXT+1XAxJJ8TaeDVuRI6dYGMAhzi
 eD8UIlLMEDPQ8PMMEIqvypbLzQfpZrisv8BfnDnHhsNTnCw/48MbMd/mfdObqFjhXMlg
 DluNha9Go99pubQ+7xyU/7uxd3em6R1w7DiFm7TgEl7b1hS75r+NssBHH+Sl4OyKo3L4
 w7Ng==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:x-gm-message-state:from:to:cc:subject:date
 :message-id:reply-to;
 bh=qCThdVYoiHOdElzmiHBfKyKfVtAT1DHfWAopE7gbyFs=;
 b=dQseQpQNufGSN+LPt3lUuRNkA5DhZ88rgXGExYOcSxLr09xNf1UCyvapwZrk1HsPzn
 6wLExwfRlM6/iD7nMirlKaNVpUMr7Tl2JLI5/ZYhxF9Nh4MfNmccNNx8f6UmJSrfKfZo
 7axpIfoNPhQpFeHCi7M9FtXETRlKWs0dbkTd0lq83tgyrrge6xM6AD7wh/5xG5NEAVdI
 U4TmSY8LiLZOKdYG+7+vxsNOSZTTlRN3QhUEEqpueOl7Uy1TQZryJH72ljP5z4Mh8ikw
 Z2Ak+F7mGtRf5eiWcvj6U/toMRB/yo9Xq6Ndk+Rd+UKBY7aEwyoG0T+aKO2MfG01bmUe
 AYew==
X-Gm-Message-State: ACrzQf12u5yjC8k6wyluI/0jQyZSzeVb7j2/pjxta2fDVr3y3YkK/pj0
 mGCv0RdMUfZdHpsCszEqNv3+sw==
X-Google-Smtp-Source: AMsMyM5z4kal28Gkf/2y4kH74ZseZjJja7Qz+g7kHNYXRfTQ442sY7VoJOkVwmeb3mfbdY5POkKHVw==
X-Received: by 2002:a05:6a00:854:b0:563:a22f:50d4 with SMTP id
 q20-20020a056a00085400b00563a22f50d4mr10187018pfk.31.1665574695228; 
 Wed, 12 Oct 2022 04:38:15 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 h14-20020a170902f54e00b00179f370dbfasm10569293plf.26.2022.10.12.04.38.13
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Wed, 12 Oct 2022 04:38:14 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Andrew Tropin <andrew@HIDDEN>
Subject: Re: [PATCH v5 2/2] home: services: Support user's fontconfig
 configuration.
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN> <87zge4chb5.fsf@HIDDEN>
 <87edvfkob8.fsf@HIDDEN> <87wn95mtih.fsf@HIDDEN>
Date: Wed, 12 Oct 2022 20:38:11 +0900
In-Reply-To: <87wn95mtih.fsf@HIDDEN> (Andrew Tropin's message of "Wed, 12 Oct
 2022 10:43:34 +0400")
Message-ID: <87k055i864.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Andrew Tropin <andrew@HIDDEN> writes:

> On 2022-10-11 12:54, Taiju HIGASHI wrote:
>
>> Hi Andrew,
>>
>> Thank you for your review!
>>
>>>> +(define (string-list? value)
>>>> +  (and (pair? value) (every string? value)))
>>>
>>> Better to use list? here and in the other places, at least for the
>>> consistency, but also for semantic meaning.
>>
>> OK. I'll rewrite it to below.
>>
>> --8<---------------cut here---------------start------------->8---
>> (define (string-list? value)
>>   (and (list? value) (every string? value)))
>> --8<---------------cut here---------------end--------------->8---
>>
>>>> +
>>>> +(define (serialize-string-list field-name value)
>>>> +  (sxml->xml-string
>>>> +   (map
>>>> +    (lambda (path) `(dir ,path))
>>>> +    (if (member guix-home-font-dir value)
>>>> +        value
>>>> +        (append (list guix-home-font-dir) value)))))
>>>> +
>>>> +(define (serialize-string field-name value)
>>>> +  (define (serialize type value)
>>>> +    (sxml->xml-string
>>>> +     `(alias
>>>> +       (family ,type)
>>>> +       (prefer
>>>> +        (family ,value)))))
>>>> +  (match (list field-name value)
>>>> +    (('default-font-serif-family family)
>>>> +     (serialize 'serif family))
>>>> +    (('default-font-sans-serif-family family)
>>>> +     (serialize 'sans-serif family))
>>>> +    (('default-font-monospace-family family)
>>>> +     (serialize 'monospace family))))
>>>> +
>>>> +(define-maybe string)
>>>> +
>>>> +(define extra-config-list? list?)
>>>> +
>>>> +(define-maybe extra-config-list)
>>>> +
>>>> +(define (serialize-extra-config-list field-name value)
>>>> +  (sxml->xml-string
>>>> +   (map (match-lambda
>>>> +          ((? pair? sxml) sxml)
>>>
>>> Other branches would never be visited because it will fail earlier by
>>> define-configuration predicate check for extra-config-list? (which is
>>> basically list?).
>
> Oh, I missed the map over the list elements and slightly missread the
> code.  I thought (according to my incorrect perception of
> implementation) extra-config have to be either sxml or string, that's is
> why I said that it will fail earlier because plan string value won't
> satisfy list predicate attached to extra-config field, but in a fact
> extra-config is always a list, but can be a list of sxml's and strings
> mixed together.
>
> Thus, some of my comments are invalid.  Sorry for the confusion.  I'll
> rephrase and elaborate in the later message.

I was worried that I was the only one who did not understand the code I
wrote, but I've relieved to hear that it was a misunderstanding :)

Is it OK to have multiple data types (XML string and SXML list) in a
list?

>> We can specify invalid value such as (list "foo" '(foo bar) 123).
>>
>>> Also, making multi-type fields is debatable, but isn't great IMO.
>>
>> I see. If we had to choose one or the other, I would prefer the
>> string-type field.
>>
>>> If serialization would support G-exps, we could write
>>>
>>> (list #~"RAW_XML_HERE")
>>>
>>> or even something like this:
>>>
>>> (list #~(READ-THE-WHOLE-FILE #$(local-file "our-old.xml")))
>>
>> Does it mean that the specification does not allow it now? Or does it
>> mean that it is not possible with my implementation?
>>
>
> It's not possible with the current implementation.

I'll try to modify it so that it can support G-exps.

>>>> + ((? string? xml) (xml->sxml xml)) + (else + (raise
>>>> (formatted-message + (G_ "'extra-config' type must be xml string or
>>>> sxml list, was given: ~a") + value)))) + value))) +
>>>> +(define-configuration home-fontconfig-configuration +
>>>> (font-directories + (string-list (list guix-home-font-dir))
>>>
>>> It's not a generic string-list, but a specific font-directories-list
>>> with extra logic inside.
>>>
>>> Also, because guix-home-font-dir always added to the list, the default
>>> value should '() and field should be called additional-font-directories
>>> instead.  Otherwise it will be confusing, why guix-home-font-dir is not
>>> removed from the final configuration, when this field is set to a
>>> different value.
>>>
>>> I skimmed previous messages, but sorry, if I missed any already
>>> mentioned points.
>>
>> Sure, It is more appropriate that the field type is to
>> font-directories-list field name is to additional-font-directories.
>>
>
> As Liliana mentioned in the other message, it's better not to set
> anything implicitly.  It's better to keep the name, but change the
> implementation and remove implicitly and unconditionally added
> directory.

OK.  I'll modify the default value to an empty list and include
~/.guix-home/profile/share/fonts in the sample code in the
documentation.

>>>> +   "The directory list that provides fonts.")
>>>> +  (default-font-serif-family
>>>> +    maybe-string
>>>> +    "The preffered default fonts of serif.")
>>>> +  (default-font-sans-serif-family
>>>> +    maybe-string
>>>> +    "The preffered default fonts of sans-serif.")
>>>> +  (default-font-monospace-family
>>>> +    maybe-string
>>>> +    "The preffered default fonts of monospace.")
>>>> +  (extra-config
>>>> +   maybe-extra-config-list
>>>> +   "Extra configuration values to append to the fonts.conf."))
>>>> +
>>>> +(define (add-fontconfig-config-file user-config)
>>>>    `(("fontconfig/fonts.conf"
>>>>       ,(mixed-text-file
>>>>         "fonts.conf"
>>>>         "<?xml version='1.0'?>
>>>>  <!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
>>>> -<fontconfig>
>>>> -  <dir>~/.guix-home/profile/share/fonts</dir>
>>>> -</fontconfig>"))))
>>>> +<fontconfig>"
>>>> +       (serialize-configuration user-config home-fontconfig-configuration-fields)
>>>
>>> Just a thought for the future and a point for configuration module
>>> improvements: It would be cool if serialize-configuration and all other
>>> serialize- functions returned a G-exps, this way we could write
>>> something like that:
>>>
>>> (home-fontconfig-configuration
>>>  (font-directories (list (file-append font-iosevka "/share/fonts"))))
>>
>> Nice.
>>
>> Thanks,
>> --
>> Taiju

Thanks,
--
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 12 Oct 2022 07:07:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 12 03:07:55 2022
Received: from localhost ([127.0.0.1]:55484 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oiVqN-000609-46
	for submit <at> debbugs.gnu.org; Wed, 12 Oct 2022 03:07:55 -0400
Received: from relay7-d.mail.gandi.net ([217.70.183.200]:59823)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <andrew@HIDDEN>) id 1oiVqK-0005zv-Go
 for 57963 <at> debbugs.gnu.org; Wed, 12 Oct 2022 03:07:54 -0400
Received: (Authenticated sender: andrew@HIDDEN)
 by mail.gandi.net (Postfix) with ESMTPSA id 5723B20002;
 Wed, 12 Oct 2022 07:07:38 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=trop.in; s=gm1;
 t=1665558466;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:cc:mime-version:mime-version:content-type:content-type:
 in-reply-to:in-reply-to:references:references;
 bh=/PzoIGULmpAnquqMIavwc1diosV4ohbDDdhfCGK0fEo=;
 b=nZmFCoPkPqZ1V1+4xpYop9LZ0RKOQNcSsyJ1YzeC5BGa6EN1XnIXsbTTTN4GMRmPLv0mvZ
 wHVRlru59UNidONvRTBhHprKUbq7DORljT5f5epPAnTYR/oAHIVCjepM51e+z9I3aDw7Zf
 IdibFo7fckYC7pA3iSsOnqoJEefN4x37QjTLXSKD3wWVIhRzIkQQW7FCgrNE1h3xBFi7ym
 29umL3tmCFNlgk5coAL0h/vcK33WScmWKhrEIZLgUrI2Xxd5yMbmqvCDVD0wEgZa+HSZi6
 EUtmau8XoNhSK82IhiOK6wg9AMgXqmKS9AbYm4PZuM+GmJf45SRNE+MUzw7D6g==
From: Andrew Tropin <andrew@HIDDEN>
To: Liliana Marie Prikler <liliana.prikler@HIDDEN>, Taiju HIGASHI
 <higashi@HIDDEN>
Subject: Almost plain SXML serializer
In-Reply-To: <7a7ba84518d2f6afa387e1e2649bc249acd74750.camel@HIDDEN>
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN> <87zge4chb5.fsf@HIDDEN>
 <87edvfkob8.fsf@HIDDEN>
 <7a7ba84518d2f6afa387e1e2649bc249acd74750.camel@HIDDEN>
Date: Wed, 12 Oct 2022 11:07:33 +0400
Message-ID: <87pmexmsei.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, 57963 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

On 2022-10-11 06:21, Liliana Marie Prikler wrote:

> Am Dienstag, dem 11.10.2022 um 12:54 +0900 schrieb Taiju HIGASHI:
>> We can specify invalid value such as (list "foo" '(foo bar) 123).
> It will be sanitized before that.
>
>> > Also, making multi-type fields is debatable, but isn't great IMO.
>>=20
>> I see. If we had to choose one or the other, I would prefer the
>> string-type field.
> Prefer sexp-type.
>

Current (v5) extra-config has a list type.  This list can contain strings
and nested lists, string elements are for raw XML, and list
elements are for SXML.

This is done I guess to support following use case:

=2D-8<---------------cut here---------------start------------->8---
(list "<tag>Already existing XML copied from existing .xml file, which
we don't want to rewrite to SXML.</tag>"
      '((tag (@ (attr1 "value1")
                (attr2 "value2"))
             (nested "Part of the configuration defined with SXML")
             (empty)))
      "<another-tag>Maybe some other part of raw XML</another-tag>")
=2D-8<---------------cut here---------------end--------------->8---

This way we can combine SXML with already existing raw XML.

Am I right?

>> > If serialization would support G-exps, we could write
>> >=20
>> > (list #~"RAW_XML_HERE")
>> >=20
>> > or even something like this:
>> >=20
>> > (list #~(READ-THE-WHOLE-FILE #$(local-file "our-old.xml")))
>>=20
>> Does it mean that the specification does not allow it now? Or does it
>> mean that it is not possible with my implementation?
> I think your serialize would have to unpack the G-Expressions.  You can
> test that with some example configs of your own.
>
>> >=20
> Cheers

=2D-=20
Best regards,
Andrew Tropin

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCgAdFiEEKEGaxlA4dEDH6S/6IgjSCVjB3rAFAmNGZ7UACgkQIgjSCVjB
3rACTxAAgofw7IrJ8T85rEom7ncoIF3E20jNhvDa34qXS2oxAzrqgCJpNNHDQZfM
t2V7RI+oqeliC0doWQTmz+gSlpbL4ilX8cFTr12fROE6wS5Mn9KQH2jeRtkGK8eC
lBj22I7wnnQHYP+5nJWvF0maPZdPU914kXcxBmFN1wJuf5k5uL3uwJf8hgAxLDG/
mkmBgQ/PLLLxgKmDcx/YVb9roPQHG9Tz6W7rbVsoWZy+1bCLYkZApUIXDALGb82w
0YQ3gkTia1E6cNEtEkrOaFGLO1UQPZyEj6S7DvRqkoSH90J/ShaI5gTUYGLdCMC2
+EFwVH9YGW4Sb9DF5V2oVuJyT5nc+NMtjG+InBcKBgRoTLwFHejjLoROBFfqj2bx
QmB3lDzXmWmt9QSonfMEBK8VUi89wsDrFkIxafATm7x42Ck7GodyrP8jW1wRx2+M
m6m0isQ3ykIojEr9bkWGSJw+eFqEh3qPjohwcgRSxphd0w0Z+597oy2CfciXxJzo
C0LY4lnFyfirasQ5fMG78FKunHQwjE++EW6BTmaRPzAjB7sE6CTbFcMPp4mx1iyU
HMQxAQWl9IkyrSOuYu8ZT2+jhPAkh0Dn4DzgmEjBj1MxU3E9HMorwDm+YBP79Qsk
S9Q1iHk5AmXr4ULXF0KkZUDGdh5bpFawWdwSAEScMmpWg53TE5E=
=uiRO
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 12 Oct 2022 06:44:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 12 02:44:01 2022
Received: from localhost ([127.0.0.1]:55460 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oiVTF-0005NW-4j
	for submit <at> debbugs.gnu.org; Wed, 12 Oct 2022 02:44:01 -0400
Received: from relay7-d.mail.gandi.net ([217.70.183.200]:32903)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <andrew@HIDDEN>) id 1oiVTD-0005NG-6A
 for 57963 <at> debbugs.gnu.org; Wed, 12 Oct 2022 02:43:59 -0400
Received: (Authenticated sender: andrew@HIDDEN)
 by mail.gandi.net (Postfix) with ESMTPSA id 233EC2000C;
 Wed, 12 Oct 2022 06:43:50 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=trop.in; s=gm1;
 t=1665557033;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:cc:mime-version:mime-version:content-type:content-type:
 in-reply-to:in-reply-to:references:references;
 bh=cmaMxgd81WZYpB160gtAQ1zRhl47DwmtxsuskHgCpwY=;
 b=agA7ZkVMe7jZf2jGTez/4DJjtNpRYhMA3QTioShQ3g+68ce0fHtC6yYkPddWHE+kfa5VaH
 wfBxr1jG/NBnlxjiYkL/PzghZ7prPCvS601dJZ6yIcMrszWQKY460xkFZ8S6wM7soL9ToY
 +it8OZN3AmSdUOkUxl5mBnP36C8HctXmOuMlzROV8yw0dxx4lIdDZ53v7iPVeKZuzeUFdt
 HtCP5N93uHsJQxSqIuBJNLhhF0eJ0VaN+Bc01g+2iAAXb1I2Dd0FsfNBhl+BJTjILHjBpG
 ppBfm9moExEgVC5Zp82Z/FNLG3ZQCQcUYTeUdgeDSryX8BOM2OyZjFo+azfhAg==
From: Andrew Tropin <andrew@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>
Subject: Re: [PATCH v5 2/2] home: services: Support user's fontconfig
 configuration.
In-Reply-To: <87edvfkob8.fsf@HIDDEN>
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN> <87zge4chb5.fsf@HIDDEN>
 <87edvfkob8.fsf@HIDDEN>
Date: Wed, 12 Oct 2022 10:43:34 +0400
Message-ID: <87wn95mtih.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

On 2022-10-11 12:54, Taiju HIGASHI wrote:

> Hi Andrew,
>
> Thank you for your review!
>
>>> +(define (string-list? value)
>>> +  (and (pair? value) (every string? value)))
>>
>> Better to use list? here and in the other places, at least for the
>> consistency, but also for semantic meaning.
>
> OK. I'll rewrite it to below.
>
> --8<---------------cut here---------------start------------->8---
> (define (string-list? value)
>   (and (list? value) (every string? value)))
> --8<---------------cut here---------------end--------------->8---
>
>>> +
>>> +(define (serialize-string-list field-name value)
>>> +  (sxml->xml-string
>>> +   (map
>>> +    (lambda (path) `(dir ,path))
>>> +    (if (member guix-home-font-dir value)
>>> +        value
>>> +        (append (list guix-home-font-dir) value)))))
>>> +
>>> +(define (serialize-string field-name value)
>>> +  (define (serialize type value)
>>> +    (sxml->xml-string
>>> +     `(alias
>>> +       (family ,type)
>>> +       (prefer
>>> +        (family ,value)))))
>>> +  (match (list field-name value)
>>> +    (('default-font-serif-family family)
>>> +     (serialize 'serif family))
>>> +    (('default-font-sans-serif-family family)
>>> +     (serialize 'sans-serif family))
>>> +    (('default-font-monospace-family family)
>>> +     (serialize 'monospace family))))
>>> +
>>> +(define-maybe string)
>>> +
>>> +(define extra-config-list? list?)
>>> +
>>> +(define-maybe extra-config-list)
>>> +
>>> +(define (serialize-extra-config-list field-name value)
>>> +  (sxml->xml-string
>>> +   (map (match-lambda
>>> +          ((? pair? sxml) sxml)
>>
>> Other branches would never be visited because it will fail earlier by
>> define-configuration predicate check for extra-config-list? (which is
>> basically list?).

Oh, I missed the map over the list elements and slightly missread the
code.  I thought (according to my incorrect perception of
implementation) extra-config have to be either sxml or string, that's is
why I said that it will fail earlier because plan string value won't
satisfy list predicate attached to extra-config field, but in a fact
extra-config is always a list, but can be a list of sxml's and strings
mixed together.

Thus, some of my comments are invalid.  Sorry for the confusion.  I'll
rephrase and elaborate in the later message.

>
> We can specify invalid value such as (list "foo" '(foo bar) 123).
>
>> Also, making multi-type fields is debatable, but isn't great IMO.
>
> I see. If we had to choose one or the other, I would prefer the
> string-type field.
>
>> If serialization would support G-exps, we could write
>>
>> (list #~"RAW_XML_HERE")
>>
>> or even something like this:
>>
>> (list #~(READ-THE-WHOLE-FILE #$(local-file "our-old.xml")))
>
> Does it mean that the specification does not allow it now? Or does it
> mean that it is not possible with my implementation?
>

It's not possible with the current implementation.

>>> + ((? string? xml) (xml->sxml xml)) + (else + (raise
>>> (formatted-message + (G_ "'extra-config' type must be xml string or
>>> sxml list, was given: ~a") + value)))) + value))) +
>>> +(define-configuration home-fontconfig-configuration +
>>> (font-directories + (string-list (list guix-home-font-dir))
>>
>> It's not a generic string-list, but a specific font-directories-list
>> with extra logic inside.
>>
>> Also, because guix-home-font-dir always added to the list, the default
>> value should '() and field should be called additional-font-directories
>> instead.  Otherwise it will be confusing, why guix-home-font-dir is not
>> removed from the final configuration, when this field is set to a
>> different value.
>>
>> I skimmed previous messages, but sorry, if I missed any already
>> mentioned points.
>
> Sure, It is more appropriate that the field type is to
> font-directories-list field name is to additional-font-directories.
>

As Liliana mentioned in the other message, it's better not to set
anything implicitly.  It's better to keep the name, but change the
implementation and remove implicitly and unconditionally added
directory.

>>> +   "The directory list that provides fonts.")
>>> +  (default-font-serif-family
>>> +    maybe-string
>>> +    "The preffered default fonts of serif.")
>>> +  (default-font-sans-serif-family
>>> +    maybe-string
>>> +    "The preffered default fonts of sans-serif.")
>>> +  (default-font-monospace-family
>>> +    maybe-string
>>> +    "The preffered default fonts of monospace.")
>>> +  (extra-config
>>> +   maybe-extra-config-list
>>> +   "Extra configuration values to append to the fonts.conf."))
>>> +
>>> +(define (add-fontconfig-config-file user-config)
>>>    `(("fontconfig/fonts.conf"
>>>       ,(mixed-text-file
>>>         "fonts.conf"
>>>         "<?xml version=3D'1.0'?>
>>>  <!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
>>> -<fontconfig>
>>> -  <dir>~/.guix-home/profile/share/fonts</dir>
>>> -</fontconfig>"))))
>>> +<fontconfig>"
>>> +       (serialize-configuration user-config home-fontconfig-configurat=
ion-fields)
>>
>> Just a thought for the future and a point for configuration module
>> improvements: It would be cool if serialize-configuration and all other
>> serialize- functions returned a G-exps, this way we could write
>> something like that:
>>
>> (home-fontconfig-configuration
>>  (font-directories (list (file-append font-iosevka "/share/fonts"))))
>
> Nice.
>
> Thanks,
> --
> Taiju

=2D-=20
Best regards,
Andrew Tropin

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCgAdFiEEKEGaxlA4dEDH6S/6IgjSCVjB3rAFAmNGYhYACgkQIgjSCVjB
3rAPzw/+L/OhOp1INFRdX4m/Qp+1BbEo5hyEKHOkDk4USdpe9Olky2izvkTU8ujH
aeZU2m/+TsbtleJaIENasmzpIVds8TrUdItwaECOxjhmyG+PbvBZyhXiBvmzKp3p
AdxvbYSU3AVlVGKETs5suyNCail9JuX9JkaTAJFWJPm6Xc9FqZwXUtvdGC9FW/5p
px+hLw0upj2h0ZmSuDU7q2LMQFk7Iehiwf4VkTNxedacx6a6FkYF9upk+j1k5o+U
2XntQxcEiCH4bHfrSte8WfBKuCQid2cHj2mYedGZ1NiSaTr59CNUb3ZL+/ABRxYc
oFiw2IIq7LbOpmJym33PITsVm1OMChLZQfaMldBMXxrndrxl7vHw333DDhxMjWyz
dZunfZsRuwqnmSG8oVmljPd243Cc0SVvDY6IDiGPIbFiwoYO5mYUAth1+mES8CS5
YJKgzgjXsTI97nSlZ4zPagnhD1wrOZzzbHqkhaPPzVV+lQue8yWiIxZDhPZ7WMDb
MnV4tVoVt5U1+Nz9pGmEmjFq+AX4IoHDZilvdLA5Vtgd3xklduyqca6LRRPrNLKn
DdtX9DDPcVxNaVeReJ0D7vpH8ZF47PZH7gUPpOsGv9V1746SsMGas5kp2PNTB3ST
KOfwDGBp8+qeHFH+gemFP/ht8GI1KAgNpQ07631r+4w1w5aFvdI=
=mzvN
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 12 Oct 2022 06:06:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 12 02:06:22 2022
Received: from localhost ([127.0.0.1]:55358 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oiUso-0004P6-Jn
	for submit <at> debbugs.gnu.org; Wed, 12 Oct 2022 02:06:22 -0400
Received: from relay8-d.mail.gandi.net ([217.70.183.201]:47721)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <andrew@HIDDEN>) id 1oiUsk-0004Oq-GG
 for 57963 <at> debbugs.gnu.org; Wed, 12 Oct 2022 02:06:20 -0400
Received: (Authenticated sender: andrew@HIDDEN)
 by mail.gandi.net (Postfix) with ESMTPSA id 50F9E1BF205;
 Wed, 12 Oct 2022 06:06:04 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=trop.in; s=gm1;
 t=1665554772;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:cc:mime-version:mime-version:content-type:content-type:
 in-reply-to:in-reply-to:references:references;
 bh=4DlHWYaa223qzHAd0pxu45cOaQ83ywm5MJEr8CYs3Ss=;
 b=jLYEknW14crZvf7c7gZ4ZViKf2EXBHZAZUgMYmO+vg+s3gZzlmZxX4JSWtjZWAV4dePS2g
 lIox59vPqVZfNUZioP0ZtaDeCyEZdRWGPm05r3u6/CWOGBhodgYJq6+sirUxRkRQ6Z8V1s
 cYngwBZ7ubQktRR2pU/e8iDRGLoDkPLwB/M9DUirtc+C9NOJ3Vf9gJtfQpUY7xv8rCrOAi
 X56E2KLIvssskwN4l1UJnpMRLNU9YaznXfVCBpUiChphdhFRkUdnzqU1phvR9pE+nRAt/q
 3ko3H5/OjXKMuQeQ7Ngo7VmTWlH6M+U1OF39bhN9O1ihkU/pRg/y+1udlHs3RA==
From: Andrew Tropin <andrew@HIDDEN>
To: Liliana Marie Prikler <liliana.prikler@HIDDEN>, Taiju HIGASHI
 <higashi@HIDDEN>, 57963 <at> debbugs.gnu.org
Subject: Re: [PATCH v5 2/2] home: services: Support user's fontconfig
 configuration.
In-Reply-To: <c0d5bf21a99468571c7ba010e9eb9c329828dca8.camel@HIDDEN>
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN> <87zge4chb5.fsf@HIDDEN>
 <c0d5bf21a99468571c7ba010e9eb9c329828dca8.camel@HIDDEN>
Date: Wed, 12 Oct 2022 10:05:56 +0400
Message-ID: <87zge1mv97.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

On 2022-10-10 18:15, Liliana Marie Prikler wrote:

> Am Montag, dem 10.10.2022 um 10:40 +0400 schrieb Andrew Tropin:
>> Also, because guix-home-font-dir always added to the list, the
>> default value should '() and field should be called
>> additional-font-directories instead.=C2=A0 Otherwise it will be confusin=
g,
>> why guix-home-font-dir is not removed from the final configuration,
>> when this field is set to a different value.
> Actually, I think the default value should (if possible) explicitly
> contain the one being added by Guix Home.  I also think it shouldn't be
> added when the user explicitly removed it.
>

Completely agree.  Probably I had to be more explicit on the implication
of my comment.

=2D-=20
Best regards,
Andrew Tropin

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCgAdFiEEKEGaxlA4dEDH6S/6IgjSCVjB3rAFAmNGWUQACgkQIgjSCVjB
3rC0CQ/9EU30aFWBMMQCSTFJC/FnpUftnXg3HtPPG8fbVqL7ZfXJk71+KNiyuEcj
4sNrtJ46qATVv05l5/PzA9fvioshAY/yEj5MGesNlE2WVmmAFCR7LZucLijPDexu
OjEpAz/hrj9hXn+QWvD7Vj3Y3vZETzA8C+oaRe6X+hs2V8DF08yvUL1S2v/o4PeE
8mvCXYY+7Sa8jrphJjklWArBzr+OpR5yyyYqGEtDq1CVUPZMO1NoMWErcGl4fksv
PJuXSzkY5pCZGdVDWkQoDySitz+FzFaKzjGGvDLentK0gpisG1YL1rmkFhNsve8d
/xmCKvx2Us4lSI7NDqjo8FSxBx13r7GJwcbTpnP+K6ybjnvo/IJah0dXw2bGlHgt
hYOBDg3U+WktsDUTILLvBKSldK8LUMu52wZrjBDo+KM+H2vliMwv8DopQwvOOC+7
kfpn5dJaylG3MdA2Cu2Te5tqEeRL8MSZQtN5mDzJkpmDRXqtQyX3YJRVEaZLW1MU
1LkCg2OeuMKdneLUv4EyEpUsRF7vmX0MknRM7CHwgg6oFlIs1or0cuEHvMmj7Ob4
gMNFOyMWmWtVihD7Df3qqbuwQ/AWtgUbbKJboPF4QSMZhm9PYODzArpYs4AlD65m
im/aLHSv9t4VyMPOh7uG81EgRhWJIkvUoNLkKqXKw9Zoqb2KgRo=
=xw86
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 12 Oct 2022 04:21:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 12 00:21:19 2022
Received: from localhost ([127.0.0.1]:55317 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oiTF8-0001bd-JQ
	for submit <at> debbugs.gnu.org; Wed, 12 Oct 2022 00:21:19 -0400
Received: from mail-ej1-f68.google.com ([209.85.218.68]:43697)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <liliana.prikler@HIDDEN>) id 1oiTF5-0001bC-Gj
 for 57963 <at> debbugs.gnu.org; Wed, 12 Oct 2022 00:21:16 -0400
Received: by mail-ej1-f68.google.com with SMTP id d26so28370858eje.10
 for <57963 <at> debbugs.gnu.org>; Tue, 11 Oct 2022 21:21:15 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:from:to:cc:subject
 :date:message-id:reply-to;
 bh=Ddv8Wgp/ImDFeGgbLs5XLlbIG68BMh6jxdNjeUY0IYA=;
 b=dayf2nkQKhuD5etr/CK1cckcO0CQX2JyAZx9/SCEl8+fefM3zb7nxCXl+MOYey59bw
 ugeT77K1JrpI7y9Dm9rJw8zORpKN9Ml10BY6vLol8K3VDtQxAq9H4UotE57DsXJEArdl
 znuLYVRpm4PobTdWJ4VyxQSPpjCVwhc8g/4/KKWRqvtMNFmXuI4AAiioLqLxUDwOlTt7
 doK/IcobMfskAdLDa9SmLYgdA31mPIUjUVyKnKVTO0hEKAQJhDOen7+a8bkrBmHovrcD
 TZ3IrmnIAPcyXhVtQxjlu/jfVDXF0GTBCxAoyCO18CqUr3G7IGX3q9rYqK4m1fPjtI6v
 6zHA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:x-gm-message-state
 :from:to:cc:subject:date:message-id:reply-to;
 bh=Ddv8Wgp/ImDFeGgbLs5XLlbIG68BMh6jxdNjeUY0IYA=;
 b=quDq7eTMyROYW+DWK9POu/iz3Y8ir/jFKLZPfoP9nREZ60mAjGhBClDDzJNlDVG+/D
 vaR+8eKneVkhOMR6bQDIdnYdQKWdGl1BY2rn05xmvXL/1BaMlpv2nWHQYx4gDq8JWfmh
 r2+De9RTm5XU6fRrQ+pmtYQbgRJ0BVhGmte3jDN+i1jSL5FKHo7jBJK1F/bpqtW3t9OZ
 M8rV7K0zSZUM5U3dBkKCej/w2rUB9oWA96KJErZEYXro5AYG9DkceJ7Zx2tzwPmJ344M
 wWxEpxH2tWajY2fUGAARM9wyCCIu+h56FLdkjRzd0LwgVtLhPdwEZzXv3yDOuj6Gvnxt
 LOOw==
X-Gm-Message-State: ACrzQf3z0a6eQdOhIm4LPfMZjPpYCx5AOXb9IyJILPYJmjyQC+3hJe6i
 dhBUEp0rKS8QJbXMNY1Qs9I=
X-Google-Smtp-Source: AMsMyM5WMx8hNEdBcLPFwSKlezajV0sJFrXcjKbLlQL/JwVny7L8+VQebOu9hfLe/WnDM1gXXJzFLg==
X-Received: by 2002:a17:907:1b1e:b0:783:8e33:2d1c with SMTP id
 mp30-20020a1709071b1e00b007838e332d1cmr21013446ejc.304.1665548468435; 
 Tue, 11 Oct 2022 21:21:08 -0700 (PDT)
Received: from lumine.fritz.box (85-127-52-93.dsl.dynamic.surfer.at.
 [85.127.52.93]) by smtp.gmail.com with ESMTPSA id
 c12-20020aa7c98c000000b0045754cd5e08sm10381840edt.39.2022.10.11.21.21.07
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Tue, 11 Oct 2022 21:21:07 -0700 (PDT)
Message-ID: <0ead19bea58a05eccfe71d2d7035419bed33cf51.camel@HIDDEN>
Subject: Re: [PATCH v5 2/2] home: services: Support user's fontconfig
 configuration.
From: Liliana Marie Prikler <liliana.prikler@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>
Date: Wed, 12 Oct 2022 06:21:06 +0200
In-Reply-To: <875ygpk7zt.fsf@HIDDEN>
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN> <87zge4chb5.fsf@HIDDEN>
 <87edvfkob8.fsf@HIDDEN>
 <7a7ba84518d2f6afa387e1e2649bc249acd74750.camel@HIDDEN>
 <87pmeykchl.fsf@HIDDEN>
 <796ace856ca7ccb44fda2b15f8f7abc6990e53e0.camel@HIDDEN>
 <875ygpk7zt.fsf@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
User-Agent: Evolution 3.46.0 
MIME-Version: 1.0
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, 57963 <at> debbugs.gnu.org, Andrew Tropin <andrew@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Am Mittwoch, dem 12.10.2022 um 12:59 +0900 schrieb Taiju HIGASHI:
> Liliana Marie Prikler <liliana.prikler@HIDDEN> writes:
>=20
> > Am Dienstag, dem 11.10.2022 um 17:09 +0900 schrieb Taiju HIGASHI:
> > > Liliana Marie Prikler <liliana.prikler@HIDDEN> writes:
> > >=20
> > > > Am Dienstag, dem 11.10.2022 um 12:54 +0900 schrieb Taiju
> > > > HIGASHI:
> > > > > We can specify invalid value such as (list "foo" '(foo bar)
> > > > > 123).
> > > > It will be sanitized before that.
> > >=20
> > > I'm sorry, I may not be getting it.
> > >=20
> > > When I reconfigure with the following settings:
> > >=20
> > > --8<---------------cut here---------------start------------->8---
> > > (home-environment
> > > =C2=A0(packages (list font-google-noto))
> > > =C2=A0(services
> > > =C2=A0 (append
> > > =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (list
> > > =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (service home-bash-service-type)=
)
> > > =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (modify-services %home-base-services
> > > =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (home-fontconfig-service-t=
ype
> > > =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 config =3D> (home-fo=
ntconfig-configuration
> > > =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=
=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (extra-config
> > > =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=
=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (list "<dir>foo</dir>" =
123))))))))
> > > --8<---------------cut here---------------end--------------->8---
> > >=20
> > > The following error occurs.
> > >=20
> > > --8<---------------cut here---------------start------------->8---
> > > ./pre-inst-env guix home container home-fontconfig-config.scm
> > > Backtrace:
> > > In guix/monads.scm:
> > > =C2=A0=C2=A0=C2=A0 487:9 19 (_ _)
> > > In gnu/services.scm:
> > > =C2=A0 1137:16 18 (_ _)
> > > In guix/monads.scm:
> > > =C2=A0=C2=A0=C2=A0 487:9 17 (_ _)
> > > In gnu/services.scm:
> > > =C2=A0 1140:36 16 (_ _)
> > > In srfi/srfi-1.scm:
> > > =C2=A0=C2=A0 586:17 15 (map1 (#<<service> type: #<service-type home-
> > > fontconfig
> > > 7f1926abf=E2=80=A6>))
> > > In ice-9/eval.scm:
> > > =C2=A0=C2=A0=C2=A0 155:9 14 (_ #(#(#<directory (gnu home services fon=
tutils)
> > > 7f1926df8780>) #))
> > > =C2=A0=C2=A0=C2=A0 159:9 13 (_ #(#(#<directory (gnu home services fon=
tutils)
> > > 7f1926df8780>) #))
> > > =C2=A0=C2=A0 173:55 12 (_ #(#(#<directory (gnu home services fontutil=
s)
> > > 7f1926df8780>) #))
> > > In gnu/services/configuration.scm:
> > > =C2=A0=C2=A0=C2=A0 124:8 11 (serialize-configuration _ _)
> > > In srfi/srfi-1.scm:
> > > =C2=A0=C2=A0 586:29 10 (map1 (#<<configuration-field> name: font-
> > > directories
> > > type: str=E2=80=A6> =E2=80=A6))
> > > =C2=A0=C2=A0 586:29=C2=A0 9 (map1 (#<<configuration-field> name: defa=
ult-font-
> > > serif-
> > > family =E2=80=A6> =E2=80=A6))
> > > =C2=A0=C2=A0 586:29=C2=A0 8 (map1 (#<<configuration-field> name: defa=
ult-font-
> > > sans-
> > > serif-fa=E2=80=A6> =E2=80=A6))
> > > =C2=A0=C2=A0 586:29=C2=A0 7 (map1 (#<<configuration-field> name: defa=
ult-font-
> > > monospace-fam=E2=80=A6> =E2=80=A6))
> > > =C2=A0=C2=A0 586:17=C2=A0 6 (map1 (#<<configuration-field> name: extr=
a-config
> > > type:
> > > maybe-ext=E2=80=A6>))
> > > In ice-9/eval.scm:
> > > =C2=A0=C2=A0=C2=A0 155:9=C2=A0 5 (_ #(#(#<directory (gnu home service=
s fontutils)
> > > 7f1926df8780>) # =E2=80=A6))
> > > In srfi/srfi-1.scm:
> > > =C2=A0=C2=A0 586:29=C2=A0 4 (map1 ("<dir>foo</dir>" 123))
> > > =C2=A0=C2=A0 586:17=C2=A0 3 (map1 (123))
> > > In unknown file:
> > > =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 2 (raise=
 #<&formatted-message format: "'extra-config'
> > > type
> > > must be x=E2=80=A6>)
> > > In ice-9/boot-9.scm:
> > > =C2=A0 1685:16=C2=A0 1 (raise-exception _ #:continuable? _)
> > > =C2=A0 1685:16=C2=A0 0 (raise-exception _ #:continuable? _)
> > >=20
> > > ice-9/boot-9.scm:1685:16: In procedure raise-exception:
> > > Wrong type (expecting exact integer): #<&formatted-message
> > > format:
> > > "'extra-config' type must be xml string or sxml list, was given:
> > > ~a\n" arguments: (("<dir>foo</dir>" 123))>
> > > --8<---------------cut here---------------end--------------->8---
> > >=20
> > > Is it sanitized before?
> > That error seems to be coming from your sanitizer if I read this
> > correctly.
>=20
> Yes, I think so.=C2=A0 So I do not know what he meant when he said "Other
> branches would never be visited."
>=20
> =C2=A0=C2=A0=C2=A0 Other branches would never be visited because it will =
fail
> earlier
> =C2=A0=C2=A0=C2=A0 by define-configuration predicate check for extra-conf=
ig-list?
> =C2=A0=C2=A0=C2=A0 (which is basically list?).
>=20
> I may have misunderstood the location of the code to which his
> comment refers.
I think this basically means that you can't have a raw string, but only
a list of strings, which conflicts with how you distinguish xml and
sxml?

> > > > > > Also, making multi-type fields is debatable, but isn't
> > > > > > great
> > > > > > IMO.
> > > > >=20
> > > > > I see. If we had to choose one or the other, I would prefer
> > > > > the
> > > > > string-type field.
> > > > Prefer sexp-type.
> > >=20
> > > I too would like to write my settings in S-expression, but for
> > > users
> > > who know the XML format of fontconfig but do not know how to use
> > > SXML, I believe the effort of converting XML to SXML in their
> > > head
> > > and writing it cannot be ignored.
> > > Still, users can write settings in SXML and convert them to
> > > strings. That is a choice the user prefers to make; someone who
> > > doesn't know SXML writing strings and converting them to SXML is
> > > not
> > > a choice the user prefers to make.
> > You can likewise convert xml->sxml explicitly, there's not really
> > any
> > difference here.=C2=A0 Providing this in a sanitizer just makes it more
> > user-friendly.
>=20
> I believe the v5 patch currently does that. Do you think a multi-type
> field is acceptable? Or do you think it is better to keep only the
> SXML-type field?
I think the field, once sanitized, should be SXML.  I care little about
what happens before.

Cheers




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 12 Oct 2022 03:59:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 11 23:59:15 2022
Received: from localhost ([127.0.0.1]:55301 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oiStm-00011Q-Op
	for submit <at> debbugs.gnu.org; Tue, 11 Oct 2022 23:59:15 -0400
Received: from mail-pj1-f45.google.com ([209.85.216.45]:43889)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1oiStj-00011C-T4
 for 57963 <at> debbugs.gnu.org; Tue, 11 Oct 2022 23:59:13 -0400
Received: by mail-pj1-f45.google.com with SMTP id
 x31-20020a17090a38a200b0020d2afec803so866757pjb.2
 for <57963 <at> debbugs.gnu.org>; Tue, 11 Oct 2022 20:59:11 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:from:to:cc:subject
 :date:message-id:reply-to;
 bh=fPOk0XrT915N51kecWBvy6fSis3djAY65tGxCAFCeZE=;
 b=yLxEladtKDV3WP/iYZ09ZCrF+XEIRls1ZBpYz0UPGIw6jJ9FYjCsHSBvs8bGL3r39P
 6AJmaEoZsnjd0EMorkHOcLL3X3xf0u8J5KfE2HJABEZdCTgjaXQM0d+oYCZj5Bol/Har
 9FiEnqtTykkRGhicEac/g77VpYCYQh15mYFy1+P+iMdk6+zNeF/PcasvokPoZhqDTPUg
 /JrQTvUtRPXVIBkwFZGkh4/Hf+Eix6Csz7TEXF1ybcQue7lW4ypti1alSVaC8xi0/lap
 tSCJLFJX8sFQzUo+3JYW/cYC6il5csmh5u2YURELmE/GtfzJX2lbrfbTk2QE4JqbR1gV
 +M4A==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:x-gm-message-state
 :from:to:cc:subject:date:message-id:reply-to;
 bh=fPOk0XrT915N51kecWBvy6fSis3djAY65tGxCAFCeZE=;
 b=fYstF9anoywvo357dZ2nvML0cQ3QD32aDZfXlMcN5Qda+rovfUrMxnAoxajVWblr9t
 0jzjsm00f1hhJMVyZdSzr4+6IuS43o8/l665hjpFcBYHZsROJKx0Op7/WsoB0ZIjmQ45
 EIPc0fwHJS0b+NPH3RBb7yRQSQna7e49Lr2Zu+sOU5k1Hxfxq9QYATuPwGWPpWXCbm8T
 2jLGoF9o8MtE2Dj75AtAUOMbBb0JM81T5sY8I84RZQb8vKR+VBy1lhSFGAqUOd0xDq7V
 aBjqJXAPGWBO9SFpxl7JR8PVdt8QXWWUK1wHXtTUu+HXFWewkm3mvPbneqmbKrQK0JFq
 HKiw==
X-Gm-Message-State: ACrzQf0bODkekZ0NYNmgWmzIkcsxUgNGW1qySjYTfKXX+4MYKfnLsNYp
 ue/NI59ut/yxSGBP7UE0mlrHfA==
X-Google-Smtp-Source: AMsMyM6mSluQnG8j2TicfQAl0ChcYlsFq2crwij8Nj+3O+uxxzaurvuqdujdLUqA7/f0hPFpydlQWw==
X-Received: by 2002:a17:902:f689:b0:179:fdac:c4e2 with SMTP id
 l9-20020a170902f68900b00179fdacc4e2mr28232800plg.119.1665547145910; 
 Tue, 11 Oct 2022 20:59:05 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 p17-20020a170902ead100b0017f778d4543sm9379542pld.241.2022.10.11.20.59.03
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Tue, 11 Oct 2022 20:59:05 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Liliana Marie Prikler <liliana.prikler@HIDDEN>
Subject: Re: [PATCH v5 2/2] home: services: Support user's fontconfig
 configuration.
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN> <87zge4chb5.fsf@HIDDEN>
 <87edvfkob8.fsf@HIDDEN>
 <7a7ba84518d2f6afa387e1e2649bc249acd74750.camel@HIDDEN>
 <87pmeykchl.fsf@HIDDEN>
 <796ace856ca7ccb44fda2b15f8f7abc6990e53e0.camel@HIDDEN>
Date: Wed, 12 Oct 2022 12:59:02 +0900
In-Reply-To: <796ace856ca7ccb44fda2b15f8f7abc6990e53e0.camel@HIDDEN>
 (Liliana Marie Prikler's message of "Tue, 11 Oct 2022 20:24:48 +0200")
Message-ID: <875ygpk7zt.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, 57963 <at> debbugs.gnu.org, Andrew Tropin <andrew@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Liliana Marie Prikler <liliana.prikler@HIDDEN> writes:

> Am Dienstag, dem 11.10.2022 um 17:09 +0900 schrieb Taiju HIGASHI:
>> Liliana Marie Prikler <liliana.prikler@HIDDEN> writes:
>>
>> > Am Dienstag, dem 11.10.2022 um 12:54 +0900 schrieb Taiju HIGASHI:
>> > > We can specify invalid value such as (list "foo" '(foo bar) 123).
>> > It will be sanitized before that.
>>
>> I'm sorry, I may not be getting it.
>>
>> When I reconfigure with the following settings:
>>
>> --8<---------------cut here---------------start------------->8---
>> (home-environment
>> =C2=A0(packages (list font-google-noto))
>> =C2=A0(services
>> =C2=A0 (append
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (list
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (service home-bash-service-type))
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (modify-services %home-base-services
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (home-fontconfig-service-type
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 config =3D> (home-fontc=
onfig-configuration
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=
=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (extra-config
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=
=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (list "<dir>foo</dir>" 123=
))))))))
>> --8<---------------cut here---------------end--------------->8---
>>
>> The following error occurs.
>>
>> --8<---------------cut here---------------start------------->8---
>> ./pre-inst-env guix home container home-fontconfig-config.scm
>> Backtrace:
>> In guix/monads.scm:
>> =C2=A0=C2=A0=C2=A0 487:9 19 (_ _)
>> In gnu/services.scm:
>> =C2=A0 1137:16 18 (_ _)
>> In guix/monads.scm:
>> =C2=A0=C2=A0=C2=A0 487:9 17 (_ _)
>> In gnu/services.scm:
>> =C2=A0 1140:36 16 (_ _)
>> In srfi/srfi-1.scm:
>> =C2=A0=C2=A0 586:17 15 (map1 (#<<service> type: #<service-type home-font=
config
>> 7f1926abf=E2=80=A6>))
>> In ice-9/eval.scm:
>> =C2=A0=C2=A0=C2=A0 155:9 14 (_ #(#(#<directory (gnu home services fontut=
ils)
>> 7f1926df8780>) #))
>> =C2=A0=C2=A0=C2=A0 159:9 13 (_ #(#(#<directory (gnu home services fontut=
ils)
>> 7f1926df8780>) #))
>> =C2=A0=C2=A0 173:55 12 (_ #(#(#<directory (gnu home services fontutils)
>> 7f1926df8780>) #))
>> In gnu/services/configuration.scm:
>> =C2=A0=C2=A0=C2=A0 124:8 11 (serialize-configuration _ _)
>> In srfi/srfi-1.scm:
>> =C2=A0=C2=A0 586:29 10 (map1 (#<<configuration-field> name: font-directo=
ries
>> type: str=E2=80=A6> =E2=80=A6))
>> =C2=A0=C2=A0 586:29=C2=A0 9 (map1 (#<<configuration-field> name: default=
-font-serif-
>> family =E2=80=A6> =E2=80=A6))
>> =C2=A0=C2=A0 586:29=C2=A0 8 (map1 (#<<configuration-field> name: default=
-font-sans-
>> serif-fa=E2=80=A6> =E2=80=A6))
>> =C2=A0=C2=A0 586:29=C2=A0 7 (map1 (#<<configuration-field> name: default=
-font-
>> monospace-fam=E2=80=A6> =E2=80=A6))
>> =C2=A0=C2=A0 586:17=C2=A0 6 (map1 (#<<configuration-field> name: extra-c=
onfig type:
>> maybe-ext=E2=80=A6>))
>> In ice-9/eval.scm:
>> =C2=A0=C2=A0=C2=A0 155:9=C2=A0 5 (_ #(#(#<directory (gnu home services f=
ontutils)
>> 7f1926df8780>) # =E2=80=A6))
>> In srfi/srfi-1.scm:
>> =C2=A0=C2=A0 586:29=C2=A0 4 (map1 ("<dir>foo</dir>" 123))
>> =C2=A0=C2=A0 586:17=C2=A0 3 (map1 (123))
>> In unknown file:
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 2 (raise #<=
&formatted-message format: "'extra-config' type
>> must be x=E2=80=A6>)
>> In ice-9/boot-9.scm:
>> =C2=A0 1685:16=C2=A0 1 (raise-exception _ #:continuable? _)
>> =C2=A0 1685:16=C2=A0 0 (raise-exception _ #:continuable? _)
>>
>> ice-9/boot-9.scm:1685:16: In procedure raise-exception:
>> Wrong type (expecting exact integer): #<&formatted-message format:
>> "'extra-config' type must be xml string or sxml list, was given:
>> ~a\n" arguments: (("<dir>foo</dir>" 123))>
>> --8<---------------cut here---------------end--------------->8---
>>
>> Is it sanitized before?
> That error seems to be coming from your sanitizer if I read this
> correctly.

Yes, I think so.  So I do not know what he meant when he said "Other
branches would never be visited."

    Other branches would never be visited because it will fail earlier
    by define-configuration predicate check for extra-config-list?
    (which is basically list?).

I may have misunderstood the location of the code to which his comment
refers.

>> > > > Also, making multi-type fields is debatable, but isn't great
>> > > > IMO.
>> > >
>> > > I see. If we had to choose one or the other, I would prefer the
>> > > string-type field.
>> > Prefer sexp-type.
>>
>> I too would like to write my settings in S-expression, but for users
>> who know the XML format of fontconfig but do not know how to use
>> SXML, I believe the effort of converting XML to SXML in their head
>> and writing it cannot be ignored.
>> Still, users can write settings in SXML and convert them to
>> strings. That is a choice the user prefers to make; someone who
>> doesn't know SXML writing strings and converting them to SXML is not
>> a choice the user prefers to make.
> You can likewise convert xml->sxml explicitly, there's not really any
> difference here.  Providing this in a sanitizer just makes it more
> user-friendly.

I believe the v5 patch currently does that. Do you think a multi-type
field is acceptable? Or do you think it is better to keep only the
SXML-type field?

Cheers,
--=20
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 11 Oct 2022 18:24:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 11 14:24:59 2022
Received: from localhost ([127.0.0.1]:54787 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oiJw3-0004j8-Cl
	for submit <at> debbugs.gnu.org; Tue, 11 Oct 2022 14:24:59 -0400
Received: from mail-ed1-f68.google.com ([209.85.208.68]:45850)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <liliana.prikler@HIDDEN>) id 1oiJw1-0004it-8e
 for 57963 <at> debbugs.gnu.org; Tue, 11 Oct 2022 14:24:57 -0400
Received: by mail-ed1-f68.google.com with SMTP id a67so11985927edf.12
 for <57963 <at> debbugs.gnu.org>; Tue, 11 Oct 2022 11:24:57 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:from:to:cc:subject
 :date:message-id:reply-to;
 bh=M61TazbGJ+eo6EbfqzVekEDU9xa45ifiLMtgAgfebW0=;
 b=etzMX8lZRtAmToJTlnvyU45alV0bIq66lJ+B1U4C0y7wWJQGKPO7W1Hqu7DIgmkUoN
 1PZwSZYkT+LHjl3sXZW/UhxgAljEvdrLUzaEJwypeNstkoOoD5/ngb1rwKBU7PKwfc47
 /RcIjL9jo0zdPSAJL6VU5rAPtAy9g+Kg+lyFi8VVZQWo/+P8mKEGvppeg/rNSR0EY1ew
 m2SvKKMxt0PPH6pQsYa7SAnzUzdrhb2G4rSwUIcrL7myi26WDWNSoWacl8K6Xy7Hf9LD
 iuD63/FsOg3UDnoiAoMHZkyGYVNWn6OxtnJi6yom0u8NIkV9qIO+HVhmPeHcURafXL1R
 CwXQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:x-gm-message-state
 :from:to:cc:subject:date:message-id:reply-to;
 bh=M61TazbGJ+eo6EbfqzVekEDU9xa45ifiLMtgAgfebW0=;
 b=m/1n6VjdNHrknAx2BzHf7iM3PSe1mc1HTjhGO/l2cCA2CCwf7W1XfsEytH4sFZZZRN
 p2zRsydIAfKLR0vJYYnsbqxhLVDhcAT/uNY8yJC8rcxKeMRS8f2rtxOYUTaW4L5Adzy7
 QqJ9X63KI81Ff0sw0WM5fgCExKTypr5ATLjJMVU5OWA4LV8g2ATpbpzV+9e0+XZTvsU3
 QIXHKjZ5V2yveO+jGcYAemVugNX4+fLWdrakiey394ThRg4bLJ7uzw0RPI1F8mWhioy1
 12KQ08Oce3+H3HIkmmRqnwxs9opI+CrSuhRyiErpdHfWfI9TlkRxP7CcpN2UlHr0bE/9
 DmTg==
X-Gm-Message-State: ACrzQf11MtcBbwq0e/cphw3ErfSlXT2cVslQEhVQCze8nQhruk03b0Ka
 DaGZj7gyWLaaeMjZBNpXhds=
X-Google-Smtp-Source: AMsMyM5Vq/0Q2uFrjtK5Pgm4bK+s5IQST544SETJGXYG6VKzJIqpeaPe3EYK+rU9/6AzSTW/9zx1Sw==
X-Received: by 2002:a05:6402:847:b0:453:943b:bf4 with SMTP id
 b7-20020a056402084700b00453943b0bf4mr24355863edz.301.1665512691381; 
 Tue, 11 Oct 2022 11:24:51 -0700 (PDT)
Received: from lumine.fritz.box (85-127-52-93.dsl.dynamic.surfer.at.
 [85.127.52.93]) by smtp.gmail.com with ESMTPSA id
 gc22-20020a1709072b1600b0078cf8a743d6sm78352ejc.100.2022.10.11.11.24.49
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Tue, 11 Oct 2022 11:24:50 -0700 (PDT)
Message-ID: <796ace856ca7ccb44fda2b15f8f7abc6990e53e0.camel@HIDDEN>
Subject: Re: [PATCH v5 2/2] home: services: Support user's fontconfig
 configuration.
From: Liliana Marie Prikler <liliana.prikler@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>
Date: Tue, 11 Oct 2022 20:24:48 +0200
In-Reply-To: <87pmeykchl.fsf@HIDDEN>
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN> <87zge4chb5.fsf@HIDDEN>
 <87edvfkob8.fsf@HIDDEN>
 <7a7ba84518d2f6afa387e1e2649bc249acd74750.camel@HIDDEN>
 <87pmeykchl.fsf@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
User-Agent: Evolution 3.46.0 
MIME-Version: 1.0
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, 57963 <at> debbugs.gnu.org, Andrew Tropin <andrew@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Am Dienstag, dem 11.10.2022 um 17:09 +0900 schrieb Taiju HIGASHI:
> Liliana Marie Prikler <liliana.prikler@HIDDEN> writes:
>=20
> > Am Dienstag, dem 11.10.2022 um 12:54 +0900 schrieb Taiju HIGASHI:
> > > We can specify invalid value such as (list "foo" '(foo bar) 123).
> > It will be sanitized before that.
>=20
> I'm sorry, I may not be getting it.
>=20
> When I reconfigure with the following settings:
>=20
> --8<---------------cut here---------------start------------->8---
> (home-environment
> =C2=A0(packages (list font-google-noto))
> =C2=A0(services
> =C2=A0 (append
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (list
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (service home-bash-service-type))
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (modify-services %home-base-services
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (home-fontconfig-service-type
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 config =3D> (home-fontco=
nfig-configuration
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=
=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (extra-config
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=
=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (list "<dir>foo</dir>" 123=
))))))))
> --8<---------------cut here---------------end--------------->8---
>=20
> The following error occurs.
>=20
> --8<---------------cut here---------------start------------->8---
> ./pre-inst-env guix home container home-fontconfig-config.scm
> Backtrace:
> In guix/monads.scm:
> =C2=A0=C2=A0=C2=A0 487:9 19 (_ _)
> In gnu/services.scm:
> =C2=A0 1137:16 18 (_ _)
> In guix/monads.scm:
> =C2=A0=C2=A0=C2=A0 487:9 17 (_ _)
> In gnu/services.scm:
> =C2=A0 1140:36 16 (_ _)
> In srfi/srfi-1.scm:
> =C2=A0=C2=A0 586:17 15 (map1 (#<<service> type: #<service-type home-fontc=
onfig
> 7f1926abf=E2=80=A6>))
> In ice-9/eval.scm:
> =C2=A0=C2=A0=C2=A0 155:9 14 (_ #(#(#<directory (gnu home services fontuti=
ls)
> 7f1926df8780>) #))
> =C2=A0=C2=A0=C2=A0 159:9 13 (_ #(#(#<directory (gnu home services fontuti=
ls)
> 7f1926df8780>) #))
> =C2=A0=C2=A0 173:55 12 (_ #(#(#<directory (gnu home services fontutils)
> 7f1926df8780>) #))
> In gnu/services/configuration.scm:
> =C2=A0=C2=A0=C2=A0 124:8 11 (serialize-configuration _ _)
> In srfi/srfi-1.scm:
> =C2=A0=C2=A0 586:29 10 (map1 (#<<configuration-field> name: font-director=
ies
> type: str=E2=80=A6> =E2=80=A6))
> =C2=A0=C2=A0 586:29=C2=A0 9 (map1 (#<<configuration-field> name: default-=
font-serif-
> family =E2=80=A6> =E2=80=A6))
> =C2=A0=C2=A0 586:29=C2=A0 8 (map1 (#<<configuration-field> name: default-=
font-sans-
> serif-fa=E2=80=A6> =E2=80=A6))
> =C2=A0=C2=A0 586:29=C2=A0 7 (map1 (#<<configuration-field> name: default-=
font-
> monospace-fam=E2=80=A6> =E2=80=A6))
> =C2=A0=C2=A0 586:17=C2=A0 6 (map1 (#<<configuration-field> name: extra-co=
nfig type:
> maybe-ext=E2=80=A6>))
> In ice-9/eval.scm:
> =C2=A0=C2=A0=C2=A0 155:9=C2=A0 5 (_ #(#(#<directory (gnu home services fo=
ntutils)
> 7f1926df8780>) # =E2=80=A6))
> In srfi/srfi-1.scm:
> =C2=A0=C2=A0 586:29=C2=A0 4 (map1 ("<dir>foo</dir>" 123))
> =C2=A0=C2=A0 586:17=C2=A0 3 (map1 (123))
> In unknown file:
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 2 (raise #<&=
formatted-message format: "'extra-config' type
> must be x=E2=80=A6>)
> In ice-9/boot-9.scm:
> =C2=A0 1685:16=C2=A0 1 (raise-exception _ #:continuable? _)
> =C2=A0 1685:16=C2=A0 0 (raise-exception _ #:continuable? _)
>=20
> ice-9/boot-9.scm:1685:16: In procedure raise-exception:
> Wrong type (expecting exact integer): #<&formatted-message format:
> "'extra-config' type must be xml string or sxml list, was given:
> ~a\n" arguments: (("<dir>foo</dir>" 123))>
> --8<---------------cut here---------------end--------------->8---
>=20
> Is it sanitized before?
That error seems to be coming from your sanitizer if I read this
correctly.

> > > > Also, making multi-type fields is debatable, but isn't great
> > > > IMO.
> > >=20
> > > I see. If we had to choose one or the other, I would prefer the
> > > string-type field.
> > Prefer sexp-type.
>=20
> I too would like to write my settings in S-expression, but for users
> who know the XML format of fontconfig but do not know how to use
> SXML, I believe the effort of converting XML to SXML in their head
> and writing it cannot be ignored.
> Still, users can write settings in SXML and convert them to
> strings. That is a choice the user prefers to make; someone who
> doesn't know SXML writing strings and converting them to SXML is not
> a choice the user prefers to make.
You can likewise convert xml->sxml explicitly, there's not really any
difference here.  Providing this in a sanitizer just makes it more
user-friendly.

Cheers




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 11 Oct 2022 08:09:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 11 04:09:54 2022
Received: from localhost ([127.0.0.1]:50787 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oiAKo-0000Wr-CR
	for submit <at> debbugs.gnu.org; Tue, 11 Oct 2022 04:09:54 -0400
Received: from mail-pj1-f41.google.com ([209.85.216.41]:37433)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1oiAKm-0000Wc-JL
 for 57963 <at> debbugs.gnu.org; Tue, 11 Oct 2022 04:09:53 -0400
Received: by mail-pj1-f41.google.com with SMTP id
 p3-20020a17090a284300b0020a85fa3ffcso15277116pjf.2
 for <57963 <at> debbugs.gnu.org>; Tue, 11 Oct 2022 01:09:52 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:from:to:cc:subject:date:message-id:reply-to;
 bh=RWsntEowhaQNEfUjM7GeMpePGIUh4tTsqTKqmm+nzNM=;
 b=GZuv2aw7AF7kml/iCo5mISdkd67IddRwB/o41WvNU64Wso9kEfIvkHA5eRrhmMFJBq
 JUDxzR3QtB46bQAS1O24lFEVzapKAQ5cgdouiKOl/aM+8ZkFz/Vd2+CQksbyWuzulKEl
 DZr+WzQ9DzS8WXBAV7sevZED0yY9no3yuNJUK7SgQfSOLzSXbho001XCz6qZ7CX8bot3
 SERKtb6JTeTENaYM4nsM3hl2cqpFggHx0b9XN7IX8JC8JwnWN/S+KwkiTDZhldmJpd9Y
 9wNGbbfiSENzJyQss6lSYSvhu6yM0vrwX4neiWaGbTleZbtYBc7qEFaJYqR569+JuIHj
 VV7A==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:x-gm-message-state:from:to:cc:subject:date
 :message-id:reply-to;
 bh=RWsntEowhaQNEfUjM7GeMpePGIUh4tTsqTKqmm+nzNM=;
 b=MpTTcxnq+V5IDliwB2EZyn7qZ6stNmqwpzsI4YtkXJRsS/RUrsrF2/gMQGjY7HG+SB
 QyzJbwphPUahjl4NQge1un5lFdpGJs1W9W1eZds/4ECp4Y77B8HiE1n5Vw67kCOoXo5q
 ERnFaDfMsEHxhLF8yeT3bSWwGHu4lq7Q67Dgc9/5UJ4iwNo1GT/XnSKLJML3/IKM3ybR
 TDrgOCYB6KhRYSkq25Asfb4hyKckCuYldFqEHfq73y0do2ifGZzFFeHih5NWAPGNWdp0
 6sGV87oK2JZPfXTTS21hjdY+btFJmNKF0EWzyoM5odWDlyh9cUzDhZvXMZre+pGwggZM
 cKjw==
X-Gm-Message-State: ACrzQf0yGg3IsIZKpKGQOaw7XC5xp6f0yjYCGVuhh6r/yinNaqZ7Wugz
 xNh0CHQZXqgofUI3dGowvAWZ5g==
X-Google-Smtp-Source: AMsMyM6zM4EMBTbW1m1K9UngnTTmm43NiDtK2cPmdQQVG9pnQYuzS2tcE88IWxXejgmM8S6e9/amZw==
X-Received: by 2002:a17:90b:4c0d:b0:20d:43db:cc14 with SMTP id
 na13-20020a17090b4c0d00b0020d43dbcc14mr10216353pjb.119.1665475786557; 
 Tue, 11 Oct 2022 01:09:46 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 y19-20020aa79af3000000b00560c9048569sm6542969pfp.67.2022.10.11.01.09.45
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Tue, 11 Oct 2022 01:09:46 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Liliana Marie Prikler <liliana.prikler@HIDDEN>
Subject: Re: [PATCH v5 2/2] home: services: Support user's fontconfig
 configuration.
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN> <87zge4chb5.fsf@HIDDEN>
 <87edvfkob8.fsf@HIDDEN>
 <7a7ba84518d2f6afa387e1e2649bc249acd74750.camel@HIDDEN>
Date: Tue, 11 Oct 2022 17:09:42 +0900
In-Reply-To: <7a7ba84518d2f6afa387e1e2649bc249acd74750.camel@HIDDEN>
 (Liliana Marie Prikler's message of "Tue, 11 Oct 2022 06:21:49 +0200")
Message-ID: <87pmeykchl.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-2022-jp
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, 57963 <at> debbugs.gnu.org, Andrew Tropin <andrew@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Liliana Marie Prikler <liliana.prikler@HIDDEN> writes:

> Am Dienstag, dem 11.10.2022 um 12:54 +0900 schrieb Taiju HIGASHI:
>> We can specify invalid value such as (list "foo" '(foo bar) 123).
> It will be sanitized before that.

I'm sorry, I may not be getting it.

When I reconfigure with the following settings:

--8<---------------cut here---------------start------------->8---
(home-environment
 (packages (list font-google-noto))
 (services
  (append
      (list
       (service home-bash-service-type))
      (modify-services %home-base-services
        (home-fontconfig-service-type
         config => (home-fontconfig-configuration
                    (extra-config
                     (list "<dir>foo</dir>" 123))))))))
--8<---------------cut here---------------end--------------->8---

The following error occurs.

--8<---------------cut here---------------start------------->8---
./pre-inst-env guix home container home-fontconfig-config.scm
Backtrace:
In guix/monads.scm:
    487:9 19 (_ _)
In gnu/services.scm:
  1137:16 18 (_ _)
In guix/monads.scm:
    487:9 17 (_ _)
In gnu/services.scm:
  1140:36 16 (_ _)
In srfi/srfi-1.scm:
   586:17 15 (map1 (#<<service> type: #<service-type home-fontconfig 7f1926abf…>))
In ice-9/eval.scm:
    155:9 14 (_ #(#(#<directory (gnu home services fontutils) 7f1926df8780>) #))
    159:9 13 (_ #(#(#<directory (gnu home services fontutils) 7f1926df8780>) #))
   173:55 12 (_ #(#(#<directory (gnu home services fontutils) 7f1926df8780>) #))
In gnu/services/configuration.scm:
    124:8 11 (serialize-configuration _ _)
In srfi/srfi-1.scm:
   586:29 10 (map1 (#<<configuration-field> name: font-directories type: str…> …))
   586:29  9 (map1 (#<<configuration-field> name: default-font-serif-family …> …))
   586:29  8 (map1 (#<<configuration-field> name: default-font-sans-serif-fa…> …))
   586:29  7 (map1 (#<<configuration-field> name: default-font-monospace-fam…> …))
   586:17  6 (map1 (#<<configuration-field> name: extra-config type: maybe-ext…>))
In ice-9/eval.scm:
    155:9  5 (_ #(#(#<directory (gnu home services fontutils) 7f1926df8780>) # …))
In srfi/srfi-1.scm:
   586:29  4 (map1 ("<dir>foo</dir>" 123))
   586:17  3 (map1 (123))
In unknown file:
           2 (raise #<&formatted-message format: "'extra-config' type must be x…>)
In ice-9/boot-9.scm:
  1685:16  1 (raise-exception _ #:continuable? _)
  1685:16  0 (raise-exception _ #:continuable? _)

ice-9/boot-9.scm:1685:16: In procedure raise-exception:
Wrong type (expecting exact integer): #<&formatted-message format: "'extra-config' type must be xml string or sxml list, was given: ~a\n" arguments: (("<dir>foo</dir>" 123))>
--8<---------------cut here---------------end--------------->8---

Is it sanitized before?

>> > Also, making multi-type fields is debatable, but isn't great IMO.
>>
>> I see. If we had to choose one or the other, I would prefer the
>> string-type field.
> Prefer sexp-type.

I too would like to write my settings in S-expression, but for users who
know the XML format of fontconfig but do not know how to use SXML, I
believe the effort of converting XML to SXML in their head and writing
it cannot be ignored.
Still, users can write settings in SXML and convert them to
strings. That is a choice the user prefers to make; someone who doesn't
know SXML writing strings and converting them to SXML is not a choice
the user prefers to make.

>> > If serialization would support G-exps, we could write
>> >
>> > (list #~"RAW_XML_HERE")
>> >
>> > or even something like this:
>> >
>> > (list #~(READ-THE-WHOLE-FILE #$(local-file "our-old.xml")))
>>
>> Does it mean that the specification does not allow it now? Or does it
>> mean that it is not possible with my implementation?
> I think your serialize would have to unpack the G-Expressions.  You can
> test that with some example configs of your own.

Thank you. I'll give it a try.

Thanks,
-- 
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 11 Oct 2022 04:22:00 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 11 00:22:00 2022
Received: from localhost ([127.0.0.1]:50515 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oi6mG-0002v2-GY
	for submit <at> debbugs.gnu.org; Tue, 11 Oct 2022 00:22:00 -0400
Received: from mail-ej1-f65.google.com ([209.85.218.65]:46788)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <liliana.prikler@HIDDEN>) id 1oi6mE-0002up-W0
 for 57963 <at> debbugs.gnu.org; Tue, 11 Oct 2022 00:21:59 -0400
Received: by mail-ej1-f65.google.com with SMTP id bj12so28693791ejb.13
 for <57963 <at> debbugs.gnu.org>; Mon, 10 Oct 2022 21:21:58 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:from:to:cc:subject
 :date:message-id:reply-to;
 bh=3c06n3ShzxKLW2EmBihlr9LETxK5OU/3BW4Q+LL6gK8=;
 b=hBR0pKml0l3AudWT4jkFF3oNndznu2Palu4u8BoqSYKP0KCAEURG7qOjWzJYMjaZ1u
 1xYgQiA7lunULkCpesnxEiEWKzOQqbbafUGZuPZpR/pgEutIbVmuB/vS0EsDGF77sT+z
 VBGOLjKTUt14Fa1pSW0ddYSVMyK92HS3LOiWiOK6YGUAt35AdA41tvFlKXjOURkr6JKW
 TS2qomqfSSb33EwAobWuUPSh5e+WAku41auwfRRjasA0zI55feAqhjLR3bOxWBUz21bt
 J9QmEcAQVWexBZZ4srZqYHXwNtDHxprK5Cwj2NPnjy4ji5uzGo141HuV8wAhtnU2Bx9b
 gndw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:x-gm-message-state
 :from:to:cc:subject:date:message-id:reply-to;
 bh=3c06n3ShzxKLW2EmBihlr9LETxK5OU/3BW4Q+LL6gK8=;
 b=0I0Hrp25PWvXKYOYEhqjiAieJ6lasHbL9nOaBfJ1Tx7aDrlLH6FZh83Wt6THxACULI
 +p59UydFtQvZbMzQgHR/tfixuWSwOZOzbSQIRk9wDs3vp0xc8Qsq1RWTTEfqRpNc6VKp
 u74FMPIDQJTgCOE8dJX+rfSu0+KBLjzCmmPbAjTZjXWRf5CVKdDunazRoJWSZ2+7d6m2
 qPZwaaELFI84VN0Nxh2ua5miq/H1T+fBSbRFll0r/1TAfa8OdfiWvuc//53P9ZMMmUAB
 HmpMT4zBJQq4e609qR783c9gTQ/bLXtbO31WwTixUaTnTh6FA6SOV6l8V2bNXzrIOHG7
 96Zg==
X-Gm-Message-State: ACrzQf0rfjtFF/x5ANplgQrrgKMrHbQtWXvK0frm4o8isaYZY2uyLyee
 Uo1ttVyqLkxJ+g91faykKoA=
X-Google-Smtp-Source: AMsMyM52dB816eoTz/TTlIJnnDKFfJfQJ+LxGGHO0Nu1JRa/s/7YWeDHndWJeJLeEx7SNIwT83ex5g==
X-Received: by 2002:a17:907:1dc7:b0:78d:c153:d64a with SMTP id
 og7-20020a1709071dc700b0078dc153d64amr4876392ejc.429.1665462111995; 
 Mon, 10 Oct 2022 21:21:51 -0700 (PDT)
Received: from lumine.fritz.box (85-127-52-93.dsl.dynamic.surfer.at.
 [85.127.52.93]) by smtp.gmail.com with ESMTPSA id
 bm22-20020a0564020b1600b0044f21c69608sm8170493edb.10.2022.10.10.21.21.51
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Mon, 10 Oct 2022 21:21:51 -0700 (PDT)
Message-ID: <7a7ba84518d2f6afa387e1e2649bc249acd74750.camel@HIDDEN>
Subject: Re: [PATCH v5 2/2] home: services: Support user's fontconfig
 configuration.
From: Liliana Marie Prikler <liliana.prikler@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>, Andrew Tropin <andrew@HIDDEN>
Date: Tue, 11 Oct 2022 06:21:49 +0200
In-Reply-To: <87edvfkob8.fsf@HIDDEN>
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN> <87zge4chb5.fsf@HIDDEN>
 <87edvfkob8.fsf@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
User-Agent: Evolution 3.46.0 
MIME-Version: 1.0
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, 57963 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Am Dienstag, dem 11.10.2022 um 12:54 +0900 schrieb Taiju HIGASHI:
> We can specify invalid value such as (list "foo" '(foo bar) 123).
It will be sanitized before that.

> > Also, making multi-type fields is debatable, but isn't great IMO.
>=20
> I see. If we had to choose one or the other, I would prefer the
> string-type field.
Prefer sexp-type.

> > If serialization would support G-exps, we could write
> >=20
> > (list #~"RAW_XML_HERE")
> >=20
> > or even something like this:
> >=20
> > (list #~(READ-THE-WHOLE-FILE #$(local-file "our-old.xml")))
>=20
> Does it mean that the specification does not allow it now? Or does it
> mean that it is not possible with my implementation?
I think your serialize would have to unpack the G-Expressions.  You can
test that with some example configs of your own.

> >=20
Cheers




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 11 Oct 2022 03:54:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 10 23:54:31 2022
Received: from localhost ([127.0.0.1]:50479 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oi6Le-0002DW-Qe
	for submit <at> debbugs.gnu.org; Mon, 10 Oct 2022 23:54:31 -0400
Received: from mail-pj1-f54.google.com ([209.85.216.54]:52187)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1oi6Ld-0002DJ-E0
 for 57963 <at> debbugs.gnu.org; Mon, 10 Oct 2022 23:54:29 -0400
Received: by mail-pj1-f54.google.com with SMTP id b15so11424221pje.1
 for <57963 <at> debbugs.gnu.org>; Mon, 10 Oct 2022 20:54:29 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:from:to:cc:subject:date:message-id:reply-to;
 bh=Q/YEJIrUxmquULnG66dWQoiznxeIFPGI0zxsfwYXUoY=;
 b=iFvCZQjPlEK7mk1tWSiFW0h4H/ljP9iywge9ua7YCD7OxyKP4mBV+GYdaEGa6HnIMd
 Nx/7QLa3levHA+NZkvxTb+KeFZXcKjkQxUXzPo8OHbo/eJ9Hdd+H6Pb5UfXSjLaeyvS6
 kDvLc6u09GuxJ8P0Kub+nWCR3PQ6W26zT8Si5U8+Bi+b9XnfDZ4oK3xaCNZbV1tv2BO6
 5jmjWgJZPLFx01BGqOGfaXEfmDiuuSdbzMWWqK59TwIOupxTWSkqHtN3klzSOTMPLORn
 vcur8xzOPICBWV+bKfwqBdceuziu/rNxe66grI/lDTN5th+UFwT/+7U+eqy0Ltjeidva
 hSLw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:x-gm-message-state:from:to:cc:subject:date
 :message-id:reply-to;
 bh=Q/YEJIrUxmquULnG66dWQoiznxeIFPGI0zxsfwYXUoY=;
 b=irGMntzVyRAq1840ua/hBnNtrv9WctEbsb4jdMUxMJwVVYCH8siB1YtEzcO2XnKInL
 w3o9PRxm7rkPt+IvChf8dOruCx1vTlPf/5ttuJQiEjzP8BvEew2QKuym8o79d2yLUL04
 izm7JZHXjqitisK6OMYB+G/0fR0xID+LykVZhKo1YGaD/lBjF4BMjvNYLqqRUnlTPe+V
 DdhBCvBeg+yk6X0u6ZE5Z+B59Z25juVEoJsdy6+GHbgY5DiNT6q4HIc2jYOr//aOtEVk
 G5c2T56gyhTJIZ41aPgeMJ1ScpXFKf8+UF2otGF/TR/wGXLU40VFMgVaNqhGixl9rNAL
 VxWw==
X-Gm-Message-State: ACrzQf0RzhU7JLB5egDUr6Ff3M2aZPKpcgD/WAInVV7w2wEr0zVHULak
 Z7swMj09RRaM4Dunex7/P0MglA==
X-Google-Smtp-Source: AMsMyM4cINMN016fvlTWf4mlxlFVvmNIHqgOFWlGWn+/SUUHJ32/1bT/eAbba4hEmXG7HluHOZcRPg==
X-Received: by 2002:a17:90a:d191:b0:20d:2649:43b1 with SMTP id
 fu17-20020a17090ad19100b0020d264943b1mr14481197pjb.154.1665460463447; 
 Mon, 10 Oct 2022 20:54:23 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 y126-20020a623284000000b00562f9ea47a5sm5433341pfy.190.2022.10.10.20.54.21
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Mon, 10 Oct 2022 20:54:22 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Andrew Tropin <andrew@HIDDEN>
Subject: Re: [PATCH v5 2/2] home: services: Support user's fontconfig
 configuration.
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN> <87zge4chb5.fsf@HIDDEN>
Date: Tue, 11 Oct 2022 12:54:19 +0900
In-Reply-To: <87zge4chb5.fsf@HIDDEN> (Andrew Tropin's message of "Mon, 10 Oct
 2022 10:40:30 +0400")
Message-ID: <87edvfkob8.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Andrew,

Thank you for your review!

>> +(define (string-list? value)
>> +  (and (pair? value) (every string? value)))
>
> Better to use list? here and in the other places, at least for the
> consistency, but also for semantic meaning.

OK. I'll rewrite it to below.

--8<---------------cut here---------------start------------->8---
(define (string-list? value)
  (and (list? value) (every string? value)))
--8<---------------cut here---------------end--------------->8---

>> +
>> +(define (serialize-string-list field-name value)
>> +  (sxml->xml-string
>> +   (map
>> +    (lambda (path) `(dir ,path))
>> +    (if (member guix-home-font-dir value)
>> +        value
>> +        (append (list guix-home-font-dir) value)))))
>> +
>> +(define (serialize-string field-name value)
>> +  (define (serialize type value)
>> +    (sxml->xml-string
>> +     `(alias
>> +       (family ,type)
>> +       (prefer
>> +        (family ,value)))))
>> +  (match (list field-name value)
>> +    (('default-font-serif-family family)
>> +     (serialize 'serif family))
>> +    (('default-font-sans-serif-family family)
>> +     (serialize 'sans-serif family))
>> +    (('default-font-monospace-family family)
>> +     (serialize 'monospace family))))
>> +
>> +(define-maybe string)
>> +
>> +(define extra-config-list? list?)
>> +
>> +(define-maybe extra-config-list)
>> +
>> +(define (serialize-extra-config-list field-name value)
>> +  (sxml->xml-string
>> +   (map (match-lambda
>> +          ((? pair? sxml) sxml)
>
> Other branches would never be visited because it will fail earlier by
> define-configuration predicate check for extra-config-list? (which is
> basically list?).

We can specify invalid value such as (list "foo" '(foo bar) 123).

> Also, making multi-type fields is debatable, but isn't great IMO.

I see. If we had to choose one or the other, I would prefer the
string-type field.

> If serialization would support G-exps, we could write
>
> (list #~"RAW_XML_HERE")
>
> or even something like this:
>
> (list #~(READ-THE-WHOLE-FILE #$(local-file "our-old.xml")))

Does it mean that the specification does not allow it now? Or does it
mean that it is not possible with my implementation?

>> +          ((? string? xml) (xml->sxml xml))
>> +          (else
>> +           (raise (formatted-message
>> + (G_ "'extra-config' type must be xml string or sxml list, was
>> given: ~a")
>> +                   value))))
>> +        value)))
>> +
>> +(define-configuration home-fontconfig-configuration
>> +  (font-directories
>> +   (string-list (list guix-home-font-dir))
>
> It's not a generic string-list, but a specific font-directories-list
> with extra logic inside.
>
> Also, because guix-home-font-dir always added to the list, the default
> value should '() and field should be called additional-font-directories
> instead.  Otherwise it will be confusing, why guix-home-font-dir is not
> removed from the final configuration, when this field is set to a
> different value.
>
> I skimmed previous messages, but sorry, if I missed any already
> mentioned points.

Sure, It is more appropriate that the field type is to
font-directories-list field name is to additional-font-directories.

>> +   "The directory list that provides fonts.")
>> +  (default-font-serif-family
>> +    maybe-string
>> +    "The preffered default fonts of serif.")
>> +  (default-font-sans-serif-family
>> +    maybe-string
>> +    "The preffered default fonts of sans-serif.")
>> +  (default-font-monospace-family
>> +    maybe-string
>> +    "The preffered default fonts of monospace.")
>> +  (extra-config
>> +   maybe-extra-config-list
>> +   "Extra configuration values to append to the fonts.conf."))
>> +
>> +(define (add-fontconfig-config-file user-config)
>>    `(("fontconfig/fonts.conf"
>>       ,(mixed-text-file
>>         "fonts.conf"
>>         "<?xml version='1.0'?>
>>  <!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
>> -<fontconfig>
>> -  <dir>~/.guix-home/profile/share/fonts</dir>
>> -</fontconfig>"))))
>> +<fontconfig>"
>> +       (serialize-configuration user-config home-fontconfig-configuration-fields)
>
> Just a thought for the future and a point for configuration module
> improvements: It would be cool if serialize-configuration and all other
> serialize- functions returned a G-exps, this way we could write
> something like that:
>
> (home-fontconfig-configuration
>  (font-directories (list (file-append font-iosevka "/share/fonts"))))

Nice.

Thanks,
--
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 10 Oct 2022 16:15:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 10 12:15:47 2022
Received: from localhost ([127.0.0.1]:49640 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ohvRT-00011Z-Bi
	for submit <at> debbugs.gnu.org; Mon, 10 Oct 2022 12:15:47 -0400
Received: from mail-ed1-f66.google.com ([209.85.208.66]:43002)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <liliana.prikler@HIDDEN>) id 1ohvRR-00011M-Lx
 for 57963 <at> debbugs.gnu.org; Mon, 10 Oct 2022 12:15:46 -0400
Received: by mail-ed1-f66.google.com with SMTP id u21so16554876edi.9
 for <57963 <at> debbugs.gnu.org>; Mon, 10 Oct 2022 09:15:45 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:from:to:cc:subject
 :date:message-id:reply-to;
 bh=NtAzRgS+L2r3TjeFVC/cQFa/qPiozpqC9I8VM/Cdz6c=;
 b=iP+gG7fdrURbaugdtLgzVbknhmG5DbwsY1TQvuYaItXfWtXkhvciT8T5paLqZmfBQK
 vgKdat0T1a9T/o4O0fLAlCmm3feH08Lsp9D2GDSOqIck+PHze4KE8k+tII/U5XdcjRCa
 hjF7EWj0ZxjlKI+/Zl+jT+KZwls3HAMLjolHkBf7ps8eY6owV3ilPQUWqAHWJcO4B2ly
 bCKsi1lEii+tAn3z5NweRz3FM777rdvIiKMAhi2EVjIuPdft6nt5Hs6FuCSCEPi7hVnl
 PhChqmqQjWkHeMVO/wz2YS1ver2bjP++WibmEsmCoUIDiH5vDa7TdpoGSGCFBNP5DgJ4
 H+gQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:x-gm-message-state
 :from:to:cc:subject:date:message-id:reply-to;
 bh=NtAzRgS+L2r3TjeFVC/cQFa/qPiozpqC9I8VM/Cdz6c=;
 b=4lT/8Jbbz6w129ZEQSsBSSwC284P+GlRJOX5z9qZOYVCul0/CIPH8ZJK5aIlUjLJmv
 HB6d+00O1wk0Lz+KVq7bGOBQwNq9dteqUtB4KSGUt3WP121hetnS8AmhU/khrK8PJmH/
 7ANp+kzFCve1k1aAIDTMrLFC4A1W/WatFeXgbgtf+80YNkpKYT//2QmjEnRDVCZVpV6B
 bha3bR/Cu5GNLIm/oma+iVJp4x5Oiw/0xw7Y2QsX16LPe4O9BETkrQQmvY3irlMo2PnA
 mOtCQy+hyEk/TXGqm4e7A8+YJFqzRzYxilaY4GfFBd34Kat7Fwx8LqEwhzidJXSQ2LPx
 cN+A==
X-Gm-Message-State: ACrzQf0TPKiabcJ4arSB8BcOXQv1/HicChvgwTmcqt0U184G4fTxpaRO
 Sa5C3POUFd4l1IKotoh+MPM=
X-Google-Smtp-Source: AMsMyM5rEDnO5iKJt6YhsdrpAG6V/TKRb5Fi4x2WzW2XA6SrSnrh6sutzpix7JzVkGuiHLfWWBwkvw==
X-Received: by 2002:a05:6402:493:b0:445:b5f0:7a0f with SMTP id
 k19-20020a056402049300b00445b5f07a0fmr18519194edv.120.1665418539532; 
 Mon, 10 Oct 2022 09:15:39 -0700 (PDT)
Received: from lumine.fritz.box (85-127-52-93.dsl.dynamic.surfer.at.
 [85.127.52.93]) by smtp.gmail.com with ESMTPSA id
 e12-20020a056402190c00b0045c329a5f81sm1606932edz.48.2022.10.10.09.15.38
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Mon, 10 Oct 2022 09:15:38 -0700 (PDT)
Message-ID: <c0d5bf21a99468571c7ba010e9eb9c329828dca8.camel@HIDDEN>
Subject: Re: [PATCH v5 2/2] home: services: Support user's fontconfig
 configuration.
From: Liliana Marie Prikler <liliana.prikler@HIDDEN>
To: Andrew Tropin <andrew@HIDDEN>, Taiju HIGASHI <higashi@HIDDEN>, 
 57963 <at> debbugs.gnu.org
Date: Mon, 10 Oct 2022 18:15:37 +0200
In-Reply-To: <87zge4chb5.fsf@HIDDEN>
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN> <87zge4chb5.fsf@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
User-Agent: Evolution 3.46.0 
MIME-Version: 1.0
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Am Montag, dem 10.10.2022 um 10:40 +0400 schrieb Andrew Tropin:
> Also, because guix-home-font-dir always added to the list, the
> default value should '() and field should be called
> additional-font-directories instead.=C2=A0 Otherwise it will be confusing=
,
> why guix-home-font-dir is not removed from the final configuration,
> when this field is set to a different value.
Actually, I think the default value should (if possible) explicitly
contain the one being added by Guix Home.  I also think it shouldn't be
added when the user explicitly removed it.

Cheers





Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 10 Oct 2022 06:40:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 10 02:40:51 2022
Received: from localhost ([127.0.0.1]:45545 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ohmT5-0003nA-1J
	for submit <at> debbugs.gnu.org; Mon, 10 Oct 2022 02:40:51 -0400
Received: from relay2-d.mail.gandi.net ([217.70.183.194]:34443)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <andrew@HIDDEN>) id 1ohmT1-0003mu-7B
 for 57963 <at> debbugs.gnu.org; Mon, 10 Oct 2022 02:40:49 -0400
Received: (Authenticated sender: andrew@HIDDEN)
 by mail.gandi.net (Postfix) with ESMTPSA id F0FE340004;
 Mon, 10 Oct 2022 06:40:39 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=trop.in; s=gm1;
 t=1665384041;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:cc:mime-version:mime-version:content-type:content-type:
 in-reply-to:in-reply-to:references:references;
 bh=eCpzUZ5YJPyFCWLfXiJHe3QfZwMrQnmxG4S0zJmXwhE=;
 b=j2NyPn+ld2Bljg4BIxI3MJyl78hoQvyTFRoCJVYrLxn7a/UYYCTjrPOsSRrC14AcgrFD7c
 PyACGlBI/NQ2ij+O71LGdliWPNIVPUb5ktMLQxbAxFJMgPxolK9i+ZLt3JmpCh9H2k+tN5
 CPSm2b1Oq34YZ0a5g45tyiVlZgKJxp3qMpiQszxFbZ2EaRKMtLJkDgtidGl4ki9ctgnDoK
 2dLUlo8opGKLzmn7xDJc5D8ouLNJP9uVJhEh9c0m5CJ6JUVNR/Vrw/2cprHo+JDun23Lu1
 q/ZqyFofpYOW7LueBLiaQ5u5Efa5EwDMnjsny48ENQYID7crTSH9ojrMdmWS0g==
From: Andrew Tropin <andrew@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>, 57963 <at> debbugs.gnu.org
Subject: Re: [PATCH v5 2/2] home: services: Support user's fontconfig
 configuration.
In-Reply-To: <20221002131535.9972-2-higashi@HIDDEN>
References: <20221002131535.9972-1-higashi@HIDDEN>
 <20221002131535.9972-2-higashi@HIDDEN>
Date: Mon, 10 Oct 2022 10:40:30 +0400
Message-ID: <87zge4chb5.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: 1.3 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  On 2022-10-02 22:15,
 Taiju HIGASHI wrote: > * gnu/home/services/fontutils.scm
 (add-fontconfig-config-file): Support user's > fontconfig configuration.
 > (home-fontconfig-configuration): New configuration for it. > (string-list,
 maybe-string, [...] 
 Content analysis details:   (1.3 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
 2.0 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: yoctocell.xyz (xyz)]
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.7 RCVD_IN_DNSWL_LOW      RBL: Sender listed at https://www.dnswl.org/,
 low trust [217.70.183.194 listed in list.dnswl.org]
 0.0 RCVD_IN_MSPIKE_H3      RBL: Good reputation (+3)
 [217.70.183.194 listed in wl.mailspike.net]
 0.0 RCVD_IN_MSPIKE_WL      Mailspike good senders
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, Taiju HIGASHI <higashi@HIDDEN>, liliana.prikler@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.3 (/)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

On 2022-10-02 22:15, Taiju HIGASHI wrote:

> * gnu/home/services/fontutils.scm (add-fontconfig-config-file): Support u=
ser's
> fontconfig configuration.
> (home-fontconfig-configuration): New configuration for it.
> (string-list, maybe-string, maybe-extra-config-list): New types for it.
> (string-list?, extra-config-list?): New predicate procedures for it.
> (serialize-string-list, serialize-string, serialize-extra-config-list): N=
ew
> serialize procedures for it.
> (guix-home-font-dir): New variable.
> ---
>  gnu/home/services/fontutils.scm | 89 ++++++++++++++++++++++++++++++---
>  1 file changed, 83 insertions(+), 6 deletions(-)
>
> diff --git a/gnu/home/services/fontutils.scm b/gnu/home/services/fontutil=
s.scm
> index 6062eaed6a..4b3caf3985 100644
> --- a/gnu/home/services/fontutils.scm
> +++ b/gnu/home/services/fontutils.scm
> @@ -1,6 +1,7 @@
>  ;;; GNU Guix --- Functional package management for GNU
>  ;;; Copyright =C2=A9 2021 Andrew Tropin <andrew@HIDDEN>
>  ;;; Copyright =C2=A9 2021 Xinglu Chen <public@HIDDEN>
> +;;; Copyright =C2=A9 2022 Taiju HIGASHI <higashi@HIDDEN>
>  ;;;
>  ;;; This file is part of GNU Guix.
>  ;;;
> @@ -20,9 +21,17 @@
>  (define-module (gnu home services fontutils)
>    #:use-module (gnu home services)
>    #:use-module (gnu packages fontutils)
> +  #:use-module (gnu services configuration)
> +  #:use-module (guix diagnostics)
>    #:use-module (guix gexp)
> +  #:use-module (guix i18n)
> +  #:use-module (guix records)
> +  #:use-module (srfi srfi-1)
> +  #:use-module (sxml simple)
> +  #:use-module (ice-9 match)
>=20=20
> -  #:export (home-fontconfig-service-type))
> +  #:export (home-fontconfig-service-type
> +            home-fontconfig-configuration))
>=20=20
>  ;;; Commentary:
>  ;;;
> @@ -33,15 +42,83 @@ (define-module (gnu home services fontutils)
>  ;;;
>  ;;; Code:
>=20=20
> -(define (add-fontconfig-config-file he-symlink-path)
> +(define (sxml->xml-string sxml)
> +  "Serialize the sxml tree @var{tree} as XML. The output will be string."
> +  (call-with-output-string
> +    (lambda (port)
> +      (sxml->xml sxml port))))
> +
> +(define guix-home-font-dir "~/.guix-home/profile/share/fonts")
> +
> +(define (string-list? value)
> +  (and (pair? value) (every string? value)))

Better to use list? here and in the other places, at least for the
consistency, but also for semantic meaning.

> +
> +(define (serialize-string-list field-name value)
> +  (sxml->xml-string
> +   (map
> +    (lambda (path) `(dir ,path))
> +    (if (member guix-home-font-dir value)
> +        value
> +        (append (list guix-home-font-dir) value)))))
> +
> +(define (serialize-string field-name value)
> +  (define (serialize type value)
> +    (sxml->xml-string
> +     `(alias
> +       (family ,type)
> +       (prefer
> +        (family ,value)))))
> +  (match (list field-name value)
> +    (('default-font-serif-family family)
> +     (serialize 'serif family))
> +    (('default-font-sans-serif-family family)
> +     (serialize 'sans-serif family))
> +    (('default-font-monospace-family family)
> +     (serialize 'monospace family))))
> +
> +(define-maybe string)
> +
> +(define extra-config-list? list?)
> +
> +(define-maybe extra-config-list)
> +
> +(define (serialize-extra-config-list field-name value)
> +  (sxml->xml-string
> +   (map (match-lambda
> +          ((? pair? sxml) sxml)

Other branches would never be visited because it will fail earlier by
define-configuration predicate check for extra-config-list? (which is
basically list?).

Also, making multi-type fields is debatable, but isn't great IMO.

If serialization would support G-exps, we could write=20

(list #~"RAW_XML_HERE")

or even something like this:

(list #~(READ-THE-WHOLE-FILE #$(local-file "our-old.xml")))

> +          ((? string? xml) (xml->sxml xml))
> +          (else
> +           (raise (formatted-message
> +                   (G_ "'extra-config' type must be xml string or sxml l=
ist, was given: ~a")
> +                   value))))
> +        value)))
> +
> +(define-configuration home-fontconfig-configuration
> +  (font-directories
> +   (string-list (list guix-home-font-dir))

It's not a generic string-list, but a specific font-directories-list
with extra logic inside.

Also, because guix-home-font-dir always added to the list, the default
value should '() and field should be called additional-font-directories
instead.  Otherwise it will be confusing, why guix-home-font-dir is not
removed from the final configuration, when this field is set to a
different value.

I skimmed previous messages, but sorry, if I missed any already
mentioned points.

> +   "The directory list that provides fonts.")
> +  (default-font-serif-family
> +    maybe-string
> +    "The preffered default fonts of serif.")
> +  (default-font-sans-serif-family
> +    maybe-string
> +    "The preffered default fonts of sans-serif.")
> +  (default-font-monospace-family
> +    maybe-string
> +    "The preffered default fonts of monospace.")
> +  (extra-config
> +   maybe-extra-config-list
> +   "Extra configuration values to append to the fonts.conf."))
> +
> +(define (add-fontconfig-config-file user-config)
>    `(("fontconfig/fonts.conf"
>       ,(mixed-text-file
>         "fonts.conf"
>         "<?xml version=3D'1.0'?>
>  <!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
> -<fontconfig>
> -  <dir>~/.guix-home/profile/share/fonts</dir>
> -</fontconfig>"))))
> +<fontconfig>"
> +       (serialize-configuration user-config home-fontconfig-configuratio=
n-fields)

Just a thought for the future and a point for configuration module
improvements: It would be cool if serialize-configuration and all other
serialize- functions returned a G-exps, this way we could write
something like that:

(home-fontconfig-configuration
 (font-directories (list (file-append font-iosevka "/share/fonts"))))

> +       "</fontconfig>\n"))))
>=20=20
>  (define (regenerate-font-cache-gexp _)
>    `(("profile/share/fonts"
> @@ -59,7 +136,7 @@ (define home-fontconfig-service-type
>                         (service-extension
>                          home-profile-service-type
>                          (const (list fontconfig)))))
> -                (default-value #f)
> +                (default-value (home-fontconfig-configuration))
>                  (description
>                   "Provides configuration file for fontconfig and make
>  fc-* utilities aware of font packages installed in Guix Home's profile."=
)))

=2D-=20
Best regards,
Andrew Tropin

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCgAdFiEEKEGaxlA4dEDH6S/6IgjSCVjB3rAFAmNDvl4ACgkQIgjSCVjB
3rCueA/+PBM5g/Qe3+91C8u4h+s/0Ot6D9VJhBDQRLEgNYPkFKHKQ4dqsR0WQVHC
QHpNmBlHp8cuh34q7UJ2YHMj+5MNzZK/iwekUu7eG0ioWTqTZe6dfVoq5ImPawgd
4f8CmcOFLRlmGD29EOjka9qkb7K8vHlBrOL3GBWiutLO7jmWgdlt3AcX6ehggqD7
8Jb5+aSwAcGl580RBMr/0SyTUqsvesyGjoRQn6T1AWZQI/2QRtYP6TAGlZ8TDbbr
tYTU7Mgcvw9WkxjfpwK4JU6kDvp9e1I9HzfjlPfCgALOeYmpCjUWIAOSaouyZxXX
JT5FmNXO+tY3Fra0SaD7CpyEF9JhtEnAgyPNECM35Ym/dP9mV/zaL4miZdJTC+Ef
2ItbOCHNU5LFWKXCOLLorKl+4D1o4Ux9csFrH9u/kHfxuZhJk8WKFW0IraMViXRN
u4TF432subComkGGyBkoe5egCahVmD6CwqpQI0YMhje5vppN6bdjp5oY94oBoLuL
MoibLZffrYmc4mTigrgzF7fA1+kg80Vm0SyOB3uVPgqokzXVJrp1vgRNVj2K0/NA
4Sq3hMPEknfLUgBktZI60C1OqFo6Eur1VAcq6DdOrJknpO2pd934gKveoFt39xcJ
sXz9YgeU0kEU68FEdDo7pS732O6WCz/Q5HNkuAXyp9e1YtPz6yY=
=ngCV
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 10 Oct 2022 05:50:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 10 01:50:37 2022
Received: from localhost ([127.0.0.1]:45409 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ohlgT-0002Vm-6Y
	for submit <at> debbugs.gnu.org; Mon, 10 Oct 2022 01:50:37 -0400
Received: from relay5-d.mail.gandi.net ([217.70.183.197]:36319)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <andrew@HIDDEN>) id 1ohlgR-0002VZ-CV
 for 57963 <at> debbugs.gnu.org; Mon, 10 Oct 2022 01:50:35 -0400
Received: (Authenticated sender: andrew@HIDDEN)
 by mail.gandi.net (Postfix) with ESMTPSA id 7121E1C0004;
 Mon, 10 Oct 2022 05:50:28 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=trop.in; s=gm1;
 t=1665381029;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:cc:mime-version:mime-version:content-type:content-type:
 in-reply-to:in-reply-to:references:references;
 bh=eqnTEu/hBN5rw9AiEY/H0++BNT4op7Mh5dhlmvCKePY=;
 b=I5AdXYd/wxfVL1wOWAh5/rkW79nJ83+iVggLaEYy8IPGZxeC4HxwXBTcMDGFxSInQ9l6oL
 FI9kl3c3ugA8W8Ckt5mBcxMdHnF7v2pyyzMQCefOMl4kW4Y2gp5yU9LceJ+N1tf/t4uByN
 tl7zhMWx3tGJ+tbnvI+aqa74oEULpCahKQqmobaGXtcahqFeszpDa+fRVFHoiKYotxPzZZ
 aPFg5FJykjFko5zyI04+jDiSLxDWU8uY1OPFb5Mxeb0yYtdRy5d/IwiWweuO2nPajALNc3
 5wqWIAQ8XgIGtx/+T2TNrtXnIhLPU1Q2tdudwkkXL07khnMCRZMtVqTlmgYcnA==
From: Andrew Tropin <andrew@HIDDEN>
To: Liliana Marie Prikler <liliana.prikler@HIDDEN>, Taiju HIGASHI
 <higashi@HIDDEN>, Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
Subject: Re: [PATCH v4 1/2] home-services: Add base.
In-Reply-To: <50fb35fa126af65eae644dbe543ffc70267908c1.camel@HIDDEN>
References: <20220929143633.28844-1-higashi@HIDDEN>
 <87r0zrb4hu.fsf@HIDDEN> <87edvqpcf4.fsf@HIDDEN>
 <50fb35fa126af65eae644dbe543ffc70267908c1.camel@HIDDEN>
Date: Mon, 10 Oct 2022 09:50:24 +0400
Message-ID: <874jwcdy73.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

On 2022-10-02 16:59, Liliana Marie Prikler wrote:

> Am Sonntag, dem 02.10.2022 um 22:45 +0900 schrieb Taiju HIGASHI:
>> > Like Liliana wrote, it may be that more of these can be moved from
>> > =E2=80=9Cessential=E2=80=9D to =E2=80=9Cbase=E2=80=9D, we can keep tha=
t for a later patch.
>>=20
>> Please let us address this in a later patch.
>>=20
>> I would like to discuss something with you.
>> I'm aware that this patch is a breaking change. We are aware that if
>> we do not add %base-home-services to the existing home configuration,
>> fontconfig will change.  I'm concerned about how the community will
>> react to this.
> As long as the out-of-the-box behaviour stays the same, the community
> has no reason to complain.  For what it's worth, you could also leave
> fontconfig as an essential service, but then you get another field to
> configure.
>
> As far as I see, essential services are also a thing on the system
> side, but the home and system variants have a somewhat different feel
> to them.=20=20

Originially purpose was the same - to have services depending on
home-environment record fields (fontconfig depended on symlink-path
field, which was configurable back in the days), later we made
~/.guix-home hardcoded and did other changes to remove all the
dependencies for essential services from home-environment.  Now the
purpose feels somewhat different, because it basically a good list of
default services, but not actually essential.  The only thing, that
still depends on home-environment fields is home-profile-service-type.

Globally, I'm good with the reorganization of essential services, but
let's make another thread for this issue.

> The fontconfig-service is not actually essential, the profile service
> type arguably isn't either (it acts as yet another profile and
> simultaneously fails to satisfy the multi-profile use-case; more on
> that elsewhere), the xdg-base-directories one notably violates the XDG
> Base Directories specification, and so on.
>
> I'd get Andrew's approval before moving services, but I'd move them in
> one go rather than bit by bit.
>
> Cheers

=2D-=20
Best regards,
Andrew Tropin

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCgAdFiEEKEGaxlA4dEDH6S/6IgjSCVjB3rAFAmNDsqAACgkQIgjSCVjB
3rAqEBAAiliL4I9yTGVH+IqLz7DEy427oqPu3sSH+xc+CZy9wz/5pUZH2ym5syJk
wsc6To00fLYl35vYhW8w43RpnpDQD6UKr4A/nht0792vdSdmMjI7l0EQsPYVgtKX
+33xuMkUsRw19+L4YHsFXZTY7vfNBwvyk8JZj8QR7T4mSa7qkGsUSRNsmIhlCHVT
pJbG2VBeNw/jguQvLRFjzqd4mYN6liM0jrtOLaK3IK/4trz7M1lalJxMY7Y5L0ai
GSLhhOWJfJ53T5EeE5EwNf4432zy+f76ILqQeThc3DWW7k/wlVahCswvzeft8x4g
nnmaKLNkX1iZf2KQMIwSFfrmL2aT07xPr9KFcLzG9aIgWbFm/QxCCmrgTue1vn6x
HPe0829qscxWepMOO9JbLUTC/H+mjY+d4XO6AmCMm67N4RrkR9a8A3O82IDLUfk0
sy2sDNYWX/VIMahdV7sBeYC//EO466NTFVSunnng0ywSNmpciUYzwZR3/B9WkQEt
kq11UquKYf1Tjf+zpuPH9PiizvVCkM/pDFaEgWw2WsY0Mgjcd7407pD4IbqtUHAU
KD8b/hLfelPm2n1p+DU4M5r/pylmGPQsJIa+IlGDXbX61G462eJ9RJ3+2TWBwspH
6gzW8l3qkaGwMst54lzDidyU5Tq09dos9LGbDGv0nuqKsyJLdhY=
=jS4A
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 7 Oct 2022 05:45:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 07 01:45:13 2022
Received: from localhost ([127.0.0.1]:34033 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oggAb-0002HS-BO
	for submit <at> debbugs.gnu.org; Fri, 07 Oct 2022 01:45:13 -0400
Received: from mail-pl1-f177.google.com ([209.85.214.177]:45873)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1oggAU-0002Ge-LU
 for 57963 <at> debbugs.gnu.org; Fri, 07 Oct 2022 01:45:11 -0400
Received: by mail-pl1-f177.google.com with SMTP id u24so3614201plq.12
 for <57963 <at> debbugs.gnu.org>; Thu, 06 Oct 2022 22:45:06 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:from:to:cc:subject:date:message-id:reply-to;
 bh=bLd0j0ZkoiDuqWglDwUpkNl5I3Ew0ysXSTReVc/ltRw=;
 b=XnZ5gB2BjdR/4NrTh34qnzcOV1h1KmQSRWpkkL/Yhe2PIuR5aExbwWMPgenPAqDh6M
 HGJpqlsoD5j6vQbdb9kTfYf0riZ+lHC/q5gULn7IV/j37v2RT3bxmLFLn8ZYCi4OuPPc
 7DQQ2F9xPeSLQfKHs+n2ZNTfQjOpojCoN09h6vQFNazkLZTBHY/ENpsDYWKcoX/97yq+
 AKt9CxhWi70JXGm2l3HoK1/lYngPvKEk6g3EFRzN6s2SXOUjzHW4bYYJtaV8iLMD36jl
 /XE4Mzu0Gv6HUZEf6XJ+hzH6L8TZFrMmVwpJ0SWFQr0+eQPyZLX4Ss0pqFOvUcJiwpfS
 izDg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:x-gm-message-state:from:to:cc:subject:date
 :message-id:reply-to;
 bh=bLd0j0ZkoiDuqWglDwUpkNl5I3Ew0ysXSTReVc/ltRw=;
 b=w77+3HmIEpphy+ggvJMzp7MKwLrnk3M8UJDF9DPAbT+1rr0rR/+RY8TF/7aWbx2qtX
 R2UxG6GaWJSwCZmzYtr/9HpCahLPn3mcSyO8fZHTnypQMGoxtKUt8uTuPONRGg0INt9r
 a7e16453S0pA4UMLswDQzW0tU0YYQvCybttQajdy97UhSwVb/C/kaeUTGDJ4/4yadseJ
 +WasC6mH9xzenugMc/dpBWV6GTXlmzUuEMoSxCANr5nuH6LsyJpuz6o17kE1kBDxyYuH
 fYUFodYAIFAN9abLTKA8i+1SQ9LI0V5HZJcvbJmzVONBiWe5+BXs6RusGAyj+XI3nR21
 sQ5A==
X-Gm-Message-State: ACrzQf0hR7PqJdjBtaC4bs1k7VfAEtqwW0iXiFkVRr/U7Dw1wSUiPoo1
 AfmO5GwS1RRpIr92Ssu2mYa1Iw==
X-Google-Smtp-Source: AMsMyM4G37tRPvDC3uBqiH5f+ic3uoh7FcakTcky4NrOHySptn08T1I+Be0g1j2xDhGh3fbYpS7vfQ==
X-Received: by 2002:a17:903:2285:b0:177:ab99:9e5 with SMTP id
 b5-20020a170903228500b00177ab9909e5mr3117263plh.121.1665121500704; 
 Thu, 06 Oct 2022 22:45:00 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 o2-20020a17090a3d4200b001fbb0f0b00fsm3784879pjf.35.2022.10.06.22.44.59
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 06 Oct 2022 22:45:00 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: 57963 <at> debbugs.gnu.org
Subject: Re: Next steps for this issue
References: <875ygwnr9t.fsf@HIDDEN>
Date: Fri, 07 Oct 2022 14:44:56 +0900
In-Reply-To: <875ygwnr9t.fsf@HIDDEN> (Taiju HIGASHI's message of "Fri, 07
 Oct 2022 14:20:46 +0900")
Message-ID: <87tu4gmbl3.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, liliana.prikler@HIDDEN, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Liliana,

I'm sorry, I had the wrong email address.

Taiju HIGASHI <higashi@HIDDEN> writes:

> Hi,
>
> What are the next steps for this issue?
>
> I recognize that the following work remains.
>
> 1. Review of the v5 patch
> 2. Consider which services to move from essentials services to base services
> 3. Modify Document
>
> If I forgot to do something, please point it out.
>
> Thanks,

-- 
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 7 Oct 2022 05:21:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 07 01:21:01 2022
Received: from localhost ([127.0.0.1]:34007 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ogfnB-0001ZE-0O
	for submit <at> debbugs.gnu.org; Fri, 07 Oct 2022 01:21:01 -0400
Received: from mail-pj1-f50.google.com ([209.85.216.50]:38527)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1ogfn6-0001Yx-6j
 for 57963 <at> debbugs.gnu.org; Fri, 07 Oct 2022 01:20:59 -0400
Received: by mail-pj1-f50.google.com with SMTP id
 x1-20020a17090ab00100b001fda21bbc90so6258439pjq.3
 for <57963 <at> debbugs.gnu.org>; Thu, 06 Oct 2022 22:20:56 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=mime-version:message-id:date:cc:subject:to:from:from:to:cc:subject
 :date:message-id:reply-to;
 bh=toCBVGgyPB/mS97lh4LZp6ui5jzD1kxOjX3d9pvNuiY=;
 b=qs2+10ZRkxMewyDiHQUH5lxDtuTCT71X+x3/LO5OlKF83dDQwhOP3uSz/qdnhCWbED
 o5oRrsVs6VngMWK8j0ln1C88JVW+t+mfOu9/f6O2WU9GpekL1SV12Itvzbw+r+1yuIMI
 n1PD8M6ljiW/p/WcSCbWPlMio3b+Nw6B8xja0t27xL+Fa8EkxZ2Q3Leam9rD3KsVhTe3
 G8PtjDt9/Qndt6620cZ7fDlR+ytz4MoUujeXvNFV9sg8q90LcR0/3xqp5OMQ13aAH0mR
 qrkcl0iuoqLdpbk8UDJULnajuumTrZPOOjkWrXJK7Uw/kf2RmRLv2G8cjDqxp0mqxES8
 6g9w==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:message-id:date:cc:subject:to:from:x-gm-message-state
 :from:to:cc:subject:date:message-id:reply-to;
 bh=toCBVGgyPB/mS97lh4LZp6ui5jzD1kxOjX3d9pvNuiY=;
 b=ONuQ7HExr5I9FiMAe2NSo61WShpkpYjMBf5znKFKRdsTzZFv1FGRydikgnheuhjYA9
 6/AuynYqB9smDF5Zy8O2rDZ2fST1Ef60SWC6FrJ0A+QjoM+/3covazFZPEhKSoDLCgyb
 FZum+Zc+mrzQ2mu0dhSQkTj6qXelBzpQQdzy05SpKugExkg5lWvIxAkR50CRa1bMy6X1
 xsLyq1yQcwfE4jsg2FKcuU+oItk4pSrbhVU5604BNlSSCEYxqIA26GIdmkW+crMWkqsO
 Stci7F8V1ZnHlm9Mkc6HsFs6YJVskhgApJG/NT8Z37J0BT3NKmfFe+A89uQjON2UgOB1
 wokg==
X-Gm-Message-State: ACrzQf0f3uWP56BJOQwXWz2w6FJxkBjGP8M+DCj8e02BXT1c1IEDq9tx
 tYUjnS5MPAe/ExcALobVFZAhPw==
X-Google-Smtp-Source: AMsMyM5VCd+v/cmSE/SlVIsC0MEq9gV+bxOm55AZAEWlJ2QiG25Js0WXu5GhjRflc4dkw5FgAqdqOA==
X-Received: by 2002:a17:90a:9381:b0:20a:79b7:766a with SMTP id
 q1-20020a17090a938100b0020a79b7766amr14689759pjo.33.1665120049915; 
 Thu, 06 Oct 2022 22:20:49 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 b203-20020a621bd4000000b0056186e8b29esm601122pfb.96.2022.10.06.22.20.47
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 06 Oct 2022 22:20:49 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: 57963 <at> debbugs.gnu.org
Subject: Next steps for this issue
Date: Fri, 07 Oct 2022 14:20:46 +0900
Message-ID: <875ygwnr9t.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: iliana.prikler@HIDDEN, ludo@HIDDEN, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi,

What are the next steps for this issue?

I recognize that the following work remains.

1. Review of the v5 patch
2. Consider which services to move from essentials services to base services
3. Modify Document

If I forgot to do something, please point it out.

Thanks,
-- 
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 3 Oct 2022 23:27:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 03 19:27:25 2022
Received: from localhost ([127.0.0.1]:51882 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ofUqK-0007CE-QJ
	for submit <at> debbugs.gnu.org; Mon, 03 Oct 2022 19:27:25 -0400
Received: from mail-pj1-f50.google.com ([209.85.216.50]:51717)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1ofUqJ-0007Bw-2f
 for 57963 <at> debbugs.gnu.org; Mon, 03 Oct 2022 19:27:23 -0400
Received: by mail-pj1-f50.google.com with SMTP id b15so3196762pje.1
 for <57963 <at> debbugs.gnu.org>; Mon, 03 Oct 2022 16:27:23 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:from:to:cc:subject:date;
 bh=zFjLZwxHKhawR29wR8UZydHDePXK6QDoDRM7C+Jjv/s=;
 b=KOm0vNeJS8CaXcicv6GTUdcH0T13tEeVtU3C4VMC0a8reUAWGh4yr3hfk0Ymq1JhO4
 ooLYwtwo4vVoFZo4Jw7OxdnWP0fwaStlZngrgPWTkJoY74FJMFKMSzsFH/JxCf8wSj11
 iU1xEZQh0pTOJ4Cd7QHb4794KAqDie1scyMgpR5cNNjevU2Gays0efh8H6rm7P+KAIm+
 hp7PTjQhSZYLgb60IK+jX0qlc7MuQz2hj43R6WYpnUa3fut0T8SwmbhLwhlcf1XP0VRE
 ltzXqL8AR2cyE5zAnUVgLCgWRhQiC1fwJxbmxtXGa9+gkB1KCUdc3eYjBvYUzSOccLBo
 k4jw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:x-gm-message-state:from:to:cc:subject:date;
 bh=zFjLZwxHKhawR29wR8UZydHDePXK6QDoDRM7C+Jjv/s=;
 b=YMwPNzbLOTMbkl1wsRWq2EkW07ZQ0kLm5u1BaStW0AyH3GuO44p4MyM/8uBGKkkcnl
 dEeX6L5W76AX/rX3qf4ZRUgwSIMLqtFM+5VguX2LDdBwQbZxN9S1zYa1GlENdDTB2wAK
 eSoXUyfu7Ub28a86t48xYPD4pc147fPPjKc2eecYbb6Gwbesnca6HrzbRrYBj2ZNsADo
 G4Rf+EMyb54YSzVBC7YAH33kuJnB7bMU32Dn0JWakPNKurb5jfc+Vkz+YGW9gDs0URpY
 Ei4FmJbOubEMRFNDE7GKGGpKpU04p03tpjoUJeUeZXCIWM2yQg6blEVErIf8X2QZ0467
 qpHg==
X-Gm-Message-State: ACrzQf2myZtSlHO/EnrRPuYc64NoBoTkvaZb4Fd/jDaYaxJ7vyxG2rZT
 Ar2Q/expBRRn9e0L1k7raSA5NQ==
X-Google-Smtp-Source: AMsMyM4sCcvcqLs6pl/P2krvURBtD2lRBy631uQwE6g6gMMA/HnJs/DETaRJs8vcMfhL5j7z/IQAwA==
X-Received: by 2002:a17:90a:1b65:b0:1f7:4725:aa6e with SMTP id
 q92-20020a17090a1b6500b001f74725aa6emr14237940pjq.179.1664839637201; 
 Mon, 03 Oct 2022 16:27:17 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 r18-20020a170903411200b00176b84eb29asm7651252pld.301.2022.10.03.16.27.15
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Mon, 03 Oct 2022 16:27:16 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Liliana Marie Prikler <liliana.prikler@HIDDEN>
Subject: Re: [PATCH v4 1/2] home-services: Add base.
References: <20220929143633.28844-1-higashi@HIDDEN>
 <87r0zrb4hu.fsf@HIDDEN> <87edvqpcf4.fsf@HIDDEN>
 <50fb35fa126af65eae644dbe543ffc70267908c1.camel@HIDDEN>
Date: Tue, 04 Oct 2022 08:27:13 +0900
In-Reply-To: <50fb35fa126af65eae644dbe543ffc70267908c1.camel@HIDDEN>
 (Liliana Marie Prikler's message of "Sun, 02 Oct 2022 16:59:26 +0200")
Message-ID: <87zgeco5da.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-2022-jp
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: Ludovic =?iso-8859-1?Q?Court=E8s?= <ludo@HIDDEN>, 57963 <at> debbugs.gnu.org,
 andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Liliana Marie Prikler <liliana.prikler@HIDDEN> writes:

> Am Sonntag, dem 02.10.2022 um 22:45 +0900 schrieb Taiju HIGASHI:
>> > Like Liliana wrote, it may be that more of these can be moved from
>> > “essential” to “base”, we can keep that for a later patch.
>>
>> Please let us address this in a later patch.
>>
>> I would like to discuss something with you.
>> I'm aware that this patch is a breaking change. We are aware that if
>> we do not add %base-home-services to the existing home configuration,
>> fontconfig will change.  I'm concerned about how the community will
>> react to this.
> As long as the out-of-the-box behaviour stays the same, the community
> has no reason to complain.  For what it's worth, you could also leave
> fontconfig as an essential service, but then you get another field to
> configure.
>
> As far as I see, essential services are also a thing on the system
> side, but the home and system variants have a somewhat different feel
> to them.  The fontconfig-service is not actually essential, the profile
> service type arguably isn't either (it acts as yet another profile and
> simultaneously fails to satisfy the multi-profile use-case; more on
> that elsewhere), the xdg-base-directories one notably violates the XDG
> Base Directories specification, and so on.

I was relieved to hear that.

> I'd get Andrew's approval before moving services, but I'd move them in
> one go rather than bit by bit.

Noted. I'll wait for his reply.

Cheers,
-- 
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 2 Oct 2022 14:59:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 02 10:59:37 2022
Received: from localhost ([127.0.0.1]:47819 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1of0RM-0002h1-RQ
	for submit <at> debbugs.gnu.org; Sun, 02 Oct 2022 10:59:37 -0400
Received: from mail-ej1-f66.google.com ([209.85.218.66]:39714)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <liliana.prikler@HIDDEN>) id 1of0RK-0002gn-Ms
 for 57963 <at> debbugs.gnu.org; Sun, 02 Oct 2022 10:59:35 -0400
Received: by mail-ej1-f66.google.com with SMTP id b2so17703387eja.6
 for <57963 <at> debbugs.gnu.org>; Sun, 02 Oct 2022 07:59:34 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:from:to:cc:subject
 :date; bh=SflwAW96ci2F7A6RlIfXioBnmS9sI/aOdyKcgcbxr+w=;
 b=m1Sm14Q79QP1wM9T+hIwD+g2++DrZTu0TzZkfC7bxRj8Oy/w6Wes25YfQWFFyCZWYq
 L/6mgM9q0EFBtjwyUKVr9HCNOPduwRe4/1SEdw9RAdTRvDDgQFCSRhOFONfxS8W0rMXa
 feXEIZd7cEoH6YgrLYOsrnIbRKXu5mBl7CUSrzmA+8fVJCSirzxV8Fp2gioaqa6t05Lv
 sk4gpytvn/TUM+Um0PtMTuiQ1ay3nkgsQE2oQ6lly3EJVa2q+8GzD5HgEvA8lRRub9BA
 U5/OwbpUn6m02d8yuOUVurHca701515GjFpGHDw7jeNm4t0hI2xjqOc7K2j+hmvLAKZP
 taog==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:x-gm-message-state
 :from:to:cc:subject:date;
 bh=SflwAW96ci2F7A6RlIfXioBnmS9sI/aOdyKcgcbxr+w=;
 b=sG6jL4/uCZubTzYk8+WkpOxgEMh8aQAm/VuFJR24Uk5qHKE0krio53hMgcSx3H50f3
 jL8lvdIeWL8hajDeZtn4hJqGMaseFtDnemMChCxES4p74MLLDfGHbsBQZoTNnV+fspLe
 7/fS5u1ddqZqnqAcfGwoM5o6ZwssIIBMLbf41XJuik/2xc0LLCYD6nMegASkbcx2fzdj
 nipW8f80IjTFuqAHnw3phY7s6QKGXjcW3ttauwuQ1jl4S90v40l5cphfOz9N867dtIOg
 P9qdIdn8IgEj09SDnZ5BhlatampxgN2DZudjHMkn413uRPm+R+rxsairq5B5TD868O4a
 rrsw==
X-Gm-Message-State: ACrzQf3Qer17YsYBLbUlWnO4fvQVlFlXThyYWnVO1BZp0tyeQOX8l0iM
 EWReEF+vsmgJltNXjOp2s5o=
X-Google-Smtp-Source: AMsMyM5ez4RD/FN0SGEaDN2MLtesx7SZ8iaFuj2W/aMzlgSNXNZM+5b+gw1TbnsA9X3L6Nnk1CMhsg==
X-Received: by 2002:a17:907:70a:b0:741:78ab:dce5 with SMTP id
 xb10-20020a170907070a00b0074178abdce5mr12913183ejb.527.1664722768756; 
 Sun, 02 Oct 2022 07:59:28 -0700 (PDT)
Received: from lumine.fritz.box (85-127-52-93.dsl.dynamic.surfer.at.
 [85.127.52.93]) by smtp.gmail.com with ESMTPSA id
 bj25-20020a170906b05900b0073d83f80b05sm4130509ejb.94.2022.10.02.07.59.27
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sun, 02 Oct 2022 07:59:28 -0700 (PDT)
Message-ID: <50fb35fa126af65eae644dbe543ffc70267908c1.camel@HIDDEN>
Subject: Re: [PATCH v4 1/2] home-services: Add base.
From: Liliana Marie Prikler <liliana.prikler@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>, Ludovic =?ISO-8859-1?Q?Court=E8s?=
 <ludo@HIDDEN>
Date: Sun, 02 Oct 2022 16:59:26 +0200
In-Reply-To: <87edvqpcf4.fsf@HIDDEN>
References: <20220929143633.28844-1-higashi@HIDDEN>
 <87r0zrb4hu.fsf@HIDDEN> <87edvqpcf4.fsf@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
User-Agent: Evolution 3.46.0 
MIME-Version: 1.0
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Am Sonntag, dem 02.10.2022 um 22:45 +0900 schrieb Taiju HIGASHI:
> > Like Liliana wrote, it may be that more of these can be moved from
> > =E2=80=9Cessential=E2=80=9D to =E2=80=9Cbase=E2=80=9D, we can keep that=
 for a later patch.
>=20
> Please let us address this in a later patch.
>=20
> I would like to discuss something with you.
> I'm aware that this patch is a breaking change. We are aware that if
> we do not add %base-home-services to the existing home configuration,
> fontconfig will change.  I'm concerned about how the community will
> react to this.
As long as the out-of-the-box behaviour stays the same, the community
has no reason to complain.  For what it's worth, you could also leave
fontconfig as an essential service, but then you get another field to
configure.

As far as I see, essential services are also a thing on the system
side, but the home and system variants have a somewhat different feel
to them.  The fontconfig-service is not actually essential, the profile
service type arguably isn't either (it acts as yet another profile and
simultaneously fails to satisfy the multi-profile use-case; more on
that elsewhere), the xdg-base-directories one notably violates the XDG
Base Directories specification, and so on.

I'd get Andrew's approval before moving services, but I'd move them in
one go rather than bit by bit.

Cheers




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 2 Oct 2022 13:45:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 02 09:45:15 2022
Received: from localhost ([127.0.0.1]:46530 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oezHP-0000TH-8h
	for submit <at> debbugs.gnu.org; Sun, 02 Oct 2022 09:45:15 -0400
Received: from mail-pg1-f182.google.com ([209.85.215.182]:33659)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1oezHO-0000T0-7u
 for 57963 <at> debbugs.gnu.org; Sun, 02 Oct 2022 09:45:14 -0400
Received: by mail-pg1-f182.google.com with SMTP id f193so7783781pgc.0
 for <57963 <at> debbugs.gnu.org>; Sun, 02 Oct 2022 06:45:14 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:from:to:cc:subject
 :date; bh=YYYsHP93bwsBUgKbNGC+jR2yaJh4OkGUM+fcJh/fvro=;
 b=xsT8fCj6ByJ9iAONnMJg/44TuWmmpnXQ+6cXpAhRljBLPPx4osSY+R/qnvXbiiHLl5
 OW3e5rJZ6bJyiY0omVaLiZfZtM5lG9n4jEZSeFv445TBXvN296ItQEWwpVW2ExO1x/4L
 Kgt/ljD9LOmjEycn8zQmRk7HfyLF34f9P2fjfXjFTDlfvUlUlPpdWJc1B0+tXWNKTF8g
 dkCA5AyUXz0ngRfwkyAknCIl06cYJ8hgA+h/rYK20BHfr+2Xmh9ICfXmLPX7UxWYumUL
 Xss+sD7A4pwjXUkiV+byBJgctz9C99w0n8aqlLG0oBy4lLN3CK/GqroxzAkEREdxU2Xm
 f25w==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:x-gm-message-state
 :from:to:cc:subject:date;
 bh=YYYsHP93bwsBUgKbNGC+jR2yaJh4OkGUM+fcJh/fvro=;
 b=wEw46ReI1B+up4UC5ZxZbxiQd453cGmQgjuy32aXlLLOooygEPsOYJY+lW8yecvj83
 hxgbG9dPULidSRuEANSz3AlK5HblaammFLOv/c/BDGsBUKqt/vIbKGmX4O3IlYctZ3GG
 oSXjMJf0OliVflOw+zf+tcr+4MjPVLD+S9ljpLK1AqSTVsX3Znb1enORI5hN5WqsaASB
 aW8pKxao78Q9Gb9EkTTULpmxBcIQSJT1odQe8Jn+wsQ1vF3/ijl++nRaC6lFMID/s0Mp
 JfTkyZh3n5DW/SH3ibN0w3Wepy4f9kibkHIX2Re1n3The/rG4ICT0GXVq+oqeE588sa+
 6N+A==
X-Gm-Message-State: ACrzQf0XXQJu5D9V9V4uF1Jzklyi3CU8m+qt+SofE6c173m2cBj+OkkU
 3ptpSOlckMguuw1y/LmkjSvq/Q==
X-Google-Smtp-Source: AMsMyM5Z6wMVLxLOnbjLYAW4XhcntIhIKxwr8+lvxlheJd2NpghjDJERYAkhU2PayB/wLPKfsydPZw==
X-Received: by 2002:a63:6905:0:b0:43c:d4:eef4 with SMTP id
 e5-20020a636905000000b0043c00d4eef4mr14686208pgc.126.1664718307191; 
 Sun, 02 Oct 2022 06:45:07 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 7-20020a620507000000b0055de3e207c9sm4049017pff.35.2022.10.02.06.45.05
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sun, 02 Oct 2022 06:45:06 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Ludovic =?iso-8859-1?Q?Court=E8s?= <ludo@HIDDEN>
Subject: Re: [PATCH v4 1/2] home-services: Add base.
References: <20220929143633.28844-1-higashi@HIDDEN>
 <87r0zrb4hu.fsf@HIDDEN>
Date: Sun, 02 Oct 2022 22:45:03 +0900
In-Reply-To: <87r0zrb4hu.fsf@HIDDEN> ("Ludovic =?iso-8859-1?Q?Court=E8s?=
 =?iso-8859-1?Q?=22's?= message of "Sat, 01
 Oct 2022 23:47:41 +0200")
Message-ID: <87edvqpcf4.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Ludovic Court=C3=A8s <ludo@HIDDEN> writes:

> Hi,
>
> Taiju HIGASHI <higashi@HIDDEN> skribis:
>
>> * gnu/home.scm: Move home-fontconfig-service-type from
>> home-environment-default-essential-services to %home-base-services.
>> * gnu/home/services/base.scm: Add base.
>
> In addition to what Liliana wrote, please make sure to add the new file
> to =E2=80=98gnu/local.mk=E2=80=99.

I have added it.

>> @@ -82,7 +82,6 @@ (define (home-environment-default-essential-services h=
e)
>>
>>     (service home-symlink-manager-service-type)
>>
>> -   (service home-fontconfig-service-type)
>>     (service home-xdg-base-directories-service-type)
>>     (service home-shell-profile-service-type)
>
> Like Liliana wrote, it may be that more of these can be moved from
> =E2=80=9Cessential=E2=80=9D to =E2=80=9Cbase=E2=80=9D, we can keep that f=
or a later patch.

Please let us address this in a later patch.

I would like to discuss something with you.
I'm aware that this patch is a breaking change. We are aware that if we
do not add %base-home-services to the existing home configuration, fontconf=
ig will change.
I'm concerned about how the community will react to this.

Thanks,
--=20
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 2 Oct 2022 13:39:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 02 09:39:21 2022
Received: from localhost ([127.0.0.1]:46526 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oezBg-0000Jz-Su
	for submit <at> debbugs.gnu.org; Sun, 02 Oct 2022 09:39:21 -0400
Received: from mail-pj1-f54.google.com ([209.85.216.54]:39497)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1oezBQ-0000JG-SQ
 for 57963 <at> debbugs.gnu.org; Sun, 02 Oct 2022 09:39:19 -0400
Received: by mail-pj1-f54.google.com with SMTP id
 v10-20020a17090a634a00b00205e48cf845so13101530pjs.4
 for <57963 <at> debbugs.gnu.org>; Sun, 02 Oct 2022 06:39:04 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:from:to:cc:subject
 :date; bh=sRiIWpUf/Uge/aDdarosjM/VnHNY5oJUfbNXFwzIqrU=;
 b=m5e8AIGQBPKtJqBwYlbhJwlSu8ksKt2VsfdkC+CJcPJsz4WiQCHZSgbjFouf8E7J2v
 3txF/lSJJiBtIOtU5A+0LOVEH2b6eLgJunCcsofwsMibnN5At7iefsH71iuO60D5EVky
 1mjkP9gl6MPQpEgkW/6h+zs9uI1OxUUzgLChrnihJeHfUQREVlgQJkssay0rGUus5ZpX
 njLH3ASV5gvra3EW9mp9jxtMqAqXB7UX3chGU68ekd/8HptOgfMXpEpbNcuv1Mv/fBaq
 hV2fG44OpzK5+pi1CSqwlHbbU2m4Y8o47cwDDzSMgd8lMBylqdyWODiNufY/qdrt6XYe
 lw2w==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:x-gm-message-state
 :from:to:cc:subject:date;
 bh=sRiIWpUf/Uge/aDdarosjM/VnHNY5oJUfbNXFwzIqrU=;
 b=lf6V0W88olWbF3wcDT0znXalgYMU8cDMVuEh70rrJVHMll2/DT0Oiwchu+V4UCXJXS
 vnjetmgIvYqrIaOU3+rNZZnXaybaOJUl+UPVXCtx0dezpcVWDM8ld03mSNJg8KPWktL2
 IPrMtmLQzrk7X2sEQHl0JGhSMZSLtv8aNgVc0qjtCvM5l4gvGq9OauLVPlM4NSTUOxxj
 +anJxfoA1/shvkn1TzUKYJBdSnJBW19NMeCi58ks8TAhgPBCOv5pzi/R7zTetR74omCW
 kz8V0EV6CxRFHfGVenu5lLUpldpXz/eTVSOXxFxe5ownm9bYR5qS/PWWQcEYGzSZsjbO
 /Z6Q==
X-Gm-Message-State: ACrzQf1r33DZb3jAQU7SWH5bFwWhfrbwfMWQP5xcNQ5u5skNZ3o5vO/C
 sngP2JRb9SkulmsFN+ZmDrgQ3Q==
X-Google-Smtp-Source: AMsMyM47I6oyjR1pojPS+9giV6Liked/VeyI3g7Ku7K/OdN+TCe6LAocKP6qTTJYPS5oH8/5LRUhLA==
X-Received: by 2002:a17:903:124b:b0:179:da2f:2457 with SMTP id
 u11-20020a170903124b00b00179da2f2457mr17607878plh.156.1664717938931; 
 Sun, 02 Oct 2022 06:38:58 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 d79-20020a621d52000000b0056012d934fasm2548462pfd.156.2022.10.02.06.38.57
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sun, 02 Oct 2022 06:38:58 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Ludovic =?iso-8859-1?Q?Court=E8s?= <ludo@HIDDEN>
Subject: Re: [PATCH v4 2/2] home: fontutils: Support user's fontconfig.
References: <20220929143633.28844-1-higashi@HIDDEN>
 <20220929143633.28844-2-higashi@HIDDEN> <87ill3b41t.fsf@HIDDEN>
Date: Sun, 02 Oct 2022 22:38:55 +0900
In-Reply-To: <87ill3b41t.fsf@HIDDEN> ("Ludovic =?iso-8859-1?Q?Court=E8s?=
 =?iso-8859-1?Q?=22's?= message of "Sat, 01
 Oct 2022 23:57:18 +0200")
Message-ID: <87pmfapcpc.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi,

Ludovic Court=C3=A8s <ludo@HIDDEN> writes:

> Taiju HIGASHI <higashi@HIDDEN> skribis:
>
>> * gnu/home/services/fontutils.scm: Support user's fontconfig.
>
> I=E2=80=99m nitpicking a bit, but here we would describe all the
> variables/procedures added, removed, or modified.  Please check =E2=80=98=
git
> log=E2=80=99 for examples.
>
> Regarding code, there=E2=80=99s a convention to add a docstring to each
> top-level procedure:
>
>   https://guix.gnu.org/manual/devel/en/html_node/Formatting-Code.html
>
> It would be nice to follow it here.

I have listed them all in the v5 patch.
As for the serializer/predicate procedure, I did not add it because
there was no docstring in the existing procedure.

>> +(define (default-font-sanitizer type)
>> +  (lambda (value)
>> +    (if (null? value)
>> +        value
>> +        `(alias
>> +          (family ,type)
>> +          (prefer
>> +           (family ,value))))))
>
> Giving '() special meaning here looks quite unusual.  As Liliana wrote,
> we=E2=80=99d usually use #f as the value denoting =E2=80=9Cnothing=E2=80=
=9D.

I may have confused it with Common Lisp.  I have eliminated the field
with the empty list as the default value.

>> +(define (sxml->xmlstring sxml)
>> +  (if (null? sxml)
>> +      ""
>> +      (call-with-output-string
>> +        (lambda (port)
>> +          (sxml->xml sxml port)))))
>
> Same here.  Also, =E2=80=9Cxml-string=E2=80=9D rather than =E2=80=9Cxmlst=
ring=E2=80=9D.

Fixed to xml-string.

>> +(define font-directories? list?)
>
> Is it really needed?

I may not have addressed this point yet. Is it possible to not define a
predicate procedure to be used for a configuration field?

>> +(define (serialize-font-directories field-name value)
>> +  (sxml->xmlstring
>> +   (append
>> +       '((dir "~/.guix-home/profile/share/fonts"))
>> +       (map
>> +        (lambda (path)
>> +          `(dir ,path))
>> +        value))))
>
> The indentation would rather be:
>
>   (append '((dir =E2=80=A6))
>           (map (lambda (directory)
>                  `(dir ,directory))
>                value))

I think I fixed it by refactoring.

>> +   (map (match-lambda
>> +          ((? pair? sxml) sxml)
>> +          ((? string? xml) (xml->sxml xml))
>> +          (_ (error "extra-config value must be xml string or sxml list=
.")))
>
> Instead of =E2=80=98error=E2=80=99, which would lead to an ugly backtrace=
 and an
> untranslated error message, write:
>
>   (raise (formatted-message (G_ "'extra-config' =E2=80=A6")))
>
> without a trailing dot in the message.

I have fixed it.

> The rest LGTM!  Like I wrote, could you please add documentation in
> =E2=80=98doc/guix.texi=E2=80=99, with a configuration example like the on=
e you gave?

Since there were many points raised and interface changes in this case,
I will revise the document after the review is complete.

Thanks,
--
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 2 Oct 2022 13:22:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 02 09:22:53 2022
Received: from localhost ([127.0.0.1]:46511 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oeyvk-0008NV-V8
	for submit <at> debbugs.gnu.org; Sun, 02 Oct 2022 09:22:53 -0400
Received: from mail-pj1-f50.google.com ([209.85.216.50]:36801)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1oeyvj-0008NG-Rb
 for 57963 <at> debbugs.gnu.org; Sun, 02 Oct 2022 09:22:52 -0400
Received: by mail-pj1-f50.google.com with SMTP id
 e11-20020a17090a77cb00b00205edbfd646so13116256pjs.1
 for <57963 <at> debbugs.gnu.org>; Sun, 02 Oct 2022 06:22:51 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:from:to:cc:subject
 :date; bh=TcVbQ3k9QuvaUSRvLXmFjZkOD+rAy6LoAlkUknLs060=;
 b=v9je8QeSS8tO2mpuBqY03BPmvjh3YrZzl5P4fEwB6FYBRkixPQuFvZnbIoN8ko7qZT
 D70TzwXr/D4j2bN4VW8PCWGnjQj0q1GKNOPW1C/+Ztv0RKt9bntGz4BwKg1Il+r+rPx9
 RjO3gU5MwnowneYoyvNHRci1PhZ3TctR0O6fAnqpjfrj3Nd3b+5hfwdELjIK7o0b7pYU
 CT/W01ba1dvThKZnM5HEyPDd6Lyd/jkYtTy2yd4L8HLrUGxPgdhs9YXP5F/axjnpGO4K
 WHpATSLQl7OkhT7Ji6h/9L+jmtXiKvadwb0sGEzWoUbk5ffQFS5FUvw87x7+w40Uabns
 LtLQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:x-gm-message-state
 :from:to:cc:subject:date;
 bh=TcVbQ3k9QuvaUSRvLXmFjZkOD+rAy6LoAlkUknLs060=;
 b=YntA2EW4GyIb2G086Fb2tqSfmFOXM1lHjkqK30yn81iol0WZ33bLE7Ud5Dm8L71Urx
 ATuOlDHyFBBRoG9ZH4x2VoaysyggjlANO7NgpE5FjPZgchK4Ey43iL7gxsnmYOFz/X2l
 o/f2OfTVcX7CgvUcYTCRK8uFBXvt4ZmEKf0IjVFg/RkXNAynp1IcK+bAK6lz+Og3q+qr
 WFbU9qR0oG2OfhlfGQpxHmV2wRMZkjkRuYAi3T/CEll/ziLKDJfSTyW63/oiMr3hv+rj
 nWo/zlq/donk56vRDCwOltxcNMsA2gwTOeyz5YWuCxTufSOTklWxFGnTSwYoNxsn85H+
 4dMg==
X-Gm-Message-State: ACrzQf1pmiCc0bFGpCAdGNbMNUqPoIZS1Z5UHpOwCjucZpt0CRsjEi9y
 V8+GCWg2bI7XmzAgjRjt1xrfUA==
X-Google-Smtp-Source: AMsMyM7Xu4XvmXS1fwbt243Q624xPB6865sQFiKnYTBYTZFEE8LZ1cHu2VIlWzdgqeFNcvZwc5lseA==
X-Received: by 2002:a17:90a:d14a:b0:203:7b4b:6010 with SMTP id
 t10-20020a17090ad14a00b002037b4b6010mr7513607pjw.237.1664716966145; 
 Sun, 02 Oct 2022 06:22:46 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 pj1-20020a17090b4f4100b001eee8998f2esm8380324pjb.17.2022.10.02.06.22.44
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sun, 02 Oct 2022 06:22:45 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: liliana.prikler@HIDDEN
Subject: Re: [PATCH v4 2/2] home: fontutils: Support user's fontconfig.
References: <20220929143633.28844-1-higashi@HIDDEN>
 <20220929143633.28844-2-higashi@HIDDEN>
 <3e28e656526b901a3fd099d1cd180528f24e15e7.camel@HIDDEN>
 <87o7uvrdt4.fsf@HIDDEN>
 <6155f2126a6725979ee51079c0d90f5d00c31e1c.camel@HIDDEN>
Date: Sun, 02 Oct 2022 22:22:42 +0900
In-Reply-To: <6155f2126a6725979ee51079c0d90f5d00c31e1c.camel@HIDDEN>
 (liliana prikler's message of "Sat, 01 Oct 2022 18:14:51 +0200")
Message-ID: <87a66eqs0t.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, 57963 <at> debbugs.gnu.org, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


>> > > +(define-record-type* <default-font> default-font
>> > > +=A0 make-default-font
>> > > +=A0 default-font?
>> > > +=A0 (serif default-font-serif
>> > > +=A0=A0=A0=A0=A0=A0=A0=A0 (default '())
>> > > +=A0=A0=A0=A0=A0=A0=A0=A0 (sanitize (default-font-sanitizer 'serif)))
>> > > +=A0 (sans-serif defalut-font-sans-serif
>> > default-font-sans-serif
>> > > +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (default '())
>> > > +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (sanitize (default-font-san=
itizer 'sans-serif)))
>> > > +=A0 (monospace default-font-monospace
>> > > +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (default '())
>> > > +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (sanitize (default-font-saniti=
zer 'monospace))))
>> > Rather than having a null default and sanitizing the field as here,
>> > can
>> > we have an #f default and omit the field?
>> >
>> > Btw. I'm not sure whether making this an extra record is the right
>> > idea.=A0 Wouldn't "default-(serif|sans-serif|monospace)-family" at
>> > the
>> > root make more sense?
>> >
>> > Cheers
>>
>> Do you mean to write as follows?
>>
>> --8<---------------cut here---------------start------------->8---
>> (home-environment
>> =A0(packages (list font-google-noto))
>> =A0(services
>> =A0 (append
>> =A0=A0=A0=A0=A0 (list
>> =A0=A0=A0=A0=A0=A0 (service home-bash-service-type))
>> =A0=A0=A0=A0=A0 (modify-services %home-base-services
>> =A0=A0=A0=A0=A0=A0=A0 (home-fontconfig-service-type
>> =A0=A0=A0=A0=A0=A0=A0=A0 config =3D> (home-fontconfig-configuration
>> =A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (font-director=
ies
>> =A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (list "~/fo=
nts"))
>> =A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (default-serif=
-family "Noto Serif CJK JP")
>> =A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (default-sans-=
serif-family "Noto Sans CJK JP")
>> =A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (extra-config
>> =A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 `((match (@=
 (target font))
>> =A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=
 (edit (@ (mode assign)
>> =A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=
=A0=A0=A0=A0=A0=A0=A0=A0=A0 (name antialias))
>> =A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=
=A0=A0=A0=A0=A0=A0 (bool true)))))))))))
>> --8<---------------cut here---------------end--------------->8---
> Yep.  Feels more natural imho.

I have changed the interface as you suggested in the v5 patch.

Cheers,
--=20
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 2 Oct 2022 13:21:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 02 09:21:01 2022
Received: from localhost ([127.0.0.1]:46507 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oeytx-0008KG-9J
	for submit <at> debbugs.gnu.org; Sun, 02 Oct 2022 09:21:01 -0400
Received: from mail-pf1-f182.google.com ([209.85.210.182]:42925)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1oeytu-0008K2-JY
 for 57963 <at> debbugs.gnu.org; Sun, 02 Oct 2022 09:20:59 -0400
Received: by mail-pf1-f182.google.com with SMTP id q7so515707pfl.9
 for <57963 <at> debbugs.gnu.org>; Sun, 02 Oct 2022 06:20:58 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:from:to:cc:subject
 :date; bh=LXRJAVpfLdBpTT2yL3606Ago0/igxgmkC0XdqAct9N8=;
 b=29FggBucOFjMspcTnkZucuTqfeSrP4YhTeN4zirARxrtaXcEw+7os2QSiaauVyDv8F
 RZ6/atwGtCbt5euYDMfHcxagH1jQ8s1A94YGP2iao61N2ysW/UQ0U/fkVtyI94XUos4U
 oXbTJTtRsO7EmTpwsc8McZbcYlxp1X+zl73x515pTNgoNSCaCOnFkxGEJzLO265NExvn
 ZQAx4WqVOPgSAtAEvHgPvXFGYdsEcCOQRHjNU4FbpMgtDvyazIlldT8F2oCvow/K18OT
 cZldKXvKbQf5NFLgKclCI1WG/wFQX0MJ+0dyMrj48/AvopaavfMDfxhPuIf8zx3pZwTs
 GuWw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:x-gm-message-state
 :from:to:cc:subject:date;
 bh=LXRJAVpfLdBpTT2yL3606Ago0/igxgmkC0XdqAct9N8=;
 b=4ysKIrRaJTPoYfLgjzdOrQ79fMcoZEjluGAdF4AtNP+0XyLRw0v2Vt9jflE8Lpmon7
 cRMoIPvTZv9TlRo8YoIN+V+8MqKW5pZzqSFRI7MOlv40kK0JWA1nAeRr94/lKsJoEoRx
 OndlkK8ufFgbTCpiFnFYCRDD0BO/5wrPPzQJVmJdm/VubsXowQceUYb06gZWhqxLOBSS
 SnPHJtPeBHpyQxK2to16XN1Af8hcpqkrFatqfMUg9g6PoTfRe8NDNWwXtCE0GPTIiBFK
 SjWtvt+q/0hBmrFqh1nCyD9LLRmPa+qEdmKPyUY/kv0OKx5V6Pj2DcmzAj0qD/3RlSqd
 VUWg==
X-Gm-Message-State: ACrzQf135tDq4+ZosXSZTk6sQ6cmvfDzHYtQX7zAO8xsZSGolkPs6gA1
 55bkyihXUoXkhGJ+L4Lo98HP+g==
X-Google-Smtp-Source: AMsMyM6ShOgMloSGpoNL/YkDASUNTBPYdC8pjv0Z7KYvetk8jFCBoPiT4SQ9LnobAeyIemG0JBohZA==
X-Received: by 2002:a05:6a00:1748:b0:55a:ddbe:85d7 with SMTP id
 j8-20020a056a00174800b0055addbe85d7mr18356103pfc.68.1664716852765; 
 Sun, 02 Oct 2022 06:20:52 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 f13-20020a170902f38d00b00176a6ba5969sm5281723ple.98.2022.10.02.06.20.51
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sun, 02 Oct 2022 06:20:52 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: 57963 <at> debbugs.gnu.org
Subject: Re: [PATCH v5 1/2] home: services: Add base.
References: <20221002131232.9063-1-higashi@HIDDEN>
Date: Sun, 02 Oct 2022 22:20:49 +0900
In-Reply-To: <20221002131232.9063-1-higashi@HIDDEN> (Taiju HIGASHI's
 message of "Sun, 2 Oct 2022 22:12:31 +0900")
Message-ID: <87fsg6qs3y.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, liliana.prikler@HIDDEN, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi,

I'm sorry.   This email is incorrect; the second email, "[PATCH v5 1/2]
home: services: Add base." is correct.

Taiju HIGASHI <higashi@HIDDEN> writes:

> * gnu/home/services/base.scm: New file.
> * gnu/home.scm (): Move home-fontconfig-service-type from
> home-environment-default-essential-services to its %home-base-services.
> * gnu/local.mk (GNU_SYSTEM_MODULES): Add it.
> ---
>  gnu/home.scm               |  5 ++---
>  gnu/home/services/base.scm | 35 +++++++++++++++++++++++++++++++++++
>  gnu/local.mk               |  2 ++
>  3 files changed, 39 insertions(+), 3 deletions(-)
>  create mode 100644 gnu/home/services/base.scm
>
> diff --git a/gnu/home.scm b/gnu/home.scm
> index c95d1e0818..c79db87018 100644
> --- a/gnu/home.scm
> +++ b/gnu/home.scm
> @@ -19,10 +19,10 @@
>
>  (define-module (gnu home)
>    #:use-module (gnu home services)
> +  #:use-module (gnu home services base)
>    #:use-module (gnu home services symlink-manager)
>    #:use-module (gnu home services shells)
>    #:use-module (gnu home services xdg)
> -  #:use-module (gnu home services fontutils)
>    #:use-module (gnu services)
>    #:use-module (guix records)
>    #:use-module (guix diagnostics)
> @@ -66,7 +66,7 @@ (define-record-type* <home-environment> home-environment
>                                  this-home-environment)))
>
>    (services           home-environment-user-services
> -                      (default '()))
> +                      (default %home-base-services))
>
>    (location           home-environment-location            ; <location>
>                        (default (and=3D> (current-source-location)
> @@ -82,7 +82,6 @@ (define (home-environment-default-essential-services he)
>
>     (service home-symlink-manager-service-type)
>
> -   (service home-fontconfig-service-type)
>     (service home-xdg-base-directories-service-type)
>     (service home-shell-profile-service-type)
>
> diff --git a/gnu/home/services/base.scm b/gnu/home/services/base.scm
> new file mode 100644
> index 0000000000..fbf92ba213
> --- /dev/null
> +++ b/gnu/home/services/base.scm
> @@ -0,0 +1,35 @@
> +;;; GNU Guix --- Functional package management for GNU
> +;;; Copyright =A9 2022 Taiju HIGASHI <higashi@HIDDEN>
> +;;;
> +;;; This file is part of GNU Guix.
> +;;;
> +;;; GNU Guix is free software; you can redistribute it and/or modify it
> +;;; under the terms of the GNU General Public License as published by
> +;;; the Free Software Foundation; either version 3 of the License, or (at
> +;;; your option) any later version.
> +;;;
> +;;; GNU Guix is distributed in the hope that it will be useful, but
> +;;; WITHOUT ANY WARRANTY; without even the implied warranty of
> +;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
> +;;; GNU General Public License for more details.
> +;;;
> +;;; You should have received a copy of the GNU General Public License
> +;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
> +
> +(define-module (gnu home services base)
> +  #:use-module (gnu home services)
> +  #:use-module (gnu home services fontutils)
> +  #:export (%home-base-services))
> +
> +;;; Commentary:
> +;;
> +;; Base home services---i,e., services that 99% of the users will want t=
o use.
> +;;
> +;;; Code:
> +
> +
> +(define %home-base-services
> +  ;; Convenience variable holding the basic services.
> +  (list (service home-fontconfig-service-type)))
> +
> +;;; base.scm ends here
> diff --git a/gnu/local.mk b/gnu/local.mk
> index 26fdfe7ca9..c0fceafd3f 100644
> --- a/gnu/local.mk
> +++ b/gnu/local.mk
> @@ -54,6 +54,7 @@
>  # Copyright =A9 2022 muradm <mail@HIDDEN>
>  # Copyright =A9 2022 Hilton Chain <hako@HIDDEN>
>  # Copyright =A9 2022 Alex Griffin <a@HIDDEN>
> +# Copyright =A9 2022 Taiju HIGASHI <higashi@HIDDEN>
>  #
>  # This file is part of GNU Guix.
>  #
> @@ -85,6 +86,7 @@ GNU_SYSTEM_MODULES =3D				\
>    %D%/compression.scm				\
>    %D%/home.scm					\
>    %D%/home/services.scm			\
> +  %D%/home/services/base.scm			\
>    %D%/home/services/desktop.scm			\
>    %D%/home/services/symlink-manager.scm		\
>    %D%/home/services/fontutils.scm		\

--




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 2 Oct 2022 13:16:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 02 09:16:01 2022
Received: from localhost ([127.0.0.1]:46502 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oeyp7-0008CQ-Br
	for submit <at> debbugs.gnu.org; Sun, 02 Oct 2022 09:16:01 -0400
Received: from mail-pl1-f173.google.com ([209.85.214.173]:45862)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1oeyp4-0008C0-Cp
 for 57963 <at> debbugs.gnu.org; Sun, 02 Oct 2022 09:15:59 -0400
Received: by mail-pl1-f173.google.com with SMTP id u24so635383plq.12
 for <57963 <at> debbugs.gnu.org>; Sun, 02 Oct 2022 06:15:58 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:references:in-reply-to
 :message-id:date:subject:cc:to:from:from:to:cc:subject:date;
 bh=IoHeb2pHkDjy0aw5l7LvutHwtBqqe7doznlxEpcU0Dw=;
 b=GgTjn5ljfLkxE/XCswtQXOsWZUu7oqHYytOz09s+NznnIeTWrcKwkmI1zI7hYIynBZ
 0uOjEEU6JV5ohWhX3rVhkwep5aI3ZEvIJPG711Mlu32YbROeqjNUqQYdQAGvHlqPjmtW
 /HbhNihigVHO9jgjnWYfMNX5eyRDza1/id7v6UQc6Er46xAf/w5stINz5hCKfSzSIqDI
 61A4YcR6HQ8DrFBBqsvUanlt3ryBUT2GfNyRpxHMj3tlH9dzoG1bhEePgsm7Ra1Gb6Be
 Tbb2rX2e3ugSIBPAdaI/rOw2Xz6nrqdj+/TclxnvBGsfBM89kP8/ti1zFxDP3Z5EPRMf
 lVxw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:references:in-reply-to
 :message-id:date:subject:cc:to:from:x-gm-message-state:from:to:cc
 :subject:date;
 bh=IoHeb2pHkDjy0aw5l7LvutHwtBqqe7doznlxEpcU0Dw=;
 b=SMbopuSY8mxjny0Us2geS9V1p7lM4BF4LeA/Hf5wq98y/9Xlmb8FK0PAzEAxr/S4p+
 m2iI6ul/2q91Rie0PYATdvtsworrQNHt9m5IXTK26GDrldb/rnNuKG/Vy57z3WD+jt17
 cE/U842236EOiAgePkEs2MChLfGYKqK5tT4p5fd7mXGpKn3r0W0zbsyt2w3rF1FkBFEB
 9+CMgDiJ/yGw1zpbrZ98qocd9Nx6GUFaNs9LFcXB8Hce9uz/07u3u1QGc8Cz0aB6xPk0
 YkPNeAlPEWlvBHdXk/k0am/vP/EHQAHCV3kaOXjuZXvCnbbBW2EunxFQCJaMW4G/y7Dc
 cmCQ==
X-Gm-Message-State: ACrzQf1j4PVPjCpFYGPFJQc/bJQ6IO4tMmKi0p9Jb9BzY7UsJJ6k9fXW
 vB1KiYoYjs2fXZyf91e7V6Wr20Z8YmRZ4z2y
X-Google-Smtp-Source: AMsMyM49DuD3ay4rsWw7WklKTrn1bEPKnVmt+iwOwBJ0EKDCW9jkwSJOoZ1lHzKRUajAidCfdBPXhQ==
X-Received: by 2002:a17:903:1c4:b0:17f:5b7b:657 with SMTP id
 e4-20020a17090301c400b0017f5b7b0657mr651090plh.125.1664716552499; 
 Sun, 02 Oct 2022 06:15:52 -0700 (PDT)
Received: from Taix.flets-west.jp ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 i2-20020a17090332c200b00176c89243fcsm5342906plr.179.2022.10.02.06.15.50
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sun, 02 Oct 2022 06:15:52 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: 57963 <at> debbugs.gnu.org
Subject: [PATCH v5 2/2] home: services: Support user's fontconfig
 configuration.
Date: Sun,  2 Oct 2022 22:15:35 +0900
Message-Id: <20221002131535.9972-2-higashi@HIDDEN>
X-Mailer: git-send-email 2.37.3
In-Reply-To: <20221002131535.9972-1-higashi@HIDDEN>
References: <20221002131535.9972-1-higashi@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: * gnu/home/services/fontutils.scm
 (add-fontconfig-config-file):
 Support user's fontconfig configuration. (home-fontconfig-configuration):
 New configuration for it. (string-list, maybe-string, maybe-ex [...] 
 Content analysis details:   (2.0 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 SPF_NONE               SPF: sender does not publish an SPF Record
 2.0 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: yoctocell.xyz (xyz)]
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [209.85.214.173 listed in list.dnswl.org]
 0.0 RCVD_IN_MSPIKE_H3      RBL: Good reputation (+3)
 [209.85.214.173 listed in wl.mailspike.net]
 0.0 RCVD_IN_MSPIKE_WL      Mailspike good senders
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, Taiju HIGASHI <higashi@HIDDEN>, liliana.prikler@HIDDEN,
 andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

* gnu/home/services/fontutils.scm (add-fontconfig-config-file): Support user's
fontconfig configuration.
(home-fontconfig-configuration): New configuration for it.
(string-list, maybe-string, maybe-extra-config-list): New types for it.
(string-list?, extra-config-list?): New predicate procedures for it.
(serialize-string-list, serialize-string, serialize-extra-config-list): New
serialize procedures for it.
(guix-home-font-dir): New variable.
---
 gnu/home/services/fontutils.scm | 89 ++++++++++++++++++++++++++++++---
 1 file changed, 83 insertions(+), 6 deletions(-)

diff --git a/gnu/home/services/fontutils.scm b/gnu/home/services/fontutils.scm
index 6062eaed6a..4b3caf3985 100644
--- a/gnu/home/services/fontutils.scm
+++ b/gnu/home/services/fontutils.scm
@@ -1,6 +1,7 @@
 ;;; GNU Guix --- Functional package management for GNU
 ;;; Copyright  2021 Andrew Tropin <andrew@HIDDEN>
 ;;; Copyright  2021 Xinglu Chen <public@HIDDEN>
+;;; Copyright  2022 Taiju HIGASHI <higashi@HIDDEN>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -20,9 +21,17 @@
 (define-module (gnu home services fontutils)
   #:use-module (gnu home services)
   #:use-module (gnu packages fontutils)
+  #:use-module (gnu services configuration)
+  #:use-module (guix diagnostics)
   #:use-module (guix gexp)
+  #:use-module (guix i18n)
+  #:use-module (guix records)
+  #:use-module (srfi srfi-1)
+  #:use-module (sxml simple)
+  #:use-module (ice-9 match)
 
-  #:export (home-fontconfig-service-type))
+  #:export (home-fontconfig-service-type
+            home-fontconfig-configuration))
 
 ;;; Commentary:
 ;;;
@@ -33,15 +42,83 @@ (define-module (gnu home services fontutils)
 ;;;
 ;;; Code:
 
-(define (add-fontconfig-config-file he-symlink-path)
+(define (sxml->xml-string sxml)
+  "Serialize the sxml tree @var{tree} as XML. The output will be string."
+  (call-with-output-string
+    (lambda (port)
+      (sxml->xml sxml port))))
+
+(define guix-home-font-dir "~/.guix-home/profile/share/fonts")
+
+(define (string-list? value)
+  (and (pair? value) (every string? value)))
+
+(define (serialize-string-list field-name value)
+  (sxml->xml-string
+   (map
+    (lambda (path) `(dir ,path))
+    (if (member guix-home-font-dir value)
+        value
+        (append (list guix-home-font-dir) value)))))
+
+(define (serialize-string field-name value)
+  (define (serialize type value)
+    (sxml->xml-string
+     `(alias
+       (family ,type)
+       (prefer
+        (family ,value)))))
+  (match (list field-name value)
+    (('default-font-serif-family family)
+     (serialize 'serif family))
+    (('default-font-sans-serif-family family)
+     (serialize 'sans-serif family))
+    (('default-font-monospace-family family)
+     (serialize 'monospace family))))
+
+(define-maybe string)
+
+(define extra-config-list? list?)
+
+(define-maybe extra-config-list)
+
+(define (serialize-extra-config-list field-name value)
+  (sxml->xml-string
+   (map (match-lambda
+          ((? pair? sxml) sxml)
+          ((? string? xml) (xml->sxml xml))
+          (else
+           (raise (formatted-message
+                   (G_ "'extra-config' type must be xml string or sxml list, was given: ~a")
+                   value))))
+        value)))
+
+(define-configuration home-fontconfig-configuration
+  (font-directories
+   (string-list (list guix-home-font-dir))
+   "The directory list that provides fonts.")
+  (default-font-serif-family
+    maybe-string
+    "The preffered default fonts of serif.")
+  (default-font-sans-serif-family
+    maybe-string
+    "The preffered default fonts of sans-serif.")
+  (default-font-monospace-family
+    maybe-string
+    "The preffered default fonts of monospace.")
+  (extra-config
+   maybe-extra-config-list
+   "Extra configuration values to append to the fonts.conf."))
+
+(define (add-fontconfig-config-file user-config)
   `(("fontconfig/fonts.conf"
      ,(mixed-text-file
        "fonts.conf"
        "<?xml version='1.0'?>
 <!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
-<fontconfig>
-  <dir>~/.guix-home/profile/share/fonts</dir>
-</fontconfig>"))))
+<fontconfig>"
+       (serialize-configuration user-config home-fontconfig-configuration-fields)
+       "</fontconfig>\n"))))
 
 (define (regenerate-font-cache-gexp _)
   `(("profile/share/fonts"
@@ -59,7 +136,7 @@ (define home-fontconfig-service-type
                        (service-extension
                         home-profile-service-type
                         (const (list fontconfig)))))
-                (default-value #f)
+                (default-value (home-fontconfig-configuration))
                 (description
                  "Provides configuration file for fontconfig and make
 fc-* utilities aware of font packages installed in Guix Home's profile.")))
-- 
2.37.3





Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 2 Oct 2022 13:15:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 02 09:15:58 2022
Received: from localhost ([127.0.0.1]:46499 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oeyp3-0008CA-Rg
	for submit <at> debbugs.gnu.org; Sun, 02 Oct 2022 09:15:58 -0400
Received: from mail-pg1-f178.google.com ([209.85.215.178]:41982)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1oeyp2-0008Bv-3o
 for 57963 <at> debbugs.gnu.org; Sun, 02 Oct 2022 09:15:56 -0400
Received: by mail-pg1-f178.google.com with SMTP id q9so7709563pgq.8
 for <57963 <at> debbugs.gnu.org>; Sun, 02 Oct 2022 06:15:56 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:message-id:date:subject:cc
 :to:from:from:to:cc:subject:date;
 bh=+6T7914hVvfpGjp1pduX+yD/C3m+igLeJJvl6eRfgA8=;
 b=aaSJ8RleC+6MTAasxntMD18Igs12pSGhAT89alUhgbjSiHWWrMrn7FNKEDtj5w2lRS
 Kq5IilUUvEd1hXDvas0UYjIm9420UYa5W2gCGrXHuDAhM/5lMjoS3N92usAd3cZxJvEm
 e/KGDOYCd0t3bvFXBDEfPmDwgCvskJnMlWc1D6vK+leP9MH+tbiF4w+VmBy5Bqg9HEjv
 If3gRTScNYptv8ZT+Q4piLVPcjHQM3YtEuQ+pJtG8WLAjjvWUDjkYBCrRf4lqpZsHrVJ
 QPLsAUF+QELMU0t+bGVzw0zG9NuV4qle9ClgWNPxcR1goducK8jn2CE/h2Jj21e2jOFa
 Jmjg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:message-id:date:subject:cc
 :to:from:x-gm-message-state:from:to:cc:subject:date;
 bh=+6T7914hVvfpGjp1pduX+yD/C3m+igLeJJvl6eRfgA8=;
 b=pCowHH7TfAK1Fv2QzZA35qVH9idY9axgZl6IIuJWyvB5Vn8zVuScsMDACZr963+Hr5
 bh6C0+4QP0DGC82LWZyc4ySgzLsfzXVyQsmmo2dS9DhoTFm+0PU/Vbpg/tSQP/O6fW1t
 bJD+zIK03l6sGDa2kcK5PkFrvfHpOvQ26HSvU2dBFKPjDOql7vmi7taK/XxfGK9fR3IH
 zAsa8krVy6oHgsx00Rb5kDNJFTW/knSVDeC/etUP76daBbNRBhribgf8ZytIA7dHgYT5
 SjP+6qydFGTjnaUaa+NiHUjZX75JFDjnUCshhHm3u/rK1aVzMRuPd6WSpkXEMD5opu2P
 Idtw==
X-Gm-Message-State: ACrzQf0UuGcMGS7NND0Qah6zHWeNe1b2XesX7cNrZ3+eMnLTwyrV2DGu
 Q27BvOv1mu2e1nnwao/oG5hyBm0ahnXP653p
X-Google-Smtp-Source: AMsMyM7wxeAsu1pgEmNSIvdV4AQRgz2uxUcfwpzc9VGLZR0Gb0V9aW3GA/pgBeA6bW0mo6WG/ENBYg==
X-Received: by 2002:a63:ea4a:0:b0:439:4695:c0f8 with SMTP id
 l10-20020a63ea4a000000b004394695c0f8mr14893985pgk.440.1664716550258; 
 Sun, 02 Oct 2022 06:15:50 -0700 (PDT)
Received: from Taix.flets-west.jp ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 i2-20020a17090332c200b00176c89243fcsm5342906plr.179.2022.10.02.06.15.48
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sun, 02 Oct 2022 06:15:49 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: 57963 <at> debbugs.gnu.org
Subject: [PATCH v5 1/2] home: services: Add base.
Date: Sun,  2 Oct 2022 22:15:34 +0900
Message-Id: <20221002131535.9972-1-higashi@HIDDEN>
X-Mailer: git-send-email 2.37.3
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, Taiju HIGASHI <higashi@HIDDEN>, liliana.prikler@HIDDEN,
 andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

* gnu/home/services/base.scm: New file.
* gnu/home.scm (home-environment): Move home-fontconfig-service-type from
home-environment-default-essential-services to %home-base-services of it.
* gnu/local.mk (GNU_SYSTEM_MODULES): Add it.
---
 gnu/home.scm               |  5 ++---
 gnu/home/services/base.scm | 35 +++++++++++++++++++++++++++++++++++
 gnu/local.mk               |  2 ++
 3 files changed, 39 insertions(+), 3 deletions(-)
 create mode 100644 gnu/home/services/base.scm

diff --git a/gnu/home.scm b/gnu/home.scm
index c95d1e0818..c79db87018 100644
--- a/gnu/home.scm
+++ b/gnu/home.scm
@@ -19,10 +19,10 @@

 (define-module (gnu home)
   #:use-module (gnu home services)
+  #:use-module (gnu home services base)
   #:use-module (gnu home services symlink-manager)
   #:use-module (gnu home services shells)
   #:use-module (gnu home services xdg)
-  #:use-module (gnu home services fontutils)
   #:use-module (gnu services)
   #:use-module (guix records)
   #:use-module (guix diagnostics)
@@ -66,7 +66,7 @@ (define-record-type* <home-environment> home-environment
                                 this-home-environment)))

   (services           home-environment-user-services
-                      (default '()))
+                      (default %home-base-services))

   (location           home-environment-location            ; <location>
                       (default (and=> (current-source-location)
@@ -82,7 +82,6 @@ (define (home-environment-default-essential-services he)

    (service home-symlink-manager-service-type)

-   (service home-fontconfig-service-type)
    (service home-xdg-base-directories-service-type)
    (service home-shell-profile-service-type)

diff --git a/gnu/home/services/base.scm b/gnu/home/services/base.scm
new file mode 100644
index 0000000000..fbf92ba213
--- /dev/null
+++ b/gnu/home/services/base.scm
@@ -0,0 +1,35 @@
+;;; GNU Guix --- Functional package management for GNU
+;;; Copyright  2022 Taiju HIGASHI <higashi@HIDDEN>
+;;;
+;;; This file is part of GNU Guix.
+;;;
+;;; GNU Guix is free software; you can redistribute it and/or modify it
+;;; under the terms of the GNU General Public License as published by
+;;; the Free Software Foundation; either version 3 of the License, or (at
+;;; your option) any later version.
+;;;
+;;; GNU Guix is distributed in the hope that it will be useful, but
+;;; WITHOUT ANY WARRANTY; without even the implied warranty of
+;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;;; GNU General Public License for more details.
+;;;
+;;; You should have received a copy of the GNU General Public License
+;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
+
+(define-module (gnu home services base)
+  #:use-module (gnu home services)
+  #:use-module (gnu home services fontutils)
+  #:export (%home-base-services))
+
+;;; Commentary:
+;;
+;; Base home services---i,e., services that 99% of the users will want to use.
+;;
+;;; Code:
+
+
+(define %home-base-services
+  ;; Convenience variable holding the basic services.
+  (list (service home-fontconfig-service-type)))
+
+;;; base.scm ends here
diff --git a/gnu/local.mk b/gnu/local.mk
index 26fdfe7ca9..c0fceafd3f 100644
--- a/gnu/local.mk
+++ b/gnu/local.mk
@@ -54,6 +54,7 @@
 # Copyright  2022 muradm <mail@HIDDEN>
 # Copyright  2022 Hilton Chain <hako@HIDDEN>
 # Copyright  2022 Alex Griffin <a@HIDDEN>
+# Copyright  2022 Taiju HIGASHI <higashi@HIDDEN>
 #
 # This file is part of GNU Guix.
 #
@@ -85,6 +86,7 @@ GNU_SYSTEM_MODULES =				\
   %D%/compression.scm				\
   %D%/home.scm					\
   %D%/home/services.scm			\
+  %D%/home/services/base.scm			\
   %D%/home/services/desktop.scm			\
   %D%/home/services/symlink-manager.scm		\
   %D%/home/services/fontutils.scm		\
--
2.37.3




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 2 Oct 2022 13:12:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 02 09:12:49 2022
Received: from localhost ([127.0.0.1]:46490 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oeym0-00086v-TO
	for submit <at> debbugs.gnu.org; Sun, 02 Oct 2022 09:12:49 -0400
Received: from mail-pf1-f176.google.com ([209.85.210.176]:35787)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1oeyly-00086i-E5
 for 57963 <at> debbugs.gnu.org; Sun, 02 Oct 2022 09:12:47 -0400
Received: by mail-pf1-f176.google.com with SMTP id i6so8109084pfb.2
 for <57963 <at> debbugs.gnu.org>; Sun, 02 Oct 2022 06:12:46 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:message-id:date:subject:cc
 :to:from:from:to:cc:subject:date;
 bh=87vD6Zl+90LTKJAKG2Oq9CaKHKW2oliUjXYGtfEuKZs=;
 b=oPBmHaGAwZAtqwDnQi5MI0ZZSCdUtg/KzEkWvR1lJZbdCYLe8/Zi/R/sYXbigRte/C
 0rVl6pdU9mz/OB1eCoDns6ZKKFM54taacx4ALn4UwZo0o+raKU3QpBehbTzbMNwZmQ8D
 7ftVqBM8kJmAKPvRgbvEoEH/dAEvincEmVhpCVo228g+CvUwlBrhhiqTMMYx1Cbx1uhx
 k1TpgF/XIjkt8nNTuXsEjM3XcflZyipzXvcle5KodJUemEbff13oBvHCJoZqP+lbNAHV
 LpVbs06DeJx2Hjs0Upyu8aNhf1JlGFFV5eI3oayg1dnqLhoR4aQJ349vP2XUgfj85hc9
 yVgw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:message-id:date:subject:cc
 :to:from:x-gm-message-state:from:to:cc:subject:date;
 bh=87vD6Zl+90LTKJAKG2Oq9CaKHKW2oliUjXYGtfEuKZs=;
 b=4r+MzheawXY2RR17/u2ppP16xJ4gLfEshjBh02SjDKBCs4VURTDhwxgBAZkYrG5t9r
 YHg3plyVP9ZYP3VHIogrRnrLMzwNBo0G2ooykAkfrxT2pgaitfMi8MPhBjTpgOpinEGp
 PxHMomsbyv77D94ngg59TXfx4kVhEcYfoVl6BVqHQDh4x1ZhzabUDj2Rapbkpn7V2CSK
 2frlV0b24yqyhPn/jFfh5CEYn/VU102jdGJ72Ip6aqq18SKMSwsxU1pyzZH1bfJK1EWv
 EA6IP73nMHLLP6JRJvDh8AVoTiAvrCmcQJpcDZ8jKiykLnTjD2lrovGTSQOvfsMtkoZ6
 Pu2g==
X-Gm-Message-State: ACrzQf0qVOWZ9Z5fbn4fpPNkQKP71EJU56ey2Js1YFfYGbdL6unsqFvK
 R6j73MtS5HcwHJ1FOi6DDC64VvtCp+jBr08c
X-Google-Smtp-Source: AMsMyM41xbL5JqHOh2OZMewDcWbw3Iz1cXpyi2hSlKg89G7wpBEl+6jWAV4iXYl7eXdioZVqw899Fg==
X-Received: by 2002:a63:c142:0:b0:43c:9fcc:c9f2 with SMTP id
 p2-20020a63c142000000b0043c9fccc9f2mr15061421pgi.44.1664716360422; 
 Sun, 02 Oct 2022 06:12:40 -0700 (PDT)
Received: from Taix.flets-west.jp ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 22-20020a621516000000b0053e669cc845sm5350141pfv.190.2022.10.02.06.12.38
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sun, 02 Oct 2022 06:12:39 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: 57963 <at> debbugs.gnu.org
Subject: [PATCH v5 1/2] home: services: Add base.
Date: Sun,  2 Oct 2022 22:12:31 +0900
Message-Id: <20221002131232.9063-1-higashi@HIDDEN>
X-Mailer: git-send-email 2.37.3
MIME-Version: 1.0
Content-Type: text/plain; charset=__emacs_complete_pre_command;
 echo -n "pwd=${PWD}"; compgen -b -c -a -A function -- n 2>/dev/null
Content-Transfer-Encoding: 8bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, Taiju HIGASHI <higashi@HIDDEN>, liliana.prikler@HIDDEN,
 andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

* gnu/home/services/base.scm: New file.
* gnu/home.scm (): Move home-fontconfig-service-type from
home-environment-default-essential-services to its %home-base-services.
* gnu/local.mk (GNU_SYSTEM_MODULES): Add it.
---
 gnu/home.scm               |  5 ++---
 gnu/home/services/base.scm | 35 +++++++++++++++++++++++++++++++++++
 gnu/local.mk               |  2 ++
 3 files changed, 39 insertions(+), 3 deletions(-)
 create mode 100644 gnu/home/services/base.scm

diff --git a/gnu/home.scm b/gnu/home.scm
index c95d1e0818..c79db87018 100644
--- a/gnu/home.scm
+++ b/gnu/home.scm
@@ -19,10 +19,10 @@
 
 (define-module (gnu home)
   #:use-module (gnu home services)
+  #:use-module (gnu home services base)
   #:use-module (gnu home services symlink-manager)
   #:use-module (gnu home services shells)
   #:use-module (gnu home services xdg)
-  #:use-module (gnu home services fontutils)
   #:use-module (gnu services)
   #:use-module (guix records)
   #:use-module (guix diagnostics)
@@ -66,7 +66,7 @@ (define-record-type* <home-environment> home-environment
                                 this-home-environment)))
 
   (services           home-environment-user-services
-                      (default '()))
+                      (default %home-base-services))
 
   (location           home-environment-location            ; <location>
                       (default (and=> (current-source-location)
@@ -82,7 +82,6 @@ (define (home-environment-default-essential-services he)
 
    (service home-symlink-manager-service-type)
 
-   (service home-fontconfig-service-type)
    (service home-xdg-base-directories-service-type)
    (service home-shell-profile-service-type)
 
diff --git a/gnu/home/services/base.scm b/gnu/home/services/base.scm
new file mode 100644
index 0000000000..fbf92ba213
--- /dev/null
+++ b/gnu/home/services/base.scm
@@ -0,0 +1,35 @@
+;;; GNU Guix --- Functional package management for GNU
+;;; Copyright  2022 Taiju HIGASHI <higashi@HIDDEN>
+;;;
+;;; This file is part of GNU Guix.
+;;;
+;;; GNU Guix is free software; you can redistribute it and/or modify it
+;;; under the terms of the GNU General Public License as published by
+;;; the Free Software Foundation; either version 3 of the License, or (at
+;;; your option) any later version.
+;;;
+;;; GNU Guix is distributed in the hope that it will be useful, but
+;;; WITHOUT ANY WARRANTY; without even the implied warranty of
+;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;;; GNU General Public License for more details.
+;;;
+;;; You should have received a copy of the GNU General Public License
+;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
+
+(define-module (gnu home services base)
+  #:use-module (gnu home services)
+  #:use-module (gnu home services fontutils)
+  #:export (%home-base-services))
+
+;;; Commentary:
+;;
+;; Base home services---i,e., services that 99% of the users will want to use.
+;;
+;;; Code:
+
+
+(define %home-base-services
+  ;; Convenience variable holding the basic services.
+  (list (service home-fontconfig-service-type)))
+
+;;; base.scm ends here
diff --git a/gnu/local.mk b/gnu/local.mk
index 26fdfe7ca9..c0fceafd3f 100644
--- a/gnu/local.mk
+++ b/gnu/local.mk
@@ -54,6 +54,7 @@
 # Copyright  2022 muradm <mail@HIDDEN>
 # Copyright  2022 Hilton Chain <hako@HIDDEN>
 # Copyright  2022 Alex Griffin <a@HIDDEN>
+# Copyright  2022 Taiju HIGASHI <higashi@HIDDEN>
 #
 # This file is part of GNU Guix.
 #
@@ -85,6 +86,7 @@ GNU_SYSTEM_MODULES =				\
   %D%/compression.scm				\
   %D%/home.scm					\
   %D%/home/services.scm			\
+  %D%/home/services/base.scm			\
   %D%/home/services/desktop.scm			\
   %D%/home/services/symlink-manager.scm		\
   %D%/home/services/fontutils.scm		\
-- 
2.37.3





Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 1 Oct 2022 21:57:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 01 17:57:29 2022
Received: from localhost ([127.0.0.1]:45795 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oekUD-0003UU-3w
	for submit <at> debbugs.gnu.org; Sat, 01 Oct 2022 17:57:29 -0400
Received: from eggs.gnu.org ([209.51.188.92]:50030)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1oekUB-0003UH-5x
 for 57963 <at> debbugs.gnu.org; Sat, 01 Oct 2022 17:57:27 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:42544)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ludo@HIDDEN>)
 id 1oekU4-0008SV-QD; Sat, 01 Oct 2022 17:57:21 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-Version:In-Reply-To:Date:References:Subject:To:
 From; bh=MG5vdF6tT2riVzNvpJ15Wd3EvTzc6Ef3e9y86B8zm+I=; b=P9Ml4h9Yvg2u+cCkw60r
 Jthe8mTNpJws/nx9pje2AkjTjdVQGu0y8OvA0fHFs1iolk+ovUiU/kjLP282KBWSDVroksjOlVAJf
 8QCKZImesyxhoJ+LgxKHMCAnUMEBpGwUs8JEWq+wsCJ8utuQ4dv5ZZk3tnoTQTlx5VERlBR1AwT3O
 zMWi2sUHmzBgTyIvVwUSESTIGUls8YyA8qP2mdAb1j4svrwM4XkEddfDeE+d3Lv898j1DCNbZNCTx
 h9hM2trzMAl5BkZATwP9xS2f+XYeAIKxxBka1d8VFZcytRvp7plsmuG8xsEUKKHEv4K+woNhyMAmq
 ms+RY9I7vZ7pWw==;
Received: from 91-160-117-201.subs.proxad.net ([91.160.117.201]:60796
 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ludo@HIDDEN>)
 id 1oekU4-0003sR-Bz; Sat, 01 Oct 2022 17:57:20 -0400
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>
Subject: Re: [PATCH v4 2/2] home: fontutils: Support user's fontconfig.
References: <20220929143633.28844-1-higashi@HIDDEN>
 <20220929143633.28844-2-higashi@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: =?utf-8?Q?D=C3=A9cadi?= 10 =?utf-8?Q?Vend=C3=A9miair?=
 =?utf-8?Q?e?= an 231 de la =?utf-8?Q?R=C3=A9volution=2C?= jour de
 la Cuve
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Sat, 01 Oct 2022 23:57:18 +0200
In-Reply-To: <20220929143633.28844-2-higashi@HIDDEN> (Taiju HIGASHI's
 message of "Thu, 29 Sep 2022 23:36:33 +0900")
Message-ID: <87ill3b41t.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Taiju HIGASHI <higashi@HIDDEN> skribis:

> * gnu/home/services/fontutils.scm: Support user's fontconfig.

I=E2=80=99m nitpicking a bit, but here we would describe all the
variables/procedures added, removed, or modified.  Please check =E2=80=98git
log=E2=80=99 for examples.

Regarding code, there=E2=80=99s a convention to add a docstring to each
top-level procedure:

  https://guix.gnu.org/manual/devel/en/html_node/Formatting-Code.html

It would be nice to follow it here.

> +(define (default-font-sanitizer type)
> +  (lambda (value)
> +    (if (null? value)
> +        value
> +        `(alias
> +          (family ,type)
> +          (prefer
> +           (family ,value))))))

Giving '() special meaning here looks quite unusual.  As Liliana wrote,
we=E2=80=99d usually use #f as the value denoting =E2=80=9Cnothing=E2=80=9D.

> +(define (sxml->xmlstring sxml)
> +  (if (null? sxml)
> +      ""
> +      (call-with-output-string
> +        (lambda (port)
> +          (sxml->xml sxml port)))))

Same here.  Also, =E2=80=9Cxml-string=E2=80=9D rather than =E2=80=9Cxmlstri=
ng=E2=80=9D.

> +(define font-directories? list?)

Is it really needed?

> +(define (serialize-font-directories field-name value)
> +  (sxml->xmlstring
> +   (append
> +       '((dir "~/.guix-home/profile/share/fonts"))
> +       (map
> +        (lambda (path)
> +          `(dir ,path))
> +        value))))

The indentation would rather be:

  (append '((dir =E2=80=A6))
          (map (lambda (directory)
                 `(dir ,directory))
               value))

> +   (map (match-lambda
> +          ((? pair? sxml) sxml)
> +          ((? string? xml) (xml->sxml xml))
> +          (_ (error "extra-config value must be xml string or sxml list.=
")))

Instead of =E2=80=98error=E2=80=99, which would lead to an ugly backtrace a=
nd an
untranslated error message, write:

  (raise (formatted-message (G_ "'extra-config' =E2=80=A6")))

without a trailing dot in the message.

The rest LGTM!  Like I wrote, could you please add documentation in
=E2=80=98doc/guix.texi=E2=80=99, with a configuration example like the one =
you gave?

Thanks for all the work!

Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 1 Oct 2022 21:47:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 01 17:47:51 2022
Received: from localhost ([127.0.0.1]:45790 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oekKs-0003G5-Vl
	for submit <at> debbugs.gnu.org; Sat, 01 Oct 2022 17:47:51 -0400
Received: from eggs.gnu.org ([209.51.188.92]:50612)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1oekKr-0003FN-E5
 for 57963 <at> debbugs.gnu.org; Sat, 01 Oct 2022 17:47:49 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:36182)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ludo@HIDDEN>)
 id 1oekKl-0007I6-EF; Sat, 01 Oct 2022 17:47:43 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-Version:In-Reply-To:Date:References:Subject:To:
 From; bh=oQESRx1vgW5XKexo1adfBErJF/NsXmecvjmAmn/wMVg=; b=ahgrbhz5DYIpEJa9Vygw
 q6WJZjnDkL4cLSuHoDyu1ivi4W5324giuJnADN2wNoww7UcrRnToES8B7pcXMZyhyeW3KYagoLcQR
 nOPk9EVPiZWHynQSFraAbdt8tILuxxILXDQ69X0idi9scc7ctCQt6RxIBzNOXKUz34KsNvb7uxdbg
 v30zlg/cCqIlYuKOCosF9G4MOndko4dCZRi1uJU88gOJXx/OrelUX4/0z3JhO1idqaFjv4x4L43mI
 q7C7omO01rsXt9iis/l0dTBJ8VNqX7rz50J33QxaSNdZdxfzxGzpGFlkKxiq4W6/0jdxeCLT8gJES
 4cZgNUUZUPFLsw==;
Received: from 91-160-117-201.subs.proxad.net ([91.160.117.201]:57948
 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ludo@HIDDEN>)
 id 1oekKk-0002t7-Ow; Sat, 01 Oct 2022 17:47:42 -0400
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>
Subject: Re: [PATCH v4 1/2] home-services: Add base.
References: <20220929143633.28844-1-higashi@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: =?utf-8?Q?D=C3=A9cadi?= 10 =?utf-8?Q?Vend=C3=A9miair?=
 =?utf-8?Q?e?= an 231 de la =?utf-8?Q?R=C3=A9volution=2C?= jour de
 la Cuve
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Sat, 01 Oct 2022 23:47:41 +0200
In-Reply-To: <20220929143633.28844-1-higashi@HIDDEN> (Taiju HIGASHI's
 message of "Thu, 29 Sep 2022 23:36:32 +0900")
Message-ID: <87r0zrb4hu.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi,

Taiju HIGASHI <higashi@HIDDEN> skribis:

> * gnu/home.scm: Move home-fontconfig-service-type from
> home-environment-default-essential-services to %home-base-services.
> * gnu/home/services/base.scm: Add base.

In addition to what Liliana wrote, please make sure to add the new file
to =E2=80=98gnu/local.mk=E2=80=99.

> @@ -82,7 +82,6 @@ (define (home-environment-default-essential-services he)
>=20=20
>     (service home-symlink-manager-service-type)
>=20=20
> -   (service home-fontconfig-service-type)
>     (service home-xdg-base-directories-service-type)
>     (service home-shell-profile-service-type)

Like Liliana wrote, it may be that more of these can be moved from
=E2=80=9Cessential=E2=80=9D to =E2=80=9Cbase=E2=80=9D, we can keep that for=
 a later patch.

Otherwise LGTM!

Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 1 Oct 2022 16:15:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 01 12:15:01 2022
Received: from localhost ([127.0.0.1]:45609 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oef8m-0003bW-Tv
	for submit <at> debbugs.gnu.org; Sat, 01 Oct 2022 12:15:01 -0400
Received: from mail-ej1-f67.google.com ([209.85.218.67]:33299)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <liliana.prikler@HIDDEN>) id 1oef8k-0003bJ-Is
 for 57963 <at> debbugs.gnu.org; Sat, 01 Oct 2022 12:14:59 -0400
Received: by mail-ej1-f67.google.com with SMTP id lc7so14691272ejb.0
 for <57963 <at> debbugs.gnu.org>; Sat, 01 Oct 2022 09:14:58 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:from:to:cc:subject
 :date; bh=2cC5zkbKktsE03UTYHiTttIuY6+40v07HcolsQU7R2s=;
 b=l8ii5pvCMN7ktz/tEihjryfq4+Wkod0OYQctudt3+cy3zqAyLQS1cjqobYu2ONA/Jw
 cPuWi+MjrWbUjyXWNOc3ERK7LytK/F2TKKvG24yR1zAgARkXLcrReoGj4pJKzkuydrBu
 TmtwNx6rvT4TmRwzxhkmM7AbiDNAe+XXBMPxiOsn3U7CTxjNUh+OZ1XSiq9B434TUNDU
 nwzOcyoLvazxL5vvv9Xv4NOazDzE46c680pN2qELB/g6wwjAjAAEMtTX8U6CTmohUdve
 4h1958kRSOOq9jfjAHzt8C/at8h+4Xhzjs8g2WOM0fDqp/7RkIjwS7YCxQTt3IXXpSSS
 fV3w==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:x-gm-message-state
 :from:to:cc:subject:date;
 bh=2cC5zkbKktsE03UTYHiTttIuY6+40v07HcolsQU7R2s=;
 b=x0JrK9cYiVBMWnBQwJTkouW+jQRbohhbxDiwPn4jkXv4IcUnaf8B091QC+zHqYgw/u
 8EOR3VQSq5se38wgnlqdQn8CSYFB0+aUK4MuE+2DrZvJLpfh9NzoJQH3709+ErX06QPc
 +rI2hWmKVpM+Ka4gF7cm+l40FJiCgUC4TgTd7jQbGG88RCckUE4GLcZRbCh2Qv0gs0hy
 3djomSoOR1kwmnY0dqK9dZp6S9YAgN6iBYp253bCpidldNUmnQebWHQnuri54tEZhHAm
 GRS5iksaR6TtynoVPNDSHhpEOu00UXjadk0obQMSp5OzJQ208YTLIjtBo8DS0tAlwNGP
 Bufg==
X-Gm-Message-State: ACrzQf3BYPTXCFICd+0Mpw4RzGO/7oaCWY9uAVYGBe+4v1qR6Ih+8Gs4
 tcO1DO04Xze5AHtBu9dnTjk=
X-Google-Smtp-Source: AMsMyM4CSl+/DTNA9d0ZaWjbJBwhlCCNEJ3NQZ+mTl5iTErlmLXyP0d6vRa7BZXFIqotVIagG7qOXw==
X-Received: by 2002:a17:907:802:b0:781:8017:b2df with SMTP id
 wv2-20020a170907080200b007818017b2dfmr9947338ejb.606.1664640892676; 
 Sat, 01 Oct 2022 09:14:52 -0700 (PDT)
Received: from lumine.fritz.box (85-127-52-93.dsl.dynamic.surfer.at.
 [85.127.52.93]) by smtp.gmail.com with ESMTPSA id
 pk5-20020a170906d7a500b0077016f4c6d4sm2926588ejb.55.2022.10.01.09.14.51
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 01 Oct 2022 09:14:52 -0700 (PDT)
Message-ID: <6155f2126a6725979ee51079c0d90f5d00c31e1c.camel@HIDDEN>
Subject: Re: [PATCH v4 2/2] home: fontutils: Support user's fontconfig.
From: liliana.prikler@HIDDEN
To: Taiju HIGASHI <higashi@HIDDEN>
Date: Sat, 01 Oct 2022 18:14:51 +0200
In-Reply-To: <87o7uvrdt4.fsf@HIDDEN>
References: <20220929143633.28844-1-higashi@HIDDEN>
 <20220929143633.28844-2-higashi@HIDDEN>
 <3e28e656526b901a3fd099d1cd180528f24e15e7.camel@HIDDEN>
 <87o7uvrdt4.fsf@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: base64
User-Agent: Evolution 3.46.0 
MIME-Version: 1.0
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Am Samstag, dem 01.10.2022 um 20:19 +0900 schrieb Taiju HIGASHI:
    > liliana.prikler@HIDDENwrites: > > > Am Donnerstag, dem 29.09.2022
   um 23:36 +0900 schrieb Taiju HIGASHI: > > > * gnu/home/service [...] 
 
 Content analysis details:   (2.0 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  2.0 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
                             provider (liliana.prikler[at]gmail.com)
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
                              no trust
                             [209.85.218.67 listed in list.dnswl.org]
  0.0 RCVD_IN_MSPIKE_H3      RBL: Good reputation (+3)
                             [209.85.218.67 listed in wl.mailspike.net]
  0.0 RCVD_IN_MSPIKE_WL      Mailspike good senders
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, 57963 <at> debbugs.gnu.org, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)
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Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 1 Oct 2022 11:20:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 01 07:20:02 2022
Received: from localhost ([127.0.0.1]:43795 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oeaXJ-0005cl-Tn
	for submit <at> debbugs.gnu.org; Sat, 01 Oct 2022 07:20:02 -0400
Received: from mail-pj1-f48.google.com ([209.85.216.48]:55200)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1oeaXH-0005cN-PY
 for 57963 <at> debbugs.gnu.org; Sat, 01 Oct 2022 07:20:00 -0400
Received: by mail-pj1-f48.google.com with SMTP id 70so6298621pjo.4
 for <57963 <at> debbugs.gnu.org>; Sat, 01 Oct 2022 04:19:59 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:from:to:cc:subject
 :date; bh=h9Zt8CGjGQSIuO2XegoXY83Brpqw0Ta5TNSxduk6BlI=;
 b=xnCkMw2MyKOb6f0t5OQyCZiLuKT3frYGzkmRsLQTyIYeQ+nXFfhq/QGHCY8Pt8CBYj
 pWrUN8LzmvWxBgCEr8WFZs9oc6vbDN2lG9OH7Y5gDlI0FR6mQsGt9md6vuCjU+lgeu96
 d6IO5UdEhH+/PYEKiIMaR4cGEYM3c8P/saNP6MfWjlOPUH/ctY0bxIMtc7To9waIEbkI
 63EyWMXE1Jeg3uA6QkaH81XFpg+z+abhsRKYkQV2G2GirfOtoTFQwJ2XI0athxKJmcRf
 8rScM0wUD8qUr+yqZBCXOzgKeJkU4P0pZazKT4vaN1roFiuSOJUwSOzu2/EfRfUu2O6Z
 uykA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:x-gm-message-state
 :from:to:cc:subject:date;
 bh=h9Zt8CGjGQSIuO2XegoXY83Brpqw0Ta5TNSxduk6BlI=;
 b=ZTEEUc4Gyvq3s4eokjVNJMm+rLg+QOeGDN7JHfMYpFuPGp1SS5eD9/k/tXp6FO8nHx
 +8gUkYvirdPUNsWm5myyj+a/0lID31fmdxuMqYuaUx7X52xW98i6ByE3Jdpq8UNw+4gE
 TbkJ8/jzC5ISk8VOq/Qiz9BYdXjTygiPGUNxURnYRwqeYfuC1qEhasej9FeHgL7B8iS5
 wNHYRLC/Xit+boCyq6e1mM3J2aS04YqA4PbczyfurcstVYqnr6ZTHY7sOHQbOkE4Bs2x
 04THExNTtnss2lFZHcgVH6Izh31E4J143CbJkB/755Ptz7l1enDLFOonvQAcynsW/yze
 SA5g==
X-Gm-Message-State: ACrzQf2N/rjEiA4A67dNwCAIqAC7YGSuWrSZRzYd4S3PCZ2OZRpkDcM9
 2joVDnkQebtIJEDTjGbp698pFQ==
X-Google-Smtp-Source: AMsMyM6MsbMve/6eoCNJeY1o2CoozOrQj03GZf9S7yZ1HrucJRZrvKxVC3N3/7vfVJ7GBCejuzj37g==
X-Received: by 2002:a17:90b:4d08:b0:20a:6861:352c with SMTP id
 mw8-20020a17090b4d0800b0020a6861352cmr2880826pjb.225.1664623193990; 
 Sat, 01 Oct 2022 04:19:53 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 m16-20020a170902db1000b00176d8e33601sm3670100plx.203.2022.10.01.04.19.52
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 01 Oct 2022 04:19:53 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: liliana.prikler@HIDDEN
Subject: Re: [PATCH v4 2/2] home: fontutils: Support user's fontconfig.
References: <20220929143633.28844-1-higashi@HIDDEN>
 <20220929143633.28844-2-higashi@HIDDEN>
 <3e28e656526b901a3fd099d1cd180528f24e15e7.camel@HIDDEN>
Date: Sat, 01 Oct 2022 20:19:51 +0900
In-Reply-To: <3e28e656526b901a3fd099d1cd180528f24e15e7.camel@HIDDEN>
 (liliana prikler's message of "Fri, 30 Sep 2022 20:34:08 +0200")
Message-ID: <87o7uvrdt4.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  liliana.prikler@HIDDEN writes: > Am Donnerstag, dem 29.09.2022
    um 23:36 +0900 schrieb Taiju HIGASHI: >> * gnu/home/services/fontutils.scm:
    Support user's fontconfig. >> --- >> gnu/home/services/fontutils.scm | 86
    +++++++++++++++++ [...] 
 
 Content analysis details:   (2.0 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
                              no trust
                             [209.85.216.48 listed in list.dnswl.org]
  0.0 SPF_NONE               SPF: sender does not publish an SPF Record
  2.0 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  0.0 RCVD_IN_MSPIKE_H3      RBL: Good reputation (+3)
                             [209.85.216.48 listed in wl.mailspike.net]
  0.0 RCVD_IN_MSPIKE_WL      Mailspike good senders
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, 57963 <at> debbugs.gnu.org, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

liliana.prikler@HIDDEN writes:

> Am Donnerstag, dem 29.09.2022 um 23:36 +0900 schrieb Taiju HIGASHI:
>> * gnu/home/services/fontutils.scm: Support user's fontconfig.
>> ---
>> =A0gnu/home/services/fontutils.scm | 86 ++++++++++++++++++++++++++++++-
>> --
>> =A01 file changed, 80 insertions(+), 6 deletions(-)
>>
>> diff --git a/gnu/home/services/fontutils.scm
>> b/gnu/home/services/fontutils.scm
>> index 6062eaed6a..32127740f6 100644
>> --- a/gnu/home/services/fontutils.scm
>> +++ b/gnu/home/services/fontutils.scm
>> @@ -1,6 +1,7 @@
>> =A0;;; GNU Guix --- Functional package management for GNU
>> =A0;;; Copyright =A9 2021 Andrew Tropin <andrew@HIDDEN>
>> =A0;;; Copyright =A9 2021 Xinglu Chen <public@HIDDEN>
>> +;;; Copyright =A9 2022 Taiju HIGASHI <higashi@HIDDEN>
>> =A0;;;
>> =A0;;; This file is part of GNU Guix.
>> =A0;;;
>> @@ -20,9 +21,16 @@
>> =A0(define-module (gnu home services fontutils)
>> =A0=A0 #:use-module (gnu home services)
>> =A0=A0 #:use-module (gnu packages fontutils)
>> +=A0 #:use-module (gnu services configuration)
>> =A0=A0 #:use-module (guix gexp)
>> +=A0 #:use-module (guix records)
>> +=A0 #:use-module (srfi srfi-1)
>> +=A0 #:use-module (sxml simple)
>> +=A0 #:use-module (ice-9 match)
>>
>> -=A0 #:export (home-fontconfig-service-type))
>> +=A0 #:export (home-fontconfig-service-type
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 home-fontconfig-configuration
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 default-font))
>>
>> =A0;;; Commentary:
>> =A0;;;
>> @@ -33,15 +41,81 @@ (define-module (gnu home services fontutils)
>> =A0;;;
>> =A0;;; Code:
>>
>> -(define (add-fontconfig-config-file he-symlink-path)
>> +(define (default-font-sanitizer type)
>> +=A0 (lambda (value)
>> +=A0=A0=A0 (if (null? value)
>> +=A0=A0=A0=A0=A0=A0=A0 value
>> +=A0=A0=A0=A0=A0=A0=A0 `(alias
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0 (family ,type)
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0 (prefer
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (family ,value))))))
>> +
>> +(define-record-type* <default-font> default-font
>> +=A0 make-default-font
>> +=A0 default-font?
>> +=A0 (serif default-font-serif
>> +=A0=A0=A0=A0=A0=A0=A0=A0 (default '())
>> +=A0=A0=A0=A0=A0=A0=A0=A0 (sanitize (default-font-sanitizer 'serif)))
>> +=A0 (sans-serif defalut-font-sans-serif
> default-font-sans-serif
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (default '())
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (sanitize (default-font-sanitiz=
er 'sans-serif)))
>> +=A0 (monospace default-font-monospace
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (default '())
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (sanitize (default-font-sanitizer =
'monospace))))
> Rather than having a null default and sanitizing the field as here, can
> we have an #f default and omit the field?
>
> Btw. I'm not sure whether making this an extra record is the right
> idea.  Wouldn't "default-(serif|sans-serif|monospace)-family" at the
> root make more sense?
>
> Cheers

Do you mean to write as follows?

--8<---------------cut here---------------start------------->8---
(home-environment
 (packages (list font-google-noto))
 (services
  (append
      (list
       (service home-bash-service-type))
      (modify-services %home-base-services
        (home-fontconfig-service-type
         config =3D> (home-fontconfig-configuration
                    (font-directories
                     (list "~/fonts"))
                    (default-serif-family "Noto Serif CJK JP")
                    (default-sans-serif-family "Noto Sans CJK JP")
                    (extra-config
                     `((match (@ (target font))
                         (edit (@ (mode assign)
                                  (name antialias))
                               (bool true)))))))))))
--8<---------------cut here---------------end--------------->8---

Cheers,
--=20
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 1 Oct 2022 11:11:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 01 07:11:13 2022
Received: from localhost ([127.0.0.1]:43785 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oeaOn-0005QA-9x
	for submit <at> debbugs.gnu.org; Sat, 01 Oct 2022 07:11:13 -0400
Received: from mail-pf1-f179.google.com ([209.85.210.179]:42714)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1oeaOl-0005Pv-Be
 for 57963 <at> debbugs.gnu.org; Sat, 01 Oct 2022 07:11:11 -0400
Received: by mail-pf1-f179.google.com with SMTP id b23so6333810pfp.9
 for <57963 <at> debbugs.gnu.org>; Sat, 01 Oct 2022 04:11:11 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:from:to:cc:subject
 :date; bh=QMuFUwa5RB8FZFdK3Z+HwZTNBlnOG5UhFp7zVkL83CQ=;
 b=04uhB9KuE5nDBLzTg6pdcb2INy/2xRmC91fYjzCRg+I+nBmiQ2mteGSLDhvCqn2lBA
 LQDJ8eY/x3hViMu9VQo4zVXJPrqB3jCHqAx0d0dp3OfRuZjFObpsKVz7pHO8MnSWSEaP
 sGQG8XuLcjcVmDgAJiNRNoz9mpM6N5U016+gRFp0kq+YZJMvEVIZOOY/ePYrROZcvD6R
 87kj/2n4+ckf+JDIdGO2Zt9l4qAHx3Xpxgx24KMk2v+TfwMyVrimEI1i5sr8hnhNCQPT
 Pp+goo1Fvz6xvAPeke5B+Bga/+bV4R7foeYIzoGVHmFK2XxvvhZPKol4B7KeNFSEOyPM
 GekQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:x-gm-message-state
 :from:to:cc:subject:date;
 bh=QMuFUwa5RB8FZFdK3Z+HwZTNBlnOG5UhFp7zVkL83CQ=;
 b=mCvEd7c9KGJveM/fJWLxU5HHFWc0kGciW4PrJCtZJ+p0/WPqpkvvYZX6UUQNHXDD/c
 eEn2hC4/i04RMe8UCbvSa0lu6AsAv453q4em4RkeFIvyf3V8ISd6lt9LxXJqWmQUPYqP
 Ki+yt3pQU8MHghzf6nfiu56QFKxBQuqAlaBX0aybXZfyXsqCMywGqnP3dsiBFaTuehfu
 9da1Yaaf1OeV9OhOml3vV5tHqbAx7bX/WvffakcAWMQNMdrm9J/x4qtk6LB8ujy2WvpJ
 8K1UVc9yy1aN8gwaVNoc4CO/e5sc6eHiQTFx8VkoChCGV880HW/8+GdC8l9TbfwKtYz4
 Ps5Q==
X-Gm-Message-State: ACrzQf0W9aIobLMiucddxgWmdkrUsRNVQdUumsAGTnUN0oyVKVuNZCXA
 M7LiP/KrpU1ykY5g8r4TTqwDGw==
X-Google-Smtp-Source: AMsMyM4ZfCX/NpInzu9NN5EPelt8hwr8uo1h6RZiF7mfqDbJRzCzXz59/ij+DLfkm0bHsIxtQhWM+Q==
X-Received: by 2002:a05:6a00:1704:b0:55a:d85a:f226 with SMTP id
 h4-20020a056a00170400b0055ad85af226mr13262131pfc.19.1664622665801; 
 Sat, 01 Oct 2022 04:11:05 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 s18-20020a170902b19200b0016dc26c7d30sm3598312plr.164.2022.10.01.04.11.03
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 01 Oct 2022 04:11:05 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: liliana.prikler@HIDDEN
Subject: Re: bug#57963: [PATCH 0/1] Support user's fontconfig.
References: <20220927095525.26431-1-higashi@HIDDEN>
 <87bkr1qg9x.fsf@HIDDEN> <87v8p7dwvc.fsf_-_@HIDDEN>
 <87y1u3ngds.fsf@HIDDEN> <87h70qb6gq.fsf@HIDDEN>
 <875yh6nshm.fsf@HIDDEN>
 <99cd84d6b5d3e3cc85f90aecae76ae0ef791e18a.camel@HIDDEN>
Date: Sat, 01 Oct 2022 20:11:02 +0900
In-Reply-To: <99cd84d6b5d3e3cc85f90aecae76ae0ef791e18a.camel@HIDDEN>
 (liliana prikler's message of "Fri, 30 Sep 2022 20:30:02 +0200")
Message-ID: <87y1tzre7t.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: Ludovic =?iso-8859-1?Q?Court=E8s?= <ludo@HIDDEN>, 57963 <at> debbugs.gnu.org,
 andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

liliana.prikler@HIDDEN writes:

> Am Donnerstag, dem 29.09.2022 um 23:51 +0900 schrieb Taiju HIGASHI:
>> I know it will take some time, but I'll try my best.=A0 By the way, if
>> I edit the texi file, am I correct in confirming that I read the
>> built Info?
> After running `make', you should run `info doc/guix.info' and scroll to
> the edited section to verify that it reads as you intended.
>
> Cheers

Thank you, I will verify the edited documentation that way.

Cheers,
--=20
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 1 Oct 2022 11:08:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 01 07:08:43 2022
Received: from localhost ([127.0.0.1]:43780 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oeaMM-0005Ls-Pu
	for submit <at> debbugs.gnu.org; Sat, 01 Oct 2022 07:08:43 -0400
Received: from mail-pj1-f52.google.com ([209.85.216.52]:38844)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1oeaML-0005Lf-CT
 for 57963 <at> debbugs.gnu.org; Sat, 01 Oct 2022 07:08:41 -0400
Received: by mail-pj1-f52.google.com with SMTP id
 x1-20020a17090ab00100b001fda21bbc90so11323087pjq.3
 for <57963 <at> debbugs.gnu.org>; Sat, 01 Oct 2022 04:08:41 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:from:to:cc:subject
 :date; bh=QsMxysmyQ5FONRL1uW46TjGT17FFH4vQiSxM71ZnBT4=;
 b=yJPSFMipJM5uHbGZSLDAlNvAUJ+uA0JZW8V4W25uLmZDyzSOSlYcT6tGOajVBrzZ38
 N7PZvCQIjOQk3yiIFcukIAe9WMo5gucmoZq3QCFJqmwbei/5IjoAhHoYOp6AuYR4PfEh
 VAX54LzLF6VC67BOHQ/JdjPuB6URyX79qilmAtW+PVkXDpIZmyPUm6N98e/nlNZ0WfsJ
 W5kynXZSZEXoClfMZVaLxl/nJpgooBAYW9/EulwerRdGVjiKW+YCEb+MKN0T4aIEJKLC
 LHSlrOl1XjSBYbwPzCqT2LFvnkLJWs6uDs0fLIG3GOtrykly0nANIsbkTQbkn8s5iwKj
 aA4A==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:x-gm-message-state
 :from:to:cc:subject:date;
 bh=QsMxysmyQ5FONRL1uW46TjGT17FFH4vQiSxM71ZnBT4=;
 b=5D4tKesMTwwU+UW3NTkLYrtU29/BGV+y2H503U4LBh56VLqMcJc8ly1IXpQ6ndhVqS
 zXU8Tuo2kxX1M9MejoqHmxh2nx5CzMMD60kW3tMIx+3wcnDOSp7pJDzKMtCMqa+SnLze
 FSD8W1SLjmYVW2f95kRocaXxMy77LmtX7+qZ0yX5TQi/z/RcKk2JzQ14ULO6kqadqTwx
 XoQJ2KMTnq7YVY/NwbuhB4sLpU7sq1XdHj5eS93d6y1983Brlgj9zkjXSHt6vzRr7wvY
 ZK/22Tcf8h4c3/no9iaJe3GPHzAMZrENvNfAk7jJfgV3yZ/fPaa3iUc5ju1OhtPDXU/U
 UAPQ==
X-Gm-Message-State: ACrzQf05YG2RG00JPxHn36FMrM67qTStwF5ySjGRQqvp4LvbeMvXRaGw
 lGL8GCHo3JQ42iHMoFLnj/kJ3Q==
X-Google-Smtp-Source: AMsMyM5DftJxJPOjUzHiUolt+QfAWe9kbRjJ81dht+5POLIpvzMU1s968X2qejp+R2qQ+zIIcWpq7g==
X-Received: by 2002:a17:903:248b:b0:17d:ea45:d76a with SMTP id
 p11-20020a170903248b00b0017dea45d76amr1474858plw.97.1664622515508; 
 Sat, 01 Oct 2022 04:08:35 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 200-20020a6214d1000000b0055abc22a1absm946802pfu.209.2022.10.01.04.08.33
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 01 Oct 2022 04:08:35 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: liliana.prikler@HIDDEN
Subject: Re: [PATCH v4 1/2] home-services: Add base.
References: <20220929143633.28844-1-higashi@HIDDEN>
 <5fae106ffa5f240d3b41d57a063afee1787ca506.camel@HIDDEN>
 <87leq2md3b.fsf@HIDDEN>
 <111ec39af53f41c937a995f494474c6ff7b1e44b.camel@HIDDEN>
Date: Sat, 01 Oct 2022 20:08:32 +0900
In-Reply-To: <111ec39af53f41c937a995f494474c6ff7b1e44b.camel@HIDDEN>
 (liliana prikler's message of "Fri, 30 Sep 2022 20:21:50 +0200")
Message-ID: <878rlzsswf.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, 57963 <at> debbugs.gnu.org, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

liliana.prikler@HIDDEN writes:

> Am Freitag, dem 30.09.2022 um 00:09 +0900 schrieb Taiju HIGASHI:
>> Liliana Marie Prikler <liliana.prikler@HIDDEN> writes:
>>
>> > Am Donnerstag, dem 29.09.2022 um 23:36 +0900 schrieb Taiju HIGASHI:
>> > > * gnu/home.scm: Move home-fontconfig-service-type from
>> > > home-environment-default-essential-services to %home-base-
>> > > services.
>> > Unless there is a precedent in system, I would make all the
>> > currently
>> > "essential" services %home-base-services perhaps move their code
>> > accordingly.
>>
>> I thought it was only for home-fontconfig-service.=A0 Does that mean
>> delete "essential" services and move everything to %home-base-
>> services?
> I'd double-check with Andrew, but my personal opinion is "yes".

Noted. It may take some time until he can reply, but I will wait for
Andrew's reply.

>> > > * gnu/home/services/base.scm: Add base.
>> > Should be "New file."=A0 Also should probably be the first item in
>> > the
>> > ChangeLog, so that other items can mention it.
>>
>> I understood that "Add base" should be "New file", but I didn't
>> understand the second part.=A0 I apologize for my lack of
>> understanding.
> It means put the * gnu/home/services/base.scm entry before the *
> gnu/home.scm one, so that you can mention the former in the latter.

Thank you for the specific explanation, I understand.

Cheers,
--=20
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 30 Sep 2022 18:34:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 30 14:34:18 2022
Received: from localhost ([127.0.0.1]:42920 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oeKq1-0007Eu-TT
	for submit <at> debbugs.gnu.org; Fri, 30 Sep 2022 14:34:18 -0400
Received: from mail-ej1-f65.google.com ([209.85.218.65]:36603)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <liliana.prikler@HIDDEN>) id 1oeKpz-0007Eh-BC
 for 57963 <at> debbugs.gnu.org; Fri, 30 Sep 2022 14:34:16 -0400
Received: by mail-ej1-f65.google.com with SMTP id 13so10822223ejn.3
 for <57963 <at> debbugs.gnu.org>; Fri, 30 Sep 2022 11:34:15 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:from:to:cc:subject
 :date; bh=vzU0A+Oak/A5HLWxU5lqbpgJsKcJnhKsPk9crDvLX3Y=;
 b=RgS6bakqL9zcpodAl9Qum0fnkfDNiR9zSecz1VbT6g4f404CCO8T9Tg500wpZMnETg
 MQot2y0JR6Uys75N8eKOgfOucboPGpPv1t7E8Bgj1fr8ykWejt2SH0ea1DImG/cYm2Rn
 aBMPjbbDcFcPXF3y1FajWJtyVyD+YxKHK51uir2S4TCDQFgCrnj5+u0VGWj9kiaPxk56
 6p7APkM+fJmBf8HpzG18nVulOfJ55DrUk6kDlp3PKMh+dK59xPETXvNP8uLb3YoPsJh8
 3vu5gRIYw3PIXjwat2lUCNmmrSmX2lZmMB+BWW/d8bqV6f/plEuaeg0KbHHMFfN+s9ig
 J0ZA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:x-gm-message-state
 :from:to:cc:subject:date;
 bh=vzU0A+Oak/A5HLWxU5lqbpgJsKcJnhKsPk9crDvLX3Y=;
 b=ojGD+T7g08iBzIomhoRimX1l/Um/e1zwJHcm78TGuNBT/Vry6y2TRdHNkcYOV2V/92
 2uOzZ70vNweIVoXWzSIXbntCIUnS2/KUKFJedwrmA20/DOWdAluhhUc2BhZzaYF+nyMP
 WAEj7vskYcBI8u9aIE+etStSJe+PxxPhIrQes5ZUSP2ajhm4BKWgvFAUEp/6zgLjpkyf
 NiUrrGF35D7kMiOBWeWpRc2lDJXw3Fc5+RyT1gYjteRv44HCiEb2pbt+LY7qttP4wFnZ
 9Uw+a1BD+7qU9QGzkxZzVWLBxTzSZBmuuRc8UHG57Guy045YBQtydT8roqUSGywyXzvb
 lTmQ==
X-Gm-Message-State: ACrzQf2Ob/JkKIMVyvGRJmH3vRVmTKr+jO5OsYbExis2l7nTY5iDbQyS
 1zXrrJF5GF4N+7u0lRzjQhs=
X-Google-Smtp-Source: AMsMyM571jdX+S3frVLyNmvglZeoRGTBjoQ+Pe3yGc6MymS38+QpB9LBtyFp8ZP1YxWuf+CzunPcGA==
X-Received: by 2002:a17:906:8455:b0:773:c45b:d970 with SMTP id
 e21-20020a170906845500b00773c45bd970mr7353670ejy.46.1664562849570; 
 Fri, 30 Sep 2022 11:34:09 -0700 (PDT)
Received: from lumine.fritz.box (85-127-52-93.dsl.dynamic.surfer.at.
 [85.127.52.93]) by smtp.gmail.com with ESMTPSA id
 f27-20020a17090631db00b0073cf6ec3276sm1477196ejf.207.2022.09.30.11.34.08
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Fri, 30 Sep 2022 11:34:09 -0700 (PDT)
Message-ID: <3e28e656526b901a3fd099d1cd180528f24e15e7.camel@HIDDEN>
Subject: Re: [PATCH v4 2/2] home: fontutils: Support user's fontconfig.
From: liliana.prikler@HIDDEN
To: Taiju HIGASHI <higashi@HIDDEN>, 57963 <at> debbugs.gnu.org
Date: Fri, 30 Sep 2022 20:34:08 +0200
In-Reply-To: <20220929143633.28844-2-higashi@HIDDEN>
References: <20220929143633.28844-1-higashi@HIDDEN>
 <20220929143633.28844-2-higashi@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
User-Agent: Evolution 3.46.0 
MIME-Version: 1.0
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Am Donnerstag, dem 29.09.2022 um 23:36 +0900 schrieb Taiju
    HIGASHI: > * gnu/home/services/fontutils.scm: Support user's fontconfig.
   > --- > gnu/home/services/fontutils.scm | 86 +++++++++++++++++++++ [...]
    
 
 Content analysis details:   (2.0 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  2.0 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
                             provider (liliana.prikler[at]gmail.com)
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  0.0 RCVD_IN_MSPIKE_H3      RBL: Good reputation (+3)
                             [209.85.218.65 listed in wl.mailspike.net]
  0.0 RCVD_IN_MSPIKE_WL      Mailspike good senders
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

Am Donnerstag, dem 29.09.2022 um 23:36 +0900 schrieb Taiju HIGASHI:
> * gnu/home/services/fontutils.scm: Support user's fontconfig.
> ---
> =C2=A0gnu/home/services/fontutils.scm | 86 ++++++++++++++++++++++++++++++=
-
> --
> =C2=A01 file changed, 80 insertions(+), 6 deletions(-)
>=20
> diff --git a/gnu/home/services/fontutils.scm
> b/gnu/home/services/fontutils.scm
> index 6062eaed6a..32127740f6 100644
> --- a/gnu/home/services/fontutils.scm
> +++ b/gnu/home/services/fontutils.scm
> @@ -1,6 +1,7 @@
> =C2=A0;;; GNU Guix --- Functional package management for GNU
> =C2=A0;;; Copyright =C2=A9 2021 Andrew Tropin <andrew@HIDDEN>
> =C2=A0;;; Copyright =C2=A9 2021 Xinglu Chen <public@HIDDEN>
> +;;; Copyright =C2=A9 2022 Taiju HIGASHI <higashi@HIDDEN>
> =C2=A0;;;
> =C2=A0;;; This file is part of GNU Guix.
> =C2=A0;;;
> @@ -20,9 +21,16 @@
> =C2=A0(define-module (gnu home services fontutils)
> =C2=A0=C2=A0 #:use-module (gnu home services)
> =C2=A0=C2=A0 #:use-module (gnu packages fontutils)
> +=C2=A0 #:use-module (gnu services configuration)
> =C2=A0=C2=A0 #:use-module (guix gexp)
> +=C2=A0 #:use-module (guix records)
> +=C2=A0 #:use-module (srfi srfi-1)
> +=C2=A0 #:use-module (sxml simple)
> +=C2=A0 #:use-module (ice-9 match)
> =C2=A0
> -=C2=A0 #:export (home-fontconfig-service-type))
> +=C2=A0 #:export (home-fontconfig-service-type
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 home-=
fontconfig-configuration
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 defau=
lt-font))
> =C2=A0
> =C2=A0;;; Commentary:
> =C2=A0;;;
> @@ -33,15 +41,81 @@ (define-module (gnu home services fontutils)
> =C2=A0;;;
> =C2=A0;;; Code:
> =C2=A0
> -(define (add-fontconfig-config-file he-symlink-path)
> +(define (default-font-sanitizer type)
> +=C2=A0 (lambda (value)
> +=C2=A0=C2=A0=C2=A0 (if (null? value)
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 value
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 `(alias
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (family ,type)
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (prefer
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (family ,va=
lue))))))
> +
> +(define-record-type* <default-font> default-font
> +=C2=A0 make-default-font
> +=C2=A0 default-font?
> +=C2=A0 (serif default-font-serif
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (default '())
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (sanitize (default-font=
-sanitizer 'serif)))
> +=C2=A0 (sans-serif defalut-font-sans-serif
default-font-sans-serif
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=
=C2=A0 (default '())
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=
=C2=A0 (sanitize (default-font-sanitizer 'sans-serif)))
> +=C2=A0 (monospace default-font-monospace
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=
 (default '())
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=
 (sanitize (default-font-sanitizer 'monospace))))
Rather than having a null default and sanitizing the field as here, can
we have an #f default and omit the field?

Btw. I'm not sure whether making this an extra record is the right
idea.  Wouldn't "default-(serif|sans-serif|monospace)-family" at the
root make more sense?

Cheers




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 30 Sep 2022 18:30:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 30 14:30:18 2022
Received: from localhost ([127.0.0.1]:42907 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oeKm9-00078b-To
	for submit <at> debbugs.gnu.org; Fri, 30 Sep 2022 14:30:18 -0400
Received: from mail-ed1-f68.google.com ([209.85.208.68]:44806)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <liliana.prikler@HIDDEN>) id 1oeKm1-00076v-6i
 for 57963 <at> debbugs.gnu.org; Fri, 30 Sep 2022 14:30:12 -0400
Received: by mail-ed1-f68.google.com with SMTP id u24so7043780edb.11
 for <57963 <at> debbugs.gnu.org>; Fri, 30 Sep 2022 11:30:09 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:from:to:cc:subject
 :date; bh=3IUQR15n1w71MKe8F3Ri/ISrB23X6gzjFfz3ots1TSI=;
 b=HBQmSbj5rW0mYBTQd/HkWUtR8S3PJkAND3TgBz5STRSMM5DDaWhlwbOKqMCGrlT1yu
 CThqm9E+Ity07FkmZgoNGCT+/YJzXv8GW6/yHgLION7c20iegWy+cmcg1v7XrpufwQT2
 79fh3IaqgPk1k8yYuym8dNEjN5BSuxOpJt16iHDhsORFUsFgJU5yIOo5sYW9wm8XbRt8
 COjqcj/fGMLq8yJ7T1+zZv22UlLvSGIxFmmLks8tWc3U8xgMVkp2LSyEslC3PunbDp2x
 DpCgwqd6jYWm34kMxGtYAkm+bzABgYsivXqGVEBRIoB6Z5n0+8c+bhgqiklG5kKR/FCf
 Svtg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:x-gm-message-state
 :from:to:cc:subject:date;
 bh=3IUQR15n1w71MKe8F3Ri/ISrB23X6gzjFfz3ots1TSI=;
 b=ny5irfgEQR+bG+u7GPh1025u3HnAmEE1lwvTukUD0LFS/lLkfGMDW+LemV9iG5pIfm
 7+a06LUusGRhhEt6EpmOg0wov7ELagZx2c7t1nJeCeKYLSD9Idd1bxLp1MtqAnkO4HQM
 CX23GhYqDdPv0Eg8RjO65UbXs4a4Pske1ddvxgLuodLA+AFZrz5f+2D6mgYc1B9MB67N
 8fS6UwnB+cQn1aYjCobyd+ZHAaTxGm8ilWbao2/3bpxp5EBjPVEMwsODCzDsbNl2B8+S
 GVEM+2gr2SeVsJCBzNxhvgvpbio85MwS8sozO6oenN4Z+XJO93TYxtBE1BvyXuAuy6sj
 hJjw==
X-Gm-Message-State: ACrzQf0kNjCUN8asB/C+h7OsnMQJTxKdzuHJAfiutAqo4mqkOu+jPVYf
 hOJ59+QbwQtswj2nPUO/30w=
X-Google-Smtp-Source: AMsMyM6rCoGXxm68ZE33ZM9ovBRu9Iow2gLZeVAkZXE26eKmJ5PJqHa/U1loZd19KOE8y2aVLnqamA==
X-Received: by 2002:a05:6402:84c:b0:451:a99b:f74a with SMTP id
 b12-20020a056402084c00b00451a99bf74amr9002039edz.100.1664562603303; 
 Fri, 30 Sep 2022 11:30:03 -0700 (PDT)
Received: from lumine.fritz.box (85-127-52-93.dsl.dynamic.surfer.at.
 [85.127.52.93]) by smtp.gmail.com with ESMTPSA id
 m4-20020aa7c484000000b004573052bf5esm2079572edq.49.2022.09.30.11.30.02
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Fri, 30 Sep 2022 11:30:02 -0700 (PDT)
Message-ID: <99cd84d6b5d3e3cc85f90aecae76ae0ef791e18a.camel@HIDDEN>
Subject: Re: bug#57963: [PATCH 0/1] Support user's fontconfig.
From: liliana.prikler@HIDDEN
To: Taiju HIGASHI <higashi@HIDDEN>, Ludovic =?ISO-8859-1?Q?Court=E8s?=
 <ludo@HIDDEN>
Date: Fri, 30 Sep 2022 20:30:02 +0200
In-Reply-To: <875yh6nshm.fsf@HIDDEN>
References: <20220927095525.26431-1-higashi@HIDDEN>
 <87bkr1qg9x.fsf@HIDDEN> <87v8p7dwvc.fsf_-_@HIDDEN>
 <87y1u3ngds.fsf@HIDDEN> <87h70qb6gq.fsf@HIDDEN>
 <875yh6nshm.fsf@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
User-Agent: Evolution 3.46.0 
MIME-Version: 1.0
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Am Donnerstag, dem 29.09.2022 um 23:51 +0900 schrieb Taiju HIGASHI:
> I know it will take some time, but I'll try my best.=C2=A0 By the way, if
> I edit the texi file, am I correct in confirming that I read the
> built Info?
After running `make', you should run `info doc/guix.info' and scroll to
the edited section to verify that it reads as you intended.

Cheers




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 30 Sep 2022 18:22:00 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 30 14:22:00 2022
Received: from localhost ([127.0.0.1]:42889 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oeKe7-0006uF-TH
	for submit <at> debbugs.gnu.org; Fri, 30 Sep 2022 14:22:00 -0400
Received: from mail-ed1-f65.google.com ([209.85.208.65]:39893)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <liliana.prikler@HIDDEN>) id 1oeKe6-0006u1-4O
 for 57963 <at> debbugs.gnu.org; Fri, 30 Sep 2022 14:21:58 -0400
Received: by mail-ed1-f65.google.com with SMTP id y100so6542786ede.6
 for <57963 <at> debbugs.gnu.org>; Fri, 30 Sep 2022 11:21:58 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:from:to:cc:subject
 :date; bh=aA7Lc6se8ckhVN/ffvAc9QuHqlLC06YhXRE6suPtW88=;
 b=Y2ZUyFjL8WktyiHBPY/ZIJDjkITSukH/bPDeEiFjFXyyXhbBuom5LxcLxL3qTC8n17
 o8iZcTi27UfvIU/BedXFzrTJRzg0ZtoHcr92/lFbUrOkT4KKUzu5++6rEyNBfExvf5fj
 aM//AAz3qp0HQUMKar6HqOPHbZp/7P+b6YlBwVSYtc4yJJCKYUa0FzpD7TWvxJ/jxMXL
 rS93Hzn2O6CYmQYdorvn+obA2TNcHljwFU5z6cfPzeKCm8/v31lo4tpvfdmuz8xtXNE2
 zb6euobQXGJGEm2mbfXyDMjlK4qCqMWqRlqU7gBbG2oSakU9tMbEzLv9LqBTifvKK61P
 sfLw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:x-gm-message-state
 :from:to:cc:subject:date;
 bh=aA7Lc6se8ckhVN/ffvAc9QuHqlLC06YhXRE6suPtW88=;
 b=tPFu65r3rYcesdg3yDcHDuge/tmzC+u5gdqpOoQrEBJPF2g2TR4U1OJDZBiL4pK/sN
 53PxhUcCkBTJUta9K4SqvH3Cdvf+ZDjNGjVosZR7kQz2MGvQD2okKYX+u2h/L0PY27B5
 dWMYUDFSTJkBSMu0Wkwb90yXeEInLbYw90u5gGWnE1T7VDbWuM/2M2byvvPUkPTSO+Mu
 J6b7sk/qfg5g3chjNUDC2j3E5Zak5dcYrhDYFlqcGQGtX51QdjVQTzHncKPsAy9XWmvg
 5Bv2c2qIo/12D8mS1vIv3wGnlgEt3yhBvuFxr6H6H71B0EnSB7z5TuUBwxMyLJzgXDdv
 XSOA==
X-Gm-Message-State: ACrzQf3JglC71qkGR+Dsvy1uQgqS/j2dYk9cJ2jaGToHbUsPpp2Mn0ex
 RkIGxYY8M40/ASrOzNGwq1U=
X-Google-Smtp-Source: AMsMyM41ti3w9l5obZXPfKZs4+5gdwwc/SUQm2qB589ymzCwaOXb7CdLfsDCSYZIA46LtrdEA3i1+A==
X-Received: by 2002:a05:6402:2881:b0:458:5bab:6490 with SMTP id
 eg1-20020a056402288100b004585bab6490mr5933210edb.364.1664562112034; 
 Fri, 30 Sep 2022 11:21:52 -0700 (PDT)
Received: from lumine.fritz.box (85-127-52-93.dsl.dynamic.surfer.at.
 [85.127.52.93]) by smtp.gmail.com with ESMTPSA id
 d1-20020a170906304100b00788c622fa2csm608718ejd.135.2022.09.30.11.21.51
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Fri, 30 Sep 2022 11:21:51 -0700 (PDT)
Message-ID: <111ec39af53f41c937a995f494474c6ff7b1e44b.camel@HIDDEN>
Subject: Re: [PATCH v4 1/2] home-services: Add base.
From: liliana.prikler@HIDDEN
To: Taiju HIGASHI <higashi@HIDDEN>
Date: Fri, 30 Sep 2022 20:21:50 +0200
In-Reply-To: <87leq2md3b.fsf@HIDDEN>
References: <20220929143633.28844-1-higashi@HIDDEN>
 <5fae106ffa5f240d3b41d57a063afee1787ca506.camel@HIDDEN>
 <87leq2md3b.fsf@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
User-Agent: Evolution 3.46.0 
MIME-Version: 1.0
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, 57963 <at> debbugs.gnu.org, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Am Freitag, dem 30.09.2022 um 00:09 +0900 schrieb Taiju HIGASHI:
> Liliana Marie Prikler <liliana.prikler@HIDDEN> writes:
>=20
> > Am Donnerstag, dem 29.09.2022 um 23:36 +0900 schrieb Taiju HIGASHI:
> > > * gnu/home.scm: Move home-fontconfig-service-type from
> > > home-environment-default-essential-services to %home-base-
> > > services.
> > Unless there is a precedent in system, I would make all the
> > currently
> > "essential" services %home-base-services perhaps move their code
> > accordingly.
>=20
> I thought it was only for home-fontconfig-service.=C2=A0 Does that mean
> delete "essential" services and move everything to %home-base-
> services?
I'd double-check with Andrew, but my personal opinion is "yes".

> > > * gnu/home/services/base.scm: Add base.
> > Should be "New file."=C2=A0 Also should probably be the first item in
> > the
> > ChangeLog, so that other items can mention it.
>=20
> I understood that "Add base" should be "New file", but I didn't
> understand the second part.=C2=A0 I apologize for my lack of
> understanding.
It means put the * gnu/home/services/base.scm entry before the *
gnu/home.scm one, so that you can mention the former in the latter.

Cheers




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 30 Sep 2022 00:12:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 29 20:12:43 2022
Received: from localhost ([127.0.0.1]:39929 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oe3dz-0005CJ-IB
	for submit <at> debbugs.gnu.org; Thu, 29 Sep 2022 20:12:43 -0400
Received: from mail-pl1-f181.google.com ([209.85.214.181]:46675)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1oe3dt-0005Bz-67
 for 57963 <at> debbugs.gnu.org; Thu, 29 Sep 2022 20:12:42 -0400
Received: by mail-pl1-f181.google.com with SMTP id jo24so2029586plb.13
 for <57963 <at> debbugs.gnu.org>; Thu, 29 Sep 2022 17:12:37 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:from:to:cc:subject:date;
 bh=NkaYdEeXl3NsRlvdcAlzmRW/V2qCefrYuzQIo4eR0wc=;
 b=W4rXm2/bsH2s6qSy0xEQYfoIvj/3P2Jtqdc9eeRricB4fY3pxv2xo8V7t4nN6ZkupN
 w2PWm+Ix1zjxHhDJGFJTKWled+4QKu5l0sjyIFHeLR8X/6q5w4q0r/LGVk75quXEu012
 7jUdXUE8a4AbIQSYLJK6B40thHTfcwwC0A3TGKyhS+Py3+lssADUlnSgSbQREAA9ldxu
 vYnrsbb1ta+vSNLtl2ozjH/rtoJ+KTVhItMhOjsOYTFSnd/HAvzyMcC7SLDXcFcbA86r
 aM7LT8HK7E5VhjplIm+dCH7hrBfxaS7zBIdrhFCuxWobI3/EAD4RdAtQRxPI4lxihfQs
 HUrw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:x-gm-message-state:from:to:cc:subject:date;
 bh=NkaYdEeXl3NsRlvdcAlzmRW/V2qCefrYuzQIo4eR0wc=;
 b=B74Qnzk1A/qk4WRTGEPLlsuQDx+HCmPi+ZpUe5r17BjkqTgue+pMOLKNf1cNzOaoOF
 FKM/LV++keNtFxKaKygeP0nHKaP3/KEMgNi/bBHNQYberZKsfOU6lpQTH+laavAGH29t
 tHlBxQBh8kMXbMC7yBWDd1SJy/wUbFKq+yKnLXQsd4Ag/vjsa1u8EyTGwnu8CV6fSino
 h8p5H9GmaLe2CZEOgGqdUBQsAZliUGkQme2E2ab7FAEcI8t9O83KYvn/n+/Cab1o+zJK
 kIt9b+fNpw22zZj25OZTY7lQnLteiQjS/mJauSXRgRwZJPskI3PVFCvG1DrD3HRgv4JM
 XwFA==
X-Gm-Message-State: ACrzQf2yo9qy+9QDSuyETYkLsVO4ZBqN52kzOvZMIZK5mWQeIRMCvAtr
 4BlTE/M/pbJFYAj0rPN6rT5Aiw==
X-Google-Smtp-Source: AMsMyM5J6I6ZKajVyu/zUTkl2kXL5oRDLNEjMqVOjkjrYmqbD+ZLlMpH0BpHIX6GrpiBZpwE44+CSw==
X-Received: by 2002:a17:90a:5a0b:b0:200:6358:83e4 with SMTP id
 b11-20020a17090a5a0b00b00200635883e4mr6625315pjd.151.1664496751250; 
 Thu, 29 Sep 2022 17:12:31 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 y26-20020aa79e1a000000b00537d60286c9sm272424pfq.113.2022.09.29.17.12.28
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 29 Sep 2022 17:12:30 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: "(" <paren@HIDDEN>
Subject: Re: [bug#57963] [PATCH 0/1] Support user's fontconfig.
References: <20220927095525.26431-1-higashi@HIDDEN>
 <87bkr1qg9x.fsf@HIDDEN> <87v8p7dwvc.fsf_-_@HIDDEN>
 <87y1u3ngds.fsf@HIDDEN> <87h70qb6gq.fsf@HIDDEN>
 <875yh6nshm.fsf@HIDDEN> <CN90FPMQ3C2P.2HK4GB7JG6GAI@guix-aspire>
Date: Fri, 30 Sep 2022 09:12:26 +0900
In-Reply-To: <CN90FPMQ3C2P.2HK4GB7JG6GAI@guix-aspire> (paren@HIDDEN's
 message of "Thu, 29 Sep 2022 17:02:41 +0100")
Message-ID: <878rm1n2j9.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-2022-jp
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: Ludovic =?iso-8859-1?Q?Court=E8s?= <ludo@HIDDEN>, 57963 <at> debbugs.gnu.org,
 liliana.prikler@HIDDEN, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi (,

"(" <paren@HIDDEN> writes:

> Hey Taiju and Liliana,
>
> On Thu Sep 29, 2022 at 3:51 PM BST, Taiju HIGASHI wrote:
>> > Sure; I’m not a native speaker either but I can help.
>>
>> I know it will take some time, but I'll try my best.
>
> If you wish I'll help you with the manual. (I'm a native
> British English speaker.)
>
>     -- (

Thank you, it helps!
However, the interface may still change, so it will be a little while
before I write documentation.

Best Regards,
-- 
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 29 Sep 2022 16:04:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 29 12:04:20 2022
Received: from localhost ([127.0.0.1]:39357 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1odw1M-0001Bd-F4
	for submit <at> debbugs.gnu.org; Thu, 29 Sep 2022 12:04:20 -0400
Received: from knopi.disroot.org ([178.21.23.139]:53072)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <paren@HIDDEN>) id 1odw1L-0001BR-1r
 for 57963 <at> debbugs.gnu.org; Thu, 29 Sep 2022 12:04:19 -0400
Received: from localhost (localhost [127.0.0.1])
 by disroot.org (Postfix) with ESMTP id 5EC754C481;
 Thu, 29 Sep 2022 18:04:17 +0200 (CEST)
X-Virus-Scanned: SPAM Filter at disroot.org
Received: from knopi.disroot.org ([127.0.0.1])
 by localhost (disroot.org [127.0.0.1]) (amavisd-new, port 10024)
 with UTF8SMTP id h9qTjd2_FAEO; Thu, 29 Sep 2022 18:04:16 +0200 (CEST)
Mime-Version: 1.0
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=disroot.org; s=mail;
 t=1664467363; bh=mEEot8Rg9MzIcUXVjeq5CcMouMpimXK9lluadzEQcPI=;
 h=Date:Cc:Subject:From:To:References:In-Reply-To;
 b=k0P7A9pftI3j1tjll4ZEmiNUJNg8xBe9LhXCdrueqlTA5XX7lbn/rKJl7BBXiYu24
 PDFgKDrWo/Jc0dXX92AUu+qq+/CF/QMQazw1bT4qXDpR0p3caGzJgSqhfB/K48lM0z
 fC/UIdtM+g4UXfyZI+FkvU3Lux+sDLR1wyo/3fEjUG2NorpRXVGOulBY8INuFVzvZ0
 ywOLr213JLnjxx0GJ2YEkcZJOqnvKCz/eVIlb7TgCglxdf50FD1so+TMPxfv6y52l4
 WPIKR00qNXkaGNnL1uH9gT8B+22LwohGB1rDLvH48/iqhTYyEpE+ZzV6Plw7JWbTYu
 Mcs/NgBraKYJA==
Content-Transfer-Encoding: quoted-printable
Content-Type: text/plain; charset=UTF-8
Date: Thu, 29 Sep 2022 17:02:41 +0100
Message-Id: <CN90FPMQ3C2P.2HK4GB7JG6GAI@guix-aspire>
Subject: Re: [bug#57963] [PATCH 0/1] Support user's fontconfig.
From: "(" <paren@HIDDEN>
To: "Taiju HIGASHI" <higashi@HIDDEN>, =?utf-8?q?Ludovic_Court=C3=A8s?=
 <ludo@HIDDEN>
References: <20220927095525.26431-1-higashi@HIDDEN>
 <87bkr1qg9x.fsf@HIDDEN> <87v8p7dwvc.fsf_-_@HIDDEN>
 <87y1u3ngds.fsf@HIDDEN> <87h70qb6gq.fsf@HIDDEN>
 <875yh6nshm.fsf@HIDDEN>
In-Reply-To: <875yh6nshm.fsf@HIDDEN>
X-Spam-Score: 1.3 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Hey Taiju and Liliana, On Thu Sep 29, 2022 at 3:51 PM BST,
    Taiju HIGASHI wrote: > > Sure; Im not a native speaker either but I can
    help. > > I know it will take some time, but I'll try my best. If you wish
    I'll help you with the manual. (I'm a native British English speaker.) 
 
 Content analysis details:   (1.3 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  1.3 FROM_ONE_CHAR          Bogus FROM name
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.3 (/)

Hey Taiju and Liliana,

On Thu Sep 29, 2022 at 3:51 PM BST, Taiju HIGASHI wrote:
> > Sure; I=E2=80=99m not a native speaker either but I can help.
>
> I know it will take some time, but I'll try my best.

If you wish I'll help you with the manual. (I'm a native
British English speaker.)

    -- (




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 29 Sep 2022 15:10:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 29 11:10:08 2022
Received: from localhost ([127.0.0.1]:39293 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1odvAt-0008Df-G7
	for submit <at> debbugs.gnu.org; Thu, 29 Sep 2022 11:10:08 -0400
Received: from mail-pj1-f53.google.com ([209.85.216.53]:52027)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1odvAf-0008Ct-Su
 for 57963 <at> debbugs.gnu.org; Thu, 29 Sep 2022 11:10:06 -0400
Received: by mail-pj1-f53.google.com with SMTP id u12so1619534pjj.1
 for <57963 <at> debbugs.gnu.org>; Thu, 29 Sep 2022 08:09:53 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:from:to:cc:subject:date;
 bh=RILArkFKqjs8UJLc7+O6y2qPA4rTuXVtqGOcdN4x1ho=;
 b=Kl0k8S/POgNJOOrYaeNHbdtI+4x0cfGqIJaodPV1/BP2E8H38+8YwscqhKhy2LoAww
 iy3s/sreBNfTcRmQDwsKlNVF+F5i2Ae6mSCBaRkShZYbUJkDjVbqmKMp3pf4aAlgVQzu
 V2uZyjOFdGqPfevB7zbsexj/1embslAuJrpk7h9MdYG6TkogfyUxFmspblZMiJ9yiSIn
 n8PW8qaVao2wwwI3AfyOahG9ynw90R7yakzuONgB5bgacvWLvpfVHOy4oEnN/obDV3IL
 SPxR6DW7i82+y/gkzbztPO/sU0rpTbvCVgJ/xy9cp/fy11227vzWbuyRbsDoZULsri4G
 xTWg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:x-gm-message-state:from:to:cc:subject:date;
 bh=RILArkFKqjs8UJLc7+O6y2qPA4rTuXVtqGOcdN4x1ho=;
 b=GyvpE2lZ1KZ2w2/aS/52aIqyZDSSdHaqKcp18+yPbJcotR1g8Bp7qoD4wqszWdkT29
 ++z6vP2sUHHU3Xow+PR44Lg+TSY7iYP2i2fXlA2+nLlwyoLb4pE1DIC16mudp/vC1pOV
 8LTrGe+6sN3wDzmTwP7bKQs3VqotN4E2S5cVZN1SwaSnmEhelXBvCH0ZynRy4/i3YlEW
 l3dLzLd03qnED8YJztQVg+IBf9N+0UUHUqQo+KlQvfQrZgkk0LOIBF6iJXvmQ5CZF+8u
 APkvNmOkwfsIo6vg3wS65uDBDgJjJDLfqS+Va6W3i/sy2We38gBBQATemBXGwvmLT5Za
 chIw==
X-Gm-Message-State: ACrzQf32esy9P9pUhsu/NEEVGdFmNybnkI72qNq7NL/WjkdoiHpH5VNj
 4uo6TmZetpRyB4nZWr6qimmJ1g==
X-Google-Smtp-Source: AMsMyM7hBLMC8Y4TRV8pnCkL0dcChf+otCeSgRmjN0YzZSjd9bnT5/VKAzxb6S274sMFh8kIfilDcQ==
X-Received: by 2002:a17:903:11cc:b0:178:aec1:18c3 with SMTP id
 q12-20020a17090311cc00b00178aec118c3mr3944813plh.91.1664464188000; 
 Thu, 29 Sep 2022 08:09:48 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 b14-20020aa7950e000000b00545b91e78d3sm6227315pfp.89.2022.09.29.08.09.46
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 29 Sep 2022 08:09:47 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Liliana Marie Prikler <liliana.prikler@HIDDEN>
Subject: Re: [PATCH v4 1/2] home-services: Add base.
References: <20220929143633.28844-1-higashi@HIDDEN>
 <5fae106ffa5f240d3b41d57a063afee1787ca506.camel@HIDDEN>
Date: Fri, 30 Sep 2022 00:09:44 +0900
In-Reply-To: <5fae106ffa5f240d3b41d57a063afee1787ca506.camel@HIDDEN>
 (Liliana Marie Prikler's message of "Thu, 29 Sep 2022 16:43:08 +0200")
Message-ID: <87leq2md3b.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, 57963 <at> debbugs.gnu.org, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Liliana Marie Prikler <liliana.prikler@HIDDEN> writes:

> Am Donnerstag, dem 29.09.2022 um 23:36 +0900 schrieb Taiju HIGASHI:
>> * gnu/home.scm: Move home-fontconfig-service-type from
>> home-environment-default-essential-services to %home-base-services.
> Unless there is a precedent in system, I would make all the currently
> "essential" services %home-base-services perhaps move their code
> accordingly.

I thought it was only for home-fontconfig-service.  Does that mean
delete "essential" services and move everything to %home-base-services?

>> * gnu/home/services/base.scm: Add base.
> Should be "New file."  Also should probably be the first item in the
> ChangeLog, so that other items can mention it.

I understood that "Add base" should be "New file", but I didn't
understand the second part.  I apologize for my lack of understanding.

Cheers,
-- 
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 29 Sep 2022 14:55:30 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 29 10:55:30 2022
Received: from localhost ([127.0.0.1]:39253 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oduwj-0007mo-Qe
	for submit <at> debbugs.gnu.org; Thu, 29 Sep 2022 10:55:30 -0400
Received: from mail-pg1-f172.google.com ([209.85.215.172]:37855)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1oduwf-0007mT-RI
 for 57963 <at> debbugs.gnu.org; Thu, 29 Sep 2022 10:55:29 -0400
Received: by mail-pg1-f172.google.com with SMTP id bh13so1674771pgb.4
 for <57963 <at> debbugs.gnu.org>; Thu, 29 Sep 2022 07:55:25 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:from:to:cc:subject
 :date; bh=et/svd1EUd6T/YAczapjYPudZ5nYFHVn2Ghlsn2aZvU=;
 b=wXjMCAb7CYZTP2e+x+5WOQV+ynDS8VyZKo3fEbSzpPYbecef2+/V2lA91+1XIjFRje
 9zttItZ8NbsCaatzvIFg3uXpucqMcuHJ3+VHaeGtG8yPJIhsUcpXnr6/JtPv9G+VUWhm
 1Yg8kpRudeC0wSbRFYNdnJfbU7lzxhVniS+CnM9GiaCjoLW6HiSoZix4uN2Ve8iSfiSr
 R5RJaJ5ywmGl3qALuZsToZLpwsGcctc97PL9anbFoUhvFzjptO5uvkjdPuoyzTGMWyn+
 qykXbx8hJi3geGzikoC0ZqpLht6YuOlpCq69fpjhjbUqLOLxIeYeXrQnOj833DXzLYw8
 VJoQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:x-gm-message-state
 :from:to:cc:subject:date;
 bh=et/svd1EUd6T/YAczapjYPudZ5nYFHVn2Ghlsn2aZvU=;
 b=Mh0URMfX9jp4DcMcxxe+53kgcQH0NR6wJhL2avqBtu6/9MY2mT/tl1stacQh3030sV
 dVHToB2zMvU/fMHEPwFFZVDTvjXSRTkSzpYhHaoFn9EIcml3l1CyTFjyuFK0oeQuVvzn
 Pk6pberSngpHYCl5NtfvF8jI7IDixq7uvQ19C1TMlzmJqW465LwnTgHQ4avqYj67HzEa
 Iq9j1qmhLAoL05zOXUiQyP3kLIbXc3nxpubhbHcosMgbYQ35ajCwvJ6+QJOSdjVfCFLe
 u1V3Ad8NgI3Sy5yzpPIaWR2twouXofnoPBrTqfcSdJdh+V/I8CA9veFH9meePbxnpKWA
 /gKQ==
X-Gm-Message-State: ACrzQf3bUbomhvR4vh6hLQGltZ48mzaTiyd7N/Yl62eJUforvJ6tUBQB
 JMt/LjkyXOk1OTDRa1PJ9oj7Xg==
X-Google-Smtp-Source: AMsMyM5PS35gPPo9Q+6tsEILH2kmhgSAyE5qtq1OmqxLlCQdVHADB4hKtDQh+5mJybLk89lXxF/9Hg==
X-Received: by 2002:a05:6a00:1c98:b0:540:d461:f9d8 with SMTP id
 y24-20020a056a001c9800b00540d461f9d8mr4028322pfw.29.1664463319966; 
 Thu, 29 Sep 2022 07:55:19 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 h8-20020a170902680800b0017a018221e2sm3881078plk.70.2022.09.29.07.55.18
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 29 Sep 2022 07:55:19 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: 57963 <at> debbugs.gnu.org
Subject: Re: [PATCH v4 2/2] home: fontutils: Support user's fontconfig.
References: <20220929143633.28844-1-higashi@HIDDEN>
 <20220929143633.28844-2-higashi@HIDDEN>
Date: Thu, 29 Sep 2022 23:55:16 +0900
In-Reply-To: <20220929143633.28844-2-higashi@HIDDEN> (Taiju HIGASHI's
 message of "Thu, 29 Sep 2022 23:36:33 +0900")
Message-ID: <87y1u2mdrf.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: The new way to extend the service is as follows. --8<cut
 herestart>8---
 (home-environment (packages (list font-google-noto)) (services (append (list
 (service home-bash-service-type)) (modify-services %home- [...] 
 Content analysis details:   (2.0 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 SPF_NONE               SPF: sender does not publish an SPF Record
 2.0 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: yoctocell.xyz (xyz)]
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
 [209.85.215.172 listed in wl.mailspike.net]
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [209.85.215.172 listed in list.dnswl.org]
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, liliana.prikler@HIDDEN, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

The new way to extend the service is as follows.

--8<---------------cut here---------------start------------->8---
(home-environment
 (packages (list font-google-noto))
 (services
  (append
      (list
       (service home-bash-service-type))
      (modify-services %home-base-services
        (home-fontconfig-service-type
         config =3D> (home-fontconfig-configuration
                    (font-directories
                     (list "~/fonts"))
                    (preferred-default-font
                     (default-font
                       (serif "Noto Serif CJK JP")
                       (sans-serif "Noto Sans CJK JP")))
                    (extra-config
                     `((match (@ (target font))
                         (edit (@ (mode assign)
                                  (name antialias))
                               (bool true)))))))))))
--8<---------------cut here---------------end--------------->8---


Taiju HIGASHI <higashi@HIDDEN> writes:

> * gnu/home/services/fontutils.scm: Support user's fontconfig.
> ---
>  gnu/home/services/fontutils.scm | 86 ++++++++++++++++++++++++++++++---
>  1 file changed, 80 insertions(+), 6 deletions(-)
>
> diff --git a/gnu/home/services/fontutils.scm b/gnu/home/services/fontutil=
s.scm
> index 6062eaed6a..32127740f6 100644
> --- a/gnu/home/services/fontutils.scm
> +++ b/gnu/home/services/fontutils.scm
> @@ -1,6 +1,7 @@
>  ;;; GNU Guix --- Functional package management for GNU
>  ;;; Copyright =A9 2021 Andrew Tropin <andrew@HIDDEN>
>  ;;; Copyright =A9 2021 Xinglu Chen <public@HIDDEN>
> +;;; Copyright =A9 2022 Taiju HIGASHI <higashi@HIDDEN>
>  ;;;
>  ;;; This file is part of GNU Guix.
>  ;;;
> @@ -20,9 +21,16 @@
>  (define-module (gnu home services fontutils)
>    #:use-module (gnu home services)
>    #:use-module (gnu packages fontutils)
> +  #:use-module (gnu services configuration)
>    #:use-module (guix gexp)
> +  #:use-module (guix records)
> +  #:use-module (srfi srfi-1)
> +  #:use-module (sxml simple)
> +  #:use-module (ice-9 match)
>
> -  #:export (home-fontconfig-service-type))
> +  #:export (home-fontconfig-service-type
> +            home-fontconfig-configuration
> +            default-font))
>
>  ;;; Commentary:
>  ;;;
> @@ -33,15 +41,81 @@ (define-module (gnu home services fontutils)
>  ;;;
>  ;;; Code:
>
> -(define (add-fontconfig-config-file he-symlink-path)
> +(define (default-font-sanitizer type)
> +  (lambda (value)
> +    (if (null? value)
> +        value
> +        `(alias
> +          (family ,type)
> +          (prefer
> +           (family ,value))))))
> +
> +(define-record-type* <default-font> default-font
> +  make-default-font
> +  default-font?
> +  (serif default-font-serif
> +         (default '())
> +         (sanitize (default-font-sanitizer 'serif)))
> +  (sans-serif defalut-font-sans-serif
> +              (default '())
> +              (sanitize (default-font-sanitizer 'sans-serif)))
> +  (monospace default-font-monospace
> +             (default '())
> +             (sanitize (default-font-sanitizer 'monospace))))
> +
> +(define (sxml->xmlstring sxml)
> +  (if (null? sxml)
> +      ""
> +      (call-with-output-string
> +        (lambda (port)
> +          (sxml->xml sxml port)))))
> +
> +(define font-directories? list?)
> +
> +(define (serialize-font-directories field-name value)
> +  (sxml->xmlstring
> +   (append
> +       '((dir "~/.guix-home/profile/share/fonts"))
> +       (map
> +        (lambda (path)
> +          `(dir ,path))
> +        value))))
> +
> +(define extra-config-list? list?)
> +
> +(define (serialize-extra-config-list field-name value)
> +  (sxml->xmlstring
> +   (map (match-lambda
> +          ((? pair? sxml) sxml)
> +          ((? string? xml) (xml->sxml xml))
> +          (_ (error "extra-config value must be xml string or sxml list.=
")))
> +        value)))
> +
> +(define (serialize-default-font field-name value)
> +  (match value
> +    (($ <default-font> serif sans-serif monospace)
> +     (sxml->xmlstring (list serif sans-serif monospace)))))
> +
> +(define-configuration home-fontconfig-configuration
> +  (font-directories
> +   (font-directories '())
> +   "The directory list that provides fonts.")
> +  (preferred-default-font
> +   (default-font (default-font))
> +   "The preffered default fonts for serif, sans-serif, and monospace.")
> +  (extra-config
> +   (extra-config-list '())
> +   "Extra configuration values to append to the fonts.conf."))
> +
> +(define (add-fontconfig-config-file user-config)
>    `(("fontconfig/fonts.conf"
>       ,(mixed-text-file
>         "fonts.conf"
>         "<?xml version=3D'1.0'?>
>  <!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
> -<fontconfig>
> -  <dir>~/.guix-home/profile/share/fonts</dir>
> -</fontconfig>"))))
> +<fontconfig>"
> +       (serialize-configuration user-config home-fontconfig-configuratio=
n-fields)
> +       "</fontconfig>\n"))))
>
>  (define (regenerate-font-cache-gexp _)
>    `(("profile/share/fonts"
> @@ -59,7 +133,7 @@ (define home-fontconfig-service-type
>                         (service-extension
>                          home-profile-service-type
>                          (const (list fontconfig)))))
> -                (default-value #f)
> +                (default-value (home-fontconfig-configuration))
>                  (description
>                   "Provides configuration file for fontconfig and make
>  fc-* utilities aware of font packages installed in Guix Home's profile."=
)))

Thanks,
--=20
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 29 Sep 2022 14:52:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 29 10:52:03 2022
Received: from localhost ([127.0.0.1]:39249 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1odutP-0007hk-7n
	for submit <at> debbugs.gnu.org; Thu, 29 Sep 2022 10:52:03 -0400
Received: from mail-pj1-f49.google.com ([209.85.216.49]:52786)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1odutK-0007hB-N1
 for 57963 <at> debbugs.gnu.org; Thu, 29 Sep 2022 10:52:01 -0400
Received: by mail-pj1-f49.google.com with SMTP id l12so1379020pjh.2
 for <57963 <at> debbugs.gnu.org>; Thu, 29 Sep 2022 07:51:58 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:from:to:cc:subject
 :date; bh=toWhj87UA1OuCv74BTanYOmr/EUUXGrdzjNRieJ/G6o=;
 b=DAgNRODXD6Qxyzd5454SUMiBaf8gBqrlwCt8WP876s2I3UlNECufhmVN7buIrrXRih
 V49Of1eWIwd7DdCU6T7bTVVvmHYJ2SZryFMpe3Hr5aCXphq1NDfoJG71n4hStPdqIRAM
 SSCF6h8RsmQjhdmEl8CBO5vA4WzwCd32TWYwgwJuaAiBehvH5Lp2xOhdxoy32LpcbSPY
 xD/anVKtLCHFypkK3q2gH9A6aKd29E36JGrj3hJdaTEWYwLzRrx6aUPUna+TNPX6/hsJ
 xxrI8Y5VoMKPCemSMVl1YJs6RRQCtSkOXEsr8CzKWq89ZKYlzCkNdfekuJuaKRiffWS8
 ZO+A==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:x-gm-message-state
 :from:to:cc:subject:date;
 bh=toWhj87UA1OuCv74BTanYOmr/EUUXGrdzjNRieJ/G6o=;
 b=tRya0cBbYz5p6BsCjtfbbCXg8MUWb+hkjODCGlVXGPTg6XGw88lKc26WaqJz5CPK6p
 5hM93KfOfZIg3pV/yiRaSd5V0CfDElPH85ZADdVjxvyVk0taabrEpkosnXh9JNPcOgWx
 udX57RSR+2sq4tL7pbWQLXe37Jy0TMBZkIlAGwenTqqzIe/95mU0RIXRE1Y7VIIWujEL
 3WuW3apKBVjy12LtEJYM6hm3ufmrtbOnjRVwcCXiR8goN4OrZU7jLavYlsNQDfFKR6Qq
 w8pMrzRyivVU6zCq8daGeT4TQPumkFGP7mclnFAP0ve3YajwpNKlQRdJptB5okPipL4M
 Wreg==
X-Gm-Message-State: ACrzQf1TFyfm4cnKOcXjqRFO732+M4SLM5jJ+3AjShG9T5ogy5cckz1R
 mEoRgRzCkWrFSpDoKu9aYW4aZg==
X-Google-Smtp-Source: AMsMyM5YHdgdJjJRauJ5TbQimGefXWjZH4ABnDn9sNNkGvH1gkfQZqTw8JR1wWskGSCXomYaQKrwaw==
X-Received: by 2002:a17:903:247:b0:179:b5e1:54b7 with SMTP id
 j7-20020a170903024700b00179b5e154b7mr3802910plh.84.1664463112768; 
 Thu, 29 Sep 2022 07:51:52 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 b6-20020a170902d50600b00172bf229dfdsm5997893plg.97.2022.09.29.07.51.51
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 29 Sep 2022 07:51:52 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Ludovic =?iso-8859-1?Q?Court=E8s?= <ludo@HIDDEN>
Subject: Re: bug#57963: [PATCH 0/1] Support user's fontconfig.
References: <20220927095525.26431-1-higashi@HIDDEN>
 <87bkr1qg9x.fsf@HIDDEN> <87v8p7dwvc.fsf_-_@HIDDEN>
 <87y1u3ngds.fsf@HIDDEN> <87h70qb6gq.fsf@HIDDEN>
Date: Thu, 29 Sep 2022 23:51:49 +0900
In-Reply-To: <87h70qb6gq.fsf@HIDDEN> ("Ludovic =?iso-8859-1?Q?Court=E8s?=
 =?iso-8859-1?Q?=22's?= message of "Thu, 29
 Sep 2022 16:28:21 +0200")
Message-ID: <875yh6nshm.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Ludovic,

I've sent you the v4 patch.

Ludovic Court=C3=A8s <ludo@HIDDEN> writes:

> Hi,
>
> Taiju HIGASHI <higashi@HIDDEN> skribis:
>
>> I found out what essential services should be.
>> I'm going to move it from essential services to base-home-services.
>
> Alright, let=E2=80=99s do that (in a separate commit).

I've tried it. In particular, I'm wondering if I defined
%home-base-services in the right place.

>>> Once we=E2=80=99ve settled on an interface, the commit that makes this =
change
>>> should include an update of doc/guix.texi.
>>
>> Yes. I can write the draft, but I may have to ask you to finish it becau=
se
>> I'm not good at writing English.
>> It would be a waste of time for you to spend a long time correcting my
>> poor grammar and expressions.
>
> Sure; I=E2=80=99m not a native speaker either but I can help.

I know it will take some time, but I'll try my best.  By the way, if I
edit the texi file, am I correct in confirming that I read the built
Info?


Thanks,
--=20
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 29 Sep 2022 14:46:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 29 10:46:25 2022
Received: from localhost ([127.0.0.1]:39240 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1odunx-0007Vq-7r
	for submit <at> debbugs.gnu.org; Thu, 29 Sep 2022 10:46:25 -0400
Received: from mail-pj1-f44.google.com ([209.85.216.44]:53790)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1odunu-0007VZ-Ir
 for 57963 <at> debbugs.gnu.org; Thu, 29 Sep 2022 10:46:23 -0400
Received: by mail-pj1-f44.google.com with SMTP id u92so1536367pjh.3
 for <57963 <at> debbugs.gnu.org>; Thu, 29 Sep 2022 07:46:22 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:from:to:cc:subject
 :date; bh=94yKpkcUr1ep30tquixzoB+rmCxeqntFBRnZQ7tyIW0=;
 b=yqlDqHvEI/otIFoxWV7UbnMf1Nc5d0b1iHpNTfX4wx6KIOuo6rfMj1VOnzS7mEG8jA
 Ewqesx+DMWhT696afwoW5mS2u1sF1DdIVn12E6ryf+LaNuPWzCU1JFiQArs1Pmz+1M0n
 YLQ6OrhifbfJg8+2dHdkuGpazgoQrwBtnF8bjQ6X5HEDLb1cRhhIk/wRl8+kuw21oFEZ
 Sy8t1Lf2Gm1an0RFsdOKKMiMPtH6w4LLH0V9upnf63/X6rtB2k3fwcR9umrHxXTd6e0u
 V83XHW8bX0iq6v5Vz5GmYPvcaPB9nvqs/p7bStbT2NtCFtUSest7i/4TfI9KbnyMFSHl
 OCWQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:x-gm-message-state
 :from:to:cc:subject:date;
 bh=94yKpkcUr1ep30tquixzoB+rmCxeqntFBRnZQ7tyIW0=;
 b=zbf+eEKpOmsO8sdElg84plRDh6mLzquWSVTJs28WfqdbdqxIrztON6hiRGvzvTaZKs
 TFkV8OKGXrcDWCtsgC+Pa5p0fPHg5Pca0TImRlcFe+Ev5hA3dufb00GtfbMP87TywlIm
 tKJQ7/qmaooxKk1I11YFR67ziUKK1Q/ld9LhCyAeHr0iSUiBGlUnB4EE5aWYAVvChXHX
 /zCWSyQhiYMLI7PaRzZFmMv5ZkVsyN0g/ySODBmB7n2diuA8BDKGBDcS979OY/WzLAhy
 f/jfrBFjJczWGscy6R3nlx/jmuE22NIgK9FNFcsyw/a3KjnjbXSUBbjjj1Dvsjk1QP9s
 D3tg==
X-Gm-Message-State: ACrzQf11bH2TDF3WNnMwCJ9iE1ugWbz5O2DuwEd0FKpAZmLIwQuUJj1c
 JjBgI4tlhAKeLCVF3dtIYVroTVC7G2FwPn8k
X-Google-Smtp-Source: AMsMyM7XI+keEurNMoCryD26Wd7rJQ5q4qRu9C7F3BJzasLfJTQUl2L4aTzQ65RaFQLb7RSTZlp1mA==
X-Received: by 2002:a17:902:eb82:b0:178:2166:fe75 with SMTP id
 q2-20020a170902eb8200b001782166fe75mr3767503plg.31.1664462776587; 
 Thu, 29 Sep 2022 07:46:16 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 t8-20020a170902e84800b001766a3b2a26sm6067532plg.105.2022.09.29.07.46.15
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 29 Sep 2022 07:46:16 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Liliana Marie Prikler <liliana.prikler@HIDDEN>
Subject: Re: [PATCH v3] home: fontutils: Support user's fontconfig.
References: <20220927095525.26431-1-higashi@HIDDEN>
 <2add7a8c83272c5bcb9aac38e63161a48f321cda.camel@HIDDEN>
 <87tu4rowc2.fsf@HIDDEN>
Date: Thu, 29 Sep 2022 23:46:13 +0900
In-Reply-To: <87tu4rowc2.fsf@HIDDEN> (Taiju HIGASHI's message of "Thu, 29
 Sep 2022 09:31:09 +0900")
Message-ID: <87fsgansqy.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, 57963 <at> debbugs.gnu.org, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Liliana,

I've sent you the v4 patch.

Taiju HIGASHI <higashi@HIDDEN> writes:

> Liliana Marie Prikler <liliana.prikler@HIDDEN> writes:
>
>>> -(define (add-fontconfig-config-file he-symlink-path)
>>> +(define-record-type* <default-font> default-font
>>> +=A0 make-default-font
>>> +=A0 default-font?
>>> +=A0 (serif default-font-serif (default ""))
>>> +=A0 (sans-serif defalut-font-sans-serif (default ""))
>>> +=A0 (monospace default-font-monospace (default "")))
>> Is the empty string a meaningful value in these places?
>
> Sure, It is not meaningful.  I would remove the default value.

I couldn't remove the default value because without a default value, for
example, it can't specify only serifs.
However, I've changed the serialization of the field so that it is now a
comfortable default value.

Cheers,
--=20
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 29 Sep 2022 14:43:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 29 10:43:21 2022
Received: from localhost ([127.0.0.1]:39236 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oduky-0007QN-OC
	for submit <at> debbugs.gnu.org; Thu, 29 Sep 2022 10:43:20 -0400
Received: from mail-ej1-f65.google.com ([209.85.218.65]:44550)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <liliana.prikler@HIDDEN>) id 1odukt-0007Pv-W0
 for 57963 <at> debbugs.gnu.org; Thu, 29 Sep 2022 10:43:19 -0400
Received: by mail-ej1-f65.google.com with SMTP id r18so3233345eja.11
 for <57963 <at> debbugs.gnu.org>; Thu, 29 Sep 2022 07:43:15 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:from:to:cc:subject
 :date; bh=S7ANm0O1llBwzHEUfEONHZHdtxyxtUaWDgjrOT3/O2E=;
 b=BlSJVNxPns/38JU1IHcoTZ6hS0cjAAbMqDm+AdK7D7IovRTGM8i6SzrSYrAI8Los72
 9vDoIpiV5UPpRCoDTwfMtan8tKncxUCsOOgS6C6Eyo2B7m0btK82OfGKBIHAjl4cosL8
 gRszDZVw9mea1TlOcpPnY0GKzUbSJsmWO5rFEQMS3ul49uRSzaFtpGQEpVVo3pIXNSpt
 hG9Qgfe+R64UDZkzhvE+MYuF7M3Q/oOiOw7cu/AgDIdxsbivBqme+zykFYBA2X6QlGYo
 gyglHHd2tEhEF0yQDSFi+1OO47X2NGsaYk/TrVmBsgxjfWaiqYauf2jcdkTLSCOoOkJL
 txdw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:x-gm-message-state
 :from:to:cc:subject:date;
 bh=S7ANm0O1llBwzHEUfEONHZHdtxyxtUaWDgjrOT3/O2E=;
 b=VY7n4UIti4mf2EtxpDqr+W56zl/9ogQ0ZwiSG93COMwdaxdgxq1euvALmIDZJa0djI
 voXiUv7KSJZhAI5nLpRhXv4SkfhiN1GPfJPyGgUwZABWuJrcz0FomLN/GwX4NU6MvrTl
 8E31Y8bFmRYijlFlQlh1qkrxDnDfrGYu4lnYtIF+SObO95Qv0QfqlovHRUKykNHZQxjg
 ZVkgC2SPWFpZbfiKblNBbjKePmuP20DL1swlzVSpHKmWRWPrrVF1MjwCnSDwXg1ncMl3
 2KBbdOBPsjrsy3peRYcPqs1xDN8MTai+eQ/fiVlt+6yjX90vSGG08X220X8HcMjlqPmp
 A2BA==
X-Gm-Message-State: ACrzQf0ozus7NWXwUt6J05bNFEWs0ehBIJ08KuKPiOtM//c6jtYfFKWD
 TEI/n0ElJSxGvCVG1YdjXq0=
X-Google-Smtp-Source: AMsMyM7vQllhEs9gr7vPWGIkl7mGNtE5Z1jVaz+IRMyjyBGIkBHUd3idSLYIBHXAfBdAVjjXq+EQtQ==
X-Received: by 2002:a17:906:8a53:b0:781:6ee9:db96 with SMTP id
 gx19-20020a1709068a5300b007816ee9db96mr2923082ejc.301.1664462590003; 
 Thu, 29 Sep 2022 07:43:10 -0700 (PDT)
Received: from lumine.fritz.box (85-127-52-93.dsl.dynamic.surfer.at.
 [85.127.52.93]) by smtp.gmail.com with ESMTPSA id
 v2-20020aa7d9c2000000b00457c321454asm5278423eds.37.2022.09.29.07.43.09
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 29 Sep 2022 07:43:09 -0700 (PDT)
Message-ID: <5fae106ffa5f240d3b41d57a063afee1787ca506.camel@HIDDEN>
Subject: Re: [PATCH v4 1/2] home-services: Add base.
From: Liliana Marie Prikler <liliana.prikler@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>, 57963 <at> debbugs.gnu.org
Date: Thu, 29 Sep 2022 16:43:08 +0200
In-Reply-To: <20220929143633.28844-1-higashi@HIDDEN>
References: <20220929143633.28844-1-higashi@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
User-Agent: Evolution 3.46.0 
MIME-Version: 1.0
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Am Donnerstag, dem 29.09.2022 um 23:36 +0900 schrieb Taiju HIGASHI:
> * gnu/home.scm: Move home-fontconfig-service-type from
> home-environment-default-essential-services to %home-base-services.
Unless there is a precedent in system, I would make all the currently
"essential" services %home-base-services perhaps move their code
accordingly.
> * gnu/home/services/base.scm: Add base.
Should be "New file."  Also should probably be the first item in the
ChangeLog, so that other items can mention it.

Cheers






Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 29 Sep 2022 14:36:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 29 10:36:57 2022
Received: from localhost ([127.0.0.1]:39223 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oduen-0007Fi-3T
	for submit <at> debbugs.gnu.org; Thu, 29 Sep 2022 10:36:57 -0400
Received: from mail-pl1-f176.google.com ([209.85.214.176]:40472)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1oduel-0007FV-Fb
 for 57963 <at> debbugs.gnu.org; Thu, 29 Sep 2022 10:36:56 -0400
Received: by mail-pl1-f176.google.com with SMTP id b21so1432705plz.7
 for <57963 <at> debbugs.gnu.org>; Thu, 29 Sep 2022 07:36:55 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:references:in-reply-to
 :message-id:date:subject:cc:to:from:from:to:cc:subject:date;
 bh=S13+hkdmE3qTTNNWXiPnC38faFIhIN66eXq0OnVY+dA=;
 b=k3b76hA4zVXUBojdFEvcgMeaql44c6diyzu4VA1KccLef9LuKyFPcVFGg55ajh3c8r
 z15QFDRyfifLbnBS1omUVjgDNGOj7SZ/0x7f3VgUYRKiF3G5cHeS8OTSKC+DC4+iAr/l
 2VwreusaDgLk9O/G9BAjpfGrIfK2pR3XkAz3SCPTo0lHZ6IM4eDmVF6PMXrWKAKxM0/w
 +g+V/6t4aO70OxJaNduV2shfmgm1ZRA/XjwMp68Gk/evPqIw0p3VzjYIlIU/NJ5I6tz5
 OxpDmCofyvxz2nuX9Hcj7AjT7Oa7jpWC2enziqzSJPM3F7BAitoD/iudl4TznenxN7Ym
 9pdg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:references:in-reply-to
 :message-id:date:subject:cc:to:from:x-gm-message-state:from:to:cc
 :subject:date;
 bh=S13+hkdmE3qTTNNWXiPnC38faFIhIN66eXq0OnVY+dA=;
 b=fomsDD6q8qbhyFd6nsqDy37I2xOb6C6Z8X5cFLMfsKHcSqG6l7tEiQjHTRlVOopW6J
 aFh4QY6Rk4e0helkTOfhdcc+C/2sAR3/RJj9W5FeAed8Mw5RNY1/9toI5CRFlDIALkyK
 qgXjrsh8AMgjlVCsXMTc18SXM/f3qDZZjBmUTP9uUjS7PmZjyJeoDCF+3Mhf41/PKqc1
 2avAWxd2pOnU5dCZBhP0pMD9Q3xaII5QAzHxB2MwfqqmVLxk48WGRq4zvD9MELTH0uP6
 amPP4Lsyk6McyoVhxwjZVz7J7qRbAugENt7pVykUyx6e+c/4UA6iw30Z87lu+pIyS4Oc
 jlTQ==
X-Gm-Message-State: ACrzQf076S4Cr3UfdMEXwI19aVpV68UEaP+F5D3dp6yVPoHVSYlcW5I2
 xQjW2ZGbsC1E7xHTFDyBXSuwduTERK4O3ywO
X-Google-Smtp-Source: AMsMyM5AgWvYdJN9Rx/Wd0v0X4spJ3xthKMyd27PxwmTl/UsBlv3OcAACB5VJFQqIAG+DDhC2kXE4Q==
X-Received: by 2002:a17:902:8c81:b0:178:a33f:8b8f with SMTP id
 t1-20020a1709028c8100b00178a33f8b8fmr3838073plo.50.1664462209619; 
 Thu, 29 Sep 2022 07:36:49 -0700 (PDT)
Received: from Taix.flets-west.jp ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 y63-20020a626442000000b0053b9e5d365bsm6265154pfb.216.2022.09.29.07.36.48
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 29 Sep 2022 07:36:49 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: 57963 <at> debbugs.gnu.org
Subject: [PATCH v4 2/2] home: fontutils: Support user's fontconfig.
Date: Thu, 29 Sep 2022 23:36:33 +0900
Message-Id: <20220929143633.28844-2-higashi@HIDDEN>
X-Mailer: git-send-email 2.37.3
In-Reply-To: <20220929143633.28844-1-higashi@HIDDEN>
References: <20220929143633.28844-1-higashi@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: * gnu/home/services/fontutils.scm: Support user's fontconfig.
 --- gnu/home/services/fontutils.scm | 86 ++++++++++++++++++++++++++++++---
 1 file changed, 80 insertions(+),
 6 deletions(-) diff --git a/gnu/home/services/fontutils.scm
 b/gnu/home/services/fontutils.scm index 6062eaed6a..32127740f6 100644 ---
 a/gnu/home/services/fontutils.scm +++ b/gnu/home/services/fontutils.scm @@
 -1,6 + [...] 
 Content analysis details:   (2.0 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 SPF_NONE               SPF: sender does not publish an SPF Record
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [209.85.214.176 listed in list.dnswl.org]
 2.0 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: yoctocell.xyz (xyz)]
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
 [209.85.214.176 listed in wl.mailspike.net]
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, Taiju HIGASHI <higashi@HIDDEN>, liliana.prikler@HIDDEN,
 andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

* gnu/home/services/fontutils.scm: Support user's fontconfig.
---
 gnu/home/services/fontutils.scm | 86 ++++++++++++++++++++++++++++++---
 1 file changed, 80 insertions(+), 6 deletions(-)

diff --git a/gnu/home/services/fontutils.scm b/gnu/home/services/fontutils.scm
index 6062eaed6a..32127740f6 100644
--- a/gnu/home/services/fontutils.scm
+++ b/gnu/home/services/fontutils.scm
@@ -1,6 +1,7 @@
 ;;; GNU Guix --- Functional package management for GNU
 ;;; Copyright  2021 Andrew Tropin <andrew@HIDDEN>
 ;;; Copyright  2021 Xinglu Chen <public@HIDDEN>
+;;; Copyright  2022 Taiju HIGASHI <higashi@HIDDEN>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -20,9 +21,16 @@
 (define-module (gnu home services fontutils)
   #:use-module (gnu home services)
   #:use-module (gnu packages fontutils)
+  #:use-module (gnu services configuration)
   #:use-module (guix gexp)
+  #:use-module (guix records)
+  #:use-module (srfi srfi-1)
+  #:use-module (sxml simple)
+  #:use-module (ice-9 match)
 
-  #:export (home-fontconfig-service-type))
+  #:export (home-fontconfig-service-type
+            home-fontconfig-configuration
+            default-font))
 
 ;;; Commentary:
 ;;;
@@ -33,15 +41,81 @@ (define-module (gnu home services fontutils)
 ;;;
 ;;; Code:
 
-(define (add-fontconfig-config-file he-symlink-path)
+(define (default-font-sanitizer type)
+  (lambda (value)
+    (if (null? value)
+        value
+        `(alias
+          (family ,type)
+          (prefer
+           (family ,value))))))
+
+(define-record-type* <default-font> default-font
+  make-default-font
+  default-font?
+  (serif default-font-serif
+         (default '())
+         (sanitize (default-font-sanitizer 'serif)))
+  (sans-serif defalut-font-sans-serif
+              (default '())
+              (sanitize (default-font-sanitizer 'sans-serif)))
+  (monospace default-font-monospace
+             (default '())
+             (sanitize (default-font-sanitizer 'monospace))))
+
+(define (sxml->xmlstring sxml)
+  (if (null? sxml)
+      ""
+      (call-with-output-string
+        (lambda (port)
+          (sxml->xml sxml port)))))
+
+(define font-directories? list?)
+
+(define (serialize-font-directories field-name value)
+  (sxml->xmlstring
+   (append
+       '((dir "~/.guix-home/profile/share/fonts"))
+       (map
+        (lambda (path)
+          `(dir ,path))
+        value))))
+
+(define extra-config-list? list?)
+
+(define (serialize-extra-config-list field-name value)
+  (sxml->xmlstring
+   (map (match-lambda
+          ((? pair? sxml) sxml)
+          ((? string? xml) (xml->sxml xml))
+          (_ (error "extra-config value must be xml string or sxml list.")))
+        value)))
+
+(define (serialize-default-font field-name value)
+  (match value
+    (($ <default-font> serif sans-serif monospace)
+     (sxml->xmlstring (list serif sans-serif monospace)))))
+
+(define-configuration home-fontconfig-configuration
+  (font-directories
+   (font-directories '())
+   "The directory list that provides fonts.")
+  (preferred-default-font
+   (default-font (default-font))
+   "The preffered default fonts for serif, sans-serif, and monospace.")
+  (extra-config
+   (extra-config-list '())
+   "Extra configuration values to append to the fonts.conf."))
+
+(define (add-fontconfig-config-file user-config)
   `(("fontconfig/fonts.conf"
      ,(mixed-text-file
        "fonts.conf"
        "<?xml version='1.0'?>
 <!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
-<fontconfig>
-  <dir>~/.guix-home/profile/share/fonts</dir>
-</fontconfig>"))))
+<fontconfig>"
+       (serialize-configuration user-config home-fontconfig-configuration-fields)
+       "</fontconfig>\n"))))
 
 (define (regenerate-font-cache-gexp _)
   `(("profile/share/fonts"
@@ -59,7 +133,7 @@ (define home-fontconfig-service-type
                        (service-extension
                         home-profile-service-type
                         (const (list fontconfig)))))
-                (default-value #f)
+                (default-value (home-fontconfig-configuration))
                 (description
                  "Provides configuration file for fontconfig and make
 fc-* utilities aware of font packages installed in Guix Home's profile.")))
-- 
2.37.3





Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 29 Sep 2022 14:36:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 29 10:36:50 2022
Received: from localhost ([127.0.0.1]:39220 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oduef-0007FO-MF
	for submit <at> debbugs.gnu.org; Thu, 29 Sep 2022 10:36:50 -0400
Received: from mail-pl1-f175.google.com ([209.85.214.175]:38763)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1odued-0007Ez-Em
 for 57963 <at> debbugs.gnu.org; Thu, 29 Sep 2022 10:36:49 -0400
Received: by mail-pl1-f175.google.com with SMTP id x1so1436063plv.5
 for <57963 <at> debbugs.gnu.org>; Thu, 29 Sep 2022 07:36:47 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:message-id:date:subject:cc
 :to:from:from:to:cc:subject:date;
 bh=XITzXonqwm/niBHUU86reo4a0pQs+lPKV0Fl71LUD84=;
 b=aFrfSpJV+leN1TldZ005w8iKn6tlIQINhQo3jSQ4mLU2g0adEXtR/QGH+5ZWfVTB3t
 Hn8NYPNVi7shu6IW/xDNhFJeg8ptRk5BMD7RRlST9dB/DCjFbZTO6XKFTk++mTDIGM+w
 ZULJbkkSb6Bm9qt2z/3Szj51+SaBOZqGrIqJ7isiDhFQx6FZ+jNnUHgCNX/+SCBdNGU8
 9UF0xXyETJc3V6RTXwv5nIG9MLoc3G4WZMkts1PyYN4nBAeSyVlNXmRYQhelJ1UVPbJ2
 +gzAALvGkmB7HevMiqYFs+TfSb9tXAeY2zdIkEazRBAnATvCFoEedH1gwn49ITWvzV29
 pCWg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:message-id:date:subject:cc
 :to:from:x-gm-message-state:from:to:cc:subject:date;
 bh=XITzXonqwm/niBHUU86reo4a0pQs+lPKV0Fl71LUD84=;
 b=ia/JYVsEn9XHj2Aab9/KofJEMUrKCP2lSH5QNUPrBpwb5usWSqreqsHv012lDNaAqQ
 KSst4uBBtrdNeKCWHJMh5LGYPd7h2W2eWQRhefVHbSdKtLIXdhdSAlRnqbce8nD7SAI8
 8tVtmqk+qviEXNZHd1v5GfMCRuLevvUlXrKe2e0bPoqSJxxt6JL7WNkVJdUohs5UDKSI
 J/JTtqnwWvZ9iGv0GYEyEw2GKU0LkOTvC16KxSa9HlW6sKJ2N1GwnkbCujRow/BicQLN
 uabJiwrwET12hDjF5Ngzz6Whrd3Wyw5bkhVVFAOZ7cuYAsi0UOC5jid8Iwy4o4rbyk72
 UUTQ==
X-Gm-Message-State: ACrzQf2BxwXQDZLA/Rg9v+zLdhbAiAovutXObr9d1u4VIqQfW96iOKUz
 JrsMsNTPR/F0xK37CqtR5tAhVuGON+rertD5
X-Google-Smtp-Source: AMsMyM78XKtiKz85Z65DLjDsGzvQzuxcSe1mnefZ6tLlp0mox14QuM3od7F8awN13FnpalS1egAygw==
X-Received: by 2002:a17:90a:d14d:b0:205:e77d:dc91 with SMTP id
 t13-20020a17090ad14d00b00205e77ddc91mr11924739pjw.20.1664462201384; 
 Thu, 29 Sep 2022 07:36:41 -0700 (PDT)
Received: from Taix.flets-west.jp ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 y63-20020a626442000000b0053b9e5d365bsm6265154pfb.216.2022.09.29.07.36.39
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 29 Sep 2022 07:36:40 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: 57963 <at> debbugs.gnu.org
Subject: [PATCH v4 1/2] home-services: Add base.
Date: Thu, 29 Sep 2022 23:36:32 +0900
Message-Id: <20220929143633.28844-1-higashi@HIDDEN>
X-Mailer: git-send-email 2.37.3
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, Taiju HIGASHI <higashi@HIDDEN>, liliana.prikler@HIDDEN,
 andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

* gnu/home.scm: Move home-fontconfig-service-type from
home-environment-default-essential-services to %home-base-services.
* gnu/home/services/base.scm: Add base.
---
 gnu/home.scm               |  5 ++---
 gnu/home/services/base.scm | 35 +++++++++++++++++++++++++++++++++++
 2 files changed, 37 insertions(+), 3 deletions(-)
 create mode 100644 gnu/home/services/base.scm

diff --git a/gnu/home.scm b/gnu/home.scm
index c95d1e0818..c79db87018 100644
--- a/gnu/home.scm
+++ b/gnu/home.scm
@@ -19,10 +19,10 @@
 
 (define-module (gnu home)
   #:use-module (gnu home services)
+  #:use-module (gnu home services base)
   #:use-module (gnu home services symlink-manager)
   #:use-module (gnu home services shells)
   #:use-module (gnu home services xdg)
-  #:use-module (gnu home services fontutils)
   #:use-module (gnu services)
   #:use-module (guix records)
   #:use-module (guix diagnostics)
@@ -66,7 +66,7 @@ (define-record-type* <home-environment> home-environment
                                 this-home-environment)))
 
   (services           home-environment-user-services
-                      (default '()))
+                      (default %home-base-services))
 
   (location           home-environment-location            ; <location>
                       (default (and=> (current-source-location)
@@ -82,7 +82,6 @@ (define (home-environment-default-essential-services he)
 
    (service home-symlink-manager-service-type)
 
-   (service home-fontconfig-service-type)
    (service home-xdg-base-directories-service-type)
    (service home-shell-profile-service-type)
 
diff --git a/gnu/home/services/base.scm b/gnu/home/services/base.scm
new file mode 100644
index 0000000000..fbf92ba213
--- /dev/null
+++ b/gnu/home/services/base.scm
@@ -0,0 +1,35 @@
+;;; GNU Guix --- Functional package management for GNU
+;;; Copyright  2022 Taiju HIGASHI <higashi@HIDDEN>
+;;;
+;;; This file is part of GNU Guix.
+;;;
+;;; GNU Guix is free software; you can redistribute it and/or modify it
+;;; under the terms of the GNU General Public License as published by
+;;; the Free Software Foundation; either version 3 of the License, or (at
+;;; your option) any later version.
+;;;
+;;; GNU Guix is distributed in the hope that it will be useful, but
+;;; WITHOUT ANY WARRANTY; without even the implied warranty of
+;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;;; GNU General Public License for more details.
+;;;
+;;; You should have received a copy of the GNU General Public License
+;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
+
+(define-module (gnu home services base)
+  #:use-module (gnu home services)
+  #:use-module (gnu home services fontutils)
+  #:export (%home-base-services))
+
+;;; Commentary:
+;;
+;; Base home services---i,e., services that 99% of the users will want to use.
+;;
+;;; Code:
+
+
+(define %home-base-services
+  ;; Convenience variable holding the basic services.
+  (list (service home-fontconfig-service-type)))
+
+;;; base.scm ends here
-- 
2.37.3





Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 29 Sep 2022 14:28:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 29 10:28:35 2022
Received: from localhost ([127.0.0.1]:39197 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oduWh-000716-F0
	for submit <at> debbugs.gnu.org; Thu, 29 Sep 2022 10:28:35 -0400
Received: from eggs.gnu.org ([209.51.188.92]:51958)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1oduWd-00070r-Bz
 for 57963 <at> debbugs.gnu.org; Thu, 29 Sep 2022 10:28:34 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:54642)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ludo@HIDDEN>)
 id 1oduWW-0005ML-6U; Thu, 29 Sep 2022 10:28:24 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-Version:In-Reply-To:Date:References:Subject:To:
 From; bh=REBcXbCo9To36uFU6vULSKT4XyLDEyMiOufzp+fTvq8=; b=cy/jc7jZhXMa7qvu6UPV
 FcpHHuwrMut+FSc1LvQpEvu+0sUvfMJjf2Lv9l4TkV2Y0yj9Johq41UfjhEDpE8F4ANanJQ/Pv5ZA
 WdC6COuVWFYpyuy2UwQAYQGhFonRxOf9ndym03UbE+vgUmx8iMkT8J0vNwVcGGZZmHRlM1kTpa/jn
 /R2qTscro4Tae3JsKcd3lNVc8pMN2qLlW1mB2kdVCF/S8Zmhgkb5e6vTPX9V+sfwhz0bUtje1VVaO
 nQdWXR7AIo1OM2lgdVv/sfe8OzbqGzYmWB0Rr50FZhZmmnoLWyAzmJ8bDjViTmCkwCN0QfnJSgzRU
 kVqaLdq0p3B0Hw==;
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=58494 helo=ribbon)
 by fencepost.gnu.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1oduWV-0000OT-NL; Thu, 29 Sep 2022 10:28:23 -0400
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>
Subject: Re: bug#57963: [PATCH 0/1] Support user's fontconfig.
References: <20220927095525.26431-1-higashi@HIDDEN>
 <87bkr1qg9x.fsf@HIDDEN> <87v8p7dwvc.fsf_-_@HIDDEN>
 <87y1u3ngds.fsf@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: Octidi 8 =?utf-8?Q?Vend=C3=A9miaire?= an 231 de la
 =?utf-8?Q?R=C3=A9volution=2C?= jour de l'Amarante
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Thu, 29 Sep 2022 16:28:21 +0200
In-Reply-To: <87y1u3ngds.fsf@HIDDEN> (Taiju HIGASHI's message of "Thu, 29
 Sep 2022 10:01:03 +0900")
Message-ID: <87h70qb6gq.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi,

Taiju HIGASHI <higashi@HIDDEN> skribis:

> I found out what essential services should be.
> I'm going to move it from essential services to base-home-services.

Alright, let=E2=80=99s do that (in a separate commit).

>> Once we=E2=80=99ve settled on an interface, the commit that makes this c=
hange
>> should include an update of doc/guix.texi.
>
> Yes. I can write the draft, but I may have to ask you to finish it because
> I'm not good at writing English.
> It would be a waste of time for you to spend a long time correcting my
> poor grammar and expressions.

Sure; I=E2=80=99m not a native speaker either but I can help.

Thanks,
Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 29 Sep 2022 01:01:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 28 21:01:17 2022
Received: from localhost ([127.0.0.1]:35311 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1odhvQ-0002N2-Or
	for submit <at> debbugs.gnu.org; Wed, 28 Sep 2022 21:01:17 -0400
Received: from mail-pj1-f47.google.com ([209.85.216.47]:43536)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1odhvM-0002Mn-CP
 for 57963 <at> debbugs.gnu.org; Wed, 28 Sep 2022 21:01:15 -0400
Received: by mail-pj1-f47.google.com with SMTP id
 g1-20020a17090a708100b00203c1c66ae3so3078343pjk.2
 for <57963 <at> debbugs.gnu.org>; Wed, 28 Sep 2022 18:01:12 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:from:to:cc:subject
 :date; bh=pEgxaCCqS2a+2A14dL+iCU24oYV9w+GO7yVnXwP/gm4=;
 b=iWETxRSXFnIyNhYj+K6hkzvA0aN4jrr11ryLXjw0cRb0J+yHyHn6mCFwUDbG4wb+iL
 rICvbew88PZlIjX2W9bIQYikjoDiPcHQ7tP5DhhVSA07A360UADiAC/3W//S7gpCdcVk
 T6UtNqBZcuVQDIGeu2NHNC1NC2J7hDXQQxu7GunmUB+HPW+bmyrT1L0iFBVt2d85EVTB
 y36ZzSxKXFSIzN+zM+h2LRUBddDQEqmMEh/UFPNr2OOHSby8Of3UKXCroNISlXklxXI6
 7G1F0ZqYA4FtGNQkQLTqY6NQL5vKkELbG9kQGZZJl0wECSQJ3n1BxZ0rGHdwEGC2+ySa
 VHlQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:x-gm-message-state
 :from:to:cc:subject:date;
 bh=pEgxaCCqS2a+2A14dL+iCU24oYV9w+GO7yVnXwP/gm4=;
 b=4aT4/2WAy8alPB7xNBzONU0qhE0ksFt13ujutyR1QWoUEUfAdFa8I0ZR4eGDh15XzK
 D6vNmYXVSGbn6KF+AfPIDVfF31VWtxiamABXEyCqFQUpgL6/Nc57X+xIqm8U7EIce8Wo
 OcFecOIrG79AiD5lShJvd9d0SHMt+O0ehcSrvcO/I+zy7TZndWSUbeD1qQKZAMZdYeEr
 X3WZxq9H/1yZ/Lw/HWZCZV86yEIY/B3NFUzmfnCaUF9VWoH8BFonWeK6jerZ6uvjwqww
 3j9DoMTZJATzoxESyEA3TkTdSH4YiLQ5NiMVdpBrrQplv2klb3XPTSs9iI9PPl2cELBe
 tCAg==
X-Gm-Message-State: ACrzQf2ydgHJNBaKZN/LSMQeXp3WQapz7Ng8s/sYKOdn6cxrzIRuYN/6
 +LI0bqmlMrCqFUvZgMfc7el/Qw==
X-Google-Smtp-Source: AMsMyM4Z7Aa4s83gEamhEr7eIp/pbXX4GhtCISQThpFx9R4SoNYeKUMm3r+wyEWM8fXd/nkl5AfCkg==
X-Received: by 2002:a17:902:b718:b0:17a:d64:de09 with SMTP id
 d24-20020a170902b71800b0017a0d64de09mr796632pls.106.1664413266379; 
 Wed, 28 Sep 2022 18:01:06 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 i2-20020a17090332c200b001751c61d3b8sm4518117plr.211.2022.09.28.18.01.04
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Wed, 28 Sep 2022 18:01:06 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Ludovic =?iso-8859-1?Q?Court=E8s?= <ludo@HIDDEN>
Subject: Re: bug#57963: [PATCH 0/1] Support user's fontconfig.
References: <20220927095525.26431-1-higashi@HIDDEN>
 <87bkr1qg9x.fsf@HIDDEN> <87v8p7dwvc.fsf_-_@HIDDEN>
Date: Thu, 29 Sep 2022 10:01:03 +0900
In-Reply-To: <87v8p7dwvc.fsf_-_@HIDDEN> ("Ludovic =?iso-8859-1?Q?Court=E8?=
 =?iso-8859-1?Q?s=22's?= message of "Wed,
 28 Sep 2022 23:15:03 +0200")
Message-ID: <87y1u3ngds.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Ludovic Court=C3=A8s <ludo@HIDDEN> writes:

> Hi,
>
> Taiju HIGASHI <higashi@HIDDEN> skribis:
>
>> I just sent you the v3 patch.
>>
>> I have changed only the interface of `preferred-defalut-font` slightly
>> from what I suggested the other day.
>>
>> We configure the service as follows.
>>
>>   (simple-service
>>     'my-fontconfig-service
>>     home-fontconfig-service-type
>>     (home-fontconfig-configuration
>>      (font-directories
>>       (list "~/fonts"))
>>      (preferred-default-font
>>       (default-font
>>         (serif "Noto Serif CJK JP")
>>         (sans-serif "Noto Sans CJK JP")
>>         (monospace "PlemolJP Console")))
>>      (extra-config
>>       `((match (@ (target font))
>>           (edit (@ (mode assign)
>>                    (name antialias))
>>                 (bool true)))))))
>
> Looks nicer IMO!
>
>>> +(define (home-fontconfig-extend original-config extend-configs)
>>> +  (home-fontconfig-configuration
>>> +   (inherit original-config)
>>> +   (font-directories
>>> +    (append
>>> +        (home-fontconfig-configuration-font-directories original-confi=
g)
>>> + (append-map home-fontconfig-configuration-font-directories
>>> extend-configs)))
>>> +   (preferred-default-font
>>> +    (home-fontconfig-configuration-preferred-default-font
>>> +     (if (null? extend-configs)
>>> +         original-config
>>> +         (last extend-configs))))
>>
>> This is the part I am most concerned about, not sure if replacing the
>> preferred-default-font setting with the last setting is the proper way
>> to go about it.
>
> It=E2=80=99s unusual for a service to receive extensions that are the full
> configuration object of that service.  Because then, indeed, you have to
> determine how to =E2=80=9Cmerge=E2=80=9D those configuration objects.
>
> The common patterns that we have are:
>
>   1. The service accepts as extensions things that represent part of its
>      configuration and where merging makes sense.
>
>      For example, nginx can be extended with
>      <nginx-location-configuration> objects, but not with a full-blown
>      <nginx-configuration>.
>
>   2. Similar, but the service has specific records for extensions.
>
>      The example that comes to mind is =E2=80=98home-bash-service-type=E2=
=80=99, which
>      accepts <home-bash-extension> records as its extensions.

Thank you. I understand well.
I felt out of place because there was no service that can full
configuration such this one.

> So=E2=80=A6
>
> I wonder, should we, as a first commit, move
> =E2=80=98home-fontconfig-service-type=E2=80=99 out of the essential servi=
ces to a
> =E2=80=98%base-home-services=E2=80=99 variable yet to be defined?
>
> I don=E2=80=99t see any good reason to have it here (=E2=80=9Cessential=
=E2=80=9D services should
> be limited to those that may not be replaced or removed; in (gnu
> system), this includes services that depend on information available in
> <operating-system>).
>
> Once we=E2=80=99ve done that, perhaps we can forget about extensions, at =
least
> for now, and let users who need to configure things write:
>
>   (modify-services %base-home-services
>     (home-fontconfig-service-type
>      config =3D> =E2=80=A6))
>
> WDYT?

I found out what essential services should be.
I'm going to move it from essential services to base-home-services.

>> I wanted to write a test as well, but since it was to be handled by
>> gexp, I could not figure out how to write a test that would validate the
>> gexp result using only exported methods. (I would like to write tests
>> for serialized functions that are private functions.)
>
> Hmm.
>
> Once we=E2=80=99ve settled on an interface, the commit that makes this ch=
ange
> should include an update of doc/guix.texi.

Yes. I can write the draft, but I may have to ask you to finish it because
I'm not good at writing English.
It would be a waste of time for you to spend a long time correcting my
poor grammar and expressions.

Thanks,
--=20
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 29 Sep 2022 00:31:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 28 20:31:22 2022
Received: from localhost ([127.0.0.1]:35272 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1odhST-0001cz-Ax
	for submit <at> debbugs.gnu.org; Wed, 28 Sep 2022 20:31:21 -0400
Received: from mail-pl1-f180.google.com ([209.85.214.180]:45917)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1odhSR-0001cg-5w
 for 57963 <at> debbugs.gnu.org; Wed, 28 Sep 2022 20:31:19 -0400
Received: by mail-pl1-f180.google.com with SMTP id w20so13057092ply.12
 for <57963 <at> debbugs.gnu.org>; Wed, 28 Sep 2022 17:31:19 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:from:to:cc:subject
 :date; bh=1qiSRL14IGgDIO3d7G+gdNNoZBFryycjEeoedNrmwS0=;
 b=pDpwtZk/wNimSwWYyelybYxEGDVeopf5EdruotqI8jl9+Y6N7l0mswRywo22es8MQa
 A2AuqvF7J2SCx880NyiW5NrZubnm6GI1R86Vwk728lmn0nOYfAdjCAuDK2Pwhsc5auGG
 HBJLPXNkJhRmXiorbu6oNRU7GQdlU5mpQy5+n2D1HMqXITgO7M4KIwuFbFmhYB3ssh4i
 8H9jQUmXOQ6BHjhgX186ffHc+v6piWn8AOU1id5gJt5BEtBuQ5e1JFFDVc6e5I0UpM/a
 9CNodpyitQvMwSEvbigX1t2X6YiBgDuUu2A43/VuR91H+IMIvTBub9I1R4w9izgOVS/4
 q4Sw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:x-gm-message-state
 :from:to:cc:subject:date;
 bh=1qiSRL14IGgDIO3d7G+gdNNoZBFryycjEeoedNrmwS0=;
 b=VuClz1dq61Rr9oLgRvuP4m1o6k7ENSjoPh3hDEIw779kJwTJxF4Zt79K4oaiz15m1S
 u1HRK4hN3pBARQGcG1hTWtrClCj5ZzVbrYJb/3sGbQsUqIDZfEGnDm36UE/PlM6jJWg+
 32DWzRcAybUMtNI1k9ft9rnuPP0GYq91fdQYFms78MHw1fXWPlIGu+iU+YsVs/0k7BXN
 Fr/STghBSPbTHPI40xEU9kJbPP0DktfvykWxaXrYGtga4svyH6caeovKfj+7jN3tfCL/
 6vDwSIE/5LUYOhW0S9/Xw3DjdJEB7EtVzhx8bVoBlRotI6V6Ult7L9+9YEZYSUdetfbN
 X7cg==
X-Gm-Message-State: ACrzQf2ITAfxDjvxVLd+AA0A7u1yefptQErGBug6BvlBu04+w5BBOrZK
 UWuOARWb+cM8S/usSiThKrqS+7nvBecxF42R
X-Google-Smtp-Source: AMsMyM7uAtEPEPkQBNOZYw7iVlbR4cJbSm7Yz0dgTIEcxBPOMvEdmZ1Htd7DlO3p2G4uaHF/gwC7fQ==
X-Received: by 2002:a17:903:442:b0:17a:ac:1b75 with SMTP id
 iw2-20020a170903044200b0017a00ac1b75mr632173plb.5.1664411473025; 
 Wed, 28 Sep 2022 17:31:13 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 y16-20020aa78f30000000b00540a3252191sm4698288pfr.28.2022.09.28.17.31.11
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Wed, 28 Sep 2022 17:31:12 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Liliana Marie Prikler <liliana.prikler@HIDDEN>
Subject: Re: [PATCH v3] home: fontutils: Support user's fontconfig.
References: <20220927095525.26431-1-higashi@HIDDEN>
 <2add7a8c83272c5bcb9aac38e63161a48f321cda.camel@HIDDEN>
Date: Thu, 29 Sep 2022 09:31:09 +0900
In-Reply-To: <2add7a8c83272c5bcb9aac38e63161a48f321cda.camel@HIDDEN>
 (Liliana Marie Prikler's message of "Wed, 28 Sep 2022 21:11:30 +0200")
Message-ID: <87tu4rowc2.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Liliana Marie Prikler <liliana.prikler@HIDDEN> writes:
   > Am Dienstag, dem 27.09.2022 um 18:55 +0900 schrieb Taiju HIGASHI: >> * gnu/home/services/fontutils.scm
    (add-fontconfig-config-file): >> Support user's >> fontconfig. >> --- >>
   gnu/home/services/fon [...] 
 
 Content analysis details:   (2.0 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  0.0 SPF_NONE               SPF: sender does not publish an SPF Record
  2.0 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  0.0 RCVD_IN_MSPIKE_H3      RBL: Good reputation (+3)
                             [209.85.214.180 listed in wl.mailspike.net]
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
                              no trust
                             [209.85.214.180 listed in list.dnswl.org]
  0.0 RCVD_IN_MSPIKE_WL      Mailspike good senders
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, 57963 <at> debbugs.gnu.org, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

Liliana Marie Prikler <liliana.prikler@HIDDEN> writes:

> Am Dienstag, dem 27.09.2022 um 18:55 +0900 schrieb Taiju HIGASHI:
>> * gnu/home/services/fontutils.scm (add-fontconfig-config-file):
>> Support user's
>> fontconfig.
>> ---
>> =A0gnu/home/services/fontutils.scm | 103
>> ++++++++++++++++++++++++++++++--
>> =A01 file changed, 97 insertions(+), 6 deletions(-)
>>
>> diff --git a/gnu/home/services/fontutils.scm
>> b/gnu/home/services/fontutils.scm
>> index 6062eaed6a..b02f43a4fc 100644
>> --- a/gnu/home/services/fontutils.scm
>> +++ b/gnu/home/services/fontutils.scm
>> @@ -1,6 +1,7 @@
>> =A0;;; GNU Guix --- Functional package management for GNU
>> =A0;;; Copyright =A9 2021 Andrew Tropin <andrew@HIDDEN>
>> =A0;;; Copyright =A9 2021 Xinglu Chen <public@HIDDEN>
>> +;;; Copyright =A9 2022 Taiju HIGASHI <higashi@HIDDEN>
>> =A0;;;
>> =A0;;; This file is part of GNU Guix.
>> =A0;;;
>> @@ -20,9 +21,16 @@
>> =A0(define-module (gnu home services fontutils)
>> =A0=A0 #:use-module (gnu home services)
>> =A0=A0 #:use-module (gnu packages fontutils)
>> +=A0 #:use-module (gnu services configuration)
>> =A0=A0 #:use-module (guix gexp)
>> +=A0 #:use-module (guix records)
>> +=A0 #:use-module (srfi srfi-1)
>> +=A0 #:use-module (sxml simple)
>> +=A0 #:use-module (ice-9 match)
>>
>> -=A0 #:export (home-fontconfig-service-type))
>> +=A0 #:export (home-fontconfig-service-type
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 home-fontconfig-configuration
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 default-font))
>>
>> =A0;;; Commentary:
>> =A0;;;
>> @@ -33,15 +41,96 @@ (define-module (gnu home services fontutils)
>> =A0;;;
>> =A0;;; Code:
>>
>> -(define (add-fontconfig-config-file he-symlink-path)
>> +(define-record-type* <default-font> default-font
>> +=A0 make-default-font
>> +=A0 default-font?
>> +=A0 (serif default-font-serif (default ""))
>> +=A0 (sans-serif defalut-font-sans-serif (default ""))
>> +=A0 (monospace default-font-monospace (default "")))
> Is the empty string a meaningful value in these places?

Sure, It is not meaningful.  I would remove the default value.

>> +(define (sxml->xmlstring sxml)
>> +=A0 (if (null? sxml)
>> +=A0=A0=A0=A0=A0 ""
>> +=A0=A0=A0=A0=A0 (call-with-output-string
>> +=A0=A0=A0=A0=A0=A0=A0 (lambda (port)
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0 (sxml->xml sxml port)
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0 (newline port)))))
>> +
>> +(define font-directories? list?)
>> +
>> +(define (serialize-font-directories field-name value)
>> +=A0 (sxml->xmlstring
>> +=A0=A0 (append
>> +=A0=A0=A0=A0=A0=A0 '((dir "~/.guix-home/profile/share/fonts"))
>> +=A0=A0=A0=A0=A0=A0 (map
>> +=A0=A0=A0=A0=A0=A0=A0 (lambda (path)
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0 `(dir ,path))
>> +=A0=A0=A0=A0=A0=A0=A0 value))))
>> +
>> +(define extra-config-list? list?)
>> +
>> +(define (serialize-extra-config-list field-name value)
>> +=A0 (sxml->xmlstring
>> +=A0=A0 (map (match-lambda
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0 ((? pair? sxml) sxml)
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0 ((? string? xml) (xml->sxml xml))
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0 (_ (error "extra-config value must be xml s=
tring or sxml
>> list.")))
>> +=A0=A0=A0=A0=A0=A0=A0 value)))
>> +
>> +(define (serialize-default-font field-name value)
>> +=A0 (match value
>> +=A0=A0=A0 (($ <default-font> serif sans-serif monospace)
>> +=A0=A0=A0=A0 (sxml->xmlstring
>> +=A0=A0=A0=A0=A0 (fold (lambda (pair sxml)
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (if (string-null? (cdr pair))
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 sxml
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (append sxml
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 `((alias
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=
=A0 (family ,(car pair))
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=
=A0 (prefer
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=
=A0=A0 (family ,(cdr pair))))))))
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 '()
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 `((serif . ,serif)
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (sans-serif . ,sans-serif)
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (monospace . ,monospace)))))))
> You can greatly simplify these by serializing the fields to SXML and
> only taking the final SXML and serializing it to a string.

I see.  We can define sanitizer for fields, right?

>> +(define-configuration home-fontconfig-configuration
>> +=A0 (font-directories
>> +=A0=A0 (font-directories '())
>> +=A0=A0 "The directory list that provides fonts.")
>> +=A0 (preferred-default-font
>> +=A0=A0 (default-font (default-font))
>> +=A0=A0 "The preffered default fonts for serif, sans-serif, and
>> monospace.")
>> +=A0 (extra-config
>> +=A0=A0 (extra-config-list '())
>> +=A0=A0 "Extra configuration values to append to the fonts.conf."))
>> +
>> +(define (home-fontconfig-extend original-config extend-configs)
>> +=A0 (home-fontconfig-configuration
>> +=A0=A0 (inherit original-config)
>> +=A0=A0 (font-directories
>> +=A0=A0=A0 (append
>> +=A0=A0=A0=A0=A0=A0=A0 (home-fontconfig-configuration-font-directories o=
riginal-
>> config)
>> +=A0=A0=A0=A0=A0=A0=A0 (append-map home-fontconfig-configuration-font-di=
rectories
>> extend-configs)))
>> +=A0=A0 (preferred-default-font
>> +=A0=A0=A0 (home-fontconfig-configuration-preferred-default-font
>> +=A0=A0=A0=A0 (if (null? extend-configs)
>> +=A0=A0=A0=A0=A0=A0=A0=A0 original-config
>> +=A0=A0=A0=A0=A0=A0=A0=A0 (last extend-configs))))
>> +=A0=A0 (extra-config
>> +=A0=A0=A0 (append
>> +=A0=A0=A0=A0=A0=A0=A0 (home-fontconfig-configuration-extra-config origi=
nal-config)
>> +=A0=A0=A0=A0=A0=A0=A0 (append-map home-fontconfig-configuration-extra-c=
onfig
>> extend-configs)))))
>> +
>> +(define (add-fontconfig-config-file user-config)
>> =A0=A0 `(("fontconfig/fonts.conf"
>> =A0=A0=A0=A0=A0 ,(mixed-text-file
>> =A0=A0=A0=A0=A0=A0=A0 "fonts.conf"
>> =A0=A0=A0=A0=A0=A0=A0 "<?xml version=3D'1.0'?>
>> =A0<!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
>> -<fontconfig>
>> -=A0 <dir>~/.guix-home/profile/share/fonts</dir>
>> -</fontconfig>"))))
>> +<fontconfig>\n"
>> +=A0=A0=A0=A0=A0=A0 (serialize-configuration user-config home-fontconfig-
>> configuration-fields)
>> +=A0=A0=A0=A0=A0=A0 "</fontconfig>\n"))))
> Is it expected that our configuration will be pretty?  If so, you might
> want to use a tree fold (there sadly doesn't seem to be a built-in XML
> pretty printer, which is a shame imho.)
>
> If not, those extra newlines do little.

OK, I would remove extra newlines.

>> =A0(define (regenerate-font-cache-gexp _)
>> =A0=A0 `(("profile/share/fonts"
>> @@ -49,6 +138,8 @@ (define (regenerate-font-cache-gexp _)
>>
>> =A0(define home-fontconfig-service-type
>> =A0=A0 (service-type (name 'home-fontconfig)
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (compose identity)
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (extend home-fontconfig-e=
xtend)
>> =A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (extensions
>> =A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (list (service-exten=
sion
>> =A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=
 home-xdg-configuration-files-service-type
>> @@ -59,7 +150,7 @@ (define home-fontconfig-service-type
>> =A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (s=
ervice-extension
>> =A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=
 home-profile-service-type
>> =A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=
 (const (list fontconfig)))))
>> -=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (default-value #f)
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (default-value (home-font=
config-configuration))
>> =A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (description
>> =A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 "Provides configurat=
ion file for fontconfig and
>> make
>> =A0fc-* utilities aware of font packages installed in Guix Home's
>> profile.")))
>
> Cheers
>

Cheers,
--
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 28 Sep 2022 21:15:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 28 17:15:16 2022
Received: from localhost ([127.0.0.1]:34999 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1odeOh-0004gD-HG
	for submit <at> debbugs.gnu.org; Wed, 28 Sep 2022 17:15:15 -0400
Received: from eggs.gnu.org ([209.51.188.92]:47984)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1odeOf-0004fu-BD
 for 57963 <at> debbugs.gnu.org; Wed, 28 Sep 2022 17:15:13 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:37920)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ludo@HIDDEN>)
 id 1odeOY-0005oy-BN; Wed, 28 Sep 2022 17:15:06 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-Version:In-Reply-To:Date:References:Subject:To:
 From; bh=7IO8r7l+Y09hT+kTG8Dzv9EyqbapE5t1blg7vSPXYxg=; b=cAvUja8/mShVZPERTzD1
 OXeN+sWVd+yQwOOB880WgcVvrBzNf5U4f8SOqnAC+7yeq5XWB6vvafnVgPsw1FMnNzyHcgnzIwUlF
 wkfwzdfhoxdiBfiyPBc1TipgYtGFSD/hH+ZFfVK3ugdpo634JzCNHA1Mu4xGT0l+HdyV9aH8EmgtW
 DwxpRk6e/37PsRn2MsXtHWQ9b226RJzXQC+2bWbORZZe9RG77iX5jlQhsimWvnF2oBWudpnuG6Wpr
 zfGVvWAoBGV00nCG3JkXDFeEGsDOheaHHVaeVxAYOTSFg3Wm+8BkZUAKn8f/witYrshNBSkvdgpzv
 02nXPQHRiv+RKw==;
Received: from 91-160-117-201.subs.proxad.net ([91.160.117.201]:60091
 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ludo@HIDDEN>)
 id 1odeOX-00064j-Uh; Wed, 28 Sep 2022 17:15:06 -0400
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>
Subject: Re: bug#57963: [PATCH 0/1] Support user's fontconfig.
References: <20220927095525.26431-1-higashi@HIDDEN>
 <87bkr1qg9x.fsf@HIDDEN>
Date: Wed, 28 Sep 2022 23:15:03 +0200
In-Reply-To: <87bkr1qg9x.fsf@HIDDEN> (Taiju HIGASHI's message of "Tue, 27
 Sep 2022 19:10:34 +0900")
Message-ID: <87v8p7dwvc.fsf_-_@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, liliana.prikler@HIDDEN, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi,

Taiju HIGASHI <higashi@HIDDEN> skribis:

> I just sent you the v3 patch.
>
> I have changed only the interface of `preferred-defalut-font` slightly
> from what I suggested the other day.
>
> We configure the service as follows.
>
>   (simple-service
>     'my-fontconfig-service
>     home-fontconfig-service-type
>     (home-fontconfig-configuration
>      (font-directories
>       (list "~/fonts"))
>      (preferred-default-font
>       (default-font
>         (serif "Noto Serif CJK JP")
>         (sans-serif "Noto Sans CJK JP")
>         (monospace "PlemolJP Console")))
>      (extra-config
>       `((match (@ (target font))
>           (edit (@ (mode assign)
>                    (name antialias))
>                 (bool true)))))))

Looks nicer IMO!

>> +(define (home-fontconfig-extend original-config extend-configs)
>> +  (home-fontconfig-configuration
>> +   (inherit original-config)
>> +   (font-directories
>> +    (append
>> +        (home-fontconfig-configuration-font-directories original-config)
>> +        (append-map home-fontconfig-configuration-font-directories exte=
nd-configs)))
>> +   (preferred-default-font
>> +    (home-fontconfig-configuration-preferred-default-font
>> +     (if (null? extend-configs)
>> +         original-config
>> +         (last extend-configs))))
>
> This is the part I am most concerned about, not sure if replacing the
> preferred-default-font setting with the last setting is the proper way
> to go about it.

It=E2=80=99s unusual for a service to receive extensions that are the full
configuration object of that service.  Because then, indeed, you have to
determine how to =E2=80=9Cmerge=E2=80=9D those configuration objects.

The common patterns that we have are:

  1. The service accepts as extensions things that represent part of its
     configuration and where merging makes sense.

     For example, nginx can be extended with
     <nginx-location-configuration> objects, but not with a full-blown
     <nginx-configuration>.

  2. Similar, but the service has specific records for extensions.

     The example that comes to mind is =E2=80=98home-bash-service-type=E2=
=80=99, which
     accepts <home-bash-extension> records as its extensions.

So=E2=80=A6

I wonder, should we, as a first commit, move
=E2=80=98home-fontconfig-service-type=E2=80=99 out of the essential service=
s to a
=E2=80=98%base-home-services=E2=80=99 variable yet to be defined?

I don=E2=80=99t see any good reason to have it here (=E2=80=9Cessential=E2=
=80=9D services should
be limited to those that may not be replaced or removed; in (gnu
system), this includes services that depend on information available in
<operating-system>).

Once we=E2=80=99ve done that, perhaps we can forget about extensions, at le=
ast
for now, and let users who need to configure things write:

  (modify-services %base-home-services
    (home-fontconfig-service-type
     config =3D> =E2=80=A6))

WDYT?

> I wanted to write a test as well, but since it was to be handled by
> gexp, I could not figure out how to write a test that would validate the
> gexp result using only exported methods. (I would like to write tests
> for serialized functions that are private functions.)

Hmm.

Once we=E2=80=99ve settled on an interface, the commit that makes this chan=
ge
should include an update of doc/guix.texi.

Thanks!

Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 28 Sep 2022 19:11:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 28 15:11:41 2022
Received: from localhost ([127.0.0.1]:34706 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1odcT6-0002mI-H3
	for submit <at> debbugs.gnu.org; Wed, 28 Sep 2022 15:11:41 -0400
Received: from mail-ej1-f66.google.com ([209.85.218.66]:37595)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <liliana.prikler@HIDDEN>) id 1odcT4-0002m4-1u
 for 57963 <at> debbugs.gnu.org; Wed, 28 Sep 2022 15:11:39 -0400
Received: by mail-ej1-f66.google.com with SMTP id a26so29171622ejc.4
 for <57963 <at> debbugs.gnu.org>; Wed, 28 Sep 2022 12:11:38 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:from:to:cc:subject
 :date; bh=608yu43Olhzj1qOwNAUuZv/eR5BRv5V3L6a9GgPpLXQ=;
 b=gBlhGlKJ/EQ8DPFYCnUDGDKiv4Wuw3GqOgVQiKDeupRGrj91WxpAi6UsO+zfwaM0eO
 U+3uQxNefUnO85p7v8CcSDstxLNgw2wpxxbw4HW4unUYXKwa73946imDFJxLxALRz9dg
 DP9eEdXuPIruGKg/tebsi2/qxDKcOb0A72XKYUOZyd7lTsSlv3vCY/K78C0q3BjyyJDl
 MgZSZa2HafIOvgGFqr6vQagK0MvQ8ZX9uWArQkrKki/V+h4TFXGEwOG710BDobsReC2G
 SH/jiUvIftPcUUqjEB5gJeNjeeN56ta+Ec5rlOjidGocGoK0dDJQfLv/mLy6cP3zYCAZ
 HzdA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:x-gm-message-state
 :from:to:cc:subject:date;
 bh=608yu43Olhzj1qOwNAUuZv/eR5BRv5V3L6a9GgPpLXQ=;
 b=2lQOZWGwkTexHJMr+CJU0kf8N1+bjQ+brHrj23Os0TknOv2+YR3HoaLsU3TL8X3l51
 hM6QMbAXPnFudS47AOq/PM/+2o7EMfyWT55wWMsaR7KXCgsv0z559eGnTTyfVkJ4cisn
 P2Uidl2G9DFQiB/SihpDsh4J1PCrPeT3m9xsC+bFrPXgReSJl5Td+g6tz6RQnvbDqlmh
 8dd7Hu4LYwyipvLPUZHcxdpV/pGzH8CJm96vFY4MPtlD1DTKMq4XUWUDjdyzgIKurat1
 CK/z25EyYI+taN8dM55By2LnQMMPkKRQ5YcwDivE0gmCjobF4QwV4pLJQKKq1qcaKxT0
 qxlQ==
X-Gm-Message-State: ACrzQf29Xqp5jkw+uunZOwUIlJA3lcZQpIQKkS7cq5Tew2WiH6HYsi9T
 SCNkEGyUVYR5TTUCJeP14wE=
X-Google-Smtp-Source: AMsMyM4QqULnajix+6qBeqtohf/PU23IRryULH5aYCY57SAHRuyczhVE6oP1kBY/5NEhCdXX0b1QGw==
X-Received: by 2002:a17:906:fe08:b0:77e:a290:988e with SMTP id
 wy8-20020a170906fe0800b0077ea290988emr27540342ejb.223.1664392292138; 
 Wed, 28 Sep 2022 12:11:32 -0700 (PDT)
Received: from lumine.fritz.box (85-127-52-93.dsl.dynamic.surfer.at.
 [85.127.52.93]) by smtp.gmail.com with ESMTPSA id
 kw26-20020a170907771a00b0073dd8e5a39fsm2798758ejc.156.2022.09.28.12.11.31
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Wed, 28 Sep 2022 12:11:31 -0700 (PDT)
Message-ID: <2add7a8c83272c5bcb9aac38e63161a48f321cda.camel@HIDDEN>
Subject: Re: [PATCH v3] home: fontutils: Support user's fontconfig.
From: Liliana Marie Prikler <liliana.prikler@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>, ludo@HIDDEN, andrew@HIDDEN
Date: Wed, 28 Sep 2022 21:11:30 +0200
In-Reply-To: <20220927095525.26431-1-higashi@HIDDEN>
References: <20220927095525.26431-1-higashi@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: base64
User-Agent: Evolution 3.46.0 
MIME-Version: 1.0
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Am Dienstag, dem 27.09.2022 um 18:55 +0900 schrieb Taiju HIGASHI:
    > * gnu/home/services/fontutils.scm (add-fontconfig-config-file): > Support
    user's > fontconfig. > --- > gnu/home/services/fontutils [...] 
 
 Content analysis details:   (2.0 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_PASS               SPF: sender matches SPF record
  2.0 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: yoctocell.xyz (xyz)]
  0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
                             provider (liliana.prikler[at]gmail.com)
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
                              no trust
                             [209.85.218.66 listed in list.dnswl.org]
  0.0 RCVD_IN_MSPIKE_H3      RBL: Good reputation (+3)
                             [209.85.218.66 listed in wl.mailspike.net]
  0.0 RCVD_IN_MSPIKE_WL      Mailspike good senders
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)
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Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 27 Sep 2022 10:10:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Sep 27 06:10:45 2022
Received: from localhost ([127.0.0.1]:52899 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1od7Y5-0005Gb-4F
	for submit <at> debbugs.gnu.org; Tue, 27 Sep 2022 06:10:45 -0400
Received: from mail-pl1-f172.google.com ([209.85.214.172]:47098)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1od7Y3-0005GN-8Y
 for 57963 <at> debbugs.gnu.org; Tue, 27 Sep 2022 06:10:44 -0400
Received: by mail-pl1-f172.google.com with SMTP id jm5so8610489plb.13
 for <57963 <at> debbugs.gnu.org>; Tue, 27 Sep 2022 03:10:43 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:from:to:cc:subject:date;
 bh=YpxXAcq9OtgPl97wgSmIkkpj2vNjWQruXMCC4W12HDE=;
 b=ZgT62yeOBvnxKhkZ+GJBCfmb/h5G8EhW/AjAjdFGwH1rNBamk8rwIxfuuUIlXxzJGB
 BTGoNE4p7rKHv3BGQ5jK1LwQeSkL726r/igP8OzxKSdKIvS63R7mw+L4lA9B23c08HBa
 K8+7Pg5pWYG3BACBup7029RkTAzkxHxBHTg/7r+UItO4RhE5XS7yDCcU4U0c2IrbmIz3
 CR76A6Z72l46ehZ0SoScRaVMUS6t1H4hOR1uPS9Df2ci69KnQwc4BEchsFdeiPPqB44i
 l+jdGp1hqoDCUBlN3y78HsWzejx3IY19bfnEggNbYVsKW/NwnvbB8lDaKGynzCAkspn0
 Cq3A==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:x-gm-message-state:from:to:cc:subject:date;
 bh=YpxXAcq9OtgPl97wgSmIkkpj2vNjWQruXMCC4W12HDE=;
 b=ckukx4Iq88/fztewX6bnlVFL6OWpgSUO1SJf3NT7NuT0QBy+PKe1DQqImJlvmWlD9M
 mb5Y4bQ5CX9whnNU2dKhR21kD04QKtupo+IqmJUxsyi7bMwazNHShheCC9uLaZbtE/XH
 qTQXAYCyRQwes7y/JhR02qHamEdvS9knLlccZB/5L+vmIvw7JuwpiWHCtRyx2sJcVnd5
 uvaFekHt0NAr/P2LjK09dkarAiV1qVSZ75W0BrXckjxlCye5D5xoXFohSoC+sdn1UNiA
 A8HwQepzGr1fPsef25ghkcUMV2uNl5p4LsK996z5FgVRrGFRlzUyrfViki1otVFj5XWx
 dfcg==
X-Gm-Message-State: ACrzQf3M5J11Bfzokf852bXAq7RfeEfyU/AaU+9RI55uedos3P+HEYOg
 +YeDmP4QmA37Bw+1AjAmBz1UEg==
X-Google-Smtp-Source: AMsMyM6QeRPUogIbe0tsynLKWXGnGbmhnmnIN9ZM0GLXTvT3fK4iAAe1vdBMWz5ZLTRLUAGMSaZTmA==
X-Received: by 2002:a17:902:7e42:b0:178:489:86ac with SMTP id
 a2-20020a1709027e4200b00178048986acmr26831689pln.68.1664273437479; 
 Tue, 27 Sep 2022 03:10:37 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 c10-20020a170903234a00b00177e5d83d3dsm1109464plh.170.2022.09.27.03.10.35
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Tue, 27 Sep 2022 03:10:37 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: 57963 <at> debbugs.gnu.org
Subject: Re: [PATCH v3] home: fontutils: Support user's fontconfig.
References: <20220927095525.26431-1-higashi@HIDDEN>
Date: Tue, 27 Sep 2022 19:10:34 +0900
In-Reply-To: <20220927095525.26431-1-higashi@HIDDEN> (Taiju HIGASHI's
 message of "Tue, 27 Sep 2022 18:55:25 +0900")
Message-ID: <87bkr1qg9x.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: ludo@HIDDEN, liliana.prikler@HIDDEN, andrew@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi,

I just sent you the v3 patch.

I have changed only the interface of `preferred-defalut-font` slightly
from what I suggested the other day.

We configure the service as follows.

--8<---------------cut here---------------start------------->8---
  (simple-service
    'my-fontconfig-service
    home-fontconfig-service-type
    (home-fontconfig-configuration
     (font-directories
      (list "~/fonts"))
     (preferred-default-font
      (default-font
        (serif "Noto Serif CJK JP")
        (sans-serif "Noto Sans CJK JP")
        (monospace "PlemolJP Console")))
     (extra-config
      `((match (@ (target font))
          (edit (@ (mode assign)
                   (name antialias))
                (bool true)))))))
--8<---------------cut here---------------end--------------->8---

I didn't understand it properly, but `home-fontconfig-service-type` is
pre-registered as `essential-services` and needs to be extended using
`simple-service`.

> +(define (home-fontconfig-extend original-config extend-configs)
> +  (home-fontconfig-configuration
> +   (inherit original-config)
> +   (font-directories
> +    (append
> +        (home-fontconfig-configuration-font-directories original-config)
> +        (append-map home-fontconfig-configuration-font-directories extend-configs)))
> +   (preferred-default-font
> +    (home-fontconfig-configuration-preferred-default-font
> +     (if (null? extend-configs)
> +         original-config
> +         (last extend-configs))))

This is the part I am most concerned about, not sure if replacing the
preferred-default-font setting with the last setting is the proper way
to go about it.

I wanted to write a test as well, but since it was to be handled by
gexp, I could not figure out how to write a test that would validate the
gexp result using only exported methods. (I would like to write tests
for serialized functions that are private functions.)

Cheers,
-- 
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 27 Sep 2022 09:55:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Sep 27 05:55:55 2022
Received: from localhost ([127.0.0.1]:52894 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1od7Jj-0004tB-EY
	for submit <at> debbugs.gnu.org; Tue, 27 Sep 2022 05:55:55 -0400
Received: from mail-pg1-f181.google.com ([209.85.215.181]:45862)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1od7Je-0004st-0z
 for 57963 <at> debbugs.gnu.org; Tue, 27 Sep 2022 05:55:53 -0400
Received: by mail-pg1-f181.google.com with SMTP id r62so5109880pgr.12
 for <57963 <at> debbugs.gnu.org>; Tue, 27 Sep 2022 02:55:49 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:message-id:date:subject:cc
 :to:from:from:to:cc:subject:date;
 bh=cdWhS+Qz1yPjvOsmI4PrFoJjJb50CRiXBRa7uh833xM=;
 b=cboOiLfKV/b9ZiLbf/H9Wc8hnSYsb8so3anDivj5atFL4nK5nzbYHInS32ZMcSb5cZ
 Y2cowMVqikC/pEM4pX0qU/lyvN/XpHEpDk6z9tyJEdVBNoA9BflpnioB2zMuHaXUCweX
 ehzXq1MGokG5UpTGLtUSdj3ACkUpHdXy4nKrPR8/XBb/mmDtx0l3ay83tftUuhTTxWPs
 9wKijQMGGIucpc0kK9ooy9FI819y2EsIk5V7owsfkOPcIF+H3KRgRgXp3YVohrQ0T/2a
 dPDjUjX6YW1BRzMACmQKahU58dmws6bS+WfJPfEPg1pAcZipY0/w20I8xtJXvnGy90qn
 ZGSQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:message-id:date:subject:cc
 :to:from:x-gm-message-state:from:to:cc:subject:date;
 bh=cdWhS+Qz1yPjvOsmI4PrFoJjJb50CRiXBRa7uh833xM=;
 b=OoyjPciM+rcrcTKYmikzoefZ8SVy4lEsgf9CP9Q8Is0rlC0MFEQboe/Li2Twvkiu7Y
 hqwWs5gV9iOtAURp1fRMMxc1fKnnnhpc+QLrHMbBTrOcoYQTQECLd+gpKzuafjPA2zAk
 QZ018Q0Jo4Amtok5Pyvr1psvrLxzNxnV/PQu52Zn+nY/l53uHW6owJKJw2hsglKn138i
 omqCrPE84n1GzIIvOdEfD586iUNbVbDnJlIeqDgRhwpQ0aIvjLWywJr+e4Oh0S0Mk2/Z
 uEnMg3RkmClgN7IpNC5ooe8rpOd0DX+Dw++QoAXe+v30V8AtmOrUUbh88jNXcRlN+xQF
 xNIQ==
X-Gm-Message-State: ACrzQf2aMorCO0c3vZftSG2eRdgP+3nm/HACBsUsvjKREWRrWqHrYNzF
 aj8UT1C8Eifdnkq+sVxRgz1Gdg==
X-Google-Smtp-Source: AMsMyM5Y4nhjHtJW75fSPJzU++Zp8vXHE6UwdsbBd/HSZNnvPzEpqCCO0yMmDf4Y6H0eDubRaw0dFA==
X-Received: by 2002:a62:e20f:0:b0:556:4265:5de2 with SMTP id
 a15-20020a62e20f000000b0055642655de2mr23896644pfi.57.1664272544140; 
 Tue, 27 Sep 2022 02:55:44 -0700 (PDT)
Received: from Taix.flets-west.jp ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 u16-20020a170902e5d000b00172f6726d8esm1067770plf.277.2022.09.27.02.55.42
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Tue, 27 Sep 2022 02:55:43 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: ludo@HIDDEN,
	liliana.prikler@HIDDEN,
	andrew@HIDDEN
Subject: [PATCH v3] home: fontutils: Support user's fontconfig.
Date: Tue, 27 Sep 2022 18:55:25 +0900
Message-Id: <20220927095525.26431-1-higashi@HIDDEN>
X-Mailer: git-send-email 2.37.3
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: * gnu/home/services/fontutils.scm
 (add-fontconfig-config-file):
 Support user's fontconfig. --- gnu/home/services/fontutils.scm | 103
 ++++++++++++++++++++++++++++++--
 1 file changed, 97 insertions(+), [...] 
 Content analysis details:   (2.0 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 SPF_NONE               SPF: sender does not publish an SPF Record
 2.0 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: yoctocell.xyz (xyz)]
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [209.85.215.181 listed in list.dnswl.org]
 0.0 RCVD_IN_MSPIKE_H3      RBL: Good reputation (+3)
 [209.85.215.181 listed in wl.mailspike.net]
 0.0 RCVD_IN_MSPIKE_WL      Mailspike good senders
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, Taiju HIGASHI <higashi@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

* gnu/home/services/fontutils.scm (add-fontconfig-config-file): Support user's
fontconfig.
---
 gnu/home/services/fontutils.scm | 103 ++++++++++++++++++++++++++++++--
 1 file changed, 97 insertions(+), 6 deletions(-)

diff --git a/gnu/home/services/fontutils.scm b/gnu/home/services/fontutils.scm
index 6062eaed6a..b02f43a4fc 100644
--- a/gnu/home/services/fontutils.scm
+++ b/gnu/home/services/fontutils.scm
@@ -1,6 +1,7 @@
 ;;; GNU Guix --- Functional package management for GNU
 ;;; Copyright  2021 Andrew Tropin <andrew@HIDDEN>
 ;;; Copyright  2021 Xinglu Chen <public@HIDDEN>
+;;; Copyright  2022 Taiju HIGASHI <higashi@HIDDEN>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -20,9 +21,16 @@
 (define-module (gnu home services fontutils)
   #:use-module (gnu home services)
   #:use-module (gnu packages fontutils)
+  #:use-module (gnu services configuration)
   #:use-module (guix gexp)
+  #:use-module (guix records)
+  #:use-module (srfi srfi-1)
+  #:use-module (sxml simple)
+  #:use-module (ice-9 match)
 
-  #:export (home-fontconfig-service-type))
+  #:export (home-fontconfig-service-type
+            home-fontconfig-configuration
+            default-font))
 
 ;;; Commentary:
 ;;;
@@ -33,15 +41,96 @@ (define-module (gnu home services fontutils)
 ;;;
 ;;; Code:
 
-(define (add-fontconfig-config-file he-symlink-path)
+(define-record-type* <default-font> default-font
+  make-default-font
+  default-font?
+  (serif default-font-serif (default ""))
+  (sans-serif defalut-font-sans-serif (default ""))
+  (monospace default-font-monospace (default "")))
+
+(define (sxml->xmlstring sxml)
+  (if (null? sxml)
+      ""
+      (call-with-output-string
+        (lambda (port)
+          (sxml->xml sxml port)
+          (newline port)))))
+
+(define font-directories? list?)
+
+(define (serialize-font-directories field-name value)
+  (sxml->xmlstring
+   (append
+       '((dir "~/.guix-home/profile/share/fonts"))
+       (map
+        (lambda (path)
+          `(dir ,path))
+        value))))
+
+(define extra-config-list? list?)
+
+(define (serialize-extra-config-list field-name value)
+  (sxml->xmlstring
+   (map (match-lambda
+          ((? pair? sxml) sxml)
+          ((? string? xml) (xml->sxml xml))
+          (_ (error "extra-config value must be xml string or sxml list.")))
+        value)))
+
+(define (serialize-default-font field-name value)
+  (match value
+    (($ <default-font> serif sans-serif monospace)
+     (sxml->xmlstring
+      (fold (lambda (pair sxml)
+              (if (string-null? (cdr pair))
+                  sxml
+                  (append sxml
+                      `((alias
+                         (family ,(car pair))
+                         (prefer
+                          (family ,(cdr pair))))))))
+            '()
+            `((serif . ,serif)
+              (sans-serif . ,sans-serif)
+              (monospace . ,monospace)))))))
+
+(define-configuration home-fontconfig-configuration
+  (font-directories
+   (font-directories '())
+   "The directory list that provides fonts.")
+  (preferred-default-font
+   (default-font (default-font))
+   "The preffered default fonts for serif, sans-serif, and monospace.")
+  (extra-config
+   (extra-config-list '())
+   "Extra configuration values to append to the fonts.conf."))
+
+(define (home-fontconfig-extend original-config extend-configs)
+  (home-fontconfig-configuration
+   (inherit original-config)
+   (font-directories
+    (append
+        (home-fontconfig-configuration-font-directories original-config)
+        (append-map home-fontconfig-configuration-font-directories extend-configs)))
+   (preferred-default-font
+    (home-fontconfig-configuration-preferred-default-font
+     (if (null? extend-configs)
+         original-config
+         (last extend-configs))))
+   (extra-config
+    (append
+        (home-fontconfig-configuration-extra-config original-config)
+        (append-map home-fontconfig-configuration-extra-config extend-configs)))))
+
+(define (add-fontconfig-config-file user-config)
   `(("fontconfig/fonts.conf"
      ,(mixed-text-file
        "fonts.conf"
        "<?xml version='1.0'?>
 <!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
-<fontconfig>
-  <dir>~/.guix-home/profile/share/fonts</dir>
-</fontconfig>"))))
+<fontconfig>\n"
+       (serialize-configuration user-config home-fontconfig-configuration-fields)
+       "</fontconfig>\n"))))
 
 (define (regenerate-font-cache-gexp _)
   `(("profile/share/fonts"
@@ -49,6 +138,8 @@ (define (regenerate-font-cache-gexp _)
 
 (define home-fontconfig-service-type
   (service-type (name 'home-fontconfig)
+                (compose identity)
+                (extend home-fontconfig-extend)
                 (extensions
                  (list (service-extension
                         home-xdg-configuration-files-service-type
@@ -59,7 +150,7 @@ (define home-fontconfig-service-type
                        (service-extension
                         home-profile-service-type
                         (const (list fontconfig)))))
-                (default-value #f)
+                (default-value (home-fontconfig-configuration))
                 (description
                  "Provides configuration file for fontconfig and make
 fc-* utilities aware of font packages installed in Guix Home's profile.")))
-- 
2.37.3





Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 26 Sep 2022 18:19:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Sep 26 14:19:41 2022
Received: from localhost ([127.0.0.1]:51726 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ocshg-0003XU-OD
	for submit <at> debbugs.gnu.org; Mon, 26 Sep 2022 14:19:40 -0400
Received: from mail-ed1-f68.google.com ([209.85.208.68]:43811)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <liliana.prikler@HIDDEN>) id 1ocshc-0003XD-Lg
 for 57963 <at> debbugs.gnu.org; Mon, 26 Sep 2022 14:19:39 -0400
Received: by mail-ed1-f68.google.com with SMTP id y8so10184008edc.10
 for <57963 <at> debbugs.gnu.org>; Mon, 26 Sep 2022 11:19:36 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:from:to:cc:subject
 :date; bh=yGpqYs9gUvuMKhnAwUUDTp4xyckBNnRet3QLc15LD3I=;
 b=ji72TlDviOR7R4REXCdY8bCMFFtCD4Bx2EMWUxHunCQ5M/cAjBKVDhv1pokOk8Yken
 Ys3uQMIsViKk4FIbCjI8q2i2IAl927c5CAYVImMozM/C0UlF6CK1AmIuqZS2KLGqj5lm
 H9zvSrKPWmEe4Utom3Wyw7TveCmpi86pghO6z2weqNl5nSRpX+VQTTs+XkeXl8B9+JqF
 QVSW/DfEo5B5EaoRFOZkEhgmaN8CK8tdOPco5QhbQPohkJTNw8jFG1wl2pL0E2U4m97b
 2sTd/tipj6OxzLlf3JLp+geJADbAbEGOVdW2nWt4nVOGcGCzVjkmisdpDCdYNv9xZLka
 y4vQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:x-gm-message-state
 :from:to:cc:subject:date;
 bh=yGpqYs9gUvuMKhnAwUUDTp4xyckBNnRet3QLc15LD3I=;
 b=AooeQCBagcHMBkHkO18pvSro6zqnyq0D4FIiwNR6uGdLQUzzy5okhxADOG0YPvxBhy
 OmuRpWZKExC3M/+8j1MVxgKnexGwrhBluoeb8Q2EZ6in4rQn07jJlqjah1JBbv9XyH3k
 fm0aPjHr0659AIF0JmY55pwvvysG8x74abUmlABvQWYKp7N9owCIKOaQZ0mwZeAiXw63
 QqQ73Uqd1zl+fpKnobSIrtOK6aBypCuNc5ff/97A0FhXUY149scm/zGBw/kItISIt8YN
 PPDHWYWHHKSV2CORBUUuOQ/+p40MSA1FOpzUbLYjDqHHckPTlnWkV1SsqC6BKHltR7Oy
 hiCA==
X-Gm-Message-State: ACrzQf1U8btENXrx1CLy67yFw8UHTHRGFi1PQCz+a8IuOR6h6mj+kQj5
 DoCJXW/aRaTHhgmni7tbwJQ=
X-Google-Smtp-Source: AMsMyM4jZpjDLGocwBrcq+QgMs58c3A7+HUUiDMC/Dg22e11BAYlpu7RQPmb51uWHzzlz5pVEDdQqw==
X-Received: by 2002:aa7:c617:0:b0:457:2d14:dc5e with SMTP id
 h23-20020aa7c617000000b004572d14dc5emr8778650edq.408.1664216370680; 
 Mon, 26 Sep 2022 11:19:30 -0700 (PDT)
Received: from lumine.fritz.box (85-127-52-93.dsl.dynamic.surfer.at.
 [85.127.52.93]) by smtp.gmail.com with ESMTPSA id
 r11-20020a170906c28b00b0073d9630cbafsm8472813ejz.126.2022.09.26.11.19.29
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Mon, 26 Sep 2022 11:19:30 -0700 (PDT)
Message-ID: <9e0c997b246e80e66d1b48b44150761aa5e8b634.camel@HIDDEN>
Subject: Re: bug#57963: [PATCH 0/1] Support user's fontconfig.
From: Liliana Marie Prikler <liliana.prikler@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>
Date: Mon, 26 Sep 2022 20:19:29 +0200
In-Reply-To: <87zgemrjub.fsf@HIDDEN>
References: <20220921002721.23511-1-higashi@HIDDEN>
 <20220922012033.30835-1-higashi@HIDDEN> <87pmfoq6kt.fsf@HIDDEN>
 <87sfkjiyck.fsf@HIDDEN> <875yhfwxe9.fsf@HIDDEN>
 <871qs093dq.fsf_-_@HIDDEN> <87edw0v0qk.fsf@HIDDEN>
 <0fdb0df07f50700454bf34cbb0d86c46bb9afe79.camel@HIDDEN>
 <87leq7ud1s.fsf@HIDDEN>
 <bfa2b7d3fccafadfe6c436c850cb29ddaf46f313.camel@HIDDEN>
 <87zgemrjub.fsf@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: base64
User-Agent: Evolution 3.46.0 
MIME-Version: 1.0
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: Ludovic =?ISO-8859-1?Q?Court=E8s?= <ludo@HIDDEN>, 57963 <at> debbugs.gnu.org,
 Andrew Tropin <andrew@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)
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Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 26 Sep 2022 01:43:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 25 21:43:55 2022
Received: from localhost ([127.0.0.1]:48791 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ocdA2-0005cc-Mc
	for submit <at> debbugs.gnu.org; Sun, 25 Sep 2022 21:43:55 -0400
Received: from mail-pf1-f177.google.com ([209.85.210.177]:37455)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1ocdA0-0005cP-5S
 for 57963 <at> debbugs.gnu.org; Sun, 25 Sep 2022 21:43:53 -0400
Received: by mail-pf1-f177.google.com with SMTP id a80so5252751pfa.4
 for <57963 <at> debbugs.gnu.org>; Sun, 25 Sep 2022 18:43:52 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:from:to:cc:subject
 :date; bh=IyEzSsNznz9Ua3L/xvQHGN5/5vBlQd8uBcCLO3DMLJY=;
 b=5gPVD0yNLzxZXCi/ApQ7pGvsfZz/g8j0oFpyKFKl0SXApuRM2MfT1fE+00+iRf5n5x
 LqgcfUzc87HunhBA4e522qX3aSTPhGEB4vGROnmxz8DQXlz3dTl1nYfy32AbiCWqj0nJ
 UYPoupcEsBbTOR37a1SVkYdxG/SiBrAW4KJzDK0cvGE0Raa+QP7SapGSOsAQ0buHIaja
 LtR0es+riIcyp6tKpNrPGp8Wfv4pLAhvbzcB6xxJ19W8D/zHkYdp2LT8Ajv/92jylT8x
 aACpY6YSn9beNp+cBNWLvcwQT/1L5vjBA1mQL5Oh7A0HI2FqdhW81+3/Vb55KQwoaC1E
 6oUw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:x-gm-message-state
 :from:to:cc:subject:date;
 bh=IyEzSsNznz9Ua3L/xvQHGN5/5vBlQd8uBcCLO3DMLJY=;
 b=alnG/MBYVXSE7Vk/Hosvauj0AsQU9xNlpnaCRJrPI0pLizyo0s4z8UFVDgPQrr1xk6
 l4teCNjIpcK8I/buFyTYtW1ayy8OvnopxmACCbiJdm2mnx74H6ocy2m/RbRVX6fRSHGw
 +ECzsj2MnwYkbzG6z8e1XldquluvFTdjIOxa6auBpnQ+awesh3MUeUjLLfwBxptV6f3R
 DYJsSq/BXSmnte9qmJmBgbFufhUoWWu1v3JViSYbyvQrAEuh7nyEPrKojT23v5nvS6N2
 wUl21Uf8Y41tNfBp5XtzKB4bMobODEKRhu0Ct/T1pd8JFQx8ca3S97DGsa6rH59tkpvl
 AJpQ==
X-Gm-Message-State: ACrzQf3AW42ZCSmQS2P6a4UI7/D6t5tra8QHqP8Gux2YSRKBQdSueqM7
 yZdwhji0uS5ac/Xhp7/QY5lEm9W6uK0DQCKq
X-Google-Smtp-Source: AMsMyM5N3CWOhj0Jgj8TIc0B5LQ4vzZTmxtNZGLmLgh6X0HdK2itwi+pX/5+1XsjqCWggjjl/t4XEw==
X-Received: by 2002:a63:5266:0:b0:439:920b:fc65 with SMTP id
 s38-20020a635266000000b00439920bfc65mr17681260pgl.417.1664156626005; 
 Sun, 25 Sep 2022 18:43:46 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 z25-20020aa79599000000b005361f6a0573sm10606718pfj.44.2022.09.25.18.43.42
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sun, 25 Sep 2022 18:43:44 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Liliana Marie Prikler <liliana.prikler@HIDDEN>
Subject: Re: bug#57963: [PATCH 0/1] Support user's fontconfig.
References: <20220921002721.23511-1-higashi@HIDDEN>
 <20220922012033.30835-1-higashi@HIDDEN> <87pmfoq6kt.fsf@HIDDEN>
 <87sfkjiyck.fsf@HIDDEN> <875yhfwxe9.fsf@HIDDEN>
 <871qs093dq.fsf_-_@HIDDEN> <87edw0v0qk.fsf@HIDDEN>
 <0fdb0df07f50700454bf34cbb0d86c46bb9afe79.camel@HIDDEN>
 <87leq7ud1s.fsf@HIDDEN>
 <bfa2b7d3fccafadfe6c436c850cb29ddaf46f313.camel@HIDDEN>
Date: Mon, 26 Sep 2022 10:43:40 +0900
In-Reply-To: <bfa2b7d3fccafadfe6c436c850cb29ddaf46f313.camel@HIDDEN>
 (Liliana Marie Prikler's message of "Sun, 25 Sep 2022 17:50:00 +0200")
Message-ID: <87zgemrjub.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: Ludovic =?iso-8859-1?Q?Court=E8s?= <ludo@HIDDEN>, 57963 <at> debbugs.gnu.org,
 Andrew Tropin <andrew@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Liliana Marie Prikler <liliana.prikler@HIDDEN> writes:

> Am Sonntag, dem 25.09.2022 um 16:29 +0900 schrieb Taiju HIGASHI:
>> Liliana Marie Prikler <liliana.prikler@HIDDEN> writes:
>>
>> > Am Sonntag, dem 25.09.2022 um 07:58 +0900 schrieb Taiju HIGASHI:
>> > > Ludovic Court=C3=A8s <ludo@HIDDEN> writes:
>> > >
>> > > > Anyway, it does look like your v2 is the way to go, with the
>> > > > obvious caveat that using it is tricky: one needs to know about
>> > > > fontconfig=E2=80=99s config file format and about sxml.
>> > > >
>> > > > Maybe we can go with v2 for now (it provides a useful =E2=80=9Cesc=
ape
>> > > > hatch=E2=80=9D) but prepare for more conventional configuration
>> > > > bindings?
>> > >
>> > > By conventional configuration binding, do you mean adding
>> > > something
>> > > like home-fontconfig-configuration to provide a dedicated
>> > > fontconfig
>> > > configuration?
>> > I think Ludo means that we should provide the most useful options
>> > (like the fontconfig dirs) as dedicated record fields, while
>> > leaving an "extra-config" escape hatch, that can be used with SXML
>> > or a raw string for stuff that's too complicated (my personal
>> > preference would still be SXML over the raw string, but YMMV).
>>
>> I see.=C2=A0 For example,
>>
>> For example, would it be as follows?
>>
>> --8<---------------cut here---------------start------------->8---
>> (service home-fontconfig-service-type
>> =C2=A0 (home-fontconfig-configuration
>> =C2=A0=C2=A0=C2=A0 (dir "~/.config/fontconfig/my-fonts1.conf"))
>> =C2=A0 (extra-config
>> =C2=A0=C2=A0=C2=A0 (list
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 "<dir>~/.config/fontconfig/my-fonts2.conf=
")))
>> --8<---------------cut here---------------end--------------->8---
> Since you can specify more than one dir, that'd be "dirs" or even
> something more helpful like "font-directories".  Note that those are
> directories and not config files.
>
> You corrected the extra-config thing in your reply, but also be aware
> of the extra-config as SXML option.
>
>>
>> > > I have been reading the DTD and think it might be a bit of a
>> > > challenge.
>> > > https://github.com/freedesktop/fontconfig/blob/e291fda7d42e5d6437955=
5097a066d9c2c4efce3/fonts.dtd
>> > >
>> > > However, I did notice one thing, and that is that there is an
>> > > include element.=C2=A0 I thought that if we had a configuration where
>> > > the include element could be added, we could handle most of the
>> > > use cases.  What do you think of this idea?
>> > I'd prefer extra-config over include =E2=80=93 extra-config doesn't ne=
ed to
>> > go through file-like objects and an additional layer of G-
>> > Expression quoting.
>> >
>> > Cheers
>>
>> It is difficult to determine which rules to define as records, but I
>> thought that if I only had includes, I could handle most use cases.
> Go for the obvious low-hanging fruits and typical use cases first.
> Don't just add a field that requires a depth of 3 or more to be useful.
>
>> For example, we assume that you will be able to write settings as
>> follows:
>>
>> --8<---------------cut here---------------start------------->8---
>> (service home-fontconfig-service-type
>> =C2=A0 (home-fontconfig-configuration
>> =C2=A0=C2=A0=C2=A0 (includes
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (list
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (include
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (path "~/.config/=
fontconfig/my-fonts1.conf")
>> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (ignore-missing #=
t))))))
>> --8<---------------cut here---------------end--------------->8---
>>
>> ref:
>> https://github.com/freedesktop/fontconfig/blob/e291fda7d42e5d64379555097=
a066d9c2c4efce3/fonts.dtd#L59-L74
>>
>> Would it also fit with your assumption if we could also specify
>> extra-config here?
>>
>> It is difficult to judge whether the ability to specify includes is
>> useful or not, though, since extra-config alone will do the job.
> Except for possibly some fringe use cases, include will be pointless if
> you have extra-config, which is a better include :)
>
> Cheers

I have designed a configuration interface with a typical font
configuration pattern. (it implemented yet.)

--8<---------------cut here---------------start------------->8---
(service home-fontconfig-service-type
         (home-fontconfig-configuration
          (font-directories
           (list "~/fonts"))
          (prefered-default-font
           (sans-serif "Noto Sans CJK JP")
           (serif "Noto Serif CJK JP")
           (monospace "PlemolJP Console"))
          (extra-config ; Also accepts lists of XML strings.
           `((match (@ (target font))
                    (edit (@ (mode assign)
                             (name antialias))
                          (bool true)))))))
--8<---------------cut here---------------end--------------->8---

This is assumed to be serialized below. (actually, it not pretty-printed.)

--8<---------------cut here---------------start------------->8---
<?xml version=3D'1.0'?>
<!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
<fontconfig>
  <dir>~/.guix-home/profile/share/fonts</dir>
  <dir>~/fonts</dir>
  <alias>
    <family>sans-serif</family>
    <prefer>
      <family>Noto Sans CJK JP</family>
    </prefer>
  </alias>
  <alias>
    <family>serif</family>
    <prefer>
      <family>Noto Serif CJK JP</family>
    </prefer>
  </alias>
  <alias>
    <family>monospace</family>
    <prefer>
      <family>PlemolJP Console</family>
    </prefer>
  </alias>
  <match target=3D"font">
    <edit mode=3D"assign" name=3D"antialias">
      <bool>true</bool>
    </edit>
  </match>
</fontconfig>
--8<---------------cut here---------------end--------------->8---

How about this?

--=20
Cheers
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 25 Sep 2022 15:50:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 25 11:50:12 2022
Received: from localhost ([127.0.0.1]:48380 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ocTtU-0002xf-4e
	for submit <at> debbugs.gnu.org; Sun, 25 Sep 2022 11:50:12 -0400
Received: from mail-ed1-f66.google.com ([209.85.208.66]:37383)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <liliana.prikler@HIDDEN>) id 1ocTtR-0002xP-8C
 for 57963 <at> debbugs.gnu.org; Sun, 25 Sep 2022 11:50:11 -0400
Received: by mail-ed1-f66.google.com with SMTP id a41so6064527edf.4
 for <57963 <at> debbugs.gnu.org>; Sun, 25 Sep 2022 08:50:09 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:from:to:cc:subject
 :date; bh=ja4YOiToIrAmYSDMz82xgeB7EYr1jvn2jlGFl2z9hJk=;
 b=hSP8gpSnsIbZtxxNl/XsXiOKveLJbW7KZNfJVhnlSguGOHj50typnncQuAzU7EuGHT
 gaqAl6sQwrbw86gqArdEuvyB0fUy24SBqD+t3glIUrAEL4+UKBRv9j1jfqS8IuxFcPcN
 cShtgXxcVqi9h57kZCXjUMlaQJiSN032G9sqz7YYBCgJgyC+IZcuoG+n5Lxd96TwvNkZ
 c1bt6X01b7xNSp/dkrMV32+RBpuVYAKnRDDveAQefWfTo5YfogQ2XUK2qtOIBhj8m76i
 faWV29IOf8Dst1+qnUx+JXQZHy7xKSMFx50XWyv1fGTXW+0vyrW4ihQWL3HIUrhWNIKq
 KikA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:x-gm-message-state
 :from:to:cc:subject:date;
 bh=ja4YOiToIrAmYSDMz82xgeB7EYr1jvn2jlGFl2z9hJk=;
 b=knmuRewfX75NhwxqQB+2K+5ql7lFqpQh2B4xSG5y6eUZZzi4Bf398oXg1DRbxTBMoT
 6BTclUE7MwWzXLtsZh44LhKEMJZptEEYhenB44Uc4ud6Iz/rH0Nx5OGFmsXEMaMeg46/
 0VlUmHeX0rCcDDpjWo47q2GaOnGJEUcKpD8EHNSaVNSQi6qMitA0ugJ5jzsjlap5VdZl
 szY3jlDtn6iEu4r2igzmVPteCmVFRYRHzqswmAHjbeClZPMX2zxf20uTrWf2U92fEBC9
 cUckRijckH+peaxBcDsKVX26KgRTrJ2vWIAYPf/6rt4wutr9A/3BHWxCiEZi/te2SkSx
 q7Lg==
X-Gm-Message-State: ACrzQf2bI3WwooIVILX8euh5nHceqVhQoilDeHgkDxCancEtHFbeouRO
 +eASf8QpZKoUaTlN0cLv5QM=
X-Google-Smtp-Source: AMsMyM58SHxRpDTvFxACsYU2vhLOk1JlwJI2KX/lC6a5mLiYo7XJngIvsIVkNW82RnkClgwuYn0vYg==
X-Received: by 2002:a05:6402:849:b0:453:10c3:2ee3 with SMTP id
 b9-20020a056402084900b0045310c32ee3mr18495862edz.339.1664121002316; 
 Sun, 25 Sep 2022 08:50:02 -0700 (PDT)
Received: from lumine.fritz.box (85-127-52-93.dsl.dynamic.surfer.at.
 [85.127.52.93]) by smtp.gmail.com with ESMTPSA id
 b20-20020a17090630d400b007262a5e2204sm6934989ejb.153.2022.09.25.08.50.01
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sun, 25 Sep 2022 08:50:01 -0700 (PDT)
Message-ID: <bfa2b7d3fccafadfe6c436c850cb29ddaf46f313.camel@HIDDEN>
Subject: Re: bug#57963: [PATCH 0/1] Support user's fontconfig.
From: Liliana Marie Prikler <liliana.prikler@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>
Date: Sun, 25 Sep 2022 17:50:00 +0200
In-Reply-To: <87leq7ud1s.fsf@HIDDEN>
References: <20220921002721.23511-1-higashi@HIDDEN>
 <20220922012033.30835-1-higashi@HIDDEN> <87pmfoq6kt.fsf@HIDDEN>
 <87sfkjiyck.fsf@HIDDEN> <875yhfwxe9.fsf@HIDDEN>
 <871qs093dq.fsf_-_@HIDDEN> <87edw0v0qk.fsf@HIDDEN>
 <0fdb0df07f50700454bf34cbb0d86c46bb9afe79.camel@HIDDEN>
 <87leq7ud1s.fsf@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
User-Agent: Evolution 3.46.0 
MIME-Version: 1.0
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: Ludovic =?ISO-8859-1?Q?Court=E8s?= <ludo@HIDDEN>, 57963 <at> debbugs.gnu.org,
 Andrew Tropin <andrew@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Am Sonntag, dem 25.09.2022 um 16:29 +0900 schrieb Taiju HIGASHI:
> Liliana Marie Prikler <liliana.prikler@HIDDEN> writes:
>=20
> > Am Sonntag, dem 25.09.2022 um 07:58 +0900 schrieb Taiju HIGASHI:
> > > Ludovic Court=C3=A8s <ludo@HIDDEN> writes:
> > >=20
> > > > Anyway, it does look like your v2 is the way to go, with the
> > > > obvious caveat that using it is tricky: one needs to know about
> > > > fontconfig=E2=80=99s config file format and about sxml.
> > > >=20
> > > > Maybe we can go with v2 for now (it provides a useful =E2=80=9Cesca=
pe
> > > > hatch=E2=80=9D) but prepare for more conventional configuration
> > > > bindings?
> > >=20
> > > By conventional configuration binding, do you mean adding
> > > something
> > > like home-fontconfig-configuration to provide a dedicated=C2=A0
> > > fontconfig
> > > configuration?
> > I think Ludo means that we should provide the most useful options
> > (like the fontconfig dirs) as dedicated record fields, while
> > leaving an "extra-config" escape hatch, that can be used with SXML
> > or a raw string for stuff that's too complicated (my personal
> > preference would still be SXML over the raw string, but YMMV).
>=20
> I see.=C2=A0 For example,
>=20
> For example, would it be as follows?
>=20
> --8<---------------cut here---------------start------------->8---
> (service home-fontconfig-service-type
> =C2=A0 (home-fontconfig-configuration
> =C2=A0=C2=A0=C2=A0 (dir "~/.config/fontconfig/my-fonts1.conf"))
> =C2=A0 (extra-config
> =C2=A0=C2=A0=C2=A0 (list
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 "<dir>~/.config/fontconfig/my-fonts2.conf"=
)))
> --8<---------------cut here---------------end--------------->8---
Since you can specify more than one dir, that'd be "dirs" or even
something more helpful like "font-directories".  Note that those are
directories and not config files.

You corrected the extra-config thing in your reply, but also be aware
of the extra-config as SXML option.

>=20
> > > I have been reading the DTD and think it might be a bit of a
> > > challenge.
> > > https://github.com/freedesktop/fontconfig/blob/e291fda7d42e5d64379555=
097a066d9c2c4efce3/fonts.dtd
> > >=20
> > > However, I did notice one thing, and that is that there is an
> > > include element.=C2=A0 I thought that if we had a configuration where
> > > the include element could be added, we could handle most of the
> > > use cases.  What do you think of this idea?
> > I'd prefer extra-config over include =E2=80=93 extra-config doesn't nee=
d to
> > go through file-like objects and an additional layer of G-
> > Expression quoting.
> >=20
> > Cheers
>=20
> It is difficult to determine which rules to define as records, but I
> thought that if I only had includes, I could handle most use cases.
Go for the obvious low-hanging fruits and typical use cases first.=20
Don't just add a field that requires a depth of 3 or more to be useful.

> For example, we assume that you will be able to write settings as
> follows:
>=20
> --8<---------------cut here---------------start------------->8---
> (service home-fontconfig-service-type
> =C2=A0 (home-fontconfig-configuration
> =C2=A0=C2=A0=C2=A0 (includes
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (list
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (include
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (path "~/.config/f=
ontconfig/my-fonts1.conf")
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (ignore-missing #t=
))))))
> --8<---------------cut here---------------end--------------->8---
>=20
> ref:
> https://github.com/freedesktop/fontconfig/blob/e291fda7d42e5d64379555097a=
066d9c2c4efce3/fonts.dtd#L59-L74
>=20
> Would it also fit with your assumption if we could also specify
> extra-config here?
>=20
> It is difficult to judge whether the ability to specify includes is
> useful or not, though, since extra-config alone will do the job.
Except for possibly some fringe use cases, include will be pointless if
you have extra-config, which is a better include :)

Cheers




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 25 Sep 2022 07:34:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 25 03:34:36 2022
Received: from localhost ([127.0.0.1]:45767 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ocM9r-00025l-TZ
	for submit <at> debbugs.gnu.org; Sun, 25 Sep 2022 03:34:36 -0400
Received: from mail-pj1-f52.google.com ([209.85.216.52]:34730)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1ocM9l-00025S-In
 for 57963 <at> debbugs.gnu.org; Sun, 25 Sep 2022 03:34:34 -0400
Received: by mail-pj1-f52.google.com with SMTP id
 a5-20020a17090aa50500b002008eeb040eso10478351pjq.1
 for <57963 <at> debbugs.gnu.org>; Sun, 25 Sep 2022 00:34:29 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:from:to:cc:subject
 :date; bh=+VPWIpU/6IMrda+EfilhqAxsCJJRHbFXEImL5RK7RoI=;
 b=7taMKx8heD9NJqvmnSVY2eHSP5eHQOYKrTwXilRee0D2QqoNcDpjj8XhvIcKhK/kap
 9vsKYMfsCkivEKM81MORCy2BvZdgGm6c13UCDLEGHmPxsxDfwRDfydlXdV++Qb4RhB0h
 RRei/zsfuxXoO73nbat9t0A/vlpuBRel99T334qo6/k4z2zanoirmVP/o/PCRNsfHcHT
 JKuqUbkNgCUvXQrTfTbquL0NuWvjKjFB8qGQ3SJjUvSiHYcu3O7JOWPh74VFMaAHv6iB
 kls4QUeozobwsvWRHfpiXQxx3C1G+WB8RZLna9tbAcZGYNaHAPGptuPLpIYbO1G9VHx+
 GP5Q==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:x-gm-message-state
 :from:to:cc:subject:date;
 bh=+VPWIpU/6IMrda+EfilhqAxsCJJRHbFXEImL5RK7RoI=;
 b=jjTxfFlUFo+r65mSHf8UVimoxBXfm2GNp/pf7I+BmE1ykmWj/XDqrQifsYkFt/WEQW
 E94RyoTDzr7iL184LTsovAly1PyEKQW+g4rVSikRFVVkiPu0hEVvtiG4uN4nvGsKvGi0
 85uHY6B3zEoPGhf1FXYqUhTqzzao69AEwG8tsq5uTrK0j8/5GrSDOf6UKX2jogl7+dNB
 lp7ga7Oxrt9RkcI41+6UkODFR31UPStqOC6DGkD0PoBBihs58dgcFqNV1znCt5TywzmE
 prVkjCseKkfM/+boa+tGDzsdVTpc6tjvJ/kfPQXbxGm6GZ3gSSkyzncAqW6PWs42nnli
 gvWw==
X-Gm-Message-State: ACrzQf3xMqGsDLt25jGibjGhznJFL4X8/3aPSSshcaBjBH7C/oiKLDOd
 vTmi+v5iya/fLWsnDtAPzIhLyg6JX5n5FTFJ
X-Google-Smtp-Source: AMsMyM7Klo75C/nZ+EglK0uilFdLJbiMTmzNT5labjzlhhnqYbjnbONCCc8r94ycqw98CBp2qv6gnw==
X-Received: by 2002:a17:90b:4d8a:b0:205:a847:d8ba with SMTP id
 oj10-20020a17090b4d8a00b00205a847d8bamr3531067pjb.93.1664091263845; 
 Sun, 25 Sep 2022 00:34:23 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 f17-20020a170902ce9100b001786b712bf7sm8905764plg.151.2022.09.25.00.34.22
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sun, 25 Sep 2022 00:34:23 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Liliana Marie Prikler <liliana.prikler@HIDDEN>
Subject: Re: bug#57963: [PATCH 0/1] Support user's fontconfig.
References: <20220921002721.23511-1-higashi@HIDDEN>
 <20220922012033.30835-1-higashi@HIDDEN> <87pmfoq6kt.fsf@HIDDEN>
 <87sfkjiyck.fsf@HIDDEN> <875yhfwxe9.fsf@HIDDEN>
 <871qs093dq.fsf_-_@HIDDEN> <87edw0v0qk.fsf@HIDDEN>
 <0fdb0df07f50700454bf34cbb0d86c46bb9afe79.camel@HIDDEN>
 <87leq7ud1s.fsf@HIDDEN>
Date: Sun, 25 Sep 2022 16:34:20 +0900
In-Reply-To: <87leq7ud1s.fsf@HIDDEN> (Taiju HIGASHI's message of "Sun, 25
 Sep 2022 16:29:51 +0900")
Message-ID: <87bkr3ucub.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: Ludovic =?iso-8859-1?Q?Court=E8s?= <ludo@HIDDEN>, 57963 <at> debbugs.gnu.org,
 Andrew Tropin <andrew@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Taiju HIGASHI <higashi@HIDDEN> writes:

> Liliana Marie Prikler <liliana.prikler@HIDDEN> writes:
>
>> Am Sonntag, dem 25.09.2022 um 07:58 +0900 schrieb Taiju HIGASHI:
>>> Ludovic Court=C3=A8s <ludo@HIDDEN> writes:
>>>
>>> > Anyway, it does look like your v2 is the way to go, with the
>>> > obvious caveat that using it is tricky: one needs to know about
>>> > fontconfig=E2=80=99s config file format and about sxml.
>>> >
>>> > Maybe we can go with v2 for now (it provides a useful =E2=80=9Cescape
>>> > hatch=E2=80=9D) but prepare for more conventional configuration bindi=
ngs?
>>>
>>> By conventional configuration binding, do you mean adding something
>>> like home-fontconfig-configuration to provide a dedicated=C2=A0 fontcon=
fig
>>> configuration?
>> I think Ludo means that we should provide the most useful options (like
>> the fontconfig dirs) as dedicated record fields, while leaving an
>> "extra-config" escape hatch, that can be used with SXML or a raw string
>> for stuff that's too complicated (my personal preference would still be
>> SXML over the raw string, but YMMV).
>
> I see.  For example,
>
> For example, would it be as follows?
>
> (service home-fontconfig-service-type
>   (home-fontconfig-configuration
>     (dir "~/.config/fontconfig/my-fonts1.conf"))
>   (extra-config
>     (list
>       "<dir>~/.config/fontconfig/my-fonts2.conf")))

It was wrong. The following is more correct.

--8<---------------cut here---------------start------------->8---
(service home-fontconfig-service-type
  (home-fontconfig-configuration
    (dirs
      (list "~/.config/fontconfig/my-fonts1.conf"))
    (extra-config
      (list
        "<match>...</match>"))))
--8<---------------cut here---------------end--------------->8---

Thanks,
--=20
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 25 Sep 2022 07:30:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 25 03:30:07 2022
Received: from localhost ([127.0.0.1]:45762 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ocM5X-0001z7-54
	for submit <at> debbugs.gnu.org; Sun, 25 Sep 2022 03:30:07 -0400
Received: from mail-pj1-f41.google.com ([209.85.216.41]:55123)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1ocM5R-0001xE-SN
 for 57963 <at> debbugs.gnu.org; Sun, 25 Sep 2022 03:30:06 -0400
Received: by mail-pj1-f41.google.com with SMTP id y11so3680023pjv.4
 for <57963 <at> debbugs.gnu.org>; Sun, 25 Sep 2022 00:30:01 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:from:to:cc:subject
 :date; bh=yiHRKyg5V5jZ5CkGj+mmWVQe/HoDbcUlRRDbWawN1XU=;
 b=a/9RpbNPj+NMk9LARArE+An7vY7nzInA75stv3ls1oMiLxfUHWhQdRgrxN54UVpfSA
 TYjsvtNTqx9wWRqwP5/SQ8l0qQEY0YIubtQqt3VrmAx+HR1xLA85LHJ1JZP0+Pr+UxTn
 R2XQ/MAH/4GI1RJprcewNDkTY/vpDo6FLy4hLX/eolK4uXujjeSqY4vcp3M/jU+/84cC
 faaFD8Y/Ac7PgBk3wio77wUfhkcvbW2OveDAHr0/9DCKUYIKbDTWZFS1+eFmbPNMtedP
 XwE5mttrrrV5tlImTbrddv/9ylYgAHDf386nd7nuZwoaDAO+qC9DtVqBKE0ofQYPoSZa
 BjxA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:x-gm-message-state
 :from:to:cc:subject:date;
 bh=yiHRKyg5V5jZ5CkGj+mmWVQe/HoDbcUlRRDbWawN1XU=;
 b=PO1PhMuHjnpUP/FOAPNeYhjlVRDpMGJlXLUd35cHFER3QtW3t/inKjhU6tEPfDgksa
 uw188ICwFSwO4nJ2yPNCJJPwoY5wj/xzGKv0TWFLDH/rgiqD9P80r7sXPl+yvq6u7W2l
 5M5JgiMznDkjLghf0tJazzF8JRKEKXAWennGTcIAr9hTMXboE+sTwkq62xo1Zy+49oai
 KibH4Acqgi4HC4XMb7kpezytV1qk3qqsp0yTn1bilAWpDmSJvtF0SiUTUE+aJRzL+rmU
 rP376FeoyU88LAI2HRFZQ5Blm8G+x2zlJ7DMWyVG7yQxJZr8+5JvHDU4QAbPVmzicSWk
 5OmQ==
X-Gm-Message-State: ACrzQf2wyLz7065NAGHQvOFgf2wwxhU6yiGqiA8oX53OghtK3ebBiDNG
 ST2mLTiqMGCi3K/tkMVTqpAKc6cba/i0Mgwb
X-Google-Smtp-Source: AMsMyM7RseTE2XoBoMqoq5xPt1ia/vg0PGsRiAh6e51aZj01MkK5Q5+eEWsqWFL6lAPt6yYFWwvdWw==
X-Received: by 2002:a17:90a:2b0c:b0:203:b7b1:2ba2 with SMTP id
 x12-20020a17090a2b0c00b00203b7b12ba2mr18685909pjc.34.1664090995874; 
 Sun, 25 Sep 2022 00:29:55 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 z9-20020a170903018900b00177f4ef7970sm8963840plg.11.2022.09.25.00.29.53
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sun, 25 Sep 2022 00:29:55 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Liliana Marie Prikler <liliana.prikler@HIDDEN>
Subject: Re: bug#57963: [PATCH 0/1] Support user's fontconfig.
References: <20220921002721.23511-1-higashi@HIDDEN>
 <20220922012033.30835-1-higashi@HIDDEN> <87pmfoq6kt.fsf@HIDDEN>
 <87sfkjiyck.fsf@HIDDEN> <875yhfwxe9.fsf@HIDDEN>
 <871qs093dq.fsf_-_@HIDDEN> <87edw0v0qk.fsf@HIDDEN>
 <0fdb0df07f50700454bf34cbb0d86c46bb9afe79.camel@HIDDEN>
Date: Sun, 25 Sep 2022 16:29:51 +0900
In-Reply-To: <0fdb0df07f50700454bf34cbb0d86c46bb9afe79.camel@HIDDEN>
 (Liliana Marie Prikler's message of "Sun, 25 Sep 2022 08:25:25 +0200")
Message-ID: <87leq7ud1s.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: Ludovic =?iso-8859-1?Q?Court=E8s?= <ludo@HIDDEN>, 57963 <at> debbugs.gnu.org,
 Andrew Tropin <andrew@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Liliana Marie Prikler <liliana.prikler@HIDDEN> writes:

> Am Sonntag, dem 25.09.2022 um 07:58 +0900 schrieb Taiju HIGASHI:
>> Ludovic Court=C3=A8s <ludo@HIDDEN> writes:
>>
>> > Anyway, it does look like your v2 is the way to go, with the
>> > obvious caveat that using it is tricky: one needs to know about
>> > fontconfig=E2=80=99s config file format and about sxml.
>> >
>> > Maybe we can go with v2 for now (it provides a useful =E2=80=9Cescape
>> > hatch=E2=80=9D) but prepare for more conventional configuration bindin=
gs?
>>
>> By conventional configuration binding, do you mean adding something
>> like home-fontconfig-configuration to provide a dedicated=C2=A0 fontconf=
ig
>> configuration?
> I think Ludo means that we should provide the most useful options (like
> the fontconfig dirs) as dedicated record fields, while leaving an
> "extra-config" escape hatch, that can be used with SXML or a raw string
> for stuff that's too complicated (my personal preference would still be
> SXML over the raw string, but YMMV).

I see.  For example,

For example, would it be as follows?

--8<---------------cut here---------------start------------->8---
(service home-fontconfig-service-type
  (home-fontconfig-configuration
    (dir "~/.config/fontconfig/my-fonts1.conf"))
  (extra-config
    (list
      "<dir>~/.config/fontconfig/my-fonts2.conf")))
--8<---------------cut here---------------end--------------->8---

>> I have been reading the DTD and think it might be a bit of a
>> challenge.
>> https://github.com/freedesktop/fontconfig/blob/e291fda7d42e5d64379555097=
a066d9c2c4efce3/fonts.dtd
>>
>> However, I did notice one thing, and that is that there is an include
>> element.  I thought that if we had a configuration where the include
>> element could be added, we could handle most of the use cases.
>> What do you think of this idea?
> I'd prefer extra-config over include =E2=80=93 extra-config doesn't need =
to go
> through file-like objects and an additional layer of G-Expression
> quoting.
>
> Cheers

It is difficult to determine which rules to define as records, but I
thought that if I only had includes, I could handle most use cases.

For example, we assume that you will be able to write settings as
follows:

--8<---------------cut here---------------start------------->8---
(service home-fontconfig-service-type
  (home-fontconfig-configuration
    (includes
      (list
        (include
          (path "~/.config/fontconfig/my-fonts1.conf")
          (ignore-missing #t))))))
--8<---------------cut here---------------end--------------->8---

ref: https://github.com/freedesktop/fontconfig/blob/e291fda7d42e5d643795550=
97a066d9c2c4efce3/fonts.dtd#L59-L74

Would it also fit with your assumption if we could also specify
extra-config here?

It is difficult to judge whether the ability to specify includes is
useful or not, though, since extra-config alone will do the job.

Thanks,
--=20
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 25 Sep 2022 06:25:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 25 02:25:36 2022
Received: from localhost ([127.0.0.1]:45709 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ocL55-0000JU-Rb
	for submit <at> debbugs.gnu.org; Sun, 25 Sep 2022 02:25:36 -0400
Received: from mail-ed1-f68.google.com ([209.85.208.68]:42612)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <liliana.prikler@HIDDEN>) id 1ocL52-0000JE-Ge
 for 57963 <at> debbugs.gnu.org; Sun, 25 Sep 2022 02:25:35 -0400
Received: by mail-ed1-f68.google.com with SMTP id u24so5121098edb.9
 for <57963 <at> debbugs.gnu.org>; Sat, 24 Sep 2022 23:25:32 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:from:to:cc:subject
 :date; bh=MNdZQC2WrV3oq7dpI7oEE15mZzkW60VihGSv4bFv9Ic=;
 b=IaKaFxgCJ700CaulyTYa2D4pK4LTtSqYdAZBCUiICf5SIaBJpOCWY5NMyBf0QKrdUw
 VVXBpfROKQiVqd7kx0kstfjL+seezoGHmS/e9pElCx0gXCMx6eUczu4AYYR/cgeXUlt9
 7X1h4FHrH74QCd1kzX5y4bu/DO6KRw8yWpex39VaesBAp/aECXOLaMEG9SDepKhxJNtM
 6aV8w/5MQePPkOQTbf71ja9JZBKJWeJkyefRs0sZVnX26cRXb9yByw66BgVovg5CIKoF
 c2aXTsrtGLJfgcCTfKQYvW+jyubljycZT3IgYl5VzWA0DXmZq0Fw1D8YwJgoM9/CdQWa
 sGUw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:content-transfer-encoding:references
 :in-reply-to:date:cc:to:from:subject:message-id:x-gm-message-state
 :from:to:cc:subject:date;
 bh=MNdZQC2WrV3oq7dpI7oEE15mZzkW60VihGSv4bFv9Ic=;
 b=sNvGeulPIHsMMe7vRTBcIfqleCTgGMvJQef+EzrZeTrIVD9hM2M4P+GAqd0bMPqZSX
 6v5F6kWhtNthNcabD5tvr6L/1orECcU4bJEex2BDHucP/y3TBgrpnGVZMS7BavBDkPsw
 DEjdamQU+onboBnkeiOi0mwP2ONyfV34vgK8osO3wkKltbG3FJfZwombIzscAF3zknaR
 953kRhApJtfRXPtNyQDvEz7k8kL1zUphs9LUMpII6g05gNzLa293hr6+1AeTV2sWazKJ
 oACQ4WJpxIs6EpNnfWfmXZPVwEDUITRY6bsy3J6BJgFhVT7hB0txQ5E7y0kCrnDtNBvr
 B7bQ==
X-Gm-Message-State: ACrzQf1Q19ciuNd4K7W4Rg5wJIN3khKYHdTdsLUPT/POc22c9rTlI+NL
 2QQQ6fXUYi/VyexKjtFq6d8=
X-Google-Smtp-Source: AMsMyM5Lywq6qlYbamWQ/eCMeg7kaSqDPxcY3HO/2Cfc9tOpO5I7pUxFqzhjP2YUF6RpfCXfFq0Pzw==
X-Received: by 2002:a05:6402:280f:b0:44e:ee5c:da6b with SMTP id
 h15-20020a056402280f00b0044eee5cda6bmr16431690ede.256.1664087126462; 
 Sat, 24 Sep 2022 23:25:26 -0700 (PDT)
Received: from lumine.fritz.box (85-127-52-93.dsl.dynamic.surfer.at.
 [85.127.52.93]) by smtp.gmail.com with ESMTPSA id
 22-20020a170906311600b007822196378asm5873558ejx.176.2022.09.24.23.25.25
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 24 Sep 2022 23:25:25 -0700 (PDT)
Message-ID: <0fdb0df07f50700454bf34cbb0d86c46bb9afe79.camel@HIDDEN>
Subject: Re: bug#57963: [PATCH 0/1] Support user's fontconfig.
From: Liliana Marie Prikler <liliana.prikler@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>, Ludovic =?ISO-8859-1?Q?Court=E8s?=
 <ludo@HIDDEN>
Date: Sun, 25 Sep 2022 08:25:25 +0200
In-Reply-To: <87edw0v0qk.fsf@HIDDEN>
References: <20220921002721.23511-1-higashi@HIDDEN>
 <20220922012033.30835-1-higashi@HIDDEN> <87pmfoq6kt.fsf@HIDDEN>
 <87sfkjiyck.fsf@HIDDEN> <875yhfwxe9.fsf@HIDDEN>
 <871qs093dq.fsf_-_@HIDDEN> <87edw0v0qk.fsf@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
User-Agent: Evolution 3.46.0 
MIME-Version: 1.0
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, Andrew Tropin <andrew@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Am Sonntag, dem 25.09.2022 um 07:58 +0900 schrieb Taiju HIGASHI:
> Ludovic Court=C3=A8s <ludo@HIDDEN> writes:
>=20
> > Anyway, it does look like your v2 is the way to go, with the
> > obvious caveat that using it is tricky: one needs to know about
> > fontconfig=E2=80=99s config file format and about sxml.
> >=20
> > Maybe we can go with v2 for now (it provides a useful =E2=80=9Cescape
> > hatch=E2=80=9D) but prepare for more conventional configuration binding=
s?
>=20
> By conventional configuration binding, do you mean adding something
> like home-fontconfig-configuration to provide a dedicated=C2=A0 fontconfi=
g
> configuration?
I think Ludo means that we should provide the most useful options (like
the fontconfig dirs) as dedicated record fields, while leaving an
"extra-config" escape hatch, that can be used with SXML or a raw string
for stuff that's too complicated (my personal preference would still be
SXML over the raw string, but YMMV).

> I have been reading the DTD and think it might be a bit of a
> challenge.
> https://github.com/freedesktop/fontconfig/blob/e291fda7d42e5d64379555097a=
066d9c2c4efce3/fonts.dtd
>=20
> However, I did notice one thing, and that is that there is an include
> element.  I thought that if we had a configuration where the include
> element could be added, we could handle most of the use cases.
> What do you think of this idea?
I'd prefer extra-config over include =E2=80=93 extra-config doesn't need to=
 go
through file-like objects and an additional layer of G-Expression
quoting.

Cheers




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 24 Sep 2022 22:58:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Sep 24 18:58:25 2022
Received: from localhost ([127.0.0.1]:45426 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ocE6K-0003DW-TY
	for submit <at> debbugs.gnu.org; Sat, 24 Sep 2022 18:58:25 -0400
Received: from mail-pj1-f42.google.com ([209.85.216.42]:55118)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1ocE6G-0003DI-Rm
 for 57963 <at> debbugs.gnu.org; Sat, 24 Sep 2022 18:58:23 -0400
Received: by mail-pj1-f42.google.com with SMTP id y11so3187157pjv.4
 for <57963 <at> debbugs.gnu.org>; Sat, 24 Sep 2022 15:58:20 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:from:to:cc:subject
 :date; bh=qYP1fh7qvQqvVQYI2pP+Kcrpo98qZ5MxM+Wv60x9NyA=;
 b=PlZpMqUcj8iuoGgExm15LPzv75UcXpVGsbaggSsE+JpaiVIac+w5iiaVogA87g8aCl
 a/AeDLziBl/fPaecojAS/M4pzCAGm3WB5b11SBM52fPvNSso1ZWz/8I/rslwX6Yx1T2J
 fbn2bxI6Ac5wzQdkka1s6sDaPcIYxfKPP1c3gag4jYGkK1MRcUSV/oOjtL9IF1gnMDjY
 1tDYY49AmYDJY55BXBhXvfT+2d3olj7V1CJwxdy8JC0Utgn35acQaThASUygWa/MeAaM
 NKyNshZ4IvBOY3ZlMa07tlEF4lEfBPcDJO3xrgTA5e0+ZBT8HLxvikpP/EAnjc/aEMBG
 qI0Q==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:x-gm-message-state
 :from:to:cc:subject:date;
 bh=qYP1fh7qvQqvVQYI2pP+Kcrpo98qZ5MxM+Wv60x9NyA=;
 b=aYvvlq38+czlCaY1d8WryGRUIXEm4jFVjYQgR68GQKUOlQADuKB4W5dIes9pkPLius
 fgqs5fhytsYDJjbe+GDcs+CdoGb2Wj/5U1/p7dHVzgkqs1P9hpO1O6L0UBhLg0474gao
 0CI3cc6PJ3ueC8nUb3t2Cr6embOxZj33lMJdlXqZWqcKnkNu+TMFrpK1IzzqvONA2onx
 bMr92gQnqV+9TcRvQOa8tS2AZe9uInv4LvBmjWpGc5w2jJ76SeJz2fnSOLnJ28M8Lk5y
 cjjJ1bOlwb9yaDF9NQIkPjNY+59ckJkMNyaCS1DrZO2V1gr0+xUakNwIgDyTABwpIltA
 XAkA==
X-Gm-Message-State: ACrzQf0aEaWkuUf+FAzI7rRxA+aZMpBKR+TbELhd2iRel2d6hu8KOquQ
 RiXZ6336gLirl5qBktqK+pPdhw==
X-Google-Smtp-Source: AMsMyM6hMwYFbpWkIZvIoUqjP91rVqEIdq4ua9uctuSPbzDrmap6PIeaKpH/UFsEsGb4HGr5z6BeFw==
X-Received: by 2002:a17:90b:3147:b0:203:6eaa:4894 with SMTP id
 ip7-20020a17090b314700b002036eaa4894mr29265526pjb.230.1664060294703; 
 Sat, 24 Sep 2022 15:58:14 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 i63-20020a17090a3dc500b001fdcb792181sm3807455pjc.43.2022.09.24.15.58.12
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 24 Sep 2022 15:58:14 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Ludovic =?iso-8859-1?Q?Court=E8s?= <ludo@HIDDEN>
Subject: Re: bug#57963: [PATCH 0/1] Support user's fontconfig.
References: <20220921002721.23511-1-higashi@HIDDEN>
 <20220922012033.30835-1-higashi@HIDDEN> <87pmfoq6kt.fsf@HIDDEN>
 <87sfkjiyck.fsf@HIDDEN> <875yhfwxe9.fsf@HIDDEN>
 <871qs093dq.fsf_-_@HIDDEN>
Date: Sun, 25 Sep 2022 07:58:11 +0900
In-Reply-To: <871qs093dq.fsf_-_@HIDDEN> ("Ludovic =?iso-8859-1?Q?Court=E8?=
 =?iso-8859-1?Q?s=22's?= message of "Sat,
 24 Sep 2022 17:52:01 +0200")
Message-ID: <87edw0v0qk.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, Liliana Marie Prikler <liliana.prikler@HIDDEN>,
 Andrew Tropin <andrew@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Ludovic Court=C3=A8s <ludo@HIDDEN> writes:

> Hi,
>
> Taiju HIGASHI <higashi@HIDDEN> skribis:
>
>> I'm not very knowledgeable about G-Expressions, so I don't understand
>> much of what you replied. (I will study it!).
>
> I didn=E2=80=99t mention gexps.  :-)

Sorry, that comment of mine was in response to Andrew's comment.

>> Ludovic Court=C3=A8s <ludo@HIDDEN> writes:
>> My motivation for writing this patch is that I wanted to continue to use
>> the settings in the following file after switching to Guix Home.
>>
>> https://git.sr.ht/~taiju/taix/tree/31a37c231ebba60e38f7fa9cfe1c7a5d7362d=
021/item/dotfiles/fontconfig/.config/fontconfig/fonts.conf
>>
>> Honestly, I don't know why it is so complicated, but I refered it from
>> the following ArchWiki content.
>>
>> https://wiki.archlinux.org/title/Font_configuration/Examples#Japanese
>>
>> Therefore, just being able to set font aliasing is unfortunately not
>> enough to satisfy my use case.
>
> Oh I see.  Do you need every single bit from the =E2=80=98fonts.conf=E2=
=80=99 file
> above?

There may be some settings that are not needed.

> Anyway, it does look like your v2 is the way to go, with the obvious
> caveat that using it is tricky: one needs to know about fontconfig=E2=80=
=99s
> config file format and about sxml.
>
> Maybe we can go with v2 for now (it provides a useful =E2=80=9Cescape hat=
ch=E2=80=9D)
> but prepare for more conventional configuration bindings?

By conventional configuration binding, do you mean adding something like
home-fontconfig-configuration to provide a dedicated  fontconfig
configuration?

I have been reading the DTD and think it might be a bit of a challenge.
https://github.com/freedesktop/fontconfig/blob/e291fda7d42e5d64379555097a06=
6d9c2c4efce3/fonts.dtd

However, I did notice one thing, and that is that there is an include
element.
I thought that if we had a configuration where the include element could
be added, we could handle most of the use cases.
What do you think of this idea?

Thanks,
--=20
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 24 Sep 2022 15:52:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Sep 24 11:52:11 2022
Received: from localhost ([127.0.0.1]:45016 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oc7Rr-0000J4-AI
	for submit <at> debbugs.gnu.org; Sat, 24 Sep 2022 11:52:11 -0400
Received: from eggs.gnu.org ([209.51.188.92]:58534)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1oc7Ro-0000Il-SK
 for 57963 <at> debbugs.gnu.org; Sat, 24 Sep 2022 11:52:10 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:38076)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ludo@HIDDEN>)
 id 1oc7Rj-0005dg-B1; Sat, 24 Sep 2022 11:52:03 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-Version:In-Reply-To:Date:References:Subject:To:
 From; bh=hILSlAEIsp+ZtoWmiW2qW47xO6Cn7DGJmcUAxQfHE1I=; b=fXgF6NhXurJ3hVR+Ss6T
 5Jjh2hUz+1XKxRcjGbwD2oz+7FPI/uonRlijddC6qGmwdQKW0FfIqN6g/C8vh2eIkwOekrNphJ0cC
 al3Lw/RFCAuY3PzeXNDiVfsPCst3QvW0RV6M5mhjOBNcQYhisIZg15cks+DW0IpXVfj/0FL1eHYpO
 fVDFAHgcN/riZfIv+kcBn405UiPBqhxDKI1bD3qqF4fz3Soy+3ppUTwZzXl0mDnu/2m8NPYySkJzv
 n0FCW9ScIgSVN5c83zwZYjIOploXA4fJfs+pGaqQwRdifdAXWNxw7aTTixe32pTuiBdDIeEyu3rpd
 lZYyRupKjtyFjA==;
Received: from 91-160-117-201.subs.proxad.net ([91.160.117.201]:58752
 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ludo@HIDDEN>)
 id 1oc7Ri-00017X-Tx; Sat, 24 Sep 2022 11:52:03 -0400
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>
Subject: Re: bug#57963: [PATCH 0/1] Support user's fontconfig.
References: <20220921002721.23511-1-higashi@HIDDEN>
 <20220922012033.30835-1-higashi@HIDDEN> <87pmfoq6kt.fsf@HIDDEN>
 <87sfkjiyck.fsf@HIDDEN> <875yhfwxe9.fsf@HIDDEN>
Date: Sat, 24 Sep 2022 17:52:01 +0200
In-Reply-To: <875yhfwxe9.fsf@HIDDEN> (Taiju HIGASHI's message of "Thu, 22
 Sep 2022 18:50:38 +0900")
Message-ID: <871qs093dq.fsf_-_@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, Liliana Marie Prikler <liliana.prikler@HIDDEN>,
 Andrew Tropin <andrew@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi,

Taiju HIGASHI <higashi@HIDDEN> skribis:

> I'm not very knowledgeable about G-Expressions, so I don't understand
> much of what you replied. (I will study it!).

I didn=E2=80=99t mention gexps.  :-)

> Ludovic Court=C3=A8s <ludo@HIDDEN> writes:
> My motivation for writing this patch is that I wanted to continue to use
> the settings in the following file after switching to Guix Home.
>
> https://git.sr.ht/~taiju/taix/tree/31a37c231ebba60e38f7fa9cfe1c7a5d7362d0=
21/item/dotfiles/fontconfig/.config/fontconfig/fonts.conf
>
> Honestly, I don't know why it is so complicated, but I refered it from
> the following ArchWiki content.
>
> https://wiki.archlinux.org/title/Font_configuration/Examples#Japanese
>
> Therefore, just being able to set font aliasing is unfortunately not
> enough to satisfy my use case.

Oh I see.  Do you need every single bit from the =E2=80=98fonts.conf=E2=80=
=99 file
above?

Anyway, it does look like your v2 is the way to go, with the obvious
caveat that using it is tricky: one needs to know about fontconfig=E2=80=99s
config file format and about sxml.

Maybe we can go with v2 for now (it provides a useful =E2=80=9Cescape hatch=
=E2=80=9D)
but prepare for more conventional configuration bindings?

Thanks,
Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 23 Sep 2022 07:20:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 23 03:20:14 2022
Received: from localhost ([127.0.0.1]:39251 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1obcyr-0002Xy-Td
	for submit <at> debbugs.gnu.org; Fri, 23 Sep 2022 03:20:14 -0400
Received: from mailrelay.tugraz.at ([129.27.2.202]:18531)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <liliana.prikler@HIDDEN>) id 1obcyp-0002Xk-CQ
 for 57963 <at> debbugs.gnu.org; Fri, 23 Sep 2022 03:20:12 -0400
Received: from lprikler-laptop.ist.intra (gw.ist.tugraz.at [129.27.202.101])
 by mailrelay.tugraz.at (Postfix) with ESMTPSA id 4MYk7W0rTkz3wXG;
 Fri, 23 Sep 2022 09:20:06 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=tugraz.at;
 s=mailrelay; t=1663917607;
 bh=jweejWx50Zxt/PImzkSZUsfCl2WUCRjtrgTOASkkvG8=;
 h=Subject:From:To:Cc:Date:In-Reply-To:References;
 b=j/lw5/mCM/PcBMUFMyzYFi/8GvRDbzAm/tgE+DfZizc8Je6JQVu/0SLD/rcXYQXvp
 T/PNIp9rMgM6fPeTro5m9dTkidcaMp7ho/U1PKvy/dRqtnrRf1hTc5uA5id2OVJUki
 IDojqj4klfijRjk5/anVwGfb2meY/LlN4IeeQqpg=
Message-ID: <8337bfeb95dffbbe171f706c1fbc36d12658d0f6.camel@HIDDEN>
Subject: Re: [PATCH 1/1] home: fontutils: Support user's fontconfig.
From: Liliana Marie Prikler <liliana.prikler@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>
Date: Fri, 23 Sep 2022 09:20:05 +0200
In-Reply-To: <87leqcw63n.fsf@HIDDEN>
References: <20220921002921.23631-2-higashi@HIDDEN>
 <eb87ef1cd1311448fc57ed045deb8de1311c6322.camel@HIDDEN>
 <871qs5xd30.fsf@HIDDEN>
 <65da0cdb245fe2bcd99589d4fb1a9eb785a1b527.camel@HIDDEN>
 <87leqcw63n.fsf@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
User-Agent: Evolution 3.45.3 
MIME-Version: 1.0
X-TUG-Backscatter-control: waObeELIUl4ypBWmcn/8wQ
X-Spam-Scanner: SpamAssassin 3.003001 
X-Spam-Score-relay: -1.9
X-Scanned-By: MIMEDefang 2.74 on 129.27.10.117
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Am Donnerstag, dem 22.09.2022 um 10:27 +0900 schrieb Taiju HIGASHI:
> I also wrote a test but did not include it in the patch because I
> thought it would be a technical debt.
> I'm attaching that as a reference.
Added tests are always welcome.




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 22 Sep 2022 09:50:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 22 05:50:50 2022
Received: from localhost ([127.0.0.1]:36444 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1obIr3-0002ZV-PY
	for submit <at> debbugs.gnu.org; Thu, 22 Sep 2022 05:50:50 -0400
Received: from mail-pg1-f181.google.com ([209.85.215.181]:39816)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1obIr1-0002ZI-Ug
 for 57963 <at> debbugs.gnu.org; Thu, 22 Sep 2022 05:50:48 -0400
Received: by mail-pg1-f181.google.com with SMTP id b5so456293pgb.6
 for <57963 <at> debbugs.gnu.org>; Thu, 22 Sep 2022 02:50:47 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:from:to:cc:subject
 :date; bh=D4dvu1qaCqOjxj8BT9V6pcem4rjBEAy8fTV5CM4Ttgk=;
 b=pN+FlG0Q3Ov1/1BQFUodRYkWYC+8pcSa9roETY8CaXc43IrUvNgQ8C54sxSB0Xd4Ll
 QA1Wt2dfGyTiZMRhhLshunjsdJ8AswIlv/wHsf41uyHp1oCsAxilaTSIYc8qRPPMiZqK
 NXRi5DtqHtLj0Yi8c2k2BguYEgFcYPyTCV6LC3Ce+WhnRJ+zahPzVscakjHEMQE59UZn
 NypZFf5s1hZw7k5KvwDP+s7mgAwhBNG74U3ci6PFeF7f7Rn7TxaHfWvjpsQJyVwLMxM/
 hGKioSHna3nr6dMGOk4PO2tR4dnZOf+HsuUBzqvPyFyBJLugFN2E/SvvH8klx7nWiWLs
 KW0Q==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:x-gm-message-state
 :from:to:cc:subject:date;
 bh=D4dvu1qaCqOjxj8BT9V6pcem4rjBEAy8fTV5CM4Ttgk=;
 b=O7mDF42o8HbgQlW/rQSboPnVTNF7+Jb2Z+zWzfnlEH4n4XJmEspEFhiAHfvrEtJaJ0
 o5JLqRX9hmd7U+Ii52STJTPaId3ldbDNX0hzwm4n1ZBzioUHC+1UZstSvHH5+rPVGXSh
 DvxHF9XPNhuvU/d5Jsbul6d7kcsLgbkzqoFux7CxmYMYm4cuYucdOo/zF78SO61cltY9
 OdDDbhlitRCLJcOQnk1xDRrPitZx1hmsh/kPPHjiKWpdt3bSpLikcwmfcpEHVHU1P986
 Eoses1gc2JzpQqioEL99j927Nj9neAcdILgSarcKTDDGLU5YlLsvwRlwFoYqk7CTIHsQ
 XSmA==
X-Gm-Message-State: ACrzQf0qoAKkrtnG2KkLPAEm643kXSYqAIQXEoAD/1ZllJVRkGhhloyt
 cXpcBYW3ThRbLzxi/aqQ8mo5yg==
X-Google-Smtp-Source: AMsMyM56d4Ew7WgBqM20m0MtfLSFX5NDtHAFJyhLKT/srOMPS2Mtg/mEaL0YtCj2idFF7odDs+h7sw==
X-Received: by 2002:a63:ff5a:0:b0:42c:61f:b81 with SMTP id
 s26-20020a63ff5a000000b0042c061f0b81mr2308403pgk.254.1663840242001; 
 Thu, 22 Sep 2022 02:50:42 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 17-20020a170902e9d100b001755e4278a6sm3549521plk.261.2022.09.22.02.50.40
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 22 Sep 2022 02:50:41 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Andrew Tropin <andrew@HIDDEN>, Ludovic =?iso-8859-1?Q?Court=E8s?=
 <ludo@HIDDEN>
Subject: Re: [bug#57963] [PATCH v2] home: fontutils: Support user's fontconfig.
References: <20220921002721.23511-1-higashi@HIDDEN>
 <20220922012033.30835-1-higashi@HIDDEN> <87pmfoq6kt.fsf@HIDDEN>
 <87sfkjiyck.fsf@HIDDEN>
Date: Thu, 22 Sep 2022 18:50:38 +0900
In-Reply-To: <87sfkjiyck.fsf@HIDDEN> ("Ludovic =?iso-8859-1?Q?Court=E8s?=
 =?iso-8859-1?Q?=22's?= message of "Thu, 22
 Sep 2022 10:53:47 +0200")
Message-ID: <875yhfwxe9.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, Liliana Marie Prikler <liliana.prikler@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Andrew and Ludovic,

Thanks for your input and background on the code style.

I'm not very knowledgeable about G-Expressions, so I don't understand
much of what you replied. (I will study it!).

Ludovic Court=C3=A8s <ludo@HIDDEN> writes:

> Hi Andrew,
>
> Andrew Tropin <andrew@HIDDEN> skribis:
>
>> 2. We had a discussion with Ludovic about rde home services vs guix home
>> services styles.  And this one looks like rde style, not guix.
>>
>> rde takes arbitrary s-exps and g-exps with optional structure checks and
>> serializes them to target format.
>>
>> guix uses nested records with rigid nesting structure.
>
> That=E2=80=99s generally true, but it=E2=80=99s not black and white and t=
here=E2=80=99s room for
> discussion.  :-)
>
> In this case, Taiju=E2=80=99s proposal is to let users write snippets lik=
e this:
>
>     (define font-family-map
>       '((sans-serif . "Noto Sans CJK JP")
>         (serif . "Noto Serif CJK JP")))
>
>     (home-environment
>      (packages (list font-google-noto))
>      (services
>       (list
>        (simple-service 'my-fontconfig-service
>                        home-fontconfig-service-type
>                        (list
>                         (call-with-output-string
>                           (lambda (port)
>                             (sxml->xml
>                              (map (lambda (pair)
>                                     `(alias
>                                       (family ,(car pair))
>                                       (prefer
>                                        (family ,(cdr pair)))))
>                                   font-family-map)
>                              port))))))))
>
> (With v2 they=E2=80=99d provide SXML instead of XML-in-a-string, so it=E2=
=80=99s
> slightly less verbose but quite similar.)
>
> In this particular case, I would find it easier to use if one could
> provide a set of <font-alias> records, let=E2=80=99s say along these line=
s:
>
>   (simple-service 'my-fontconfig-service
>                   home-fontconfig-service-type
>                   (list (font-alias 'sans-serif "Noto Sans CJK JP") =E2=
=80=A6))
>
> That way, users wouldn=E2=80=99t need to know the details of the XML synt=
ax for
> fontconfig.
>
> The downside is that it restricts what can be done: it lets you add font
> aliases, but nothing more.
>
> Do you have other use cases in mind, Taiju?

My motivation for writing this patch is that I wanted to continue to use
the settings in the following file after switching to Guix Home.

https://git.sr.ht/~taiju/taix/tree/31a37c231ebba60e38f7fa9cfe1c7a5d7362d021=
/item/dotfiles/fontconfig/.config/fontconfig/fonts.conf

Honestly, I don't know why it is so complicated, but I refered it from
the following ArchWiki content.

https://wiki.archlinux.org/title/Font_configuration/Examples#Japanese

Therefore, just being able to set font aliasing is unfortunately not
enough to satisfy my use case.

Thanks,
--
Taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 22 Sep 2022 08:53:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 22 04:53:59 2022
Received: from localhost ([127.0.0.1]:36320 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1obHy3-0007Hq-H0
	for submit <at> debbugs.gnu.org; Thu, 22 Sep 2022 04:53:59 -0400
Received: from eggs.gnu.org ([209.51.188.92]:37694)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1obHy1-0007Hd-Pm
 for 57963 <at> debbugs.gnu.org; Thu, 22 Sep 2022 04:53:59 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:50598)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ludo@HIDDEN>)
 id 1obHxu-00041I-WC; Thu, 22 Sep 2022 04:53:51 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-Version:In-Reply-To:Date:References:Subject:To:
 From; bh=/zlhUtB6Uw9consf16MKCK1Ab7s2tWue51KxkCiGBqY=; b=Ngnsor+Zr67OSdmqRpHN
 Qc4icXZXKE4yJWISCc1ueZpAde3H6abqpTRWDTZlaKspW+eGSgNSOq1RU1Fcx0glxGOItDbs7xFe5
 9cpdk0Is44Lv39USI975F+Ccbus44Z5hNiCh0WKXONt1n7y80ZjG6vBtDuFHfd4UOyp+fQWW9HYW6
 Jjk4sNGJ8SlPQxiOItTMBTLIdbpiHEfl1NVkhoH1ErWt1Xd+X7a0uD8siPumkVDE/6KssgD2emkdf
 AbsnGvf0bJGFWKI8F+TzlrdAsdcCU0DYGSJ0d2OZ5qBimD27lNZMaG0+ydCsdB1Yr02HLlymqJG3c
 9hUwMTOrzQV5fQ==;
Received: from [2001:660:6102:320:e120:2c8f:8909:cdfe] (port=57702 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ludo@HIDDEN>)
 id 1obHxu-0007Hu-Hz; Thu, 22 Sep 2022 04:53:50 -0400
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Andrew Tropin <andrew@HIDDEN>, Taiju HIGASHI <higashi@HIDDEN>
Subject: Re: [bug#57963] [PATCH v2] home: fontutils: Support user's fontconfig.
References: <20220921002721.23511-1-higashi@HIDDEN>
 <20220922012033.30835-1-higashi@HIDDEN> <87pmfoq6kt.fsf@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: Primidi 1 =?utf-8?Q?Vend=C3=A9miaire?= an 231 de la
 =?utf-8?Q?R=C3=A9volution=2C?= jour du Raisin
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Thu, 22 Sep 2022 10:53:47 +0200
In-Reply-To: <87pmfoq6kt.fsf@HIDDEN> (Andrew Tropin's message of "Thu, 22 Sep
 2022 09:14:10 +0300")
Message-ID: <87sfkjiyck.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org, Liliana Marie Prikler <liliana.prikler@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi Andrew,

Andrew Tropin <andrew@HIDDEN> skribis:

> 2. We had a discussion with Ludovic about rde home services vs guix home
> services styles.  And this one looks like rde style, not guix.
>
> rde takes arbitrary s-exps and g-exps with optional structure checks and
> serializes them to target format.
>
> guix uses nested records with rigid nesting structure.

That=E2=80=99s generally true, but it=E2=80=99s not black and white and the=
re=E2=80=99s room for
discussion.  :-)

In this case, Taiju=E2=80=99s proposal is to let users write snippets like =
this:

--8<---------------cut here---------------start------------->8---
    (define font-family-map
      '((sans-serif . "Noto Sans CJK JP")
        (serif . "Noto Serif CJK JP")))

    (home-environment
     (packages (list font-google-noto))
     (services
      (list
       (simple-service 'my-fontconfig-service
                       home-fontconfig-service-type
                       (list
                        (call-with-output-string
                          (lambda (port)
                            (sxml->xml
                             (map (lambda (pair)
                                    `(alias
                                      (family ,(car pair))
                                      (prefer
                                       (family ,(cdr pair)))))
                                  font-family-map)
                             port))))))))
--8<---------------cut here---------------end--------------->8---

(With v2 they=E2=80=99d provide SXML instead of XML-in-a-string, so it=E2=
=80=99s
slightly less verbose but quite similar.)

In this particular case, I would find it easier to use if one could
provide a set of <font-alias> records, let=E2=80=99s say along these lines:

  (simple-service 'my-fontconfig-service
                  home-fontconfig-service-type
                  (list (font-alias 'sans-serif "Noto Sans CJK JP") =E2=80=
=A6))

That way, users wouldn=E2=80=99t need to know the details of the XML syntax=
 for
fontconfig.

The downside is that it restricts what can be done: it lets you add font
aliases, but nothing more.

Do you have other use cases in mind, Taiju?

Thanks,
Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 22 Sep 2022 06:14:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Sep 22 02:14:23 2022
Received: from localhost ([127.0.0.1]:35880 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1obFTb-000748-Do
	for submit <at> debbugs.gnu.org; Thu, 22 Sep 2022 02:14:23 -0400
Received: from relay10.mail.gandi.net ([217.70.178.230]:36431)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <andrew@HIDDEN>) id 1obFTY-00073t-Vg
 for 57963 <at> debbugs.gnu.org; Thu, 22 Sep 2022 02:14:22 -0400
Received: (Authenticated sender: andrew@HIDDEN)
 by mail.gandi.net (Postfix) with ESMTPSA id BBB1E240002;
 Thu, 22 Sep 2022 06:14:13 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=trop.in; s=gm1;
 t=1663827254;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:cc:mime-version:mime-version:content-type:content-type:
 in-reply-to:in-reply-to:references:references;
 bh=6KE27D7zhunqEKYwJfdq8mYnaZw0IQ+DnubKJYfU+L0=;
 b=oSGh3I5vmnxdIUZnU0E4eYAQqKlLqV+v/0sSSEyOgZDtDqvKxwBRhDXP+Gnl8gCZZSjT+g
 F1/KxJV5YB+xt2RLs11VYuOKy3SxWqmfgzzwXJ1pRIBxkswFulPFU6uUEbXKqunkroRuum
 L0D/fyXiCT7KHIVKMNm7EYo2HkCwAcLKaiIbn3FBVmwnHV1PLn/8aV2Jd9btJ3uXG4HIK9
 nLJKjgrMkbNeB75l4mdH1VgMYld3k8xKlNxxgpgGqDOuQUKeAfDuxpuaUjORUXjrPxfkS7
 Jom800iDl9YKR9t/1h3r9/XYINm0Oo8pqiQJHWvovY3M20IzVAuxF5PKN+Xp0w==
From: Andrew Tropin <andrew@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>, 57963 <at> debbugs.gnu.org
Subject: Re: [bug#57963] [PATCH v2] home: fontutils: Support user's fontconfig.
In-Reply-To: <20220922012033.30835-1-higashi@HIDDEN>
References: <20220921002721.23511-1-higashi@HIDDEN>
 <20220922012033.30835-1-higashi@HIDDEN>
Date: Thu, 22 Sep 2022 09:14:10 +0300
Message-ID: <87pmfoq6kt.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: 1.3 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  On 2022-09-22 10:20,
 Taiju HIGASHI wrote: > * gnu/home/services/fontutils.scm
 (add-fontconfig-config-file): Support user's > fontconfig. > --- >
 gnu/home/services/fontutils.scm
 | 29 ++++++++++++++++++++++++----- > 1 file changed, 24 insertion [...] 
 Content analysis details:   (1.3 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.7 RCVD_IN_DNSWL_LOW      RBL: Sender listed at https://www.dnswl.org/,
 low trust [217.70.178.230 listed in list.dnswl.org]
 -0.0 SPF_PASS               SPF: sender matches SPF record
 2.0 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: yoctocell.xyz (xyz)]
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
X-Debbugs-Envelope-To: 57963
Cc: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>,
 Liliana Marie Prikler <liliana.prikler@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.3 (/)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

On 2022-09-22 10:20, Taiju HIGASHI wrote:

> * gnu/home/services/fontutils.scm (add-fontconfig-config-file): Support u=
ser's
> fontconfig.
> ---
>  gnu/home/services/fontutils.scm | 29 ++++++++++++++++++++++++-----
>  1 file changed, 24 insertions(+), 5 deletions(-)
>
> diff --git a/gnu/home/services/fontutils.scm b/gnu/home/services/fontutil=
s.scm
> index 6062eaed6a..b57cccbaae 100644
> --- a/gnu/home/services/fontutils.scm
> +++ b/gnu/home/services/fontutils.scm
> @@ -1,6 +1,7 @@
>  ;;; GNU Guix --- Functional package management for GNU
>  ;;; Copyright =C2=A9 2021 Andrew Tropin <andrew@HIDDEN>
>  ;;; Copyright =C2=A9 2021 Xinglu Chen <public@HIDDEN>
> +;;; Copyright =C2=A9 2022 Taiju HIGASHI <higashi@HIDDEN>
>  ;;;
>  ;;; This file is part of GNU Guix.
>  ;;;
> @@ -21,6 +22,9 @@ (define-module (gnu home services fontutils)
>    #:use-module (gnu home services)
>    #:use-module (gnu packages fontutils)
>    #:use-module (guix gexp)
> +  #:use-module (srfi srfi-1)
> +  #:use-module (sxml simple)
> +  #:use-module (ice-9 match)
>=20=20
>    #:export (home-fontconfig-service-type))
>=20=20
> @@ -33,15 +37,28 @@ (define-module (gnu home services fontutils)
>  ;;;
>  ;;; Code:
>=20=20
> -(define (add-fontconfig-config-file he-symlink-path)
> +(define (parse-extra-user-config extra-user-config)
> +  (map (match-lambda
> +         ((? pair? sxml) sxml)
> +         ((? string? xml) (xml->sxml xml))
> +         (_ (error "extra-user-config must be xml string or sxml.")))
> +       extra-user-config))
> +
> +(define (add-fontconfig-config-file extra-user-config)
>    `(("fontconfig/fonts.conf"
>       ,(mixed-text-file
>         "fonts.conf"
>         "<?xml version=3D'1.0'?>
>  <!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
> -<fontconfig>
> -  <dir>~/.guix-home/profile/share/fonts</dir>
> -</fontconfig>"))))
> +"
> +       (call-with-output-string
> +         (lambda (port)
> +           (sxml->xml
> +            `(fontconfig
> +              (dir "~/.guix-home/profile/share/fonts")
> +              ,@(parse-extra-user-config extra-user-config))
> +            port)
> +           (newline port)))))))
>=20=20
>  (define (regenerate-font-cache-gexp _)
>    `(("profile/share/fonts"
> @@ -49,6 +66,8 @@ (define (regenerate-font-cache-gexp _)
>=20=20
>  (define home-fontconfig-service-type
>    (service-type (name 'home-fontconfig)
> +                (compose concatenate)
> +                (extend append)
>                  (extensions
>                   (list (service-extension
>                          home-xdg-configuration-files-service-type
> @@ -59,7 +78,7 @@ (define home-fontconfig-service-type
>                         (service-extension
>                          home-profile-service-type
>                          (const (list fontconfig)))))
> -                (default-value #f)
> +                (default-value '())
>                  (description
>                   "Provides configuration file for fontconfig and make
>  fc-* utilities aware of font packages installed in Guix Home's profile."=
)))

I like the current approach, but I have two concerns:

1. Serialization happens on client side, not daemon side (during the
build), thus it doesn't support gexp and file-likes, so it would be hard
to append part of already existing file to the config or do similiar thing.

2. We had a discussion with Ludovic about rde home services vs guix home
services styles.  And this one looks like rde style, not guix.

rde takes arbitrary s-exps and g-exps with optional structure checks and
serializes them to target format.

guix uses nested records with rigid nesting structure.

rde services style examples:
https://git.sr.ht/~abcdw/rde/tree/8ec99884fad18a80a08a7c1d6a7cf46a006327c4/=
rde/home/services/wm.scm#L145
https://git.sr.ht/~abcdw/rde/tree/8ec99884fad18a80a08a7c1d6a7cf46a006327c4/=
rde/home/services/xdisorg.scm#L55

guix services style examples:
https://guix.gnu.org/manual/devel/en/guix.html#Web-Services

Related discussions:
https://issues.guix.gnu.org/53466
https://issues.guix.gnu.org/52698
https://yhetil.org/guix-devel/87h79qx5db.fsf@HIDDEN/

To sum up, personally I like and prefer the configuration style from
this patch, but to keep it consistent with guix system services we need
to use guix style.

=2D-=20
Best regards,
Andrew Tropin

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCgAdFiEEKEGaxlA4dEDH6S/6IgjSCVjB3rAFAmMr/TIACgkQIgjSCVjB
3rCDDxAAkwi5UxtFBWaGU+WrzUdSxp5ClXpCM1kfHD8XSI2dMEQJbz7YGXQ7f7MD
hwv7489dQcDkqjwFYr6hTTMyicqemrnhi9OIg2rInp8UO83DwLCkZaJP0KVc8/mH
NpB0IaOn1hNqMjHnsgja79PLGXw+wBVrWOxTSVci3QfMv7DzO5E3abrqEzB6LuYR
xOWprV8r3/WttKLoRQ5LD113WbrDdITUrAa2Cs0yZi+bRdAEqw7jz99riqJukpnb
F2zOj5RZUkWq75cTpHCkg7DnB6iASLbMvKvJXnqYr9Yeja1w4XOmzw4Rf3DVdu15
UdiaUGwyWzuaQh61vxlVFCnJ2RQwaFL0/ClXfNH3L7ORmTbvJJT2FXhly3Nxaebn
koxWOSC2NK+PwV0WfaIoEeefT6l/FGZfhuRavSb6nKlQhgUxAnzwSjCVHGV1a94S
kNsagP23PeVtpN+vtTWdoSCKLW1xzGN8ozbrCTDfOdUiw0m1nNLrHnVgc077gjFZ
zVaQC5cmSXkpvJy7cydEEQC7erIf5BIdfbf94DP2mKmiGb1TmV5g/DY+3GEK//WS
wJiV+AdhaboAOufX9Xd/WI6ruEydHQANIUf7Yl9la05loJLTsCZ7kSsjLHfMJOCD
8QuXnZKn6weoL6YPvpgL8HCbV1WaOOvQ6h0Q5gX6JvFTiUb5Cn8=
=uFxI
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 22 Sep 2022 01:28:10 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 21 21:28:10 2022
Received: from localhost ([127.0.0.1]:35523 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1obB0c-0005Q4-46
	for submit <at> debbugs.gnu.org; Wed, 21 Sep 2022 21:28:10 -0400
Received: from mail-pg1-f179.google.com ([209.85.215.179]:47048)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1obB0Y-0005PX-P9
 for 57963 <at> debbugs.gnu.org; Wed, 21 Sep 2022 21:28:07 -0400
Received: by mail-pg1-f179.google.com with SMTP id 78so7652300pgb.13
 for <57963 <at> debbugs.gnu.org>; Wed, 21 Sep 2022 18:28:06 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:from:to:cc:subject:date;
 bh=z1f3JQHwL3jgd/0xICnyBF+2/k9bcuH1wojBbH9YdLs=;
 b=0YqYpt1x3GtLaSEKV4eZTmzwtte5J3on1gZqiLB5IRDk4U7LO6KJk7hTkyUaUfOOuN
 2ldSFMqoajGc9NfVKQtEXD5vzZZrrinMApEbgXD18WbbJAI1Vje+xTywsBA1T+OKv1sj
 qmwcZsQ2PwzIzLl3INd86yi/nMJ8Pqt7OLQ97QhVW6hItJFPDkv2j7jSDTl5CVtV96YH
 Iav/eOhPS5lYq1p9JhcKpZ8Hh8nMODg+zaXSC0G56tjIlxxYamgXsVqwhyIw1DTNUHZm
 1DGKnzNv9gGrE8Dr294p8XrUspgfPlRieDYpbmSULSmy8sclJR3Ti4ERi6N6JMrBHMee
 iaHw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=mime-version:user-agent:message-id:in-reply-to:date:references
 :subject:cc:to:from:x-gm-message-state:from:to:cc:subject:date;
 bh=z1f3JQHwL3jgd/0xICnyBF+2/k9bcuH1wojBbH9YdLs=;
 b=AynDcsDby1CqpGJ/wGxgRa5x697DnF6OPwGa5Cj21Nm42PBEf5GOpy1lyiCVjr2/DA
 v1a0xgngv4CwvqnofmjAT+zzt5cFR7IAghjhFEATavUJg3lH+cDyqSQKCsRO4NOMmxsR
 ebtyackDf+FuckiPjY2T8s1kLd8K4/5df13N0EO2vt9idyhfd7T1eW3J5zjaQCkT9Rm9
 6EkxD8qHigYpvDOytkp316/n7GHWkVkl8GRUW0WaixOZrawUc1AQNnZYNkDwvnMi6Yu7
 yIDax5V4p5ZoWVUjOX8cBF5rDIjVDoIP4ja3XSMLFNqfWEC7PvffQ+xfbDcO6kg96Tyh
 H+Yw==
X-Gm-Message-State: ACrzQf28E9TIo7zpYa7zE69J1VIPgAAhSwmx4Gd16arnuwidFaGrh41Y
 Zaek6MjJKevNmEIzpjDw7tqx+mTxT5UTrTLc
X-Google-Smtp-Source: AMsMyM7IVZqZDqnl8zNxK9/6udqK5QhWe5GMQ7KBundRDHM1AMVKdF2CZksFS1OvchaldycL6VdPoQ==
X-Received: by 2002:a63:f806:0:b0:439:d86e:1f6e with SMTP id
 n6-20020a63f806000000b00439d86e1f6emr934541pgh.46.1663810080630; 
 Wed, 21 Sep 2022 18:28:00 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 b15-20020a63d30f000000b004393cb720afsm2583462pgg.38.2022.09.21.18.27.59
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Wed, 21 Sep 2022 18:28:00 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Liliana Marie Prikler <liliana.prikler@HIDDEN>
Subject: Re: [PATCH 1/1] home: fontutils: Support user's fontconfig.
References: <20220921002921.23631-2-higashi@HIDDEN>
 <eb87ef1cd1311448fc57ed045deb8de1311c6322.camel@HIDDEN>
 <871qs5xd30.fsf@HIDDEN>
 <65da0cdb245fe2bcd99589d4fb1a9eb785a1b527.camel@HIDDEN>
Date: Thu, 22 Sep 2022 10:27:56 +0900
In-Reply-To: <65da0cdb245fe2bcd99589d4fb1a9eb785a1b527.camel@HIDDEN>
 (Liliana Marie Prikler's message of "Wed, 21 Sep 2022 13:40:14 +0200")
Message-ID: <87leqcw63n.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: quoted-printable

Liliana Marie Prikler <liliana.prikler@HIDDEN> writes:

> Am Mittwoch, dem 21.09.2022 um 18:59 +0900 schrieb Taiju HIGASHI:
>> Hi Liliana,
>>
>> Thank you for your review.
>>
>> > > -(define (add-fontconfig-config-file he-symlink-path)
>> > > +(define (add-fontconfig-config-file font-config)
>> > > =A0=A0 `(("fontconfig/fonts.conf"
>> > > =A0=A0=A0=A0=A0 ,(mixed-text-file
>> > > =A0=A0=A0=A0=A0=A0=A0 "fonts.conf"
>> > > =A0=A0=A0=A0=A0=A0=A0 "<?xml version=3D'1.0'?>
>> > > =A0<!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
>> > > =A0<fontconfig>
>> > > -=A0 <dir>~/.guix-home/profile/share/fonts</dir>
>> > > -</fontconfig>"))))
>> > > +=A0 <dir>~/.guix-home/profile/share/fonts</dir>\n"
>> > > +=A0=A0=A0=A0=A0=A0 (if (null? font-config)
>> > > +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 ""
>> > > +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (string-join font-config "\n" 'suffi=
x))
>> > > +=A0=A0=A0=A0=A0=A0 "</fontconfig>\n"))))
>> > I think it'd be wiser to pretty-print SXML here.
>> > The structure could look something like
>> > `(fontconfig
>> > =A0=A0 (dir "~/.guix-home/profile/share/fonts")
>> > =A0=A0 ,@(extra-user-config ...))
>>
>> That's definitely better!
>> Does this assume that SXML will also accept additional user settings?
> It assumes that whatever (extra-user-config ...) does, it returns a
> list of SXML nodes, e.g. ((dir "~/.fonts")).  Writing correct SXML
> should be comparatively simpler to writing correct XML.

I just sent you the v2 patch.  It uses SXML to handle the user's extra
configs.
I also made it so that the user can pass SXML directly.

I also wrote a test but did not include it in the patch because I
thought it would be a technical debt.
I'm attaching that as a reference.


--=-=-=
Content-Type: text/plain; charset=iso-8859-1
Content-Disposition: attachment; filename=fontutils.scm
Content-Transfer-Encoding: quoted-printable
Content-Description: tests/home-services/fontutils.scm

;;; GNU Guix --- Functional package management for GNU
;;; Copyright =A9 2022 Taiju HIGASHI <higashi@HIDDEN>
;;;
;;; This file is part of GNU Guix.
;;;
;;; GNU Guix is free software; you can redistribute it and/or modify it
;;; under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 3 of the License, or (at
;;; your option) any later version.
;;;
;;; GNU Guix is distributed in the hope that it will be useful, but
;;; WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.

(define-module (test-home-services-fontutils)
  #:use-module (gnu services)
  #:use-module (gnu home services)
  #:use-module (gnu home services fontutils)
  #:use-module (guix tests)
  #:use-module (sxml simple)
  #:use-module (srfi srfi-1)
  #:use-module (srfi srfi-64))

;; or (@@ (gnu home services fontutils) add-fontconfig-config-file)
(define add-fontconfig-config-file
  (let* ((extensions (service-type-extensions home-fontconfig-service-type))
         (extension (find (lambda (ext)
                            (eq? (service-extension-target ext)
                                 home-xdg-configuration-files-service-type))
                          extensions))
         (compute (service-extension-compute extension)))
    compute))

(define (assert-fontconfig-value value expected)
  (mock ((guix gexp) mixed-text-file
         (lambda* (name #:key guile #:rest text)
           (let ((text (string-join text "")))
             (unless (string=3D text expected)
               (error "assert failed. actual: %s" text)))))
        (add-fontconfig-config-file value)
        #t))

(test-begin "home-services-fontutils")

(test-assert "fontconfig (default value)"
  (assert-fontconfig-value '() "\
<?xml version=3D'1.0'?>
<!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
<fontconfig><dir>~/.guix-home/profile/share/fonts</dir></fontconfig>
"))

(test-assert "fontconfig (a text)"
  (assert-fontconfig-value '("<foo>foo</foo>") "\
<?xml version=3D'1.0'?>
<!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
<fontconfig><dir>~/.guix-home/profile/share/fonts</dir><foo>foo</foo></font=
config>
"))

(test-assert "fontconfig (multiple texts)"
  (assert-fontconfig-value '("<foo>foo</foo>" "<bar><baz>baz</baz></bar>") =
"\
<?xml version=3D'1.0'?>
<!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
<fontconfig><dir>~/.guix-home/profile/share/fonts</dir><foo>foo</foo><bar><=
baz>baz</baz></bar></fontconfig>
"))

(test-assert "fontconfig (a sxml)"
  (assert-fontconfig-value '((foo foo)) "\
<?xml version=3D'1.0'?>
<!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
<fontconfig><dir>~/.guix-home/profile/share/fonts</dir><foo>foo</foo></font=
config>
"))

(test-assert "fontconfig (multiple sxml)"
  (assert-fontconfig-value '((foo foo) (bar (baz baz))) "\
<?xml version=3D'1.0'?>
<!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
<fontconfig><dir>~/.guix-home/profile/share/fonts</dir><foo>foo</foo><bar><=
baz>baz</baz></bar></fontconfig>
"))

(test-error "fontconfig (invalid value)"
  (add-fontconfig-config-file '(123)))

(test-end "home-services-fontutils")

--=-=-=
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: quoted-printable


>> > Also, for the particular use case of handling multiple profiles
>> > gracefully (rather than the current status quo) I think fontconfig-
>> > service-type should be able to construct (dir
>> > "#$profile/share/fonts") style entries on its own.=A0 However, given
>> > that multiple profiles aren't supported yet, this is future work.
>>
>> Noted. I believe that even with the current patch, it is possible to
>> add arbitrary directories, so it will be better than what we have
>> now.
> That's fine, just know that this use case might at some point become
> obsolete thanks to a better implementation :)

No problem. I would like to solve the current problem first. A better
implementation is always welcome :)

Cheers
--=20
taiju

--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 22 Sep 2022 01:21:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 21 21:21:08 2022
Received: from localhost ([127.0.0.1]:35508 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1obAto-0005Eg-4Q
	for submit <at> debbugs.gnu.org; Wed, 21 Sep 2022 21:21:08 -0400
Received: from mail-pj1-f52.google.com ([209.85.216.52]:46064)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1obAti-0005Dn-Nf
 for 57963 <at> debbugs.gnu.org; Wed, 21 Sep 2022 21:21:06 -0400
Received: by mail-pj1-f52.google.com with SMTP id
 p1-20020a17090a2d8100b0020040a3f75eso570471pjd.4
 for <57963 <at> debbugs.gnu.org>; Wed, 21 Sep 2022 18:21:02 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:message-id:date:subject:cc
 :to:from:from:to:cc:subject:date;
 bh=rIL9alDk/h4IHhW6O2PK1plbXPTTrfvcaPUJzEtmTxE=;
 b=sPqkBmdQooAoaz44YMlb0kShyyS2EwkZzcqoxu7ERsW4wcTJOl41SA65WUc6mwcdKz
 Wdz7olrgs0Yn8P0bgWPTkExH5K4T/oztR7C5i2y/J2pTCXY7DF98Z/YQ2cNoVu5cKJq4
 R2WVZkcQWPBeGdfigjgU9Ym3ypz5WJgBpeU/2FMv3Kh5w5RZiqogXL4H4qqjZCnc+IAB
 vcTIwmcyihNnjrGmJ/KH5tk0rb5HWpbMUF8Vf+UDgStuuDpOHWh8sga/zOcalHKujZx2
 iquntOs/qtBAlG6rZpkBXWNDkwIf8ZVlbpAfCHbeC7vVhfdVdODw3j1tlnGG/AAnzj1H
 Wwtw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:message-id:date:subject:cc
 :to:from:x-gm-message-state:from:to:cc:subject:date;
 bh=rIL9alDk/h4IHhW6O2PK1plbXPTTrfvcaPUJzEtmTxE=;
 b=D3/3MjmdfWL/5g98WVg5qZTjuy9BbrBs9mWVBWBCw4NgFFWXD/yaglsmogei2GDme9
 KJf8Z5345Qai6K5eESyOmUXz9bWc9dULgsb1TyJXFQQuepM4JjthsY41zemdwtmI+jvY
 Ttk4lqlzT0vPSaUrUIH9U9E7XK1tzKesqQmx0fsMo+MAuHc9JM3z95F6sun4vuawJruA
 088jdexnoUEPe3Gd2EXfFb8VaO/5gW3MWwqMUq/3gckUUIhqZJgT1Pqz/zd/yoUoBPpB
 hOwVf5hW/JepQntKJk4m9tS2KsyAOfivcNRW3RWI5K6eZzalZbHuHDQfXQYqtjJzy8dB
 V6XQ==
X-Gm-Message-State: ACrzQf0MUy7pdyhFQDtyMs1/JVVzGIJQEchWjj76Dj/50twz0kApCZES
 R4Xmw4fGGMUljAi5JaxbDxxTx0t+L9ktWBgf
X-Google-Smtp-Source: AMsMyM5m1XlloRtra3Ivs3sUkakaUq4wqcUhUSHHWDdjOB81uKARIDau5tAPjaI3G9TkH09gD+j2Jg==
X-Received: by 2002:a17:902:b415:b0:178:2835:29e7 with SMTP id
 x21-20020a170902b41500b00178283529e7mr936781plr.86.1663809656469; 
 Wed, 21 Sep 2022 18:20:56 -0700 (PDT)
Received: from Taix.flets-west.jp ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 d18-20020a170902ced200b001783f964fe3sm2660325plg.113.2022.09.21.18.20.54
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Wed, 21 Sep 2022 18:20:55 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: 57963 <at> debbugs.gnu.org
Subject: [PATCH v2] home: fontutils: Support user's fontconfig.
Date: Thu, 22 Sep 2022 10:20:33 +0900
Message-Id: <20220922012033.30835-1-higashi@HIDDEN>
X-Mailer: git-send-email 2.37.3
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: * gnu/home/services/fontutils.scm
 (add-fontconfig-config-file):
 Support user's fontconfig. --- gnu/home/services/fontutils.scm | 29
 ++++++++++++++++++++++++-----
 1 file changed, 24 insertions(+), 5 de [...] 
 Content analysis details:   (2.0 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 SPF_NONE               SPF: sender does not publish an SPF Record
 2.0 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: yoctocell.xyz (xyz)]
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 0.0 RCVD_IN_MSPIKE_H3      RBL: Good reputation (+3)
 [209.85.216.52 listed in wl.mailspike.net]
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [209.85.216.52 listed in list.dnswl.org]
 0.0 RCVD_IN_MSPIKE_WL      Mailspike good senders
X-Debbugs-Envelope-To: 57963
Cc: Taiju HIGASHI <higashi@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

* gnu/home/services/fontutils.scm (add-fontconfig-config-file): Support user's
fontconfig.
---
 gnu/home/services/fontutils.scm | 29 ++++++++++++++++++++++++-----
 1 file changed, 24 insertions(+), 5 deletions(-)

diff --git a/gnu/home/services/fontutils.scm b/gnu/home/services/fontutils.scm
index 6062eaed6a..b57cccbaae 100644
--- a/gnu/home/services/fontutils.scm
+++ b/gnu/home/services/fontutils.scm
@@ -1,6 +1,7 @@
 ;;; GNU Guix --- Functional package management for GNU
 ;;; Copyright  2021 Andrew Tropin <andrew@HIDDEN>
 ;;; Copyright  2021 Xinglu Chen <public@HIDDEN>
+;;; Copyright  2022 Taiju HIGASHI <higashi@HIDDEN>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -21,6 +22,9 @@ (define-module (gnu home services fontutils)
   #:use-module (gnu home services)
   #:use-module (gnu packages fontutils)
   #:use-module (guix gexp)
+  #:use-module (srfi srfi-1)
+  #:use-module (sxml simple)
+  #:use-module (ice-9 match)
 
   #:export (home-fontconfig-service-type))
 
@@ -33,15 +37,28 @@ (define-module (gnu home services fontutils)
 ;;;
 ;;; Code:
 
-(define (add-fontconfig-config-file he-symlink-path)
+(define (parse-extra-user-config extra-user-config)
+  (map (match-lambda
+         ((? pair? sxml) sxml)
+         ((? string? xml) (xml->sxml xml))
+         (_ (error "extra-user-config must be xml string or sxml.")))
+       extra-user-config))
+
+(define (add-fontconfig-config-file extra-user-config)
   `(("fontconfig/fonts.conf"
      ,(mixed-text-file
        "fonts.conf"
        "<?xml version='1.0'?>
 <!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
-<fontconfig>
-  <dir>~/.guix-home/profile/share/fonts</dir>
-</fontconfig>"))))
+"
+       (call-with-output-string
+         (lambda (port)
+           (sxml->xml
+            `(fontconfig
+              (dir "~/.guix-home/profile/share/fonts")
+              ,@(parse-extra-user-config extra-user-config))
+            port)
+           (newline port)))))))
 
 (define (regenerate-font-cache-gexp _)
   `(("profile/share/fonts"
@@ -49,6 +66,8 @@ (define (regenerate-font-cache-gexp _)
 
 (define home-fontconfig-service-type
   (service-type (name 'home-fontconfig)
+                (compose concatenate)
+                (extend append)
                 (extensions
                  (list (service-extension
                         home-xdg-configuration-files-service-type
@@ -59,7 +78,7 @@ (define home-fontconfig-service-type
                        (service-extension
                         home-profile-service-type
                         (const (list fontconfig)))))
-                (default-value #f)
+                (default-value '())
                 (description
                  "Provides configuration file for fontconfig and make
 fc-* utilities aware of font packages installed in Guix Home's profile.")))
-- 
2.37.3





Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 21 Sep 2022 11:40:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 21 07:40:22 2022
Received: from localhost ([127.0.0.1]:60925 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oay5W-0000Oh-AP
	for submit <at> debbugs.gnu.org; Wed, 21 Sep 2022 07:40:22 -0400
Received: from mailrelay.tugraz.at ([129.27.2.202]:37950)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <liliana.prikler@HIDDEN>) id 1oay5U-0000OT-Dd
 for 57963 <at> debbugs.gnu.org; Wed, 21 Sep 2022 07:40:21 -0400
Received: from lprikler-laptop.ist.intra (gw.ist.tugraz.at [129.27.202.101])
 by mailrelay.tugraz.at (Postfix) with ESMTPSA id 4MXc0b59g9z1DPy8;
 Wed, 21 Sep 2022 13:40:15 +0200 (CEST)
DKIM-Filter: OpenDKIM Filter v2.11.0 mailrelay.tugraz.at 4MXc0b59g9z1DPy8
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=tugraz.at;
 s=mailrelay; t=1663760416;
 bh=7c64LMVhIQbeeocNQtA2/JjHpJK3h9uF/0nODBf+fI0=;
 h=Subject:From:To:Cc:Date:In-Reply-To:References:From;
 b=fr86r7sbC1j8Pj2IbPtva/RFnxu6jn40GNKWRrQI5DIhIxajXfKTUifR8+2m4SKdx
 X3W11fR9tr943ZG4OVLAaTM03zDZy+H2eMumAqvMjExVEL/bcWRNNA0aCRAkfTRGuX
 NyDBjNaWUqOnOCzkCLNYWIXJnmxwxLy0SerFlzss=
Message-ID: <65da0cdb245fe2bcd99589d4fb1a9eb785a1b527.camel@HIDDEN>
Subject: Re: [PATCH 1/1] home: fontutils: Support user's fontconfig.
From: Liliana Marie Prikler <liliana.prikler@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>
Date: Wed, 21 Sep 2022 13:40:14 +0200
In-Reply-To: <871qs5xd30.fsf@HIDDEN>
References: <20220921002921.23631-2-higashi@HIDDEN>
 <eb87ef1cd1311448fc57ed045deb8de1311c6322.camel@HIDDEN>
 <871qs5xd30.fsf@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
User-Agent: Evolution 3.45.3 
MIME-Version: 1.0
X-TUG-Backscatter-control: waObeELIUl4ypBWmcn/8wQ
X-Spam-Scanner: SpamAssassin 3.003001 
X-Spam-Score-relay: -1.9
X-Scanned-By: MIMEDefang 2.74 on 129.27.10.117
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Am Mittwoch, dem 21.09.2022 um 18:59 +0900 schrieb Taiju HIGASHI:
> Hi Liliana,
>=20
> Thank you for your review.
>=20
> > > -(define (add-fontconfig-config-file he-symlink-path)
> > > +(define (add-fontconfig-config-file font-config)
> > > =C2=A0=C2=A0 `(("fontconfig/fonts.conf"
> > > =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 ,(mixed-text-file
> > > =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 "fonts.conf"
> > > =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 "<?xml version=3D'1.0'?>
> > > =C2=A0<!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
> > > =C2=A0<fontconfig>
> > > -=C2=A0 <dir>~/.guix-home/profile/share/fonts</dir>
> > > -</fontconfig>"))))
> > > +=C2=A0 <dir>~/.guix-home/profile/share/fonts</dir>\n"
> > > +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (if (null? font-config)
> > > +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 ""
> > > +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (string=
-join font-config "\n" 'suffix))
> > > +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 "</fontconfig>\n"))))
> > I think it'd be wiser to pretty-print SXML here.
> > The structure could look something like
> > `(fontconfig
> > =C2=A0=C2=A0 (dir "~/.guix-home/profile/share/fonts")
> > =C2=A0=C2=A0 ,@(extra-user-config ...))
>=20
> That's definitely better!
> Does this assume that SXML will also accept additional user settings?
It assumes that whatever (extra-user-config ...) does, it returns a
list of SXML nodes, e.g. ((dir "~/.fonts")).  Writing correct SXML
should be comparatively simpler to writing correct XML.

> > Also, for the particular use case of handling multiple profiles
> > gracefully (rather than the current status quo) I think fontconfig-
> > service-type should be able to construct (dir
> > "#$profile/share/fonts") style entries on its own.=C2=A0 However, given
> > that multiple profiles aren't supported yet, this is future work.
>=20
> Noted. I believe that even with the current patch, it is possible to
> add arbitrary directories, so it will be better than what we have
> now.
That's fine, just know that this use case might at some point become
obsolete thanks to a better implementation :)




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 21 Sep 2022 09:59:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 21 05:59:43 2022
Received: from localhost ([127.0.0.1]:60737 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oawW7-0007t3-Ik
	for submit <at> debbugs.gnu.org; Wed, 21 Sep 2022 05:59:43 -0400
Received: from mail-pg1-f178.google.com ([209.85.215.178]:38467)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1oawW4-0007sp-Bf
 for 57963 <at> debbugs.gnu.org; Wed, 21 Sep 2022 05:59:42 -0400
Received: by mail-pg1-f178.google.com with SMTP id t70so5415272pgc.5
 for <57963 <at> debbugs.gnu.org>; Wed, 21 Sep 2022 02:59:40 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:from:to:cc:subject
 :date; bh=dcUdtul+/c5tYibo0P+kA/1g7XOiyIvJp0/xKXYa4DI=;
 b=OXpaNzw+2J/hjCTer+/sBYzWZzDTqKHxAWbjCL62MrM5KoarrZxakr5rMvzToVZEkv
 UYTAaifr5/sa+EV8119GPPERL32PpjBfkbv9OEcHtKB6RlqU2iv2xqIpcGmKCezo8TNG
 Eh2VXrq4oSCv13GzxdiRN4ZL7GhxPrBDug4VxR9jlao8WrvDk7URWf3zv8tZ2/Esi/Ra
 peNBSvPwokKH66znodlgRX/XeBxX2JmxDVbZwPGeR8LsJ7GLdXLAj4ONbU2QFWjZjg1M
 44+xeIFgBcjDBqKECsqrag+zbMJeyR2/qGBjBldS3L2gaVAEL/pWNlXR1W54EakOywg/
 c/yw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:user-agent:message-id
 :in-reply-to:date:references:subject:cc:to:from:x-gm-message-state
 :from:to:cc:subject:date;
 bh=dcUdtul+/c5tYibo0P+kA/1g7XOiyIvJp0/xKXYa4DI=;
 b=oCncJ7DVxmrgFstsWD2YIEryFp7cr9UIvVpTWMImvnN7NajDICPo2Nmg4AuSAelDrD
 nIVAkwzdKp+UZxHIOl6ZAzqqVSy5jdfiepvml5wqUDFa7/gdDvqrV1W6cwieq3a4AJqr
 OCzWOnk/YzeQzGEyNwAiKcgUtZZilkIHNo9/dB+afq4iZ5WjyqYmS5RMeunYJN6GR50Z
 IhPRQWjLuCWMDUhH1fav2Bz//vWUB3AQGFzUiF9ky+mFrWRt2f2B1jUG7Yl7WUcvQ4VB
 N05HP0gsr+fodURdi0rp+x8MzbrW1H3PahzOMD+nDZmArdpn+qu2HTasNjx2daEOPcbR
 FX3A==
X-Gm-Message-State: ACrzQf1HmtFHRuPRlOi4sYDwmadbb6jtInG0G5n1g9tDFqCBvHTb2XhE
 32fEgHYcl1okSf/aA7hii7+/Nbr94Vg+dbUj
X-Google-Smtp-Source: AMsMyM765QIAJ23b3dhFUHfWPT53F2GmXj9s3IIVFuwfq2ZpVgcGKOXs7aFBiSbSG0r6GP/FX0ic3Q==
X-Received: by 2002:aa7:9851:0:b0:53e:87eb:1ffa with SMTP id
 n17-20020aa79851000000b0053e87eb1ffamr28222435pfq.35.1663754374138; 
 Wed, 21 Sep 2022 02:59:34 -0700 (PDT)
Received: from Taix ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 c6-20020a170903234600b0017680faa1a8sm1562347plh.112.2022.09.21.02.59.32
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Wed, 21 Sep 2022 02:59:33 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: Liliana Marie Prikler <liliana.prikler@HIDDEN>
Subject: Re: [PATCH 1/1] home: fontutils: Support user's fontconfig.
References: <20220921002921.23631-2-higashi@HIDDEN>
 <eb87ef1cd1311448fc57ed045deb8de1311c6322.camel@HIDDEN>
Date: Wed, 21 Sep 2022 18:59:31 +0900
In-Reply-To: <eb87ef1cd1311448fc57ed045deb8de1311c6322.camel@HIDDEN>
 (Liliana Marie Prikler's message of "Wed, 21 Sep 2022 10:54:34 +0200")
Message-ID: <871qs5xd30.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57963
Cc: 57963 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Liliana,

Thank you for your review.

>> -(define (add-fontconfig-config-file he-symlink-path)
>> +(define (add-fontconfig-config-file font-config)
>> =A0=A0 `(("fontconfig/fonts.conf"
>> =A0=A0=A0=A0=A0 ,(mixed-text-file
>> =A0=A0=A0=A0=A0=A0=A0 "fonts.conf"
>> =A0=A0=A0=A0=A0=A0=A0 "<?xml version=3D'1.0'?>
>> =A0<!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
>> =A0<fontconfig>
>> -=A0 <dir>~/.guix-home/profile/share/fonts</dir>
>> -</fontconfig>"))))
>> +=A0 <dir>~/.guix-home/profile/share/fonts</dir>\n"
>> +=A0=A0=A0=A0=A0=A0 (if (null? font-config)
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 ""
>> +=A0=A0=A0=A0=A0=A0=A0=A0=A0=A0 (string-join font-config "\n" 'suffix))
>> +=A0=A0=A0=A0=A0=A0 "</fontconfig>\n"))))
> I think it'd be wiser to pretty-print SXML here.
> The structure could look something like
> `(fontconfig
>    (dir "~/.guix-home/profile/share/fonts")
>    ,@(extra-user-config ...))

That's definitely better!
Does this assume that SXML will also accept additional user settings?

> Also, for the particular use case of handling multiple profiles
> gracefully (rather than the current status quo) I think fontconfig-
> service-type should be able to construct (dir "#$profile/share/fonts")
> style entries on its own.  However, given that multiple profiles aren't
> supported yet, this is future work.

Noted. I believe that even with the current patch, it is possible to add
arbitrary directories, so it will be better than what we have now.

Cheers
--=20
taiju




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 21 Sep 2022 08:54:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 21 04:54:44 2022
Received: from localhost ([127.0.0.1]:60610 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oavVE-00066m-5H
	for submit <at> debbugs.gnu.org; Wed, 21 Sep 2022 04:54:44 -0400
Received: from mailrelay.tugraz.at ([129.27.2.202]:19475)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <liliana.prikler@HIDDEN>) id 1oavV9-00066U-3l
 for 57963 <at> debbugs.gnu.org; Wed, 21 Sep 2022 04:54:42 -0400
Received: from lprikler-laptop.ist.intra (gw.ist.tugraz.at [129.27.202.101])
 by mailrelay.tugraz.at (Postfix) with ESMTPSA id 4MXXKR14W2z1LZWr;
 Wed, 21 Sep 2022 10:54:35 +0200 (CEST)
DKIM-Filter: OpenDKIM Filter v2.11.0 mailrelay.tugraz.at 4MXXKR14W2z1LZWr
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=tugraz.at;
 s=mailrelay; t=1663750475;
 bh=SiewZ3YU/RLxivLopaQMakfaHyE1Xt3JfmoPGcAK4IE=;
 h=Subject:From:To:Date:In-Reply-To:References:From;
 b=uSRE6G2kj61PuU1pga63SjQONpOWdIdxHqXUrcx6MRPYGblIcoLIs5TLJEwGwO06f
 IF28mSqhd2QsS+hDQBPEzi6aLVlM38y2hL0pwnMuv8wSl2ro9RVhkXnO+L2uj8FhZ2
 cSKryeoe+tH28Q/LjP9/sTFsdvfa/2UyLSE7xP4Q=
Message-ID: <eb87ef1cd1311448fc57ed045deb8de1311c6322.camel@HIDDEN>
Subject: Re: [PATCH 1/1] home: fontutils: Support user's fontconfig.
From: Liliana Marie Prikler <liliana.prikler@HIDDEN>
To: Taiju HIGASHI <higashi@HIDDEN>, 57963 <at> debbugs.gnu.org
Date: Wed, 21 Sep 2022 10:54:34 +0200
In-Reply-To: <20220921002921.23631-2-higashi@HIDDEN>
References: <20220921002921.23631-2-higashi@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
User-Agent: Evolution 3.45.3 
MIME-Version: 1.0
X-TUG-Backscatter-control: waObeELIUl4ypBWmcn/8wQ
X-Spam-Scanner: SpamAssassin 3.003001 
X-Spam-Score-relay: -0.4
X-Scanned-By: MIMEDefang 2.74 on 129.27.10.117
X-Spam-Score: -0.3 (/)
X-Debbugs-Envelope-To: 57963
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.3 (-)

Am Mittwoch, dem 21.09.2022 um 09:29 +0900 schrieb Taiju HIGASHI:
> * gnu/home/services/fontutils.scm (add-fontconfig-config-file):
> Support user's fontconfig.
> ---
> =C2=A0gnu/home/services/fontutils.scm | 15 +++++++++++----
> =C2=A01 file changed, 11 insertions(+), 4 deletions(-)
>=20
> diff --git a/gnu/home/services/fontutils.scm
> b/gnu/home/services/fontutils.scm
> index 6062eaed6a..3ea8b1db74 100644
> --- a/gnu/home/services/fontutils.scm
> +++ b/gnu/home/services/fontutils.scm
> @@ -1,6 +1,7 @@
> =C2=A0;;; GNU Guix --- Functional package management for GNU
> =C2=A0;;; Copyright =C2=A9 2021 Andrew Tropin <andrew@HIDDEN>
> =C2=A0;;; Copyright =C2=A9 2021 Xinglu Chen <public@HIDDEN>
> +;;; Copyright =C2=A9 2022 Taiju HIGASHI <higashi@HIDDEN>
> =C2=A0;;;
> =C2=A0;;; This file is part of GNU Guix.
> =C2=A0;;;
> @@ -21,6 +22,7 @@ (define-module (gnu home services fontutils)
> =C2=A0=C2=A0 #:use-module (gnu home services)
> =C2=A0=C2=A0 #:use-module (gnu packages fontutils)
> =C2=A0=C2=A0 #:use-module (guix gexp)
> +=C2=A0 #:use-module (srfi srfi-1)
> =C2=A0
> =C2=A0=C2=A0 #:export (home-fontconfig-service-type))
> =C2=A0
> @@ -33,15 +35,18 @@ (define-module (gnu home services fontutils)
> =C2=A0;;;
> =C2=A0;;; Code:
> =C2=A0
> -(define (add-fontconfig-config-file he-symlink-path)
> +(define (add-fontconfig-config-file font-config)
> =C2=A0=C2=A0 `(("fontconfig/fonts.conf"
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 ,(mixed-text-file
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 "fonts.conf"
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 "<?xml version=3D'1.0'?>
> =C2=A0<!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
> =C2=A0<fontconfig>
> -=C2=A0 <dir>~/.guix-home/profile/share/fonts</dir>
> -</fontconfig>"))))
> +=C2=A0 <dir>~/.guix-home/profile/share/fonts</dir>\n"
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (if (null? font-config)
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 ""
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (string-joi=
n font-config "\n" 'suffix))
> +=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 "</fontconfig>\n"))))
I think it'd be wiser to pretty-print SXML here.
The structure could look something like
`(fontconfig=C2=A0
   (dir "~/.guix-home/profile/share/fonts")
   ,@(extra-user-config ...))

Also, for the particular use case of handling multiple profiles
gracefully (rather than the current status quo) I think fontconfig-
service-type should be able to construct (dir "#$profile/share/fonts")
style entries on its own.  However, given that multiple profiles aren't
supported yet, this is future work.

Cheers




Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at 57963 <at> debbugs.gnu.org:


Received: (at 57963) by debbugs.gnu.org; 21 Sep 2022 00:29:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Sep 20 20:29:45 2022
Received: from localhost ([127.0.0.1]:60072 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oancW-0007b7-Lv
	for submit <at> debbugs.gnu.org; Tue, 20 Sep 2022 20:29:44 -0400
Received: from mail-pg1-f175.google.com ([209.85.215.175]:44886)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1oancU-0007aq-Cy
 for 57963 <at> debbugs.gnu.org; Tue, 20 Sep 2022 20:29:42 -0400
Received: by mail-pg1-f175.google.com with SMTP id c7so4316546pgt.11
 for <57963 <at> debbugs.gnu.org>; Tue, 20 Sep 2022 17:29:42 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:message-id:date:subject:cc
 :to:from:from:to:cc:subject:date;
 bh=wz0FAF8lUUJIDLZjh0sc33ihU8m/ext0PdmPTJHBuwE=;
 b=3M0dmK6dPkFWVKQlS47Ge0JcsugiXonm14ZqayPq4zyF5MFlu9pYJwBr58BrRGzg6N
 GK8+br4KDKCzoUCE76bYxKqmX7S/KeOeUy81oiC2/ph878lMOYrcRvkZ9/jRU8/+u5Kp
 urE1cAph/8+ersCkOocYWMT9c37wB2mDcosYlfDFPr/7h/RHkNUPAULGCzBtjyZ7gRWP
 sV1saTu7lBnV4YhIt4v1t7KcaMR9CEliApzSripf/AH4C3i1wzSv/ovwyXSpDyB1KywB
 kknnWXEvgESZZu+yK6Cjo9qwDpBiBSy4+S25d4C2xbq23110IL1TZhXP5PMKq4Moy/Mf
 8vQg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:message-id:date:subject:cc
 :to:from:x-gm-message-state:from:to:cc:subject:date;
 bh=wz0FAF8lUUJIDLZjh0sc33ihU8m/ext0PdmPTJHBuwE=;
 b=Yq0v3oQCLFTN5N8uDAW47J34Tx734RHW28xmfHbOkn+tp88Sv+aDNzh7J/MMJcIkDY
 jY4PWJ5vzoJBBVlMW/4LBqoWGOAnCOgDH3VP8BTGWzF2yCJVwNsYymgJODztF6WoiHcL
 J4dysU0YdAgvRxTWuqk5f97UqUtvZ3Bz2UWylZv8vp0AUz0i4LdfgLmKgnk7XUk3t6+V
 +VFgvKTilBbIvpxC6is+VntW2/g0h3apLKP8/SAx75pL+7eH4wC9I5aHOIJiETQ6S/AO
 W3lSVTYD2pkpKenE02tVMlyfdrhtPPPywrUZChfl+ebP6uEe3DuTapPXr2xqE6+q25ct
 b/LQ==
X-Gm-Message-State: ACrzQf09ZpVFl1qGH2YX4tMMnxr244zqJZF2aNTjB4b7nfAnp15BZqR9
 647RlBGrhfZnipkTwTdwytX1g+5rpLKw5MiY
X-Google-Smtp-Source: AMsMyM7E1fUz8fovv13QxvPsavuL2aNLYzxNVifSvz2YitLTm9A+LI4ID5jvw2hvW1QVeRX8/LQxxw==
X-Received: by 2002:a63:2bcc:0:b0:439:36bb:c036 with SMTP id
 r195-20020a632bcc000000b0043936bbc036mr22304743pgr.447.1663720176217; 
 Tue, 20 Sep 2022 17:29:36 -0700 (PDT)
Received: from Taix.flets-west.jp ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 u1-20020a626001000000b0053b9e5d365bsm494914pfb.216.2022.09.20.17.29.35
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Tue, 20 Sep 2022 17:29:35 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: 57963 <at> debbugs.gnu.org
Subject: [PATCH 1/1] home: fontutils: Support user's fontconfig.
Date: Wed, 21 Sep 2022 09:29:21 +0900
Message-Id: <20220921002921.23631-2-higashi@HIDDEN>
X-Mailer: git-send-email 2.37.3
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: * gnu/home/services/fontutils.scm
 (add-fontconfig-config-file):
 Support user's fontconfig. --- gnu/home/services/fontutils.scm | 15
 +++++++++++---- 1 file changed, 11 insertions(+),
 4 deletions(-) diff --git a/gnu/home/services/fontutils.scm
 b/gnu/home/services/fontutils.scm index 6062eaed6a..3ea8b1db74 100644 ---
 a/gnu/home/services/fontutils.scm +++ b/gnu/home/services/fontutils.scm @@
 -1,6 + [...] 
 Content analysis details:   (2.0 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 SPF_NONE               SPF: sender does not publish an SPF Record
 2.0 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: yoctocell.xyz (xyz)]
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [209.85.215.175 listed in list.dnswl.org]
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
 [209.85.215.175 listed in wl.mailspike.net]
X-Debbugs-Envelope-To: 57963
Cc: Taiju HIGASHI <higashi@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

* gnu/home/services/fontutils.scm (add-fontconfig-config-file): Support user's
fontconfig.
---
 gnu/home/services/fontutils.scm | 15 +++++++++++----
 1 file changed, 11 insertions(+), 4 deletions(-)

diff --git a/gnu/home/services/fontutils.scm b/gnu/home/services/fontutils.scm
index 6062eaed6a..3ea8b1db74 100644
--- a/gnu/home/services/fontutils.scm
+++ b/gnu/home/services/fontutils.scm
@@ -1,6 +1,7 @@
 ;;; GNU Guix --- Functional package management for GNU
 ;;; Copyright  2021 Andrew Tropin <andrew@HIDDEN>
 ;;; Copyright  2021 Xinglu Chen <public@HIDDEN>
+;;; Copyright  2022 Taiju HIGASHI <higashi@HIDDEN>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -21,6 +22,7 @@ (define-module (gnu home services fontutils)
   #:use-module (gnu home services)
   #:use-module (gnu packages fontutils)
   #:use-module (guix gexp)
+  #:use-module (srfi srfi-1)
 
   #:export (home-fontconfig-service-type))
 
@@ -33,15 +35,18 @@ (define-module (gnu home services fontutils)
 ;;;
 ;;; Code:
 
-(define (add-fontconfig-config-file he-symlink-path)
+(define (add-fontconfig-config-file font-config)
   `(("fontconfig/fonts.conf"
      ,(mixed-text-file
        "fonts.conf"
        "<?xml version='1.0'?>
 <!DOCTYPE fontconfig SYSTEM 'fonts.dtd'>
 <fontconfig>
-  <dir>~/.guix-home/profile/share/fonts</dir>
-</fontconfig>"))))
+  <dir>~/.guix-home/profile/share/fonts</dir>\n"
+       (if (null? font-config)
+           ""
+           (string-join font-config "\n" 'suffix))
+       "</fontconfig>\n"))))
 
 (define (regenerate-font-cache-gexp _)
   `(("profile/share/fonts"
@@ -49,6 +54,8 @@ (define (regenerate-font-cache-gexp _)
 
 (define home-fontconfig-service-type
   (service-type (name 'home-fontconfig)
+                (compose concatenate)
+                (extend append)
                 (extensions
                  (list (service-extension
                         home-xdg-configuration-files-service-type
@@ -59,7 +66,7 @@ (define home-fontconfig-service-type
                        (service-extension
                         home-profile-service-type
                         (const (list fontconfig)))))
-                (default-value #f)
+                (default-value '())
                 (description
                  "Provides configuration file for fontconfig and make
 fc-* utilities aware of font packages installed in Guix Home's profile.")))
-- 
2.37.3





Information forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 21 Sep 2022 00:27:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Sep 20 20:27:43 2022
Received: from localhost ([127.0.0.1]:60067 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oanaZ-0007Xf-69
	for submit <at> debbugs.gnu.org; Tue, 20 Sep 2022 20:27:43 -0400
Received: from lists.gnu.org ([209.51.188.17]:32832)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <higashi@HIDDEN>) id 1oanaX-0007XY-UJ
 for submit <at> debbugs.gnu.org; Tue, 20 Sep 2022 20:27:42 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:38094)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <higashi@HIDDEN>)
 id 1oanaW-0006j5-HG
 for guix-patches@HIDDEN; Tue, 20 Sep 2022 20:27:40 -0400
Received: from mail-pl1-x635.google.com ([2607:f8b0:4864:20::635]:42756)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.90_1) (envelope-from <higashi@HIDDEN>)
 id 1oanaT-0002Ax-VM
 for guix-patches@HIDDEN; Tue, 20 Sep 2022 20:27:39 -0400
Received: by mail-pl1-x635.google.com with SMTP id v1so4031462plo.9
 for <guix-patches@HIDDEN>; Tue, 20 Sep 2022 17:27:34 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=taiju-info.20210112.gappssmtp.com; s=20210112;
 h=content-transfer-encoding:mime-version:message-id:date:subject:cc
 :to:from:from:to:cc:subject:date;
 bh=i9X28lRC10/wDMzT13xQWNgyw28Ty7Te0iOfB1EO7Yw=;
 b=Mwi15I0O2tLj8Y+pwAF/x6IvAlHaOtCWQX3JdCpTtLWAUEyz76LWvkoGbzWKrlIOSm
 7oMszS20nArrVayzn1pCvDeZvLAb04VJWrTtduJ1FsdUJq1Q+Geg8vEEkafbrBSSz2kp
 HbQR+X8GiAR59HjWNCjd1IK90oStNAjc+sKeaFTEkt1biBLNntLI+GORWpepHXRGQMB9
 VyREJQ45hnOeB/HXbryY69zjZhU/SoP597Nal4Bl1TThjuWib/D0GqJqFQvXuyTPfgmK
 MycvjGJG7ZSj+AZ0e4GrGtO3mpitbIwHW8wUxT/f9RjesYJV2NZZMmxeSN0HHlzPkNPG
 ErrQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=content-transfer-encoding:mime-version:message-id:date:subject:cc
 :to:from:x-gm-message-state:from:to:cc:subject:date;
 bh=i9X28lRC10/wDMzT13xQWNgyw28Ty7Te0iOfB1EO7Yw=;
 b=vpHqALaBx2YvA6Cz/3fGq6FoqkOFuO5r5gSONr+xTSG9WrNEs+uQtNgac0sD7MzvEZ
 Yurkhh/ontYLUzrJL7PazeO6J25dpjJgtaMFkQLscDZpfIyhsHu5mi4DHFf8uoMGRJhK
 cKCRoTJazZSPMZ2umS3+vF8+PX2OmNQFZhjfU2HeJaN2MqUme2kj/Sx+xOo6BUhF1nTH
 b16MXO7ocVp2Nb0z8s7poTMT6KRwEEeUzfDy5RN/m5bRloOP7OrEuPqOc8tsnp42F0dU
 NXdCfWJm5WpmGpS5+fCnxFZNYbVK+TcekBavxiya2wwUfxbvBQhh88KwxKNos+9OEAE9
 7Fhg==
X-Gm-Message-State: ACrzQf2a9llIc7OwAeYaDdWbZwe13vFJ0iGpGB4hzOWV34BStjPhO/to
 IdLy+T5STXgJBt18vHH4dwHW1qrbdrHUXgKx
X-Google-Smtp-Source: AMsMyM6k+9vhgRSJLwS/ulRJTmoNa0eodIXbEGDUHxvAlFQSMsHkrHWZ1LubDEeZCZkoPEUFTVMSkg==
X-Received: by 2002:a17:902:b281:b0:177:f1db:9a32 with SMTP id
 u1-20020a170902b28100b00177f1db9a32mr2089848plr.149.1663720052947; 
 Tue, 20 Sep 2022 17:27:32 -0700 (PDT)
Received: from Taix.flets-west.jp ([240b:253:ec40:2400:b7d1:436e:2d61:e925])
 by smtp.gmail.com with ESMTPSA id
 p1-20020a170902bd0100b001769e6d4fafsm530808pls.57.2022.09.20.17.27.31
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Tue, 20 Sep 2022 17:27:32 -0700 (PDT)
From: Taiju HIGASHI <higashi@HIDDEN>
To: guix-patches@HIDDEN
Subject: [PATCH 0/1] Support user's fontconfig.
Date: Wed, 21 Sep 2022 09:27:20 +0900
Message-Id: <20220921002721.23511-1-higashi@HIDDEN>
X-Mailer: git-send-email 2.37.3
MIME-Version: 1.0
Content-Transfer-Encoding: 8bit
Received-SPF: none client-ip=2607:f8b0:4864:20::635;
 envelope-from=higashi@HIDDEN; helo=mail-pl1-x635.google.com
X-Spam_score_int: -18
X-Spam_score: -1.9
X-Spam_bar: -
X-Spam_report: (-1.9 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, RCVD_IN_DNSWL_NONE=-0.0001, SPF_HELO_NONE=0.001,
 SPF_NONE=0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: submit
Cc: Taiju HIGASHI <higashi@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi,

I want to add custom fontconfig, so I've implemented the ability of custom
font configuration to fontutils.

It allows us to set up our fontconfig as follows.

    (home-environment
     (packages (list font-google-noto))
     (services
      (list
       (simple-service 'my-fontconfig-service
                       home-fontconfig-service-type
                       (list
                        "<alias>
      <family>sans-serif</family>
      <prefer>
        <family>Noto Sans CJK JP</family>
      </prefer>
    </alias>"
                        "<alias>
      <family>sans-serif</family>
      <prefer>
        <family>Noto Serif CJK JP</family>
      </prefer>
    </alias>")))))

Of course, we can also use SXML!

    (define font-family-map
      '((sans-serif . "Noto Sans CJK JP")
        (serif . "Noto Serif CJK JP")))

    (home-environment
     (packages (list font-google-noto))
     (services
      (list
       (simple-service 'my-fontconfig-service
                       home-fontconfig-service-type
                       (list
                        (call-with-output-string
                          (lambda (port)
                            (sxml->xml
                             (map (lambda (pair)
                                    `(alias
                                      (family ,(car pair))
                                      (prefer
                                       (family ,(cdr pair)))))
                                  font-family-map)
                             port))))))))

Taiju HIGASHI (1):
  home: fontutils: Support user's fontconfig.

 gnu/home/services/fontutils.scm | 15 +++++++++++----
 1 file changed, 11 insertions(+), 4 deletions(-)

--
2.37.3




Acknowledgement sent to Taiju HIGASHI <higashi@HIDDEN>:
New bug report received and forwarded. Copy sent to guix-patches@HIDDEN. Full text available.
Report forwarded to guix-patches@HIDDEN:
bug#57963; Package guix-patches. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Sun, 23 Oct 2022 11:45:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.